/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 32 "parser.y"

/** @endcond */

// local
#include "pjl_config.h"                 /* must go first */
#include "c_ast.h"
#include "c_ast_check.h"
#include "c_ast_util.h"
#include "c_keyword.h"
#include "c_lang.h"
#include "c_operator.h"
#include "c_sglob.h"
#include "c_sname.h"
#include "c_type.h"
#include "c_typedef.h"
#include "cdecl.h"
#include "cdecl_keyword.h"
#include "color.h"
#include "decl_flags.h"
#include "dump.h"
#include "did_you_mean.h"
#include "english.h"
#include "gibberish.h"
#include "help.h"
#include "lexer.h"
#include "literals.h"
#include "options.h"
#include "p_macro.h"
#include "p_token.h"
#include "print.h"
#include "set_options.h"
#include "show.h"
#include "slist.h"
#include "types.h"
#include "util.h"

/// @cond DOXYGEN_IGNORE

// standard
#include <assert.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

// Silence these warnings for Bison-generated code.
#ifdef __GNUC__
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wconversion"
# pragma GCC diagnostic ignored "-Wredundant-decls"
# pragma GCC diagnostic ignored "-Wunreachable-code"
#endif /* __GNUC__ */

// Developer aid for tracing when Bison %destructors are called.
#if 0
#define DTRACE                    EPRINTF( "%d: destructor\n", __LINE__ )
#else
#define DTRACE                    NO_OP
#endif

/// @endcond

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-group Parser
 * Helper macros, data structures, variables, functions, and the grammar for
 * C/C++ declarations.
 * @{
 */

/**
 * Calls #elaborate_error_dym() with #DYM_NONE.
 *
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | Y_define error
 *    {
 *      elaborate_error( "name expected" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error(...) \
  elaborate_error_dym( DYM_NONE, __VA_ARGS__ )

/**
 * Calls fl_elaborate_error() followed by #PARSE_ABORT().
 *
 * @param DYM_KINDS The bitwise-or of \ref dym_kind_t things possibly meant.
 * @param ... Arguments passed to fl_elaborate_error().
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  | error
 *    {
 *      elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
 *    }
 * ```
 * @note A newline _is_ printed.
 *
 * @sa elaborate_error()
 * @sa keyword_expected()
 * @sa punct_expected()
 */
#define elaborate_error_dym(DYM_KINDS,...) BLOCK( \
  fl_elaborate_error( __FILE__, __LINE__, (DYM_KINDS), __VA_ARGS__ ); PARSE_ABORT(); )

/**
 * Executes the given statements only if \ref opt_cdecl_debug `!=`
 * #CDECL_DEBUG_NO.
 *
 * @param ... The statement(s) to execute.
 */
#define IF_CDECL_DEBUG(...) \
  BLOCK( if ( opt_cdecl_debug != CDECL_DEBUG_NO ) { __VA_ARGS__ } )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * will be ignored.
 *
 * @param LOC The location of what's being ignored.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is being ignored.
 *
 * @sa #UNSUPPORTED()
 */
#define IGNORING(LOC,...) \
  IGNORING_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define IGNORING_IMPL(LOC,WHAT,...) \
  print_warning( (LOC), WHAT " not supported by %s (ignoring)%s", __VA_ARGS__, "\n" )
/// @endcond

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @remarks In debug mode, also includes the file & line where the function was
 * called from in the error message.
 *
 * @param TYPE_LOC The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 *
 * @sa fl_is_nested_type_ok()
 */
#define is_nested_type_ok(TYPE_LOC) \
  fl_is_nested_type_ok( __FILE__, __LINE__, (TYPE_LOC) )

/**
 * Checks whether \ref opt_lang_id is among the bitwise-or of languages
 * specified by \a LANG_MACRO, i.e., \a LANG_MACRO is supported by \ref
 * opt_lang_id.
 *
 * @param LANG_MACRO A `LANG_*` macro without the `LANG_` prefix.
 * @return Returns `true` only if either **cdecl** is \ref cdecl_initialized is
 * `false` or \ref opt_lang_id is among the bitwise-or of languages specified
 * by \a LANG_MACRO.
 *
 * @sa #OPT_LANG_IS()
 */
#define IS_SUPPORTED(LANG_MACRO) \
  ( !cdecl_initialized || OPT_LANG_IS( LANG_MACRO ) )

/**
 * Calls fl_keyword_expected() followed by #PARSE_ABORT().
 *
 * @param KEYWORD A keyword literal.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : Y_virtual
 *  | error
 *    {
 *      keyword_expected( L_virtual );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa punct_expected()
 */
#define keyword_expected(KEYWORD) BLOCK ( \
  fl_keyword_expected( __FILE__, __LINE__, (KEYWORD) ); PARSE_ABORT(); )

/**
 * Aborts the current parse after an error message has been printed.
 *
 * @sa #PARSE_ASSERT()
 */
#define PARSE_ABORT() \
  BLOCK( parse_cleanup( /*fatal_error=*/true ); YYABORT; )

/**
 * Evaluates \a EXPR: if `false`, calls #PARSE_ABORT().
 *
 * @param EXPR The expression to evalulate.
 */
#define PARSE_ASSERT(EXPR)        BLOCK( if ( !(EXPR) ) PARSE_ABORT(); )

/**
 * Calls fl_punct_expected() followed by #PARSE_ABORT().
 *
 * @param PUNCT The punctuation character that was expected.
 *
 * @note This must be used _only_ after an `error` token, e.g.:
 * ```
 *  : ','
 *  | error
 *    {
 *      punct_expected( ',' );
 *    }
 * ```
 *
 * @sa elaborate_error()
 * @sa elaborate_error_dym()
 * @sa keyword_expected()
 */
#define punct_expected(PUNCT) BLOCK( \
  fl_punct_expected( __FILE__, __LINE__, (PUNCT) ); PARSE_ABORT(); )

/**
 * Checks whether \a SNAME is a type.
 *
 * @param SNAME The scoped name to check.
 * @param LOC The location of \a SNAME.
 * @return Returns `true` only if \a SNAME is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
#define sname_is_type(SNAME,LOC) \
  fl_sname_is_type( __FILE__, __LINE__, (SNAME), (LOC) )

/**
 * Prints that a particular language feature is not supported by **cdecl** and
 * it an error.
 *
 * @param LOC The location of what's not supported.
 * @param ... The `printf()` arguments, the first of which _must_ be a string
 * literal of what is unsupported.
 *
 * @sa #IGNORING()
 */
#define UNSUPPORTED(LOC,...) \
  UNSUPPORTED_IMPL( (LOC), __VA_ARGS__, CDECL )

/// @cond DOXYGEN_IGNORE
#define UNSUPPORTED_IMPL(LOC,WHAT,...) \
  print_error( (LOC), WHAT " not supported by %s%s", __VA_ARGS__, "\n" )
/// @endcond

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @defgroup parser-dump-group Debugging Macros
 * Macros that are used to dump a trace during parsing when \ref
 * opt_cdecl_debug is set.
 * @ingroup parser-group
 * @{
 */

/**
 * Dumps \a ALIGN.
 *
 * @param KEY The key name to print.
 * @param ALIGN The \ref c_alignas to dump.
 */
#define DUMP_ALIGN(KEY,ALIGN) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_alignas_dump( &(ALIGN), stdout ); )

/**
 * Dumps an AST.
 *
 * @param KEY The key name to print.
 * @param AST The AST to dump.
 *
 * @sa #DUMP_AST_LIST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST(KEY,AST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_dump( (AST), stdout ); )

/**
 * Dumps an s_list of AST.
 *
 * @param KEY The key name to print.
 * @param AST_LIST The \ref slist of AST to dump.
 *
 * @sa #DUMP_AST()
 * @sa #DUMP_AST_PAIR()
 */
#define DUMP_AST_LIST(KEY,AST_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_list_dump( &(AST_LIST), stdout ); )

/**
 * Dump a \ref c_ast_pair.
 *
 * @param KEY The key name to print.
 * @param ASTP The \ref c_ast_pair to dump.
 *
 * @sa #DUMP_AST()
 */
#define DUMP_AST_PAIR(KEY,ASTP) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_ast_pair_dump( &(ASTP), stdout ); )

/**
 * Dumps a `bool`.
 *
 * @param KEY The key name to print.
 * @param BOOL The `bool` to dump.
 */
#define DUMP_BOOL(KEY,BOOL)  IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); bool_dump( (BOOL), stdout ); )

/**
 * Ends a dump block.
 *
 * @sa #DUMP_START()
 */
#define DUMP_END()                IF_CDECL_DEBUG( PUTS( "\n}\n\n" ); )

/**
 * Possibly dumps a comma and a newline followed by the `printf()` arguments
 * --- used for printing a key followed by a value.
 *
 * @param ... The `printf()` arguments.
 *
 * @warning This _must_ only be called inside #IF_CDECL_DEBUG().
 */
#define DUMP_KEY_IMPL(...) BLOCK(         \
  fput_sep( ",\n", &dump_comma, stdout ); \
  PRINTF( "  " __VA_ARGS__ ); )

/**
 * Dumps an integer.
 *
 * @param KEY The key name to print.
 * @param NUM The integer to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_INT(KEY,NUM) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": %d", STATIC_CAST( int, (NUM) ) ); )

/**
 * Dumps a \ref p_macro.
 *
 * @param KEY The key name to print.
 * @param MACRO The \ref p_macro to dump.
 */
#define DUMP_MACRO(KEY,MACRO) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); p_macro_dump( (MACRO), stdout ); )

/**
 * Dumps a list of macro arguments.
 *
 * @param KEY The key name to print.
 * @param ARG_LIST The list of arguments to dump.
 */
#define DUMP_MACRO_ARG_LIST(KEY,ARG_LIST) IF_CDECL_DEBUG( \
  if ( (ARG_LIST) != NULL ) {                             \
    DUMP_KEY_IMPL( KEY ": " );                            \
    p_arg_list_dump( (ARG_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_param.
 *
 * @param KEY The key name to print.
 * @param PARAM_LIST The list of \ref p_param to dump.
 */
#define DUMP_MACRO_PARAM_LIST(KEY,PARAM_LIST) IF_CDECL_DEBUG( \
  if ( (PARAM_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_param_list_dump( (PARAM_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Dumps a list of \ref p_token.
 *
 * @param KEY The key name to print.
 * @param TOKEN_LIST The list of \ref p_token to dump.
 */
#define DUMP_MACRO_TOKEN_LIST(KEY,TOKEN_LIST) IF_CDECL_DEBUG( \
  if ( (TOKEN_LIST) != NULL ) {                               \
    DUMP_KEY_IMPL( KEY ": " );                                \
    p_token_list_dump( (TOKEN_LIST), /*indent=*/1, stdout );  \
  } )

/**
 * Starts a dump block.
 *
 * @remarks If a production has a result, it should be dumped as the final
 * thing before the #DUMP_END() with the KEY of `$$_` followed by a suffix
 * denoting the type, e.g., `ast`.  For example:
 * ```
 *  DUMP_START( "rule",
 *              "subrule_1 subrule_2 ..." );
 *  DUMP_AST( "subrule_1", $1 );
 *  DUMP_STR( "name", $2 );
 *  DUMP_AST( "subrule_2", $3 );
 *  // ...
 *  DUMP_AST( "$$_ast", $$ );
 *  DUMP_END();
 * ```
 *
 * @param NAME The grammar production name.
 * @param RULE The grammar production rule.
 *
 * @note The dump block _must_ end with #DUMP_END().
 *
 * @sa #DUMP_END()
 */
#define DUMP_START(NAME,RULE) \
  bool dump_comma = false;    \
  IF_CDECL_DEBUG( PUTS( "{\n  rule: {\n    lhs: \"" NAME "\",\n    rhs: \"" RULE "\"\n  },\n" ); )

/**
 * Dumps a scoped name.
 *
 * @param KEY The key name to print.
 * @param SNAME The scoped name to dump.
 *
 * @sa #DUMP_SNAME_LIST()
 * @sa #DUMP_STR()
 */
#define DUMP_SNAME(KEY,SNAME) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_dump( &(SNAME), stdout ); )

/**
 * Dumps a list of scoped names.
 *
 * @param KEY The key name to print.
 * @param LIST The list of scoped names to dump.
 *
 * @sa #DUMP_SNAME()
 */
#define DUMP_SNAME_LIST(KEY,LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_sname_list_dump( &(LIST), stdout ); )

/**
 * Dumps a C string.
 *
 * @param KEY The key name to print.
 * @param STR The C string to dump.
 *
 * @sa #DUMP_INT()
 * @sa #DUMP_SNAME()
 * @sa #DUMP_STR_LIST()
 */
#define DUMP_STR(KEY,STR) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); fputs_quoted( (STR), '"', stdout ); )

/**
 * Dumps a list of C strings.
 *
 * @param KEY The key name to print.
 * @param STR_LIST The list of C strings to dump.
 *
 * @sa #DUMP_STR()
 */
#define DUMP_STR_LIST(KEY,STR_LIST) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); str_list_dump( (STR_LIST), stdout ); )

/**
 * Dumps a \ref c_tid_t.
 *
 * @param KEY The key name to print.
 * @param TID The \ref c_tid_t to dump.
 *
 * @sa #DUMP_TYPE()
 */
#define DUMP_TID(KEY,TID) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_tid_dump( (TID), stdout ); )

/**
 * Dumps a \ref c_type.
 *
 * @param KEY The key name to print.
 * @param TYPE The \ref c_type to dump.
 *
 * @sa #DUMP_TID()
 */
#define DUMP_TYPE(KEY,TYPE) IF_CDECL_DEBUG( \
  DUMP_KEY_IMPL( KEY ": " ); c_type_dump( &(TYPE), stdout ); )

/** @} */

///////////////////////////////////////////////////////////////////////////////

/**
 * @addtogroup parser-group
 * @{
 */

/**
 * Inherited attributes.
 *
 * @remarks These are grouped into a `struct` (rather than having them as
 * separate global variables) so that they can all be reset (mostly) via a
 * single assignment from `{0}`.
 *
 * @sa ia_cleanup()
 */
struct in_attr {
  c_alignas_t     align;            ///< Alignment, if any.
  unsigned        ast_depth;        ///< Parentheses nesting depth.
  bool            is_typename;      ///< C++ only: is `typename` specified?
  c_sname_t       scope_sname;      ///< C++ only: current scope name, if any.

  /**
   * Type AST stack.
   *
   * @sa ia_type_ast_peek()
   * @sa ia_type_ast_pop()
   * @sa ia_type_ast_push()
   */
  c_ast_list_t    type_ast_stack;

  /**
   * Declaration type specifier AST.
   *
   * @remarks A C/C++ declaration is of the form:
   *
   *      type-specifier declarator+
   *
   * where one or more declarators all have the same base type, e.g.:
   *
   *      int i, *p, a[2], f(double);
   *
   * This is a pointer to the base type AST (above, `int`) that is duplicated
   * for each declarator.  It's set by the first call to ia_type_ast_push().
   *
   * @sa ia_type_spec_ast()
   */
  c_ast_t const  *type_spec_ast;

  /**
   * Red-black node for temporary `typedef`.
   *
   * @remarks This is used only in the `pc99_func_or_constructor_declaration_c`
   * grammar production. It's needed because a temporary `typedef` needs to be
   * created in a mid-rule action then removed in the end-rule action and
   * there's no way to pass local variables between Bison actions, so it's
   * passed via an inherited attribute.
   */
  rb_node_t      *tdef_rb;
};
typedef struct in_attr in_attr_t;

// local functions
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const*, int, dym_kind_t, char const*,
                                ... );
PJL_DISCARD
static bool print_error_token( char const* );

// local variables
static c_ast_list_t   gc_ast_list;      ///< c_ast nodes freed after parse.
static in_attr_t      in_attr;          ///< Inherited attributes.
static c_ast_list_t   typedef_ast_list; ///< List of ASTs for `typedef`s.

////////// inline functions ///////////////////////////////////////////////////

/**
 * Duplicates \a ast and adds it to \ref gc_ast_list.
 *
 * @param ast The AST to duplicate.
 * @return Returns the duplicated AST.
 *
 * @sa c_ast_new_gc()
 */
static inline c_ast_t* c_ast_dup_gc( c_ast_t const *ast ) {
  return c_ast_dup( ast, &gc_ast_list );
}

/**
 * Garbage-collects the AST nodes on \a ast_list but does _not_ free \a
 * ast_list itself.
 *
 * @param ast_list The AST list to free the nodes of.
 *
 * @sa c_ast_list_cleanup()
 * @sa c_ast_dup_gc()
 * @sa c_ast_new_gc()
 * @sa c_ast_pair_new_gc()
 */
static inline void c_ast_list_cleanup_gc( c_ast_list_t *ast_list ) {
  slist_cleanup( ast_list, POINTER_CAST( slist_free_fn_t, &c_ast_free ) );
}

/**
 * Creates a new AST and adds it to \ref gc_ast_list.
 *
 * @param kind The kind of AST to create.
 * @param loc A pointer to the token location data.
 * @return Returns a pointer to a new AST.
 *
 * @sa c_ast_dup_gc()
 * @sa c_ast_pair_new_gc()
 */
NODISCARD
static inline c_ast_t* c_ast_new_gc( c_ast_kind_t kind, c_loc_t const *loc ) {
  return c_ast_new( kind, in_attr.ast_depth, loc, &gc_ast_list );
}

/**
 * Set our mode to deciphering gibberish into English.
 */
static inline void gibberish_to_english( void ) {
  lexer_find &= ~LEXER_FIND_CDECL_KEYWORDS;
}

/**
 * Peeks at the type AST at the top of the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_pop()
 * @sa ia_type_ast_push()
 */
NODISCARD
static inline c_ast_t* ia_type_ast_peek( void ) {
  return slist_front( &in_attr.type_ast_stack );
}

/**
 * Pops a type AST from the
 * \ref in_attr.type_ast_stack "type AST inherited attribute stack".
 *
 * @return Returns said AST.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_push()
 */
PJL_DISCARD
static inline c_ast_t* ia_type_ast_pop( void ) {
  return slist_pop_front( &in_attr.type_ast_stack );
}

/**
 * Pushes a type AST onto the
 * \ref in_attr.type_ast_stack "type AST inherited attribute  stack".
 *
 * @remarks Additionally, if \a ast is #K_BUILTIN and \ref
 * in_attr::type_spec_ast "type_spec_ast" is NULL, sets \ref
 * in_attr::type_spec_ast "type_spec_ast" to \a ast.
 *
 * @param ast The AST to push.
 *
 * @sa ia_type_ast_peek()
 * @sa ia_type_ast_pop()
 */
static inline void ia_type_ast_push( c_ast_t *ast ) {
  slist_push_front( &in_attr.type_ast_stack, ast );
  if ( in_attr.type_spec_ast == NULL && ast->kind == K_BUILTIN )
    in_attr.type_spec_ast = ast;
}

/**
 * Given an AST for a type that is the "of type", return type, or "to type" of
 * a declaration, returns a duplicate of \a type_ast if necessary.
 *
 * @param type_ast The AST of a type.
 * @return If \a type_ast `==` \ref in_attr::type_spec_ast "type_spec_ast",
 * returns a duplicate of \a type_ast; otherwise returns \a type_ast.
 *
 * @sa \ref in_attr::type_spec_ast
 */
NODISCARD
static inline c_ast_t* ia_type_spec_ast( c_ast_t *type_ast ) {
  // Yes, == is correct here: we mean the same AST node.
  return type_ast == in_attr.type_spec_ast ?
    c_ast_dup_gc( type_ast ) : type_ast;
}

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints a warning that the attribute \a keyword syntax is not supported (and
 * ignored).
 *
 * @param keyword The attribute syntax keyword, e.g., `__attribute__` or
 * `__declspec`.
 * @param keyword_loc The source location of \a keyword.
 */
static void attr_syntax_not_supported( char const *keyword,
                                       c_loc_t const *keyword_loc ) {
  assert( keyword != NULL );
  assert( keyword_loc != NULL );

  print_warning( keyword_loc,
    "\"%s\" not supported by " CDECL " (ignoring)", keyword
  );
  if ( OPT_LANG_IS( ATTRIBUTES ) )
    print_hint( "%s...%s", other_token_c( "[[" ), other_token_c( "]]" ) );
  else
    EPUTC( '\n' );
}

/**
 * A predicate function for slist_free_if() that checks whether \a ast is one
 * that can be garbage collected: if so, c_ast_free()s it.
 *
 * @param ast_node The \ref slist_node pointing to the AST to check.
 * @param data Contains the AST of the type being declared.
 * @return Returns `true` only if \a ast should be removed from the list.
 */
NODISCARD
static bool c_ast_free_if_garbage( slist_node_t *ast_node, void *data ) {
  assert( ast_node != NULL );
  c_ast_t *const ast = ast_node->data;
  assert( ast != NULL );
  c_ast_t const *const type_ast = data;
  assert( type_ast != NULL );

  if ( ast == type_ast || !c_ast_is_orphan( ast ) ) {
    assert( ast->kind != K_PLACEHOLDER );
    return false;
  }

  // We also need to ensure the AST isn't in the type_ast_stack.
  FOREACH_SLIST_NODE( type_node, &in_attr.type_ast_stack ) {
    c_ast_t const *const stack_type_ast = type_node->data;
    if ( ast == stack_type_ast )
      return false;
  } // for

  c_ast_free( ast );
  return true;
}

/**
 * Checks whether `typename` is OK since the type's name is a qualified name.
 *
 * @param ast The AST to check.
 * @return Returns `true` only upon success.
 */
NODISCARD
bool c_ast_is_typename_ok( c_ast_t const *ast ) {
  c_ast_t const *const raw_ast = c_ast_untypedef( ast );
  if ( c_sname_count( &raw_ast->sname ) < 2 ) {
    print_error( &ast->loc, "qualified name expected after \"typename\"\n" );
    return false;
  }
  return true;
}

/**
 * If \a bit_width is &gt; 0 and \a ast is an integral type, sets \a ast's \ref
 * c_bit_field_ast::bit_width "bit_width" to \a bit_width.
 *
 * @remarks This check has to be done now in the parser rather than later in
 * the AST since we need to use the \ref c_ast::bit_field `union` member now.
 *
 * @param ast The AST whose \ref c_bit_field_ast::bit_width "bit_width" to
 * possibly set.
 * @param bit_width The bit-field width.
 * @return Returns `true` only if \a bit_width is &gt; 0 and \a ast if an
 * integral type.
 */
NODISCARD
static bool c_ast_set_bit_field_width( c_ast_t *ast, unsigned bit_width ) {
  assert( ast != NULL );

  if ( bit_width > 0 ) {
    if ( !c_ast_is_integral( ast ) ) {
      print_error( &ast->loc, "invalid bit-field type " );
      print_ast_type_aka( ast, stderr );
      EPRINTF( "; must be an integral %stype\n",
        OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
      );
      return false;
    }
    ast->bit_field.bit_width = bit_width;
  }

  return true;
}

/**
 * Defines a type by adding it to the global set.
 *
 * @param type_ast The AST of the type to define.
 * @param decl_flags The declaration flags to use; must only be one of
 * #C_ENG_DECL, #C_GIB_TYPEDEF, or #C_GIB_USING.
 * @return Returns `true` either if the type was defined or it's equivalent to
 * an existing type; `false` if a different type already exists having the same
 * name.
 */
NODISCARD
static bool define_type( c_ast_t const *type_ast, unsigned decl_flags ) {
  assert( type_ast != NULL );
  assert( is_1_bit_only_in_set( decl_flags, C_TYPE_DECL_ANY ) );

  c_ast_t const *const leaf_ast = c_ast_leaf( type_ast );
  if ( c_ast_is_tid_any( leaf_ast, TB_auto ) ) {
    print_error( &leaf_ast->loc,
      "\"%s\" illegal in type definition\n",
      c_type_name_error( &leaf_ast->type )
    );
    return false;
  }

  c_typedef_t *const tdef = c_typedef_add( type_ast, decl_flags )->data;

  if ( tdef->ast == type_ast ) {
    //
    // Type was added: we have to move the AST from the gc_ast_list so it won't
    // be garbage collected at the end of the parse to a separate
    // typedef_ast_list that's freed only at program termination.
    //
    // But first, garbage collect all orphaned AST nodes.  (For a non-type-
    // defining parse, this step isn't necessary since all nodes are freed at
    // the end of the parse anyway.)
    //
    slist_free_if(
      &gc_ast_list,
      &c_ast_free_if_garbage,
      CONST_CAST( void*, type_ast )
    );
    slist_push_list_back( &typedef_ast_list, &gc_ast_list );
    return true;
  }

  //
  // Type was NOT added because a previously declared type having the same name
  // was returned: check if the types are equal.
  //
  // In C, multiple typedef declarations having the same name are allowed only
  // if the types are equivalent:
  //
  //      typedef int T;
  //      typedef int T;                // OK
  //      typedef double T;             // error: types aren't equivalent
  //
  if ( c_ast_equal( type_ast, tdef->ast ) ) {
    // Update the language(s) the type is available in to include opt_lang_id.
    if ( opt_lang_id < c_lang_oldest( tdef->lang_ids ) )
      tdef->lang_ids = c_lang_and_newer( opt_lang_id );
    return true;
  }

  if ( tdef->is_predefined ) {
    print_error( &type_ast->loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_full_name( &type_ast->sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    print_error( &type_ast->loc, "type " );
    print_ast_type_aka( type_ast, stderr );
    EPUTS( " redefinition incompatible with original type \"" );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return false;
}

/**
 * Checks whether \a sname is a type.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param sname The scoped name to check.
 * @param loc The location of \a sname.
 * @return Returns `true` only if \a sname is a type (and prints an error
 * message); otherwise `false` (and does nothing).
 */
static bool fl_sname_is_type( char const *file, int line,
                              c_sname_t const *sname, c_loc_t const *loc ) {
  assert( sname != NULL );
  assert( loc != NULL );

  c_typedef_t const *const tdef = c_typedef_find_sname( sname );
  if ( tdef == NULL )
    return false;

  if ( tdef->is_predefined ) {
    fl_print_error( file, line, loc,
      "\"%s\" is a predefined type starting in %s\n",
      c_sname_full_name( sname ),
      c_lang_name( c_lang_oldest( tdef->lang_ids ) )
    );
  } else {
    fl_print_error( file, line, loc,
      "\"%s\": previously declared as type \"",
      c_sname_full_name( sname )
    );
    print_type_ast( tdef, stderr );
    EPUTS( "\"\n" );
  }

  return true;
}

/**
 * Checks whether the type currently being declared (`enum`, `struct`,
 * `typedef`, or `union`) is nested within some other type (`struct` or
 * `union`) and whether the current language is C: if not, prints an error
 * message.
 *
 * @note It is unnecessary to check either when a `class` is being declared or
 * when a type is being declared within a `namespace` since those are not legal
 * in C anyway.
 *
 * @note This function isn't normally called directly; use the
 * #is_nested_type_ok() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param type_loc The location of the type declaration.
 * @return Returns `true` only if the type currently being declared is either
 * not nested or the current language is C++.
 */
NODISCARD
static bool fl_is_nested_type_ok( char const *file, int line,
                                  c_loc_t const *type_loc ) {
  assert( type_loc != NULL );
  if ( !c_sname_empty( &in_attr.scope_sname ) &&
       !OPT_LANG_IS( NESTED_TYPES ) ) {
    fl_print_error( file, line, type_loc,
      "nested types not supported%s\n",
      C_LANG_WHICH( NESTED_TYPES )
    );
    return false;
  }
  return true;
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages where a C/C++ keyword is expected, but that keyword isn't a keyword
 * either until a later version of the language or in a different language;
 * hence, the lexer will return the keyword as the `Y_NAME` token instead of
 * the keyword token.
 *
 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command when the current language is C, you'd get the following:
 * ```
 * declare f as virtual function returning void
 *              ^
 * 14: syntax error: "virtual": "virtual" expected; not a keyword until C++98
 * ```
 * because it's really this:
 * ```
 * ... "virtual" [the name]": "virtual" [the token] expected ...
 * ```
 * and that looks odd.
 *
 * @note This function isn't normally called directly; use the
 * #keyword_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param keyword A keyword literal.
 *
 * @sa fl_elaborate_error()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
static void fl_keyword_expected( char const *file, int line,
                                 char const *keyword ) {
  assert( keyword != NULL );

  dym_kind_t dym_kinds = DYM_NONE;

  char const *const error_token = lexer_printable_token();
  if ( error_token != NULL ) {
    if ( strcmp( error_token, keyword ) == 0 ) {
      //
      // The error token is the expected keyword which means the lexer returned
      // it as a name and not the token which likely means it's not a C/C++
      // keyword until a later version of the current language.
      //
      c_keyword_t const *const ck =
        c_keyword_find( keyword, LANG_ANY, C_KW_CTX_DEFAULT );
      if ( ck != NULL ) {
        char const *const which_lang = c_lang_which( ck->lang_ids );
        if ( which_lang[0] != '\0' ) {
          EPUTS( ": " );
          print_debug_file_line( file, line );
          EPRINTF( "\"%s\" not supported%s\n", keyword, which_lang );
          return;
        }
      }
    }

    dym_kinds = is_english_to_gibberish() ? DYM_CDECL_KEYWORDS : DYM_C_KEYWORDS;
  }

  fl_elaborate_error( file, line, dym_kinds, "\"%s\" expected", keyword );
}

/**
 * A special case of fl_elaborate_error() that prevents oddly worded error
 * messages when a punctuation character is expected by not doing keyword look-
 * ups of the error token.

 * For example, if fl_elaborate_error() were used for the following \b cdecl
 * command, you'd get the following:
 * ```
 * explain void f(int g const)
 *                      ^
 * 29: syntax error: "const": ',' expected ("const" is a keyword)
 * ```
 * and that looks odd since, if a punctuation character was expected, it seems
 * silly to point out that the encountered token is a keyword.
 *
 * @note This function isn't normally called directly; use the
 * #punct_expected() macro instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param punct The punctuation character that was expected.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa yyerror()
 */
static void fl_punct_expected( char const *file, int line, char punct ) {
  EPUTS( ": " );
  print_debug_file_line( file, line );
  if ( print_error_token( lexer_printable_token() ) )
    EPUTS( ": " );
  EPRINTF( "'%c' expected\n", punct );
}

/**
 * Cleans-up all resources used by \ref in_attr "inherited attributes".
 */
static void ia_cleanup( void ) {
  c_sname_cleanup( &in_attr.scope_sname );
  // Do _not_ pass &c_ast_free for the 2nd argument! All AST nodes were already
  // free'd from the gc_ast_list in parse_cleanup(). Just free the slist nodes.
  slist_cleanup( &in_attr.type_ast_stack, /*free_fn=*/NULL );
  in_attr = (in_attr_t){ 0 };
}

/**
 * Joins \a type_ast and \a decl_ast into a single AST.
 *
 * @param type_ast The type AST.
 * @param decl_ast The declaration AST.
 * @return Returns the joined AST on success or NULL on error.
 */
NODISCARD
c_ast_t* join_type_decl( c_ast_t *type_ast, c_ast_t *decl_ast ) {
  assert( type_ast != NULL );
  assert( decl_ast != NULL );

  if ( in_attr.is_typename && !c_ast_is_typename_ok( type_ast ) )
    return NULL;

  c_type_t type = c_ast_take_type_any( type_ast, &T_TS_typedef );

  if ( c_tid_is_any( type.stids, TS_typedef ) && decl_ast->kind == K_TYPEDEF ) {
    //
    // This is for a case like:
    //
    //      explain typedef int int32_t;
    //
    // that is: explaining an existing typedef.  In order to do that, we have
    // to un-typedef it so we explain the type that it's a typedef for.
    //
    c_ast_t const *const raw_decl_ast = c_ast_untypedef( decl_ast );

    //
    // However, we also have to check whether the typedef being explained is
    // not equivalent to the existing typedef.  This is for a case like:
    //
    //      explain typedef char int32_t;
    //
    if ( !c_ast_equal( type_ast, raw_decl_ast ) ) {
      print_error( &decl_ast->loc, "type " );
      print_ast_type_aka( type_ast, stderr );
      EPUTS( " redefinition incompatible with original type " );
      print_ast_type_aka( decl_ast, stderr );
      EPUTC( '\n' );
      return NULL;
    }

    //
    // Because the raw_decl_ast for the existing type is about to be combined
    // with type_ast, duplicate raw_decl_ast first.
    //
    decl_ast = c_ast_dup_gc( raw_decl_ast );
  }

  c_ast_t *const ast = c_ast_patch_placeholder( type_ast, decl_ast );
  c_type_t const tdef_type = c_ast_take_type_any( ast, &T_TS_typedef );
  c_type_or_eq( &type, &tdef_type );
  c_type_or_eq( &ast->type, &type );

  if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
    ast->align = in_attr.align;
    if ( c_tid_is_any( type.stids, TS_typedef ) ) {
      //
      // We check for illegal aligned typedef here rather than in c_ast_check.c
      // because the "typedef-ness" needed to be removed previously before the
      // eventual call to c_ast_check().
      //
      print_error( &ast->align.loc, "typedef can not be aligned\n" );
      return NULL;
    }
  }

  if ( ast->kind == K_UDEF_CONV &&
       c_sname_local_type( &ast->sname )->btids == TB_SCOPE ) {
    //
    // User-defined conversions don't have names, but they can still have a
    // scope.  Since only classes can have them, if the scope is still
    // TB_SCOPE, change it to TB_class.
    //
    c_sname_set_local_type( &ast->sname, &C_TYPE_LIT_B( TB_class ) );
  }

  return ast;
}

/**
 * Cleans up individial parse data after each parse.
 *
 * @param fatal_error Must be `true` only if a fatal semantic error has
 * occurred and `YYABORT` is about to be called to bail out of parsing by
 * returning from yyparse().
 */
static void parse_cleanup( bool fatal_error ) {
  //
  // We need to reset the lexer differently depending on whether we completed a
  // parse with a fatal error.  If so, do a "hard" reset that also resets the
  // EOF flag of the lexer.
  //
  lexer_reset( /*hard_reset=*/fatal_error );

  c_ast_list_cleanup_gc( &gc_ast_list );
  ia_cleanup();
}

/**
 * Creates a new \ref p_token_list_t containing a single #P_PLACEMARKER token.
 *
 * @return Returns said list.
 */
NODISCARD
static p_token_list_t* p_token_list_new_placemarker( void ) {
  p_token_list_t *const rv_tokens = MALLOC( p_token_list_t, 1 );
  slist_init( rv_tokens );
  slist_push_back( rv_tokens, p_token_new( P_PLACEMARKER, /*literal=*/NULL ) );
  return rv_tokens;
}

/**
 * Called by Bison to print a parsing error message to standard error.
 *
 * @remarks A custom error printing function via `%%define parse.error custom`
 * and
 * [`yyreport_syntax_error()`](https://www.gnu.org/software/bison/manual/html_node/Syntax-Error-Reporting-Function.html)
 * is not done because printing a (perhaps long) list of all the possible
 * expected tokens isn't helpful.
 * @par
 * It's also more flexible to be able to call one of #elaborate_error(),
 * #keyword_expected(), or #punct_expected() at the point of the error rather
 * than having a single function try to figure out the best type of error
 * message to print.
 *
 * @note A newline is _not_ printed since the error message will be appended to
 * by fl_elaborate_error().  For example, the parts of an error message are
 * printed by the functions shown:
 *
 *      42: syntax error: "int": "into" expected
 *      |--||----------||----------------------|
 *      |   |           |
 *      |   yyerror()   fl_elaborate_error()
 *      |
 *      print_loc()
 *
 * @param msg The error message to print.  Bison invariably passes `syntax
 * error`.
 *
 * @sa fl_elaborate_error()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa print_loc()
 */
static void yyerror( char const *msg ) {
  assert( msg != NULL );

  c_loc_t const loc = lexer_loc();
  print_loc( &loc );

  color_start( stderr, sgr_error );
  EPUTS( msg );                         // no newline
  color_end( stderr, sgr_error );

  //
  // A syntax error has occurred, but syntax errors aren't fatal since Bison
  // tries to recover.  We'll clean-up the current parse, but YYABORT won't be
  // called so we won't bail out of parsing by returning from yyparse(); hence,
  // parsing will continue.
  //
  parse_cleanup( /*fatal_error=*/false );
}

/** @} */

///////////////////////////////////////////////////////////////////////////////

/// @cond DOXYGEN_IGNORE


#line 1300 "parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include  "parser.h" 
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_Y_cast = 3,                     /* Y_cast  */
  YYSYMBOL_Y_const_ENG = 4,                /* Y_const_ENG  */
  YYSYMBOL_Y_declare = 5,                  /* Y_declare  */
  YYSYMBOL_Y_define = 6,                   /* Y_define  */
  YYSYMBOL_Y_dynamic = 7,                  /* Y_dynamic  */
  YYSYMBOL_Y_explain = 8,                  /* Y_explain  */
  YYSYMBOL_Y_no = 9,                       /* Y_no  */
  YYSYMBOL_Y_quit = 10,                    /* Y_quit  */
  YYSYMBOL_Y_reinterpret = 11,             /* Y_reinterpret  */
  YYSYMBOL_Y_set = 12,                     /* Y_set  */
  YYSYMBOL_Y_show = 13,                    /* Y_show  */
  YYSYMBOL_Y_aligned = 14,                 /* Y_aligned  */
  YYSYMBOL_Y_all = 15,                     /* Y_all  */
  YYSYMBOL_Y_array = 16,                   /* Y_array  */
  YYSYMBOL_Y_as = 17,                      /* Y_as  */
  YYSYMBOL_Y_bit = 18,                     /* Y_bit  */
  YYSYMBOL_Y_bit_precise = 19,             /* Y_bit_precise  */
  YYSYMBOL_Y_bits = 20,                    /* Y_bits  */
  YYSYMBOL_Y_by = 21,                      /* Y_by  */
  YYSYMBOL_Y_bytes = 22,                   /* Y_bytes  */
  YYSYMBOL_Y_capturing = 23,               /* Y_capturing  */
  YYSYMBOL_Y_commands = 24,                /* Y_commands  */
  YYSYMBOL_Y_constructor = 25,             /* Y_constructor  */
  YYSYMBOL_Y_conversion = 26,              /* Y_conversion  */
  YYSYMBOL_Y_copy = 27,                    /* Y_copy  */
  YYSYMBOL_Y_defined = 28,                 /* Y_defined  */
  YYSYMBOL_Y_destructor = 29,              /* Y_destructor  */
  YYSYMBOL_Y_english = 30,                 /* Y_english  */
  YYSYMBOL_Y_evaluation = 31,              /* Y_evaluation  */
  YYSYMBOL_Y_expand = 32,                  /* Y_expand  */
  YYSYMBOL_Y_expression = 33,              /* Y_expression  */
  YYSYMBOL_Y_floating = 34,                /* Y_floating  */
  YYSYMBOL_Y_function = 35,                /* Y_function  */
  YYSYMBOL_Y_initialization = 36,          /* Y_initialization  */
  YYSYMBOL_Y_into = 37,                    /* Y_into  */
  YYSYMBOL_Y_lambda = 38,                  /* Y_lambda  */
  YYSYMBOL_Y_length = 39,                  /* Y_length  */
  YYSYMBOL_Y_linkage = 40,                 /* Y_linkage  */
  YYSYMBOL_Y_literal = 41,                 /* Y_literal  */
  YYSYMBOL_Y_macros = 42,                  /* Y_macros  */
  YYSYMBOL_Y_member = 43,                  /* Y_member  */
  YYSYMBOL_Y_non_empty = 44,               /* Y_non_empty  */
  YYSYMBOL_Y_non_member = 45,              /* Y_non_member  */
  YYSYMBOL_Y_of = 46,                      /* Y_of  */
  YYSYMBOL_Y_options = 47,                 /* Y_options  */
  YYSYMBOL_Y_point = 48,                   /* Y_point  */
  YYSYMBOL_Y_pointer = 49,                 /* Y_pointer  */
  YYSYMBOL_Y_precise = 50,                 /* Y_precise  */
  YYSYMBOL_Y_precision = 51,               /* Y_precision  */
  YYSYMBOL_Y_predefined = 52,              /* Y_predefined  */
  YYSYMBOL_Y_pure = 53,                    /* Y_pure  */
  YYSYMBOL_Y_reference = 54,               /* Y_reference  */
  YYSYMBOL_Y_returning = 55,               /* Y_returning  */
  YYSYMBOL_Y_rvalue = 56,                  /* Y_rvalue  */
  YYSYMBOL_Y_scope = 57,                   /* Y_scope  */
  YYSYMBOL_Y_to = 58,                      /* Y_to  */
  YYSYMBOL_Y_user = 59,                    /* Y_user  */
  YYSYMBOL_Y_user_defined = 60,            /* Y_user_defined  */
  YYSYMBOL_Y_variable = 61,                /* Y_variable  */
  YYSYMBOL_Y_wide = 62,                    /* Y_wide  */
  YYSYMBOL_Y_width = 63,                   /* Y_width  */
  YYSYMBOL_Y_PREC_LESS_THAN_upc_layout_qualifier = 64, /* Y_PREC_LESS_THAN_upc_layout_qualifier  */
  YYSYMBOL_Y_COLON_COLON = 65,             /* Y_COLON_COLON  */
  YYSYMBOL_66_ = 66,                       /* "::"  */
  YYSYMBOL_Y_COLON_COLON_STAR = 67,        /* Y_COLON_COLON_STAR  */
  YYSYMBOL_Y_PLUS_PLUS = 68,               /* "++"  */
  YYSYMBOL_Y_MINUS_MINUS = 69,             /* "--"  */
  YYSYMBOL_70_ = 70,                       /* '('  */
  YYSYMBOL_71_ = 71,                       /* ')'  */
  YYSYMBOL_72_ = 72,                       /* '['  */
  YYSYMBOL_73_ = 73,                       /* ']'  */
  YYSYMBOL_74_ = 74,                       /* '.'  */
  YYSYMBOL_Y_MINUS_GREATER = 75,           /* Y_MINUS_GREATER  */
  YYSYMBOL_76_ = 76,                       /* "->"  */
  YYSYMBOL_77_ = 77,                       /* '&'  */
  YYSYMBOL_78_ = 78,                       /* '*'  */
  YYSYMBOL_79_ = 79,                       /* '!'  */
  YYSYMBOL_Y_sizeof = 80,                  /* Y_sizeof  */
  YYSYMBOL_81_ = 81,                       /* '~'  */
  YYSYMBOL_Y_DOT_STAR = 82,                /* Y_DOT_STAR  */
  YYSYMBOL_83_ = 83,                       /* ".*"  */
  YYSYMBOL_Y_MINUS_GREATER_STAR = 84,      /* Y_MINUS_GREATER_STAR  */
  YYSYMBOL_85_ = 85,                       /* "->*"  */
  YYSYMBOL_86_ = 86,                       /* '/'  */
  YYSYMBOL_87_ = 87,                       /* '%'  */
  YYSYMBOL_88_ = 88,                       /* '-'  */
  YYSYMBOL_89_ = 89,                       /* '+'  */
  YYSYMBOL_Y_LESS_LESS = 90,               /* Y_LESS_LESS  */
  YYSYMBOL_91_ = 91,                       /* "<<"  */
  YYSYMBOL_Y_GREATER_GREATER = 92,         /* Y_GREATER_GREATER  */
  YYSYMBOL_93_ = 93,                       /* ">>"  */
  YYSYMBOL_Y_LESS_EQUAL_GREATER = 94,      /* Y_LESS_EQUAL_GREATER  */
  YYSYMBOL_95_ = 95,                       /* "<=>"  */
  YYSYMBOL_96_ = 96,                       /* '<'  */
  YYSYMBOL_97_ = 97,                       /* '>'  */
  YYSYMBOL_Y_LESS_EQUAL = 98,              /* Y_LESS_EQUAL  */
  YYSYMBOL_99_ = 99,                       /* "<="  */
  YYSYMBOL_Y_GREATER_EQUAL = 100,          /* Y_GREATER_EQUAL  */
  YYSYMBOL_101_ = 101,                     /* ">="  */
  YYSYMBOL_Y_EQUAL_EQUAL = 102,            /* Y_EQUAL_EQUAL  */
  YYSYMBOL_103_ = 103,                     /* "=="  */
  YYSYMBOL_Y_EXCLAM_EQUAL = 104,           /* Y_EXCLAM_EQUAL  */
  YYSYMBOL_Y_bit_and = 105,                /* Y_bit_and  */
  YYSYMBOL_106_ = 106,                     /* '^'  */
  YYSYMBOL_107_ = 107,                     /* '|'  */
  YYSYMBOL_Y_AMPER_AMPER = 108,            /* Y_AMPER_AMPER  */
  YYSYMBOL_Y_PIPE_PIPE = 109,              /* Y_PIPE_PIPE  */
  YYSYMBOL_Y_QMARK_COLON = 110,            /* Y_QMARK_COLON  */
  YYSYMBOL_111_ = 111,                     /* "?:"  */
  YYSYMBOL_112_ = 112,                     /* '='  */
  YYSYMBOL_Y_PERCENT_EQUAL = 113,          /* Y_PERCENT_EQUAL  */
  YYSYMBOL_114_ = 114,                     /* "%="  */
  YYSYMBOL_Y_AMPER_EQUAL = 115,            /* Y_AMPER_EQUAL  */
  YYSYMBOL_Y_STAR_EQUAL = 116,             /* Y_STAR_EQUAL  */
  YYSYMBOL_117_ = 117,                     /* "*="  */
  YYSYMBOL_Y_PLUS_EQUAL = 118,             /* Y_PLUS_EQUAL  */
  YYSYMBOL_119_ = 119,                     /* "+="  */
  YYSYMBOL_Y_MINUS_EQUAL = 120,            /* Y_MINUS_EQUAL  */
  YYSYMBOL_121_ = 121,                     /* "-="  */
  YYSYMBOL_Y_SLASH_EQUAL = 122,            /* Y_SLASH_EQUAL  */
  YYSYMBOL_123_ = 123,                     /* "/="  */
  YYSYMBOL_Y_LESS_LESS_EQUAL = 124,        /* Y_LESS_LESS_EQUAL  */
  YYSYMBOL_125_ = 125,                     /* "<<="  */
  YYSYMBOL_Y_GREATER_GREATER_EQUAL = 126,  /* Y_GREATER_GREATER_EQUAL  */
  YYSYMBOL_127_ = 127,                     /* ">>="  */
  YYSYMBOL_Y_CARET_EQUAL = 128,            /* Y_CARET_EQUAL  */
  YYSYMBOL_Y_PIPE_EQUAL = 129,             /* Y_PIPE_EQUAL  */
  YYSYMBOL_130_ = 130,                     /* ','  */
  YYSYMBOL_Y_auto_STORAGE = 131,           /* Y_auto_STORAGE  */
  YYSYMBOL_Y_break = 132,                  /* Y_break  */
  YYSYMBOL_Y_case = 133,                   /* Y_case  */
  YYSYMBOL_Y_char = 134,                   /* Y_char  */
  YYSYMBOL_Y_continue = 135,               /* Y_continue  */
  YYSYMBOL_Y_default = 136,                /* Y_default  */
  YYSYMBOL_Y_do = 137,                     /* Y_do  */
  YYSYMBOL_Y_double = 138,                 /* Y_double  */
  YYSYMBOL_Y_else = 139,                   /* Y_else  */
  YYSYMBOL_Y_extern = 140,                 /* Y_extern  */
  YYSYMBOL_Y_float = 141,                  /* Y_float  */
  YYSYMBOL_Y_for = 142,                    /* Y_for  */
  YYSYMBOL_Y_goto = 143,                   /* Y_goto  */
  YYSYMBOL_Y_if = 144,                     /* Y_if  */
  YYSYMBOL_Y_int = 145,                    /* Y_int  */
  YYSYMBOL_Y_long = 146,                   /* Y_long  */
  YYSYMBOL_Y_register = 147,               /* Y_register  */
  YYSYMBOL_Y_return = 148,                 /* Y_return  */
  YYSYMBOL_Y_short = 149,                  /* Y_short  */
  YYSYMBOL_Y_static = 150,                 /* Y_static  */
  YYSYMBOL_Y_struct = 151,                 /* Y_struct  */
  YYSYMBOL_Y_switch = 152,                 /* Y_switch  */
  YYSYMBOL_Y_typedef = 153,                /* Y_typedef  */
  YYSYMBOL_Y_union = 154,                  /* Y_union  */
  YYSYMBOL_Y_unsigned = 155,               /* Y_unsigned  */
  YYSYMBOL_Y_while = 156,                  /* Y_while  */
  YYSYMBOL_157_ = 157,                     /* '#'  */
  YYSYMBOL_Y_PRE_CONCAT = 158,             /* "##"  */
  YYSYMBOL_Y_PRE_SPACE = 159,              /* Y_PRE_SPACE  */
  YYSYMBOL_Y_PRE_define = 160,             /* Y_PRE_define  */
  YYSYMBOL_Y_PRE_elif = 161,               /* Y_PRE_elif  */
  YYSYMBOL_Y_PRE_else = 162,               /* Y_PRE_else  */
  YYSYMBOL_Y_PRE_error = 163,              /* Y_PRE_error  */
  YYSYMBOL_Y_PRE_if = 164,                 /* Y_PRE_if  */
  YYSYMBOL_Y_PRE_ifdef = 165,              /* Y_PRE_ifdef  */
  YYSYMBOL_Y_PRE_ifndef = 166,             /* Y_PRE_ifndef  */
  YYSYMBOL_Y_PRE_line = 167,               /* Y_PRE_line  */
  YYSYMBOL_Y_PRE_undef = 168,              /* Y_PRE_undef  */
  YYSYMBOL_Y_PRE___VA_ARGS__ = 169,        /* Y_PRE___VA_ARGS__  */
  YYSYMBOL_Y_PRE___VA_OPT__ = 170,         /* Y_PRE___VA_OPT__  */
  YYSYMBOL_Y_PRE_pragma = 171,             /* Y_PRE_pragma  */
  YYSYMBOL_Y_PRE_elifdef = 172,            /* Y_PRE_elifdef  */
  YYSYMBOL_Y_PRE_elifndef = 173,           /* Y_PRE_elifndef  */
  YYSYMBOL_Y_PRE_embed = 174,              /* Y_PRE_embed  */
  YYSYMBOL_Y_PRE_warning = 175,            /* Y_PRE_warning  */
  YYSYMBOL_Y_asm = 176,                    /* Y_asm  */
  YYSYMBOL_Y_const = 177,                  /* Y_const  */
  YYSYMBOL_Y_DOT_DOT_DOT = 178,            /* "..."  */
  YYSYMBOL_Y_enum = 179,                   /* Y_enum  */
  YYSYMBOL_Y_signed = 180,                 /* Y_signed  */
  YYSYMBOL_Y_void = 181,                   /* Y_void  */
  YYSYMBOL_Y_volatile = 182,               /* Y_volatile  */
  YYSYMBOL_Y_wchar_t = 183,                /* Y_wchar_t  */
  YYSYMBOL_Y__Bool = 184,                  /* Y__Bool  */
  YYSYMBOL_Y__Complex = 185,               /* Y__Complex  */
  YYSYMBOL_Y__Imaginary = 186,             /* Y__Imaginary  */
  YYSYMBOL_Y_inline = 187,                 /* Y_inline  */
  YYSYMBOL_Y_restrict = 188,               /* Y_restrict  */
  YYSYMBOL_Y__Alignas = 189,               /* Y__Alignas  */
  YYSYMBOL_Y__Alignof = 190,               /* Y__Alignof  */
  YYSYMBOL_Y__Atomic_QUAL = 191,           /* Y__Atomic_QUAL  */
  YYSYMBOL_Y__Atomic_SPEC = 192,           /* Y__Atomic_SPEC  */
  YYSYMBOL_Y__Generic = 193,               /* Y__Generic  */
  YYSYMBOL_Y__Noreturn = 194,              /* Y__Noreturn  */
  YYSYMBOL_Y__Static_assert = 195,         /* Y__Static_assert  */
  YYSYMBOL_Y__Thread_local = 196,          /* Y__Thread_local  */
  YYSYMBOL_Y_thread = 197,                 /* Y_thread  */
  YYSYMBOL_Y_local = 198,                  /* Y_local  */
  YYSYMBOL_Y_bool = 199,                   /* Y_bool  */
  YYSYMBOL_Y_catch = 200,                  /* Y_catch  */
  YYSYMBOL_Y_class = 201,                  /* Y_class  */
  YYSYMBOL_Y_const_cast = 202,             /* Y_const_cast  */
  YYSYMBOL_Y_CONSTRUCTOR_SNAME = 203,      /* Y_CONSTRUCTOR_SNAME  */
  YYSYMBOL_Y_delete = 204,                 /* Y_delete  */
  YYSYMBOL_Y_DESTRUCTOR_SNAME = 205,       /* Y_DESTRUCTOR_SNAME  */
  YYSYMBOL_Y_dynamic_cast = 206,           /* Y_dynamic_cast  */
  YYSYMBOL_Y_explicit = 207,               /* Y_explicit  */
  YYSYMBOL_Y_false = 208,                  /* Y_false  */
  YYSYMBOL_Y_friend = 209,                 /* Y_friend  */
  YYSYMBOL_Y_mutable = 210,                /* Y_mutable  */
  YYSYMBOL_Y_namespace = 211,              /* Y_namespace  */
  YYSYMBOL_Y_new = 212,                    /* Y_new  */
  YYSYMBOL_Y_operator = 213,               /* Y_operator  */
  YYSYMBOL_Y_OPERATOR_SNAME = 214,         /* Y_OPERATOR_SNAME  */
  YYSYMBOL_Y_private = 215,                /* Y_private  */
  YYSYMBOL_Y_protected = 216,              /* Y_protected  */
  YYSYMBOL_Y_public = 217,                 /* Y_public  */
  YYSYMBOL_Y_reinterpret_cast = 218,       /* Y_reinterpret_cast  */
  YYSYMBOL_Y_static_cast = 219,            /* Y_static_cast  */
  YYSYMBOL_Y_template = 220,               /* Y_template  */
  YYSYMBOL_Y_this = 221,                   /* Y_this  */
  YYSYMBOL_Y_throw = 222,                  /* Y_throw  */
  YYSYMBOL_Y_true = 223,                   /* Y_true  */
  YYSYMBOL_Y_try = 224,                    /* Y_try  */
  YYSYMBOL_Y_typeid = 225,                 /* Y_typeid  */
  YYSYMBOL_Y_typename = 226,               /* Y_typename  */
  YYSYMBOL_Y_using = 227,                  /* Y_using  */
  YYSYMBOL_Y_virtual = 228,                /* Y_virtual  */
  YYSYMBOL_Y_char16_t = 229,               /* Y_char16_t  */
  YYSYMBOL_Y_char32_t = 230,               /* Y_char32_t  */
  YYSYMBOL_Y__BitInt = 231,                /* Y__BitInt  */
  YYSYMBOL_Y_reproducible = 232,           /* Y_reproducible  */
  YYSYMBOL_Y_typeof = 233,                 /* Y_typeof  */
  YYSYMBOL_Y_typeof_unqual = 234,          /* Y_typeof_unqual  */
  YYSYMBOL_Y_unsequenced = 235,            /* Y_unsequenced  */
  YYSYMBOL_Y_ATTR_BEGIN = 236,             /* Y_ATTR_BEGIN  */
  YYSYMBOL_Y_auto_TYPE = 237,              /* Y_auto_TYPE  */
  YYSYMBOL_Y_alignas = 238,                /* Y_alignas  */
  YYSYMBOL_Y_alignof = 239,                /* Y_alignof  */
  YYSYMBOL_Y_carries = 240,                /* Y_carries  */
  YYSYMBOL_Y_dependency = 241,             /* Y_dependency  */
  YYSYMBOL_Y_carries_dependency = 242,     /* Y_carries_dependency  */
  YYSYMBOL_Y_constexpr = 243,              /* Y_constexpr  */
  YYSYMBOL_Y_decltype = 244,               /* Y_decltype  */
  YYSYMBOL_Y_except = 245,                 /* Y_except  */
  YYSYMBOL_Y_final = 246,                  /* Y_final  */
  YYSYMBOL_Y_noexcept = 247,               /* Y_noexcept  */
  YYSYMBOL_Y_nullptr = 248,                /* Y_nullptr  */
  YYSYMBOL_Y_override = 249,               /* Y_override  */
  YYSYMBOL_Y_static_assert = 250,          /* Y_static_assert  */
  YYSYMBOL_Y_thread_local = 251,           /* Y_thread_local  */
  YYSYMBOL_Y_deprecated = 252,             /* Y_deprecated  */
  YYSYMBOL_Y_discard = 253,                /* Y_discard  */
  YYSYMBOL_Y_maybe_unused = 254,           /* Y_maybe_unused  */
  YYSYMBOL_Y_maybe = 255,                  /* Y_maybe  */
  YYSYMBOL_Y_unused = 256,                 /* Y_unused  */
  YYSYMBOL_Y_nodiscard = 257,              /* Y_nodiscard  */
  YYSYMBOL_Y_noreturn = 258,               /* Y_noreturn  */
  YYSYMBOL_Y_char8_t = 259,                /* Y_char8_t  */
  YYSYMBOL_Y_concept = 260,                /* Y_concept  */
  YYSYMBOL_Y_consteval = 261,              /* Y_consteval  */
  YYSYMBOL_Y_constinit = 262,              /* Y_constinit  */
  YYSYMBOL_Y_co_await = 263,               /* Y_co_await  */
  YYSYMBOL_Y_co_return = 264,              /* Y_co_return  */
  YYSYMBOL_Y_co_yield = 265,               /* Y_co_yield  */
  YYSYMBOL_Y_export = 266,                 /* Y_export  */
  YYSYMBOL_Y_no_unique_address = 267,      /* Y_no_unique_address  */
  YYSYMBOL_Y_requires = 268,               /* Y_requires  */
  YYSYMBOL_Y_unique = 269,                 /* Y_unique  */
  YYSYMBOL_Y_address = 270,                /* Y_address  */
  YYSYMBOL_Y_EMC__Accum = 271,             /* Y_EMC__Accum  */
  YYSYMBOL_Y_EMC__Fract = 272,             /* Y_EMC__Fract  */
  YYSYMBOL_Y_EMC__Sat = 273,               /* Y_EMC__Sat  */
  YYSYMBOL_Y_UPC_relaxed = 274,            /* Y_UPC_relaxed  */
  YYSYMBOL_Y_UPC_shared = 275,             /* Y_UPC_shared  */
  YYSYMBOL_Y_UPC_strict = 276,             /* Y_UPC_strict  */
  YYSYMBOL_Y_GNU___attribute__ = 277,      /* Y_GNU___attribute__  */
  YYSYMBOL_Y_GNU___restrict = 278,         /* Y_GNU___restrict  */
  YYSYMBOL_Y_Apple___block = 279,          /* Y_Apple___block  */
  YYSYMBOL_Y_Apple_block = 280,            /* Y_Apple_block  */
  YYSYMBOL_Y_MSC___cdecl = 281,            /* Y_MSC___cdecl  */
  YYSYMBOL_Y_MSC___clrcall = 282,          /* Y_MSC___clrcall  */
  YYSYMBOL_Y_MSC___declspec = 283,         /* Y_MSC___declspec  */
  YYSYMBOL_Y_MSC___fastcall = 284,         /* Y_MSC___fastcall  */
  YYSYMBOL_Y_MSC___stdcall = 285,          /* Y_MSC___stdcall  */
  YYSYMBOL_Y_MSC___thiscall = 286,         /* Y_MSC___thiscall  */
  YYSYMBOL_Y_MSC___vectorcall = 287,       /* Y_MSC___vectorcall  */
  YYSYMBOL_288_ = 288,                     /* ':'  */
  YYSYMBOL_289_ = 289,                     /* ';'  */
  YYSYMBOL_290_ = 290,                     /* '{'  */
  YYSYMBOL_291_ = 291,                     /* '}'  */
  YYSYMBOL_Y_CHAR_LIT = 292,               /* Y_CHAR_LIT  */
  YYSYMBOL_Y_END = 293,                    /* Y_END  */
  YYSYMBOL_Y_ERROR = 294,                  /* Y_ERROR  */
  YYSYMBOL_Y_FLOAT_LIT = 295,              /* Y_FLOAT_LIT  */
  YYSYMBOL_Y_GLOB = 296,                   /* Y_GLOB  */
  YYSYMBOL_Y_INT_LIT = 297,                /* Y_INT_LIT  */
  YYSYMBOL_Y_NAME = 298,                   /* Y_NAME  */
  YYSYMBOL_Y_SET_OPTION = 299,             /* Y_SET_OPTION  */
  YYSYMBOL_Y_STR_LIT = 300,                /* Y_STR_LIT  */
  YYSYMBOL_Y_TYPEDEF_NAME = 301,           /* Y_TYPEDEF_NAME  */
  YYSYMBOL_Y_TYPEDEF_SNAME = 302,          /* Y_TYPEDEF_SNAME  */
  YYSYMBOL_Y_LEXER_ERROR = 303,            /* Y_LEXER_ERROR  */
  YYSYMBOL_304_ = 304,                     /* '$'  */
  YYSYMBOL_305_ = 305,                     /* '@'  */
  YYSYMBOL_306_ = 306,                     /* '`'  */
  YYSYMBOL_307_ = 307,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 308,                 /* $accept  */
  YYSYMBOL_command_list = 309,             /* command_list  */
  YYSYMBOL_command = 310,                  /* command  */
  YYSYMBOL_cast_command = 311,             /* cast_command  */
  YYSYMBOL_new_style_cast_english = 312,   /* new_style_cast_english  */
  YYSYMBOL_declare_command = 313,          /* declare_command  */
  YYSYMBOL_314_1 = 314,                    /* $@1  */
  YYSYMBOL_alignas_or_width_decl_english_ast = 315, /* alignas_or_width_decl_english_ast  */
  YYSYMBOL_alignas_specifier_english = 316, /* alignas_specifier_english  */
  YYSYMBOL_aligned_english = 317,          /* aligned_english  */
  YYSYMBOL_capturing_paren_capture_decl_list_english_opt = 318, /* capturing_paren_capture_decl_list_english_opt  */
  YYSYMBOL_paren_capture_decl_list_english = 319, /* paren_capture_decl_list_english  */
  YYSYMBOL_capture_decl_list_english_opt = 320, /* capture_decl_list_english_opt  */
  YYSYMBOL_capture_decl_list_english = 321, /* capture_decl_list_english  */
  YYSYMBOL_capture_decl_english_ast = 322, /* capture_decl_english_ast  */
  YYSYMBOL_capture_default_opt = 323,      /* capture_default_opt  */
  YYSYMBOL_width_specifier_english_uint = 324, /* width_specifier_english_uint  */
  YYSYMBOL_storage_class_subset_english_type_opt = 325, /* storage_class_subset_english_type_opt  */
  YYSYMBOL_storage_class_subset_english_type = 326, /* storage_class_subset_english_type  */
  YYSYMBOL_storage_class_subset_english_stid = 327, /* storage_class_subset_english_stid  */
  YYSYMBOL_define_command = 328,           /* define_command  */
  YYSYMBOL_expand_command = 329,           /* expand_command  */
  YYSYMBOL_expand_command2 = 330,          /* expand_command2  */
  YYSYMBOL_p_extra_token_except_lparen = 331, /* p_extra_token_except_lparen  */
  YYSYMBOL_p_extra_tokens_opt = 332,       /* p_extra_tokens_opt  */
  YYSYMBOL_p_extra_tokens = 333,           /* p_extra_tokens  */
  YYSYMBOL_p_extra_token = 334,            /* p_extra_token  */
  YYSYMBOL_p_arg_list_opt = 335,           /* p_arg_list_opt  */
  YYSYMBOL_p_comma_arg_list = 336,         /* p_comma_arg_list  */
  YYSYMBOL_p_arg_list = 337,               /* p_arg_list  */
  YYSYMBOL_p_arg_tokens = 338,             /* p_arg_tokens  */
  YYSYMBOL_p_arg_token_as_list = 339,      /* p_arg_token_as_list  */
  YYSYMBOL_p_arg_token = 340,              /* p_arg_token  */
  YYSYMBOL_p_num_lit = 341,                /* p_num_lit  */
  YYSYMBOL_p_other = 342,                  /* p_other  */
  YYSYMBOL_p_punctuator = 343,             /* p_punctuator  */
  YYSYMBOL_p_arg_tokens_with_comma_opt = 344, /* p_arg_tokens_with_comma_opt  */
  YYSYMBOL_p_arg_tokens_with_comma = 345,  /* p_arg_tokens_with_comma  */
  YYSYMBOL_p_arg_token_with_comma_as_list = 346, /* p_arg_token_with_comma_as_list  */
  YYSYMBOL_p_arg_token_with_comma = 347,   /* p_arg_token_with_comma  */
  YYSYMBOL_explain_command = 348,          /* explain_command  */
  YYSYMBOL_349_2 = 349,                    /* $@2  */
  YYSYMBOL_explain = 350,                  /* explain  */
  YYSYMBOL_help_command = 351,             /* help_command  */
  YYSYMBOL_352_3 = 352,                    /* $@3  */
  YYSYMBOL_help_what_opt = 353,            /* help_what_opt  */
  YYSYMBOL_preprocessor_command = 354,     /* preprocessor_command  */
  YYSYMBOL_p_define = 355,                 /* p_define  */
  YYSYMBOL_p_paren_param_list_opt = 356,   /* p_paren_param_list_opt  */
  YYSYMBOL_p_param_list_opt = 357,         /* p_param_list_opt  */
  YYSYMBOL_p_param_list = 358,             /* p_param_list  */
  YYSYMBOL_p_param = 359,                  /* p_param  */
  YYSYMBOL_p_replace_list_opt = 360,       /* p_replace_list_opt  */
  YYSYMBOL_p_replace_list = 361,           /* p_replace_list  */
  YYSYMBOL_p_replace_token = 362,          /* p_replace_token  */
  YYSYMBOL_p_undef = 363,                  /* p_undef  */
  YYSYMBOL_quit_command = 364,             /* quit_command  */
  YYSYMBOL_scoped_command = 365,           /* scoped_command  */
  YYSYMBOL_set_command = 366,              /* set_command  */
  YYSYMBOL_set_option_list = 367,          /* set_option_list  */
  YYSYMBOL_set_option = 368,               /* set_option  */
  YYSYMBOL_set_option_value_opt = 369,     /* set_option_value_opt  */
  YYSYMBOL_show_command = 370,             /* show_command  */
  YYSYMBOL_show_format = 371,              /* show_format  */
  YYSYMBOL_show_format_exp = 372,          /* show_format_exp  */
  YYSYMBOL_show_format_opt = 373,          /* show_format_opt  */
  YYSYMBOL_show_types_opt = 374,           /* show_types_opt  */
  YYSYMBOL_predefined_or_user_types_opt = 375, /* predefined_or_user_types_opt  */
  YYSYMBOL_template_command = 376,         /* template_command  */
  YYSYMBOL_typedef_command = 377,          /* typedef_command  */
  YYSYMBOL_using_command = 378,            /* using_command  */
  YYSYMBOL_c_style_cast_expr_c = 379,      /* c_style_cast_expr_c  */
  YYSYMBOL_380_4 = 380,                    /* $@4  */
  YYSYMBOL_new_style_cast_expr_c = 381,    /* new_style_cast_expr_c  */
  YYSYMBOL_382_5 = 382,                    /* $@5  */
  YYSYMBOL_new_style_cast_c = 383,         /* new_style_cast_c  */
  YYSYMBOL_aligned_declaration_c = 384,    /* aligned_declaration_c  */
  YYSYMBOL_385_6 = 385,                    /* $@6  */
  YYSYMBOL_386_7 = 386,                    /* $@7  */
  YYSYMBOL_alignas_specifier_c = 387,      /* alignas_specifier_c  */
  YYSYMBOL_388_8 = 388,                    /* $@8  */
  YYSYMBOL_alignas = 389,                  /* alignas  */
  YYSYMBOL_asm_declaration_c = 390,        /* asm_declaration_c  */
  YYSYMBOL_scoped_declaration_c = 391,     /* scoped_declaration_c  */
  YYSYMBOL_class_struct_union_declaration_c = 392, /* class_struct_union_declaration_c  */
  YYSYMBOL_393_9 = 393,                    /* $@9  */
  YYSYMBOL_394_10 = 394,                   /* $@10  */
  YYSYMBOL_enum_declaration_c = 395,       /* enum_declaration_c  */
  YYSYMBOL_396_11 = 396,                   /* $@11  */
  YYSYMBOL_namespace_declaration_c = 397,  /* namespace_declaration_c  */
  YYSYMBOL_398_12 = 398,                   /* $@12  */
  YYSYMBOL_399_13 = 399,                   /* $@13  */
  YYSYMBOL_namespace_sname_c_exp = 400,    /* namespace_sname_c_exp  */
  YYSYMBOL_namespace_sname_c = 401,        /* namespace_sname_c  */
  YYSYMBOL_namespace_typedef_sname_c = 402, /* namespace_typedef_sname_c  */
  YYSYMBOL_brace_in_scope_declaration_c_exp = 403, /* brace_in_scope_declaration_c_exp  */
  YYSYMBOL_brace_in_scope_declaration_c_opt = 404, /* brace_in_scope_declaration_c_opt  */
  YYSYMBOL_brace_in_scope_declaration_c = 405, /* brace_in_scope_declaration_c  */
  YYSYMBOL_in_scope_declaration_c_exp = 406, /* in_scope_declaration_c_exp  */
  YYSYMBOL_lambda_declaration_c = 407,     /* lambda_declaration_c  */
  YYSYMBOL_capture_decl_list_c_opt = 408,  /* capture_decl_list_c_opt  */
  YYSYMBOL_capture_decl_list_c = 409,      /* capture_decl_list_c  */
  YYSYMBOL_capture_decl_c_ast = 410,       /* capture_decl_c_ast  */
  YYSYMBOL_lambda_param_c_ast_list_opt = 411, /* lambda_param_c_ast_list_opt  */
  YYSYMBOL_lambda_return_type_c_ast_opt = 412, /* lambda_return_type_c_ast_opt  */
  YYSYMBOL_413_14 = 413,                   /* $@14  */
  YYSYMBOL_template_declaration_c = 414,   /* template_declaration_c  */
  YYSYMBOL_typed_declaration_c = 415,      /* typed_declaration_c  */
  YYSYMBOL_416_15 = 416,                   /* $@15  */
  YYSYMBOL_typedef_declaration_c = 417,    /* typedef_declaration_c  */
  YYSYMBOL_418_16 = 418,                   /* $@16  */
  YYSYMBOL_419_17 = 419,                   /* $@17  */
  YYSYMBOL_typedef_decl_list_c = 420,      /* typedef_decl_list_c  */
  YYSYMBOL_typedef_decl_c = 421,           /* typedef_decl_c  */
  YYSYMBOL_typedef_decl_c_exp = 422,       /* typedef_decl_c_exp  */
  YYSYMBOL_user_defined_conversion_declaration_c = 423, /* user_defined_conversion_declaration_c  */
  YYSYMBOL_using_declaration_c = 424,      /* using_declaration_c  */
  YYSYMBOL_using_decl_c_ast = 425,         /* using_decl_c_ast  */
  YYSYMBOL_426_18 = 426,                   /* $@18  */
  YYSYMBOL_427_19 = 427,                   /* $@19  */
  YYSYMBOL_decl_list_c_opt = 428,          /* decl_list_c_opt  */
  YYSYMBOL_decl_list_c = 429,              /* decl_list_c  */
  YYSYMBOL_decl_c = 430,                   /* decl_c  */
  YYSYMBOL_decl_c_exp = 431,               /* decl_c_exp  */
  YYSYMBOL_decl_c_astp = 432,              /* decl_c_astp  */
  YYSYMBOL_msc_calling_convention_c_astp = 433, /* msc_calling_convention_c_astp  */
  YYSYMBOL_decl2_c_astp = 434,             /* decl2_c_astp  */
  YYSYMBOL_array_decl_c_astp = 435,        /* array_decl_c_astp  */
  YYSYMBOL_array_size_c_ast = 436,         /* array_size_c_ast  */
  YYSYMBOL_block_decl_c_astp = 437,        /* block_decl_c_astp  */
  YYSYMBOL_438_20 = 438,                   /* $@20  */
  YYSYMBOL_destructor_declaration_c = 439, /* destructor_declaration_c  */
  YYSYMBOL_no_destructor_params = 440,     /* no_destructor_params  */
  YYSYMBOL_file_scope_constructor_declaration_c = 441, /* file_scope_constructor_declaration_c  */
  YYSYMBOL_file_scope_destructor_declaration_c = 442, /* file_scope_destructor_declaration_c  */
  YYSYMBOL_func_decl_c_astp = 443,         /* func_decl_c_astp  */
  YYSYMBOL_pc99_func_or_constructor_declaration_c = 444, /* pc99_func_or_constructor_declaration_c  */
  YYSYMBOL_445_21 = 445,                   /* $@21  */
  YYSYMBOL_rparen_func_qualifier_list_c_stid_opt = 446, /* rparen_func_qualifier_list_c_stid_opt  */
  YYSYMBOL_447_22 = 447,                   /* $@22  */
  YYSYMBOL_func_qualifier_list_c_stid_opt = 448, /* func_qualifier_list_c_stid_opt  */
  YYSYMBOL_func_qualifier_c_stid = 449,    /* func_qualifier_c_stid  */
  YYSYMBOL_func_ref_qualifier_c_stid_opt = 450, /* func_ref_qualifier_c_stid_opt  */
  YYSYMBOL_noexcept_c_stid_opt = 451,      /* noexcept_c_stid_opt  */
  YYSYMBOL_noexcept_bool_stid_exp = 452,   /* noexcept_bool_stid_exp  */
  YYSYMBOL_trailing_return_type_c_ast_opt = 453, /* trailing_return_type_c_ast_opt  */
  YYSYMBOL_454_23 = 454,                   /* $@23  */
  YYSYMBOL_func_equals_c_stid_opt = 455,   /* func_equals_c_stid_opt  */
  YYSYMBOL_param_c_ast_list_exp = 456,     /* param_c_ast_list_exp  */
  YYSYMBOL_param_c_ast_list_opt = 457,     /* param_c_ast_list_opt  */
  YYSYMBOL_param_c_ast_list = 458,         /* param_c_ast_list  */
  YYSYMBOL_param_c_ast = 459,              /* param_c_ast  */
  YYSYMBOL_460_24 = 460,                   /* $@24  */
  YYSYMBOL_param_c_ast_exp = 461,          /* param_c_ast_exp  */
  YYSYMBOL_nested_decl_c_astp = 462,       /* nested_decl_c_astp  */
  YYSYMBOL_463_25 = 463,                   /* $@25  */
  YYSYMBOL_oper_decl_c_astp = 464,         /* oper_decl_c_astp  */
  YYSYMBOL_pointer_decl_c_astp = 465,      /* pointer_decl_c_astp  */
  YYSYMBOL_466_26 = 466,                   /* $@26  */
  YYSYMBOL_pointer_type_c_ast = 467,       /* pointer_type_c_ast  */
  YYSYMBOL_pc99_pointer_decl_list_c = 468, /* pc99_pointer_decl_list_c  */
  YYSYMBOL_pc99_pointer_decl_c = 469,      /* pc99_pointer_decl_c  */
  YYSYMBOL_470_27 = 470,                   /* $@27  */
  YYSYMBOL_pc99_pointer_type_c_ast = 471,  /* pc99_pointer_type_c_ast  */
  YYSYMBOL_pointer_to_member_decl_c_astp = 472, /* pointer_to_member_decl_c_astp  */
  YYSYMBOL_473_28 = 473,                   /* $@28  */
  YYSYMBOL_pointer_to_member_type_c_ast = 474, /* pointer_to_member_type_c_ast  */
  YYSYMBOL_reference_decl_c_astp = 475,    /* reference_decl_c_astp  */
  YYSYMBOL_476_29 = 476,                   /* $@29  */
  YYSYMBOL_reference_type_c_ast = 477,     /* reference_type_c_ast  */
  YYSYMBOL_typedef_type_decl_c_ast = 478,  /* typedef_type_decl_c_ast  */
  YYSYMBOL_user_defined_conversion_decl_c_astp = 479, /* user_defined_conversion_decl_c_astp  */
  YYSYMBOL_480_30 = 480,                   /* $@30  */
  YYSYMBOL_user_defined_literal_decl_c_astp = 481, /* user_defined_literal_decl_c_astp  */
  YYSYMBOL_cast_c_astp_opt = 482,          /* cast_c_astp_opt  */
  YYSYMBOL_cast_c_astp = 483,              /* cast_c_astp  */
  YYSYMBOL_cast2_c_astp = 484,             /* cast2_c_astp  */
  YYSYMBOL_array_cast_c_astp = 485,        /* array_cast_c_astp  */
  YYSYMBOL_block_cast_c_astp = 486,        /* block_cast_c_astp  */
  YYSYMBOL_487_31 = 487,                   /* $@31  */
  YYSYMBOL_func_cast_c_astp = 488,         /* func_cast_c_astp  */
  YYSYMBOL_nested_cast_c_astp = 489,       /* nested_cast_c_astp  */
  YYSYMBOL_490_32 = 490,                   /* $@32  */
  YYSYMBOL_pointer_cast_c_astp = 491,      /* pointer_cast_c_astp  */
  YYSYMBOL_492_33 = 492,                   /* $@33  */
  YYSYMBOL_pointer_to_member_cast_c_astp = 493, /* pointer_to_member_cast_c_astp  */
  YYSYMBOL_494_34 = 494,                   /* $@34  */
  YYSYMBOL_reference_cast_c_astp = 495,    /* reference_cast_c_astp  */
  YYSYMBOL_496_35 = 496,                   /* $@35  */
  YYSYMBOL_udc_decl_c_ast_opt = 497,       /* udc_decl_c_ast_opt  */
  YYSYMBOL_udc_decl_c_ast = 498,           /* udc_decl_c_ast  */
  YYSYMBOL_pointer_udc_decl_c_ast = 499,   /* pointer_udc_decl_c_ast  */
  YYSYMBOL_500_36 = 500,                   /* $@36  */
  YYSYMBOL_pointer_to_member_udc_decl_c_ast = 501, /* pointer_to_member_udc_decl_c_ast  */
  YYSYMBOL_502_37 = 502,                   /* $@37  */
  YYSYMBOL_reference_udc_decl_c_ast = 503, /* reference_udc_decl_c_ast  */
  YYSYMBOL_504_38 = 504,                   /* $@38  */
  YYSYMBOL_type_c_ast = 505,               /* type_c_ast  */
  YYSYMBOL_type_modifier_list_c_type_opt = 506, /* type_modifier_list_c_type_opt  */
  YYSYMBOL_type_modifier_list_c_type = 507, /* type_modifier_list_c_type  */
  YYSYMBOL_type_modifier_c_type = 508,     /* type_modifier_c_type  */
  YYSYMBOL_type_modifier_base_type = 509,  /* type_modifier_base_type  */
  YYSYMBOL_east_modified_type_c_ast = 510, /* east_modified_type_c_ast  */
  YYSYMBOL_atomic_builtin_typedef_type_c_ast = 511, /* atomic_builtin_typedef_type_c_ast  */
  YYSYMBOL_atomic_specifier_type_c_ast = 512, /* atomic_specifier_type_c_ast  */
  YYSYMBOL_513_39 = 513,                   /* $@39  */
  YYSYMBOL_builtin_type_c_ast = 514,       /* builtin_type_c_ast  */
  YYSYMBOL_builtin_no_BitInt_c_btid = 515, /* builtin_no_BitInt_c_btid  */
  YYSYMBOL_typeof_type_c_ast = 516,        /* typeof_type_c_ast  */
  YYSYMBOL_517_40 = 517,                   /* $@40  */
  YYSYMBOL_typeof = 518,                   /* typeof  */
  YYSYMBOL_enum_class_struct_union_c_ast = 519, /* enum_class_struct_union_c_ast  */
  YYSYMBOL_class_struct_union_c_ast = 520, /* class_struct_union_c_ast  */
  YYSYMBOL_enum_c_ast = 521,               /* enum_c_ast  */
  YYSYMBOL_enum_btids = 522,               /* enum_btids  */
  YYSYMBOL_enum_fixed_type_c_ast_opt = 523, /* enum_fixed_type_c_ast_opt  */
  YYSYMBOL_enum_fixed_type_c_ast = 524,    /* enum_fixed_type_c_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid_opt = 525, /* enum_fixed_type_modifier_list_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_btid = 526, /* enum_fixed_type_modifier_list_btid  */
  YYSYMBOL_enum_fixed_type_modifier_btid = 527, /* enum_fixed_type_modifier_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_c_ast = 528, /* enum_unmodified_fixed_type_c_ast  */
  YYSYMBOL_class_struct_btid_opt = 529,    /* class_struct_btid_opt  */
  YYSYMBOL_class_struct_btid = 530,        /* class_struct_btid  */
  YYSYMBOL_class_struct_union_btid = 531,  /* class_struct_union_btid  */
  YYSYMBOL_type_qualifier_list_c_stid_opt = 532, /* type_qualifier_list_c_stid_opt  */
  YYSYMBOL_type_qualifier_list_c_stid = 533, /* type_qualifier_list_c_stid  */
  YYSYMBOL_type_qualifier_c_stid = 534,    /* type_qualifier_c_stid  */
  YYSYMBOL_cv_qualifier_stid = 535,        /* cv_qualifier_stid  */
  YYSYMBOL_cv_qualifier_list_stid_opt = 536, /* cv_qualifier_list_stid_opt  */
  YYSYMBOL_restrict_qualifier_c_stid = 537, /* restrict_qualifier_c_stid  */
  YYSYMBOL_upc_layout_qualifier_c = 538,   /* upc_layout_qualifier_c  */
  YYSYMBOL_storage_class_c_type = 539,     /* storage_class_c_type  */
  YYSYMBOL__Noreturn_atid = 540,           /* _Noreturn_atid  */
  YYSYMBOL_attribute_specifier_list_c_atid_opt = 541, /* attribute_specifier_list_c_atid_opt  */
  YYSYMBOL_attribute_specifier_list_c_atid = 542, /* attribute_specifier_list_c_atid  */
  YYSYMBOL_543_41 = 543,                   /* $@41  */
  YYSYMBOL_using_opt = 544,                /* using_opt  */
  YYSYMBOL_attribute_list_c_atid_opt = 545, /* attribute_list_c_atid_opt  */
  YYSYMBOL_attribute_list_c_atid = 546,    /* attribute_list_c_atid  */
  YYSYMBOL_attribute_c_atid_exp = 547,     /* attribute_c_atid_exp  */
  YYSYMBOL_attribute_str_arg_c_opt = 548,  /* attribute_str_arg_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c_opt = 549, /* gnu_or_msc_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_or_msc_attribute_specifier_list_c = 550, /* gnu_or_msc_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_list_c_opt = 551, /* gnu_attribute_specifier_list_c_opt  */
  YYSYMBOL_gnu_attribute_specifier_list_c = 552, /* gnu_attribute_specifier_list_c  */
  YYSYMBOL_gnu_attribute_specifier_c = 553, /* gnu_attribute_specifier_c  */
  YYSYMBOL_554_42 = 554,                   /* $@42  */
  YYSYMBOL_gnu_attribute_list_c_opt = 555, /* gnu_attribute_list_c_opt  */
  YYSYMBOL_gnu_attribuet_list_c = 556,     /* gnu_attribuet_list_c  */
  YYSYMBOL_gnu_attribute_c_exp = 557,      /* gnu_attribute_c_exp  */
  YYSYMBOL_gnu_attribute_decl_arg_list_c_opt = 558, /* gnu_attribute_decl_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c_opt = 559, /* gnu_attribute_arg_list_c_opt  */
  YYSYMBOL_gnu_attribute_arg_list_c = 560, /* gnu_attribute_arg_list_c  */
  YYSYMBOL_gnu_attribute_arg_c = 561,      /* gnu_attribute_arg_c  */
  YYSYMBOL_msc_attribute_specifier_list_c = 562, /* msc_attribute_specifier_list_c  */
  YYSYMBOL_msc_attribute_specifier_c = 563, /* msc_attribute_specifier_c  */
  YYSYMBOL_564_43 = 564,                   /* $@43  */
  YYSYMBOL_msc_attribute_list_c_opt = 565, /* msc_attribute_list_c_opt  */
  YYSYMBOL_msc_attribuet_list_c = 566,     /* msc_attribuet_list_c  */
  YYSYMBOL_decl_english_ast = 567,         /* decl_english_ast  */
  YYSYMBOL_array_decl_english_ast = 568,   /* array_decl_english_ast  */
  YYSYMBOL_array_size_decl_ast = 569,      /* array_size_decl_ast  */
  YYSYMBOL_length_opt = 570,               /* length_opt  */
  YYSYMBOL_block_decl_english_ast = 571,   /* block_decl_english_ast  */
  YYSYMBOL_constructor_decl_english_ast = 572, /* constructor_decl_english_ast  */
  YYSYMBOL_destructor_decl_english_ast = 573, /* destructor_decl_english_ast  */
  YYSYMBOL_destructor_parens_opt = 574,    /* destructor_parens_opt  */
  YYSYMBOL_func_decl_english_ast = 575,    /* func_decl_english_ast  */
  YYSYMBOL_func_qualifier_english_type_opt = 576, /* func_qualifier_english_type_opt  */
  YYSYMBOL_msc_calling_convention_atid = 577, /* msc_calling_convention_atid  */
  YYSYMBOL_paren_param_decl_list_english_opt = 578, /* paren_param_decl_list_english_opt  */
  YYSYMBOL_paren_param_decl_list_english = 579, /* paren_param_decl_list_english  */
  YYSYMBOL_param_decl_list_english_opt = 580, /* param_decl_list_english_opt  */
  YYSYMBOL_param_decl_list_english = 581,  /* param_decl_list_english  */
  YYSYMBOL_decl_english_ast_exp = 582,     /* decl_english_ast_exp  */
  YYSYMBOL_ref_qualifier_english_stid_opt = 583, /* ref_qualifier_english_stid_opt  */
  YYSYMBOL_returning_english_ast_opt = 584, /* returning_english_ast_opt  */
  YYSYMBOL_returning_english_ast = 585,    /* returning_english_ast  */
  YYSYMBOL_qualified_decl_english_ast = 586, /* qualified_decl_english_ast  */
  YYSYMBOL_type_qualifier_list_english_type_opt = 587, /* type_qualifier_list_english_type_opt  */
  YYSYMBOL_type_qualifier_list_english_type = 588, /* type_qualifier_list_english_type  */
  YYSYMBOL_type_qualifier_english_type = 589, /* type_qualifier_english_type  */
  YYSYMBOL_attribute_english_atid = 590,   /* attribute_english_atid  */
  YYSYMBOL_storage_class_english_stid = 591, /* storage_class_english_stid  */
  YYSYMBOL_eval_expr_init_stid = 592,      /* eval_expr_init_stid  */
  YYSYMBOL_linkage_stid = 593,             /* linkage_stid  */
  YYSYMBOL_linkage_opt = 594,              /* linkage_opt  */
  YYSYMBOL_type_qualifier_english_stid = 595, /* type_qualifier_english_stid  */
  YYSYMBOL_upc_layout_qualifier_english = 596, /* upc_layout_qualifier_english  */
  YYSYMBOL_qualifiable_decl_english_ast = 597, /* qualifiable_decl_english_ast  */
  YYSYMBOL_pointer_decl_english_ast = 598, /* pointer_decl_english_ast  */
  YYSYMBOL_reference_decl_english_ast = 599, /* reference_decl_english_ast  */
  YYSYMBOL_reference_english_ast = 600,    /* reference_english_ast  */
  YYSYMBOL_user_defined_literal_decl_english_ast = 601, /* user_defined_literal_decl_english_ast  */
  YYSYMBOL_var_decl_english_ast = 602,     /* var_decl_english_ast  */
  YYSYMBOL_type_english_ast = 603,         /* type_english_ast  */
  YYSYMBOL_type_modifier_list_english_type_opt = 604, /* type_modifier_list_english_type_opt  */
  YYSYMBOL_type_modifier_list_english_type = 605, /* type_modifier_list_english_type  */
  YYSYMBOL_type_modifier_english_type = 606, /* type_modifier_english_type  */
  YYSYMBOL_unmodified_type_english_ast = 607, /* unmodified_type_english_ast  */
  YYSYMBOL_builtin_type_english_ast = 608, /* builtin_type_english_ast  */
  YYSYMBOL_builtin_no_BitInt_english_btid = 609, /* builtin_no_BitInt_english_btid  */
  YYSYMBOL_BitInt_english_int = 610,       /* BitInt_english_int  */
  YYSYMBOL_BitInt_english = 611,           /* BitInt_english  */
  YYSYMBOL_precise_opt = 612,              /* precise_opt  */
  YYSYMBOL_class_struct_union_english_ast = 613, /* class_struct_union_english_ast  */
  YYSYMBOL_enum_english_ast = 614,         /* enum_english_ast  */
  YYSYMBOL_of_type_enum_fixed_type_english_ast_opt = 615, /* of_type_enum_fixed_type_english_ast_opt  */
  YYSYMBOL_enum_fixed_type_english_ast = 616, /* enum_fixed_type_english_ast  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid_opt = 617, /* enum_fixed_type_modifier_list_english_btid_opt  */
  YYSYMBOL_enum_fixed_type_modifier_list_english_btid = 618, /* enum_fixed_type_modifier_list_english_btid  */
  YYSYMBOL_enum_unmodified_fixed_type_english_ast = 619, /* enum_unmodified_fixed_type_english_ast  */
  YYSYMBOL_any_name = 620,                 /* any_name  */
  YYSYMBOL_any_name_exp = 621,             /* any_name_exp  */
  YYSYMBOL_any_sname_c = 622,              /* any_sname_c  */
  YYSYMBOL_any_sname_c_exp = 623,          /* any_sname_c_exp  */
  YYSYMBOL_any_sname_c_opt = 624,          /* any_sname_c_opt  */
  YYSYMBOL_any_typedef = 625,              /* any_typedef  */
  YYSYMBOL_name_ast = 626,                 /* name_ast  */
  YYSYMBOL_name_exp = 627,                 /* name_exp  */
  YYSYMBOL_name_cat = 628,                 /* name_cat  */
  YYSYMBOL_name_opt = 629,                 /* name_opt  */
  YYSYMBOL_oper_sname_c_opt = 630,         /* oper_sname_c_opt  */
  YYSYMBOL_typedef_type_c_ast = 631,       /* typedef_type_c_ast  */
  YYSYMBOL_sub_scope_sname_c_opt = 632,    /* sub_scope_sname_c_opt  */
  YYSYMBOL_sname_c = 633,                  /* sname_c  */
  YYSYMBOL_sname_c_ast = 634,              /* sname_c_ast  */
  YYSYMBOL_bit_field_c_uint_opt = 635,     /* bit_field_c_uint_opt  */
  YYSYMBOL_sname_c_exp = 636,              /* sname_c_exp  */
  YYSYMBOL_sname_c_opt = 637,              /* sname_c_opt  */
  YYSYMBOL_sname_english = 638,            /* sname_english  */
  YYSYMBOL_sname_english_ast = 639,        /* sname_english_ast  */
  YYSYMBOL_sname_english_exp = 640,        /* sname_english_exp  */
  YYSYMBOL_sname_english_opt = 641,        /* sname_english_opt  */
  YYSYMBOL_sname_list_english = 642,       /* sname_list_english  */
  YYSYMBOL_typedef_sname_c = 643,          /* typedef_sname_c  */
  YYSYMBOL_address_exp = 644,              /* address_exp  */
  YYSYMBOL_array_exp = 645,                /* array_exp  */
  YYSYMBOL_as_exp = 646,                   /* as_exp  */
  YYSYMBOL_as_into_to_exp = 647,           /* as_into_to_exp  */
  YYSYMBOL_as_or_to_opt = 648,             /* as_or_to_opt  */
  YYSYMBOL_bits_opt = 649,                 /* bits_opt  */
  YYSYMBOL_bytes_opt = 650,                /* bytes_opt  */
  YYSYMBOL_cast_exp = 651,                 /* cast_exp  */
  YYSYMBOL_char_exp = 652,                 /* char_exp  */
  YYSYMBOL_class_struct_union_btid_exp = 653, /* class_struct_union_btid_exp  */
  YYSYMBOL_colon_exp = 654,                /* colon_exp  */
  YYSYMBOL_comma_exp = 655,                /* comma_exp  */
  YYSYMBOL_conversion_exp = 656,           /* conversion_exp  */
  YYSYMBOL_c_operator = 657,               /* c_operator  */
  YYSYMBOL_default_exp = 658,              /* default_exp  */
  YYSYMBOL_defined_exp = 659,              /* defined_exp  */
  YYSYMBOL_dependency_exp = 660,           /* dependency_exp  */
  YYSYMBOL_destructor_sname = 661,         /* destructor_sname  */
  YYSYMBOL_empty_str_lit_exp = 662,        /* empty_str_lit_exp  */
  YYSYMBOL_equals_exp = 663,               /* equals_exp  */
  YYSYMBOL_extern_linkage_c_stid = 664,    /* extern_linkage_c_stid  */
  YYSYMBOL_extern_linkage_c_stid_opt = 665, /* extern_linkage_c_stid_opt  */
  YYSYMBOL_glob = 666,                     /* glob  */
  YYSYMBOL_glob_opt = 667,                 /* glob_opt  */
  YYSYMBOL_gt_exp = 668,                   /* gt_exp  */
  YYSYMBOL_inline_stid_opt = 669,          /* inline_stid_opt  */
  YYSYMBOL_int_exp = 670,                  /* int_exp  */
  YYSYMBOL_literal_exp = 671,              /* literal_exp  */
  YYSYMBOL_local_exp = 672,                /* local_exp  */
  YYSYMBOL_lparen_exp = 673,               /* lparen_exp  */
  YYSYMBOL_lt_exp = 674,                   /* lt_exp  */
  YYSYMBOL_member_or_non_member_opt = 675, /* member_or_non_member_opt  */
  YYSYMBOL_namespace_btid_exp = 676,       /* namespace_btid_exp  */
  YYSYMBOL_namespace_type = 677,           /* namespace_type  */
  YYSYMBOL_of_exp = 678,                   /* of_exp  */
  YYSYMBOL_of_scope_english = 679,         /* of_scope_english  */
  YYSYMBOL_of_scope_list_english = 680,    /* of_scope_list_english  */
  YYSYMBOL_of_scope_list_english_opt = 681, /* of_scope_list_english_opt  */
  YYSYMBOL_operator_exp = 682,             /* operator_exp  */
  YYSYMBOL_operator_opt = 683,             /* operator_opt  */
  YYSYMBOL_point_exp = 684,                /* point_exp  */
  YYSYMBOL_precision_opt = 685,            /* precision_opt  */
  YYSYMBOL_rbrace_exp = 686,               /* rbrace_exp  */
  YYSYMBOL_rbracket_exp = 687,             /* rbracket_exp  */
  YYSYMBOL_reference_exp = 688,            /* reference_exp  */
  YYSYMBOL_returning = 689,                /* returning  */
  YYSYMBOL_returning_exp = 690,            /* returning_exp  */
  YYSYMBOL_rparen_exp = 691,               /* rparen_exp  */
  YYSYMBOL_scope_english_type = 692,       /* scope_english_type  */
  YYSYMBOL_scope_english_type_exp = 693,   /* scope_english_type_exp  */
  YYSYMBOL_semi_exp = 694,                 /* semi_exp  */
  YYSYMBOL_semi_opt = 695,                 /* semi_opt  */
  YYSYMBOL_semi_or_end = 696,              /* semi_or_end  */
  YYSYMBOL_static_stid_opt = 697,          /* static_stid_opt  */
  YYSYMBOL_str_lit = 698,                  /* str_lit  */
  YYSYMBOL_str_lit_exp = 699,              /* str_lit_exp  */
  YYSYMBOL_this_exp = 700,                 /* this_exp  */
  YYSYMBOL_this_stid_opt = 701,            /* this_stid_opt  */
  YYSYMBOL_to_exp = 702,                   /* to_exp  */
  YYSYMBOL_type_opt = 703,                 /* type_opt  */
  YYSYMBOL_typename_flag_opt = 704,        /* typename_flag_opt  */
  YYSYMBOL_uint_lit = 705,                 /* uint_lit  */
  YYSYMBOL_uint_lit_exp = 706,             /* uint_lit_exp  */
  YYSYMBOL_uint_lit_opt = 707,             /* uint_lit_opt  */
  YYSYMBOL_unused_exp = 708,               /* unused_exp  */
  YYSYMBOL_user_defined = 709,             /* user_defined  */
  YYSYMBOL_virtual_stid_exp = 710,         /* virtual_stid_exp  */
  YYSYMBOL_virtual_stid_opt = 711          /* virtual_stid_opt  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6308

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  308
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  404
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1084
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1428

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   534


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,     2,   157,   304,    87,    77,     2,
      70,    71,    78,    89,   130,    88,    74,    86,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   288,   289,
      96,   112,    97,   307,   305,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    73,   106,     2,   306,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   290,   107,   291,    81,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    75,    76,    80,    82,    83,
      84,    85,    90,    91,    92,    93,    94,    95,    98,    99,
     100,   101,   102,   103,   104,   105,   108,   109,   110,   111,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1922,  1922,  1923,  1932,  1933,  1934,  1935,  1936,  1937,
    1938,  1939,  1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,
    1966,  1988,  2012,  2013,  2014,  2015,  2016,  2025,  2096,  2095,
    2159,  2194,  2226,  2236,  2238,  2253,  2283,  2289,  2295,  2304,
    2305,  2306,  2310,  2311,  2315,  2322,  2326,  2330,  2338,  2339,
    2343,  2358,  2373,  2378,  2383,  2389,  2393,  2394,  2395,  2399,
    2413,  2414,  2432,  2433,  2454,  2458,  2459,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,
    2473,  2479,  2529,  2550,  2557,  2572,  2584,  2592,  2593,  2600,
    2601,  2605,  2610,  2619,  2620,  2628,  2633,  2645,  2665,  2685,
    2707,  2714,  2722,  2727,  2746,  2758,  2767,  2772,  2776,  2782,
    2791,  2795,  2799,  2803,  2807,  2811,  2815,  2822,  2823,  2827,
    2828,  2829,  2833,  2834,  2835,  2836,  2839,  2840,  2842,  2843,
    2844,  2845,  2846,  2847,  2848,  2849,  2850,  2851,  2852,  2853,
    2854,  2855,  2856,  2857,  2858,  2859,  2860,  2861,  2862,  2863,
    2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,
    2874,  2875,  2876,  2877,  2878,  2879,  2880,  2881,  2882,  2883,
    2888,  2892,  2906,  2912,  2916,  2922,  2931,  2932,  2944,  2949,
    2954,  2959,  2964,  2969,  2974,  2979,  2984,  2989,  2999,  3008,
    3018,  3018,  3033,  3038,  3061,  3068,  3075,  3093,  3092,  3111,
    3112,  3113,  3114,  3119,  3131,  3132,  3134,  3136,  3141,  3146,
    3151,  3156,  3161,  3166,  3171,  3176,  3181,  3186,  3191,  3196,
    3203,  3244,  3245,  3249,  3259,  3263,  3276,  3291,  3296,  3301,
    3312,  3313,  3317,  3323,  3332,  3343,  3347,  3351,  3355,  3359,
    3363,  3370,  3379,  3385,  3391,  3395,  3399,  3400,  3404,  3414,
    3415,  3416,  3426,  3436,  3446,  3452,  3458,  3463,  3491,  3500,
    3501,  3502,  3516,  3517,  3527,  3528,  3532,  3533,  3537,  3538,
    3543,  3546,  3547,  3553,  3559,  3565,  3576,  3575,  3612,  3623,
    3622,  3654,  3655,  3656,  3657,  3667,  3668,  3667,  3673,  3686,
    3686,  3704,  3711,  3712,  3718,  3729,  3730,  3731,  3739,  3744,
    3738,  3793,  3792,  3834,  3838,  3833,  3901,  3902,  3903,  3916,
    3930,  3945,  3961,  3980,  3994,  4010,  4028,  4032,  4033,  4040,
    4041,  4045,  4046,  4050,  4051,  4052,  4053,  4062,  4094,  4095,
    4099,  4115,  4130,  4135,  4141,  4146,  4151,  4156,  4164,  4165,
    4169,  4170,  4170,  4190,  4200,  4200,  4210,  4216,  4209,  4231,
    4232,  4237,  4301,  4302,  4311,  4327,  4338,  4359,  4337,  4423,
    4471,  4479,  4484,  4493,  4521,  4522,  4529,  4530,  4531,  4532,
    4533,  4542,  4543,  4547,  4548,  4549,  4550,  4551,  4552,  4556,
    4560,  4561,  4568,  4603,  4608,  4614,  4620,  4626,  4634,  4642,
    4648,  4657,  4666,  4677,  4676,  4729,  4779,  4780,  4807,  4844,
    4886,  5023,  5022,  5131,  5130,  5149,  5150,  5166,  5167,  5168,
    5176,  5180,  5181,  5182,  5186,  5187,  5188,  5192,  5196,  5213,
    5214,  5215,  5222,  5224,  5224,  5276,  5283,  5284,  5285,  5286,
    5294,  5306,  5307,  5315,  5316,  5320,  5333,  5351,  5350,  5385,
    5390,  5402,  5403,  5413,  5412,  5437,  5493,  5493,  5513,  5533,
    5538,  5546,  5546,  5566,  5606,  5606,  5626,  5665,  5665,  5684,
    5702,  5724,  5812,  5811,  5857,  5902,  5903,  5907,  5908,  5909,
    5910,  5914,  5915,  5916,  5917,  5919,  5929,  5967,  5966,  6016,
    6091,  6090,  6133,  6133,  6155,  6155,  6178,  6178,  6207,  6208,
    6212,  6213,  6214,  6215,  6219,  6219,  6237,  6237,  6255,  6255,
    6282,  6317,  6332,  6336,  6337,  6341,  6355,  6359,  6383,  6384,
    6385,  6392,  6393,  6394,  6395,  6396,  6397,  6398,  6404,  6408,
    6425,  6443,  6444,  6445,  6446,  6453,  6452,  6500,  6511,  6526,
    6527,  6528,  6529,  6530,  6531,  6532,  6533,  6534,  6535,  6536,
    6537,  6538,  6539,  6544,  6543,  6585,  6594,  6595,  6601,  6602,
    6606,  6625,  6637,  6658,  6672,  6676,  6677,  6678,  6694,  6712,
    6738,  6757,  6758,  6762,  6778,  6782,  6783,  6784,  6785,  6789,
    6790,  6791,  6797,  6798,  6802,  6803,  6807,  6808,  6814,  6815,
    6819,  6834,  6839,  6846,  6847,  6848,  6849,  6850,  6851,  6852,
    6856,  6857,  6861,  6862,  6878,  6892,  6896,  6897,  6898,  6899,
    6908,  6909,  6910,  6911,  6912,  6913,  6914,  6915,  6916,  6917,
    6918,  6919,  6920,  6921,  6950,  6952,  6953,  6954,  6955,  6956,
    6960,  6961,  6967,  6968,  6973,  6972,  6997,  7004,  7005,  7013,
    7014,  7018,  7032,  7036,  7037,  7038,  7039,  7040,  7041,  7042,
    7043,  7044,  7075,  7082,  7083,  7091,  7092,  7096,  7097,  7101,
    7102,  7106,  7107,  7112,  7111,  7127,  7128,  7132,  7133,  7137,
    7141,  7148,  7149,  7153,  7154,  7158,  7159,  7163,  7164,  7165,
    7166,  7167,  7168,  7175,  7176,  7181,  7180,  7193,  7194,  7205,
    7206,  7214,  7215,  7216,  7222,  7237,  7261,  7265,  7271,  7277,
    7285,  7286,  7293,  7315,  7333,  7345,  7346,  7353,  7380,  7384,
    7391,  7392,  7393,  7394,  7395,  7396,  7402,  7403,  7407,  7421,
    7422,  7426,  7441,  7458,  7459,  7468,  7469,  7470,  7477,  7488,
    7492,  7503,  7512,  7532,  7533,  7537,  7553,  7557,  7558,  7559,
    7563,  7564,  7565,  7566,  7567,  7568,  7569,  7570,  7571,  7572,
    7573,  7574,  7575,  7576,  7580,  7581,  7582,  7586,  7587,  7588,
    7589,  7590,  7591,  7592,  7593,  7594,  7598,  7599,  7600,  7601,
    7602,  7603,  7604,  7605,  7607,  7608,  7609,  7610,  7611,  7612,
    7613,  7614,  7615,  7619,  7620,  7621,  7632,  7652,  7653,  7657,
    7658,  7659,  7660,  7661,  7662,  7663,  7667,  7668,  7672,  7673,
    7674,  7675,  7676,  7677,  7678,  7679,  7689,  7711,  7731,  7744,
    7761,  7766,  7775,  7816,  7840,  7845,  7862,  7884,  7904,  7905,
    7909,  7925,  7929,  7933,  7934,  7935,  7936,  7940,  7952,  7967,
    7968,  7969,  7970,  7971,  7983,  7984,  7985,  7986,  7987,  7988,
    7989,  7990,  7991,  7992,  7993,  7997,  8001,  8005,  8009,  8016,
    8017,  8018,  8022,  8023,  8027,  8044,  8065,  8066,  8073,  8091,
    8106,  8107,  8111,  8127,  8131,  8132,  8140,  8141,  8149,  8150,
    8158,  8159,  8163,  8164,  8172,  8173,  8177,  8178,  8182,  8196,
    8197,  8205,  8210,  8214,  8215,  8219,  8221,  8230,  8291,  8292,
    8299,  8324,  8346,  8360,  8380,  8381,  8395,  8396,  8404,  8405,
    8409,  8428,  8457,  8458,  8466,  8467,  8471,  8487,  8503,  8522,
    8544,  8552,  8553,  8560,  8561,  8568,  8588,  8595,  8596,  8597,
    8598,  8605,  8606,  8607,  8611,  8612,  8613,  8617,  8618,  8622,
    8623,  8630,  8631,  8638,  8639,  8646,  8647,  8654,  8655,  8662,
    8663,  8670,  8671,  8672,  8673,  8674,  8675,  8676,  8677,  8678,
    8679,  8680,  8681,  8682,  8683,  8684,  8685,  8686,  8687,  8688,
    8689,  8690,  8691,  8692,  8693,  8694,  8695,  8696,  8697,  8698,
    8699,  8700,  8701,  8702,  8703,  8704,  8705,  8706,  8707,  8708,
    8709,  8710,  8711,  8712,  8713,  8714,  8715,  8716,  8717,  8721,
    8722,  8729,  8730,  8737,  8738,  8745,  8746,  8754,  8769,  8770,
    8777,  8778,  8786,  8787,  8791,  8806,  8807,  8811,  8812,  8819,
    8820,  8824,  8825,  8832,  8833,  8840,  8841,  8848,  8849,  8856,
    8857,  8864,  8865,  8866,  8870,  8871,  8878,  8879,  8883,  8884,
    8891,  8914,  8925,  8929,  8930,  8934,  8935,  8942,  8943,  8947,
    8948,  8954,  8955,  8959,  8960,  8967,  8968,  8975,  8976,  8983,
    8984,  8988,  8989,  8996,  8997,  9004,  9005,  9006,  9010,  9011,
    9020,  9021,  9028,  9029,  9033,  9034,  9038,  9039,  9043,  9044,
    9052,  9053,  9061,  9062,  9069,  9070,  9074,  9075,  9082,  9083,
    9087,  9088,  9092,  9108,  9109,  9116,  9117,  9121,  9122,  9129,
    9130,  9134,  9135,  9142,  9143
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "Y_cast",
  "Y_const_ENG", "Y_declare", "Y_define", "Y_dynamic", "Y_explain", "Y_no",
  "Y_quit", "Y_reinterpret", "Y_set", "Y_show", "Y_aligned", "Y_all",
  "Y_array", "Y_as", "Y_bit", "Y_bit_precise", "Y_bits", "Y_by", "Y_bytes",
  "Y_capturing", "Y_commands", "Y_constructor", "Y_conversion", "Y_copy",
  "Y_defined", "Y_destructor", "Y_english", "Y_evaluation", "Y_expand",
  "Y_expression", "Y_floating", "Y_function", "Y_initialization", "Y_into",
  "Y_lambda", "Y_length", "Y_linkage", "Y_literal", "Y_macros", "Y_member",
  "Y_non_empty", "Y_non_member", "Y_of", "Y_options", "Y_point",
  "Y_pointer", "Y_precise", "Y_precision", "Y_predefined", "Y_pure",
  "Y_reference", "Y_returning", "Y_rvalue", "Y_scope", "Y_to", "Y_user",
  "Y_user_defined", "Y_variable", "Y_wide", "Y_width",
  "Y_PREC_LESS_THAN_upc_layout_qualifier", "Y_COLON_COLON", "\"::\"",
  "Y_COLON_COLON_STAR", "\"++\"", "\"--\"", "'('", "')'", "'['", "']'",
  "'.'", "Y_MINUS_GREATER", "\"->\"", "'&'", "'*'", "'!'", "Y_sizeof",
  "'~'", "Y_DOT_STAR", "\".*\"", "Y_MINUS_GREATER_STAR", "\"->*\"", "'/'",
  "'%'", "'-'", "'+'", "Y_LESS_LESS", "\"<<\"", "Y_GREATER_GREATER",
  "\">>\"", "Y_LESS_EQUAL_GREATER", "\"<=>\"", "'<'", "'>'",
  "Y_LESS_EQUAL", "\"<=\"", "Y_GREATER_EQUAL", "\">=\"", "Y_EQUAL_EQUAL",
  "\"==\"", "Y_EXCLAM_EQUAL", "Y_bit_and", "'^'", "'|'", "Y_AMPER_AMPER",
  "Y_PIPE_PIPE", "Y_QMARK_COLON", "\"?:\"", "'='", "Y_PERCENT_EQUAL",
  "\"%=\"", "Y_AMPER_EQUAL", "Y_STAR_EQUAL", "\"*=\"", "Y_PLUS_EQUAL",
  "\"+=\"", "Y_MINUS_EQUAL", "\"-=\"", "Y_SLASH_EQUAL", "\"/=\"",
  "Y_LESS_LESS_EQUAL", "\"<<=\"", "Y_GREATER_GREATER_EQUAL", "\">>=\"",
  "Y_CARET_EQUAL", "Y_PIPE_EQUAL", "','", "Y_auto_STORAGE", "Y_break",
  "Y_case", "Y_char", "Y_continue", "Y_default", "Y_do", "Y_double",
  "Y_else", "Y_extern", "Y_float", "Y_for", "Y_goto", "Y_if", "Y_int",
  "Y_long", "Y_register", "Y_return", "Y_short", "Y_static", "Y_struct",
  "Y_switch", "Y_typedef", "Y_union", "Y_unsigned", "Y_while", "'#'",
  "\"##\"", "Y_PRE_SPACE", "Y_PRE_define", "Y_PRE_elif", "Y_PRE_else",
  "Y_PRE_error", "Y_PRE_if", "Y_PRE_ifdef", "Y_PRE_ifndef", "Y_PRE_line",
  "Y_PRE_undef", "Y_PRE___VA_ARGS__", "Y_PRE___VA_OPT__", "Y_PRE_pragma",
  "Y_PRE_elifdef", "Y_PRE_elifndef", "Y_PRE_embed", "Y_PRE_warning",
  "Y_asm", "Y_const", "\"...\"", "Y_enum", "Y_signed", "Y_void",
  "Y_volatile", "Y_wchar_t", "Y__Bool", "Y__Complex", "Y__Imaginary",
  "Y_inline", "Y_restrict", "Y__Alignas", "Y__Alignof", "Y__Atomic_QUAL",
  "Y__Atomic_SPEC", "Y__Generic", "Y__Noreturn", "Y__Static_assert",
  "Y__Thread_local", "Y_thread", "Y_local", "Y_bool", "Y_catch", "Y_class",
  "Y_const_cast", "Y_CONSTRUCTOR_SNAME", "Y_delete", "Y_DESTRUCTOR_SNAME",
  "Y_dynamic_cast", "Y_explicit", "Y_false", "Y_friend", "Y_mutable",
  "Y_namespace", "Y_new", "Y_operator", "Y_OPERATOR_SNAME", "Y_private",
  "Y_protected", "Y_public", "Y_reinterpret_cast", "Y_static_cast",
  "Y_template", "Y_this", "Y_throw", "Y_true", "Y_try", "Y_typeid",
  "Y_typename", "Y_using", "Y_virtual", "Y_char16_t", "Y_char32_t",
  "Y__BitInt", "Y_reproducible", "Y_typeof", "Y_typeof_unqual",
  "Y_unsequenced", "Y_ATTR_BEGIN", "Y_auto_TYPE", "Y_alignas", "Y_alignof",
  "Y_carries", "Y_dependency", "Y_carries_dependency", "Y_constexpr",
  "Y_decltype", "Y_except", "Y_final", "Y_noexcept", "Y_nullptr",
  "Y_override", "Y_static_assert", "Y_thread_local", "Y_deprecated",
  "Y_discard", "Y_maybe_unused", "Y_maybe", "Y_unused", "Y_nodiscard",
  "Y_noreturn", "Y_char8_t", "Y_concept", "Y_consteval", "Y_constinit",
  "Y_co_await", "Y_co_return", "Y_co_yield", "Y_export",
  "Y_no_unique_address", "Y_requires", "Y_unique", "Y_address",
  "Y_EMC__Accum", "Y_EMC__Fract", "Y_EMC__Sat", "Y_UPC_relaxed",
  "Y_UPC_shared", "Y_UPC_strict", "Y_GNU___attribute__",
  "Y_GNU___restrict", "Y_Apple___block", "Y_Apple_block", "Y_MSC___cdecl",
  "Y_MSC___clrcall", "Y_MSC___declspec", "Y_MSC___fastcall",
  "Y_MSC___stdcall", "Y_MSC___thiscall", "Y_MSC___vectorcall", "':'",
  "';'", "'{'", "'}'", "Y_CHAR_LIT", "Y_END", "Y_ERROR", "Y_FLOAT_LIT",
  "Y_GLOB", "Y_INT_LIT", "Y_NAME", "Y_SET_OPTION", "Y_STR_LIT",
  "Y_TYPEDEF_NAME", "Y_TYPEDEF_SNAME", "Y_LEXER_ERROR", "'$'", "'@'",
  "'`'", "'?'", "$accept", "command_list", "command", "cast_command",
  "new_style_cast_english", "declare_command", "$@1",
  "alignas_or_width_decl_english_ast", "alignas_specifier_english",
  "aligned_english", "capturing_paren_capture_decl_list_english_opt",
  "paren_capture_decl_list_english", "capture_decl_list_english_opt",
  "capture_decl_list_english", "capture_decl_english_ast",
  "capture_default_opt", "width_specifier_english_uint",
  "storage_class_subset_english_type_opt",
  "storage_class_subset_english_type", "storage_class_subset_english_stid",
  "define_command", "expand_command", "expand_command2",
  "p_extra_token_except_lparen", "p_extra_tokens_opt", "p_extra_tokens",
  "p_extra_token", "p_arg_list_opt", "p_comma_arg_list", "p_arg_list",
  "p_arg_tokens", "p_arg_token_as_list", "p_arg_token", "p_num_lit",
  "p_other", "p_punctuator", "p_arg_tokens_with_comma_opt",
  "p_arg_tokens_with_comma", "p_arg_token_with_comma_as_list",
  "p_arg_token_with_comma", "explain_command", "$@2", "explain",
  "help_command", "$@3", "help_what_opt", "preprocessor_command",
  "p_define", "p_paren_param_list_opt", "p_param_list_opt", "p_param_list",
  "p_param", "p_replace_list_opt", "p_replace_list", "p_replace_token",
  "p_undef", "quit_command", "scoped_command", "set_command",
  "set_option_list", "set_option", "set_option_value_opt", "show_command",
  "show_format", "show_format_exp", "show_format_opt", "show_types_opt",
  "predefined_or_user_types_opt", "template_command", "typedef_command",
  "using_command", "c_style_cast_expr_c", "$@4", "new_style_cast_expr_c",
  "$@5", "new_style_cast_c", "aligned_declaration_c", "$@6", "$@7",
  "alignas_specifier_c", "$@8", "alignas", "asm_declaration_c",
  "scoped_declaration_c", "class_struct_union_declaration_c", "$@9",
  "$@10", "enum_declaration_c", "$@11", "namespace_declaration_c", "$@12",
  "$@13", "namespace_sname_c_exp", "namespace_sname_c",
  "namespace_typedef_sname_c", "brace_in_scope_declaration_c_exp",
  "brace_in_scope_declaration_c_opt", "brace_in_scope_declaration_c",
  "in_scope_declaration_c_exp", "lambda_declaration_c",
  "capture_decl_list_c_opt", "capture_decl_list_c", "capture_decl_c_ast",
  "lambda_param_c_ast_list_opt", "lambda_return_type_c_ast_opt", "$@14",
  "template_declaration_c", "typed_declaration_c", "$@15",
  "typedef_declaration_c", "$@16", "$@17", "typedef_decl_list_c",
  "typedef_decl_c", "typedef_decl_c_exp",
  "user_defined_conversion_declaration_c", "using_declaration_c",
  "using_decl_c_ast", "$@18", "$@19", "decl_list_c_opt", "decl_list_c",
  "decl_c", "decl_c_exp", "decl_c_astp", "msc_calling_convention_c_astp",
  "decl2_c_astp", "array_decl_c_astp", "array_size_c_ast",
  "block_decl_c_astp", "$@20", "destructor_declaration_c",
  "no_destructor_params", "file_scope_constructor_declaration_c",
  "file_scope_destructor_declaration_c", "func_decl_c_astp",
  "pc99_func_or_constructor_declaration_c", "$@21",
  "rparen_func_qualifier_list_c_stid_opt", "$@22",
  "func_qualifier_list_c_stid_opt", "func_qualifier_c_stid",
  "func_ref_qualifier_c_stid_opt", "noexcept_c_stid_opt",
  "noexcept_bool_stid_exp", "trailing_return_type_c_ast_opt", "$@23",
  "func_equals_c_stid_opt", "param_c_ast_list_exp", "param_c_ast_list_opt",
  "param_c_ast_list", "param_c_ast", "$@24", "param_c_ast_exp",
  "nested_decl_c_astp", "$@25", "oper_decl_c_astp", "pointer_decl_c_astp",
  "$@26", "pointer_type_c_ast", "pc99_pointer_decl_list_c",
  "pc99_pointer_decl_c", "$@27", "pc99_pointer_type_c_ast",
  "pointer_to_member_decl_c_astp", "$@28", "pointer_to_member_type_c_ast",
  "reference_decl_c_astp", "$@29", "reference_type_c_ast",
  "typedef_type_decl_c_ast", "user_defined_conversion_decl_c_astp", "$@30",
  "user_defined_literal_decl_c_astp", "cast_c_astp_opt", "cast_c_astp",
  "cast2_c_astp", "array_cast_c_astp", "block_cast_c_astp", "$@31",
  "func_cast_c_astp", "nested_cast_c_astp", "$@32", "pointer_cast_c_astp",
  "$@33", "pointer_to_member_cast_c_astp", "$@34", "reference_cast_c_astp",
  "$@35", "udc_decl_c_ast_opt", "udc_decl_c_ast", "pointer_udc_decl_c_ast",
  "$@36", "pointer_to_member_udc_decl_c_ast", "$@37",
  "reference_udc_decl_c_ast", "$@38", "type_c_ast",
  "type_modifier_list_c_type_opt", "type_modifier_list_c_type",
  "type_modifier_c_type", "type_modifier_base_type",
  "east_modified_type_c_ast", "atomic_builtin_typedef_type_c_ast",
  "atomic_specifier_type_c_ast", "$@39", "builtin_type_c_ast",
  "builtin_no_BitInt_c_btid", "typeof_type_c_ast", "$@40", "typeof",
  "enum_class_struct_union_c_ast", "class_struct_union_c_ast",
  "enum_c_ast", "enum_btids", "enum_fixed_type_c_ast_opt",
  "enum_fixed_type_c_ast", "enum_fixed_type_modifier_list_btid_opt",
  "enum_fixed_type_modifier_list_btid", "enum_fixed_type_modifier_btid",
  "enum_unmodified_fixed_type_c_ast", "class_struct_btid_opt",
  "class_struct_btid", "class_struct_union_btid",
  "type_qualifier_list_c_stid_opt", "type_qualifier_list_c_stid",
  "type_qualifier_c_stid", "cv_qualifier_stid",
  "cv_qualifier_list_stid_opt", "restrict_qualifier_c_stid",
  "upc_layout_qualifier_c", "storage_class_c_type", "_Noreturn_atid",
  "attribute_specifier_list_c_atid_opt", "attribute_specifier_list_c_atid",
  "$@41", "using_opt", "attribute_list_c_atid_opt",
  "attribute_list_c_atid", "attribute_c_atid_exp",
  "attribute_str_arg_c_opt", "gnu_or_msc_attribute_specifier_list_c_opt",
  "gnu_or_msc_attribute_specifier_list_c",
  "gnu_attribute_specifier_list_c_opt", "gnu_attribute_specifier_list_c",
  "gnu_attribute_specifier_c", "$@42", "gnu_attribute_list_c_opt",
  "gnu_attribuet_list_c", "gnu_attribute_c_exp",
  "gnu_attribute_decl_arg_list_c_opt", "gnu_attribute_arg_list_c_opt",
  "gnu_attribute_arg_list_c", "gnu_attribute_arg_c",
  "msc_attribute_specifier_list_c", "msc_attribute_specifier_c", "$@43",
  "msc_attribute_list_c_opt", "msc_attribuet_list_c", "decl_english_ast",
  "array_decl_english_ast", "array_size_decl_ast", "length_opt",
  "block_decl_english_ast", "constructor_decl_english_ast",
  "destructor_decl_english_ast", "destructor_parens_opt",
  "func_decl_english_ast", "func_qualifier_english_type_opt",
  "msc_calling_convention_atid", "paren_param_decl_list_english_opt",
  "paren_param_decl_list_english", "param_decl_list_english_opt",
  "param_decl_list_english", "decl_english_ast_exp",
  "ref_qualifier_english_stid_opt", "returning_english_ast_opt",
  "returning_english_ast", "qualified_decl_english_ast",
  "type_qualifier_list_english_type_opt",
  "type_qualifier_list_english_type", "type_qualifier_english_type",
  "attribute_english_atid", "storage_class_english_stid",
  "eval_expr_init_stid", "linkage_stid", "linkage_opt",
  "type_qualifier_english_stid", "upc_layout_qualifier_english",
  "qualifiable_decl_english_ast", "pointer_decl_english_ast",
  "reference_decl_english_ast", "reference_english_ast",
  "user_defined_literal_decl_english_ast", "var_decl_english_ast",
  "type_english_ast", "type_modifier_list_english_type_opt",
  "type_modifier_list_english_type", "type_modifier_english_type",
  "unmodified_type_english_ast", "builtin_type_english_ast",
  "builtin_no_BitInt_english_btid", "BitInt_english_int", "BitInt_english",
  "precise_opt", "class_struct_union_english_ast", "enum_english_ast",
  "of_type_enum_fixed_type_english_ast_opt", "enum_fixed_type_english_ast",
  "enum_fixed_type_modifier_list_english_btid_opt",
  "enum_fixed_type_modifier_list_english_btid",
  "enum_unmodified_fixed_type_english_ast", "any_name", "any_name_exp",
  "any_sname_c", "any_sname_c_exp", "any_sname_c_opt", "any_typedef",
  "name_ast", "name_exp", "name_cat", "name_opt", "oper_sname_c_opt",
  "typedef_type_c_ast", "sub_scope_sname_c_opt", "sname_c", "sname_c_ast",
  "bit_field_c_uint_opt", "sname_c_exp", "sname_c_opt", "sname_english",
  "sname_english_ast", "sname_english_exp", "sname_english_opt",
  "sname_list_english", "typedef_sname_c", "address_exp", "array_exp",
  "as_exp", "as_into_to_exp", "as_or_to_opt", "bits_opt", "bytes_opt",
  "cast_exp", "char_exp", "class_struct_union_btid_exp", "colon_exp",
  "comma_exp", "conversion_exp", "c_operator", "default_exp",
  "defined_exp", "dependency_exp", "destructor_sname", "empty_str_lit_exp",
  "equals_exp", "extern_linkage_c_stid", "extern_linkage_c_stid_opt",
  "glob", "glob_opt", "gt_exp", "inline_stid_opt", "int_exp",
  "literal_exp", "local_exp", "lparen_exp", "lt_exp",
  "member_or_non_member_opt", "namespace_btid_exp", "namespace_type",
  "of_exp", "of_scope_english", "of_scope_list_english",
  "of_scope_list_english_opt", "operator_exp", "operator_opt", "point_exp",
  "precision_opt", "rbrace_exp", "rbracket_exp", "reference_exp",
  "returning", "returning_exp", "rparen_exp", "scope_english_type",
  "scope_english_type_exp", "semi_exp", "semi_opt", "semi_or_end",
  "static_stid_opt", "str_lit", "str_lit_exp", "this_exp", "this_stid_opt",
  "to_exp", "type_opt", "typename_flag_opt", "uint_lit", "uint_lit_exp",
  "uint_lit_opt", "unused_exp", "user_defined", "virtual_stid_exp",
  "virtual_stid_opt", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1237)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1085)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1237,  1091, -1237, -1237,   355,  3060,    73,   681, -1237, -1237,
     681,  -159,  1718,   101,   681, -1237,   -74, -1237,  1179,   681,
      17,   129, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,   356,    73,   356,   356,   356,   356,
    1659,   356,  -113,   356, -1237,   356,   356,   356,   356,   356,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,   238, -1237,   368,
   -1237,   614,   423, -1237, -1237, -1237, -1237,   197,   153, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,   465,   496, -1237,
    4567, -1237,   122, -1237, -1237, -1237,   178, -1237, -1237, -1237,
   -1237,   435,  -159, -1237, -1237,   171, -1237, -1237, -1237,    34,
     460, -1237,  5033, -1237, -1237, -1237, -1237,   102, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,   102, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,    94,
     121, -1237,   614, -1237, -1237, -1237, -1237, -1237,  5652,    36,
     875, -1237, -1237, -1237,   253, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,   162, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,   -20, -1237, -1237, -1237,   162, -1237, -1237, -1237,
   -1237, -1237, -1237,   512, -1237,   514, -1237, -1237,   162, -1237,
   -1237,   531, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,   537, -1237, -1237,
   -1237, -1237, -1237,   530, -1237, -1237,   150, -1237, -1237,   162,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
     576, -1237, -1237, -1237,  5810, -1237, -1237, -1237,  6025, -1237,
   -1237, -1237, -1237,   162, -1237, -1237, -1237,   310,   310, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,   383, -1237,   426, -1237,
     662,   515, -1237,   368,   521,   552,   278,   668, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,    86,    86,    92,   709,
   -1237,   238, -1237,   433, -1237, -1237, -1237, -1237,  4137,   355,
   -1237, -1237, -1237, -1237, -1237, -1237,   153,   153,   647,   377,
     112,    96, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,    76, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
      71, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   579,
   -1237, -1237, -1237,    73,  4137,   238,  4137,    47, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,   490,    98, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,  1318, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  5170, -1237, -1237, -1237, -1237, -1237,
    5810, -1237, -1237,   688, -1237, -1237, -1237, -1237, -1237,   310,
   -1237,   103, -1237, -1237,   461,  4137, -1237, -1237,   197, -1237,
   -1237,   466,    78, -1237, -1237, -1237,   710,   130, -1237, -1237,
     809,   208,   809, -1237, -1237,   516, -1237, -1237, -1237,    54,
    5810, -1237,  5810,    44, -1237,   114, -1237,   162,   162, -1237,
   -1237, -1237,  5810,   -74,  3671,  1207,  1207,  1741, -1237, -1237,
   -1237,  6025,  3829,   292,    68, -1237,    68, -1237, -1237,   355,
   -1237,  5810, -1237,   162, -1237, -1237,   162,    94, -1237, -1237,
     520, -1237, -1237, -1237, -1237,   739,   744, -1237, -1237, -1237,
   -1237, -1237, -1237,    86, -1237, -1237, -1237,   647,   541, -1237,
      96,   168, -1237, -1237, -1237,   253, -1237, -1237, -1237, -1237,
   -1237, -1237,   118, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,     7,
   -1237, -1237,   463, -1237, -1237, -1237, -1237,  4695,  4447, -1237,
   -1237, -1237, -1237, -1237, -1237,   475, -1237,   190, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,    67,
     157,   620,   745, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,   446, -1237, -1237,   486,   178, -1237, -1237,
   -1237,    98, -1237, -1237, -1237, -1237, -1237,  5277, -1237,   752,
    5414,   694,  5521, -1237, -1237, -1237, -1237, -1237,  5170, -1237,
   -1237,    58,  4918,   126, -1237, -1237, -1237, -1237, -1237,   134,
   -1237, -1237, -1237, -1237,   759, -1237, -1237,    36,   208, -1237,
   -1237, -1237, -1237, -1237, -1237,   197, -1237, -1237, -1237, -1237,
   -1237,   197,   605,   763, -1237,   153,   153,   162,    63,    50,
   -1237, -1237,   767, -1237,   197,   736,   875,   875,   875, -1237,
   -1237, -1237, -1237, -1237, -1237,   713, -1237, -1237,   621, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,   524,   785,   651,   644,   566,    19,   383,
   -1237, -1237,   713, -1237, -1237,   577,   520,   578, -1237,   580,
   -1237, -1237,    50,   199,   162,   988, -1237,   581,    77,   -22,
     557, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   833, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,   166,   745,   807,   141,
     155,   154,   841,   745, -1237, -1237, -1237, -1237, -1237, -1237,
     702, -1237, -1237, -1237, -1237, -1237,   141, -1237,  4293,  4277,
   -1237, -1237,  4137, -1237, -1237,   162, -1237, -1237, -1237, -1237,
     620,   620, -1237,   139,   151,   808,   117, -1237, -1237,  3982,
      91, -1237, -1237, -1237,   669,   161,    44, -1237, -1237, -1237,
    1940, -1237,  4447, -1237,  5277,   812,  5277, -1237, -1237,  5170,
   -1237,   694,  5414, -1237, -1237,  1207, -1237, -1237, -1237,   813,
     131, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
    4918, -1237, -1237, -1237,  5810,   784, -1237, -1237, -1237,   631,
   -1237,   825, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
      50, -1237, -1237, -1237, -1237,   134, -1237,   102,   634, -1237,
   -1237, -1237,    82, -1237,   827, -1237,   828,   100, -1237, -1237,
   -1237,   829,   135, -1237, -1237,  5810,   134,  5810, -1237,   134,
   -1237, -1237,  1207, -1237, -1237, -1237,   563,    50,  1184,   383,
    1207,  1207,  1207, -1237,   621,   693, -1237,    35,   831,  1449,
      44, -1237, -1237, -1237,   383,   134, -1237, -1237, -1237,   480,
     834, -1237,   834,   199, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,  5958, -1237,   641, -1237,   300, -1237, -1237, -1237,
   -1237, -1237,   102, -1237, -1237,   102, -1237, -1237, -1237, -1237,
   -1237, -1237,   176, -1237, -1237,   199, -1237, -1237, -1237,  2227,
   -1237, -1237,   209, -1237,   522,    91, -1237, -1237,   877,  4137,
     864,   108,   214,   115,   618,   865, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,    86,
      86, -1237, -1237, -1237, -1237,    80, -1237, -1237, -1237, -1237,
   -1237,  3982,   846,   848,   119, -1237, -1237,   102, -1237, -1237,
     620, -1237,   855,   136, -1237, -1237, -1237, -1237,  2514, -1237,
     238, -1237, -1237, -1237,   749, -1237, -1237,   897,   717,   856,
   -1237, -1237, -1237,  5414,  5521,   798, -1237, -1237, -1237,    70,
   -1237, -1237, -1237,   134,   134,   134,   134, -1237,   632,    50,
     860,  4644,   631,   124, -1237, -1237, -1237, -1237,   863, -1237,
     863, -1237, -1237,   862,   144, -1237,   368,   868,   143, -1237,
     170, -1237, -1237, -1237,   304,  3353, -1237,   532, -1237,   631,
     875,   197, -1237, -1237, -1237,   834,   867,   875,   153,   866,
     477, -1237,   153, -1237, -1237, -1237, -1237, -1237,   162,   102,
   -1237, -1237,   631, -1237, -1237, -1237,   162, -1237, -1237, -1237,
   -1237, -1237, -1237,   304,   304,   834, -1237,   641, -1237,   641,
   -1237, -1237, -1237,   652,    61,    61, -1237, -1237, -1237, -1237,
    4137,   871, -1237,   176, -1237, -1237, -1237,   649, -1237,   745,
   -1237, -1237,   108, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,   899, -1237, -1237,    44,
      44,   749,   878, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,  2801, -1237, -1237,   111, -1237, -1237, -1237, -1237, -1237,
   -1237,   154,   702, -1237,   952, -1237,   134,   875,   631,   876,
     876,   876,   368, -1237,   834, -1237,  5810, -1237, -1237, -1237,
   -1237, -1237,    54, -1237, -1237,   153,   354,   197,   105,   170,
   -1237, -1237, -1237, -1237, -1237,   880,   504, -1237,   162,   882,
     843, -1237, -1237, -1237,   134, -1237, -1237,   162, -1237,  1207,
   -1237,   394, -1237,   339, -1237,   153, -1237, -1237,   372, -1237,
     292,    50,   162, -1237,   480,   480,   480,   834, -1237,   383,
     383,   304, -1237, -1237,    72, -1237, -1237, -1237, -1237, -1237,
   -1237,   422, -1237,   176,    91, -1237,   805, -1237,   749,   197,
   -1237,    91, -1237, -1237, -1237, -1237, -1237,  4137, -1237,   200,
   -1237, -1237, -1237,   876,   134, -1237,   304, -1237,   197, -1237,
   -1237, -1237, -1237,   528, -1237,   170,  3194,   242,    89, -1237,
     876,   106,   197, -1237, -1237,   304,   153,   153, -1237,   153,
     153,   834,  3512, -1237, -1237, -1237,   304,   607, -1237, -1237,
     383, -1237, -1237, -1237, -1237, -1237,    73,  4137, -1237, -1237,
     641, -1237, -1237, -1237, -1237, -1237, -1237,   745,   631,    33,
     134, -1237,   534, -1237, -1237,   547, -1237, -1237, -1237, -1237,
     197, -1237, -1237, -1237, -1237, -1237,   368,   197,   162,    33,
   -1237, -1237, -1237, -1237,   394, -1237,   888,   584,   843, -1237,
   -1237, -1237, -1237, -1237,   843,  4137, -1237, -1237, -1237,  4344,
    2102,    91,   162,  5810, -1237,   383,   876, -1237, -1237, -1237,
      50,   843,   304,   304, -1237, -1237, -1237,   238, -1237, -1237,
   -1237, -1237, -1237,    50, -1237,   889, -1237,    33,    33,   891,
     134,   383,   843, -1237, -1237, -1237, -1237, -1237
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     1,    19,   894,     0,     0,     0,   196,   242,
       0,   244,     0,     0,     0,   575,  1070,   577,     0,     0,
     572,     0,   574,   281,   282,  1016,   283,   284,   343,   356,
    1054,  1055,   197,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    12,     0,     0,     0,     0,     0,
      26,   243,   295,   296,   297,   273,   274,   275,   355,   301,
     576,   298,   303,    18,   882,   866,   867,  1023,   900,   860,
     895,     0,   861,    32,   959,   947,   951,     0,     0,   955,
     953,   940,   944,   936,   978,   956,   954,   957,   938,   950,
     946,   961,   968,   964,   960,   967,   963,   970,   966,   937,
     973,   975,   941,   976,   971,   965,   939,   942,   945,   948,
     952,   958,   962,   969,   974,   977,   949,   934,   932,   931,
     592,   897,     0,    28,   893,   892,     0,   920,   919,    23,
      24,   249,   245,   247,   258,   270,   268,   269,   257,   995,
     264,    83,    84,    25,  1071,   346,   219,     0,   207,   210,
     212,   213,   214,   215,   216,     0,   217,   208,   209,   211,
     218,   205,   206,    22,   554,   573,  1015,  1014,  1017,     0,
       0,     4,     0,     5,     6,     7,     8,   195,     0,   328,
     578,   600,   533,   540,   607,   539,   538,   513,   518,   514,
     615,   616,   516,     0,   590,   515,   529,   591,   537,   531,
     511,   512,   611,   594,   292,   583,     0,   620,   617,   532,
     605,   610,   612,     0,   190,   619,   535,   536,     0,   546,
     547,     0,   530,   293,   603,   609,   614,   618,   621,   534,
     602,   604,   606,   541,   542,   517,   586,   587,   589,   653,
     595,   601,   675,   882,   178,   179,     0,   181,   285,     0,
     182,   186,   189,   180,   192,   184,   183,   185,   187,   188,
     450,   451,   354,   344,   500,   506,   507,   502,   503,   521,
     522,   527,   524,     0,   592,   548,   549,   622,   622,   508,
     584,   585,   509,   613,   510,   626,   647,   652,   648,   674,
     878,     0,   523,   194,   608,     0,     0,     0,     9,    10,
      11,    13,    14,    15,    16,    17,     0,     0,     0,     0,
    1022,  1024,   890,     0,   910,   907,   908,   909,   723,     0,
    1044,  1043,   943,  1036,  1035,   972,     0,     0,     0,     0,
      42,     0,    77,    72,   738,    68,    71,    73,    78,    79,
     742,   743,     0,   731,    66,    70,    75,    76,   732,   734,
       0,   736,   739,    65,    67,    69,   741,    61,    63,     0,
      62,   906,   905,     0,   723,  1023,   723,     0,   248,   246,
     271,   272,   267,   256,   994,   996,   264,     0,   259,   260,
     261,   265,   252,   147,   167,   162,     0,    88,   137,   138,
     129,   160,   125,   126,   122,   143,   149,   161,   130,   124,
     128,   127,   157,   153,   156,   133,   135,   155,   152,   150,
     151,   139,   141,   144,   165,   134,   163,   145,   169,   166,
     159,   168,   158,   154,   146,   164,   177,   123,   113,   148,
     131,   132,   140,   142,   110,   117,   118,   111,   114,   119,
     120,   121,   136,    82,    89,   176,   112,   115,   116,    87,
       0,   870,   869,   221,   241,   859,   856,   857,   858,   622,
     203,     0,   872,   198,   200,   723,   611,   619,     0,   276,
     608,   332,     0,   334,   336,   335,     0,     0,   331,   453,
     579,   645,     0,  1058,  1059,   990,   776,  1008,  1007,     0,
       0,   876,     0,     0,   624,     0,   588,     0,     0,   401,
    1010,  1009,     0,  1070,     0,   875,   875,   359,   505,   501,
     519,   504,     0,   520,     0,   623,     0,   651,   673,     0,
     877,     0,   193,     0,   985,   986,     0,     0,   863,   862,
     555,   299,   308,   312,   304,   306,   307,   316,  1049,  1047,
    1045,  1046,  1048,     0,  1021,   880,   881,     0,     0,   762,
       0,     0,  1079,   744,   750,   754,   764,   770,   805,   758,
     779,   767,     0,   751,   752,   757,   759,   765,   769,   771,
     748,   756,   761,   763,   768,   747,   749,   753,   782,   783,
     785,   745,  1023,   780,   781,    20,   681,   808,   724,   726,
     727,   728,   729,   682,   683,     0,   804,     0,   899,   898,
     935,   933,   773,   774,   775,    64,   737,    74,   735,     0,
       0,    48,   706,  1082,  1081,    80,   984,   983,   730,  1078,
    1077,   733,   593,     0,   896,    27,    33,     0,    81,   251,
     250,     0,   254,   263,   262,   253,   101,   170,   103,     0,
      97,    96,   105,   107,   108,    94,    93,    85,    90,    92,
     347,     0,   230,     0,   202,   201,   871,    21,   278,   465,
     333,  1063,  1062,   337,   338,   928,   927,     0,   645,   582,
     646,   581,   991,  1061,  1060,     0,   525,   191,  1074,  1072,
    1073,     0,   627,     0,   596,     0,     0,     0,     0,  1064,
     279,   286,     0,   289,     0,   443,   578,   578,   578,   700,
     701,   702,   703,   704,   705,   449,   362,   363,   366,   373,
     374,   375,   376,   377,   367,   446,   368,   454,   369,   457,
     379,   380,   381,   875,     0,   878,     0,   884,   884,   649,
     452,   345,   360,   545,   543,   862,   555,     0,   550,     0,
     879,   462,  1064,     0,     0,     0,   302,   319,     0,     0,
       0,  1020,   746,   760,   772,   982,   981,  1080,   777,  1006,
    1005,   766,   787,   784,   786,   891,   686,   706,   695,     0,
     716,     0,   690,   706,   812,   788,   789,   790,   791,   792,
    1011,   699,   698,   722,   793,   794,     0,   795,     0,   809,
     811,   725,   723,  1004,  1003,     0,   902,   901,   740,    47,
      48,    48,    43,    56,    56,     0,     0,    51,    55,   723,
     718,   707,   930,   929,  1027,   911,     0,    40,    41,    34,
       0,    35,   723,   255,   170,     0,   171,   173,   174,    89,
     102,    98,   100,   106,    91,   875,   229,   228,   227,     0,
       0,   226,   235,   236,   237,   238,   239,   240,   234,   220,
     231,   233,   989,   988,     0,   480,   482,   484,   486,     0,
     466,   467,   471,   472,   473,   474,   468,   469,   470,   475,
    1064,    60,   330,   580,   294,   465,   528,     0,     0,   599,
     598,   597,     0,   660,   661,   680,     0,     0,   440,  1065,
     868,     0,     0,   436,   439,     0,   465,     0,   291,   465,
     288,   393,   875,   459,   448,   460,     0,  1064,     0,   649,
     875,   875,   875,   370,     0,   371,   372,   884,     0,     0,
       0,   461,   883,   378,   650,   465,   552,   553,   551,   488,
       0,   397,     0,     0,   557,   565,   566,   568,   567,   569,
     571,   556,   558,   564,   561,   570,     0,   300,   320,   318,
     305,   317,     0,   309,   310,     0,   314,   313,   778,   755,
     689,   688,     0,   687,   693,     0,   694,  1067,  1066,     0,
    1038,  1037,   717,   691,     0,   718,  1012,  1013,     0,   723,
     842,     0,     0,     0,  1075,  1031,   830,   829,   819,   827,
     821,   822,   825,   826,   839,   820,   824,   833,   834,     0,
       0,   806,   813,   817,   818,     0,   814,   815,   816,   810,
     803,   723,     0,     0,     0,    58,    52,     0,    53,    44,
       0,   712,     0,     0,  1039,  1040,    30,   719,     0,  1028,
    1023,   912,   913,    39,   914,    38,    37,   917,   715,     0,
     109,   172,    86,    99,   104,   348,   350,   351,   222,     0,
     232,   357,   477,   465,   465,   465,   465,   476,   888,  1064,
       0,   340,     0,     0,   642,   639,   640,   633,   643,   635,
     643,   637,   638,     0,     0,   632,   641,     0,     0,   658,
     663,   659,   676,   679,   414,     0,   437,     0,   287,     0,
     578,     0,   365,   364,   361,     0,  1036,   578,     0,     0,
       0,   383,     0,   382,   447,   455,   458,   592,     0,     0,
     987,   885,     0,   494,   496,   498,     0,   489,   490,   491,
     492,   493,   403,   414,   414,     0,   563,   561,   560,   562,
     326,   321,   323,  1052,     0,     0,   311,   315,  1019,  1018,
     723,     0,   798,     0,   796,   904,   903,   873,   692,   706,
     799,   843,     0,  1002,  1001,   840,  1030,  1029,   831,   922,
     921,   828,  1076,   823,  1032,   832,   846,   844,   838,     0,
       0,   914,     0,    46,    45,   980,   979,    57,    54,    50,
     708,     0,   721,   720,     0,   915,   916,    59,   918,    36,
     716,     0,  1011,   175,     0,   225,   465,   578,     0,   483,
     485,   487,   889,   277,     0,   339,     0,   327,   526,   926,
     925,   628,     0,   634,   636,     0,     0,     0,     0,     0,
     668,   669,   667,   670,   672,     0,     0,   666,     0,   415,
     426,   442,   441,   435,   465,   998,   997,     0,   290,   875,
     444,   411,   392,     0,   385,     0,  1057,   386,     0,   384,
     456,  1064,     0,   544,   488,   488,   488,     0,   405,   649,
     649,   414,   559,  1053,     0,  1051,  1050,   324,   325,   684,
     696,     0,   874,     0,   718,   841,  1068,   845,   914,     0,
     835,   718,   714,   713,   711,  1042,  1041,   723,   717,     0,
     353,   352,   349,   358,   465,   481,   414,   341,     0,   625,
     631,   654,   657,     0,   662,     0,     0,     0,     0,   402,
     438,     0,     0,   412,   413,   414,     0,     0,   389,     0,
       0,     0,     0,   495,   497,   499,   414,   404,   398,   399,
     649,  1034,  1033,   322,   924,   923,     0,   723,   697,  1069,
     850,   837,   836,   802,    31,  1026,  1025,   706,     0,   422,
     465,   644,   928,   671,   665,     0,   417,   421,   419,   420,
       0,   430,   427,   428,   429,   887,   886,     0,     0,   422,
     391,   390,   388,   387,   411,   432,     0,     0,   426,   408,
     409,   410,   406,   407,   426,   723,   685,   853,   847,     0,
     851,   718,     0,     0,   479,   425,   342,   418,   416,   280,
    1064,   426,   414,   414,   463,   395,   797,  1023,   854,   848,
     855,   852,    29,  1064,   423,     0,   400,   422,   422,     0,
     465,   649,   426,   464,   478,   424,   394,   445
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,  -607, -1237,   -57,   160, -1237,    95, -1237, -1237,
   -1237, -1237, -1237,   826,   138, -1237,   321, -1237,  -549,   330,
    -627,  -600,  -225, -1237, -1237, -1237,   148, -1237,   147,  -200,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,   -75, -1237, -1237,   133, -1237, -1237, -1237, -1237, -1237,
     844, -1237, -1237,  -295,   348,   604, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,   945, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,    42, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,   244, -1237, -1237,
   -1237, -1237,  -145, -1237, -1237, -1237,   950,  -463, -1237,    48,
   -1237, -1237, -1237,  -201, -1237, -1237,    52,   704, -1237, -1237,
   -1237,   497,    97, -1237,  -471, -1237,   282, -1237,  -620, -1237,
   -1237, -1237,  -776, -1237, -1237,   285, -1237, -1237,  -875, -1237,
   -1237, -1237,  -359,  -698, -1237, -1236, -1237,  -734, -1237,  -721,
   -1034,   -69, -1237, -1237, -1237, -1237, -1237,   294, -1237,  -454,
     840, -1237, -1237, -1237, -1237, -1237,  -216, -1237, -1237,   -99,
   -1237,   981, -1237, -1237,  -758, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,  -672,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,  -169, -1237,   757,
    -189,  -371,   762, -1237, -1237, -1237,  -521, -1237,  -487, -1237,
   -1237, -1237, -1237, -1237,    10,   291, -1237,   -95,   283,  -895,
      93, -1237,  1013,     4,  -631,   128,  -154,  -268,  -256,  -303,
   -1237, -1237, -1237,  -173,  -167, -1237, -1237, -1237, -1237,  -175,
     -28,   376,  -136,  -887,  -688,  -276, -1237, -1237, -1237,  -833,
   -1237, -1237,  -174,  -259, -1237,   760, -1237, -1237, -1237,  -306,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   464,
    -727, -1237,    39, -1237, -1237,     9,  -942, -1237, -1237,   231,
   -1237,   467,  -104, -1237,   517,   507, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   276, -1237,
    -322, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,   543,     2,  -279,   555,    -8, -1237,  -138,
   -1237, -1237,  1032,  -482, -1237,    -4,  -332,   347, -1237, -1237,
     695,  -313,   -32, -1237, -1237, -1237, -1237, -1237,   -96,   905,
   -1237, -1045, -1237,   821, -1237, -1237, -1237,  -464, -1237,   159,
   -1237, -1237, -1237, -1237, -1237, -1237,  1040, -1237, -1237, -1237,
   -1237, -1237,   -71, -1237, -1237,  -179, -1237,  -106, -1237,   779,
   -1019,   778, -1237,   -53, -1237, -1237, -1237, -1237, -1237,  -307,
    -101,   -91, -1237,  -292, -1237, -1237,   -35, -1237,  1154, -1237,
    -146,  -863, -1237, -1237,   319, -1237,   603,  -415,  -773, -1237,
   -1237,   748,   558, -1237
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,    33,    34,    35,    36,   365,   625,   819,   820,
     612,   802,   805,   806,   807,  1016,   821,   120,   357,   358,
      37,    38,   443,   646,   647,   648,   649,   639,   640,   641,
     642,   643,   445,   446,   447,   448,   825,   826,   827,   449,
      39,   492,    40,    41,   170,   463,    42,   161,   652,   839,
     840,   841,   849,   850,   851,   162,    43,    44,    45,   132,
     133,   368,    46,   381,   635,   382,   139,   372,    47,    48,
      49,   244,   659,   245,   896,    50,   247,   503,   897,   248,
     899,   249,   250,    51,    52,   307,   747,    53,   306,    54,
     308,   748,   534,   535,   536,   950,   947,   948,  1133,   251,
     476,   477,   808,   871,  1207,  1350,    55,   253,   507,    56,
     450,   835,  1045,  1046,  1292,   254,    57,    58,   169,  1196,
     731,   705,   706,  1094,   707,   913,   708,   709,  1057,   710,
    1090,   255,   932,   256,   257,   711,   258,   689,  1123,  1258,
    1327,  1382,  1315,  1230,  1360,  1394,  1420,  1309,  1376,   891,
     892,   893,  1234,  1233,   712,   902,   713,   714,   910,   856,
     259,   260,   506,   261,   716,   911,   857,   718,   912,   858,
     720,   721,   929,   722,   859,   860,   861,   862,   863,  1197,
     864,   865,  1053,   866,  1054,   867,  1055,   868,  1056,  1116,
    1117,  1118,  1254,  1119,  1255,  1120,  1256,   263,   510,   264,
     265,   266,   267,   268,   269,   875,   270,   271,   272,   925,
     273,   274,   275,   276,   277,   746,   941,  1128,  1129,   943,
     944,   164,    60,   278,   479,   480,   279,   280,   359,   281,
     496,   282,   283,   514,   284,   682,   878,  1073,  1074,  1075,
    1213,   669,   285,   923,   286,   287,   497,  1077,  1078,   885,
    1081,  1225,  1226,  1227,   288,   289,   498,   886,   887,  1021,
     775,   962,   974,   776,   777,   778,   966,   779,   780,   723,
     810,   811,  1022,  1023,  1284,   782,  1026,  1027,   586,   587,
     588,   589,   590,   591,   605,   485,   959,   592,   763,   783,
     784,   785,   786,   593,   594,   787,   788,   789,   790,  1001,
    1002,  1003,  1004,  1005,  1152,  1006,  1007,  1277,  1388,  1389,
    1390,  1409,   458,   459,   724,   530,   737,    68,   894,   453,
     464,  1273,   726,   292,   520,   728,   869,   922,  1367,  1203,
     125,   596,   126,    71,   122,    72,   798,  1147,   364,   318,
    1033,  1187,  1189,   129,  1161,  1336,  1211,  1085,   814,   123,
    1177,   757,   618,   526,  1109,   854,   470,   295,   375,   376,
    1237,   296,  1155,   795,   761,   489,   502,   978,   168,    62,
    1140,   310,   311,   765,  1347,  1030,  1158,  1165,  1333,   325,
     972,  1028,  1287,   322,   542,   543,  1267,  1264,    63,  1248,
     674,   675,   663,   895,   969,  1340,   145,   680,   681,  1163,
     621,   597,   615,   297
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      69,    69,    69,   172,   140,    61,    67,    67,    67,   469,
     517,    59,   585,   667,   312,   584,   360,   454,   513,   600,
     601,   930,  1103,   727,   727,   727,   481,   490,   531,   677,
     366,    69,   290,  1148,   478,   730,   293,    67,   486,   493,
     964,   924,   833,  1034,   482,   678,   975,  1126,   629,  1079,
     583,   715,   715,   715,  1083,   673,  1110,  1124,   626,   836,
     628,   584,  1265,   584,   883,   903,   904,   905,   796,   528,
     504,   836,   619,  1331,   124,   508,   373,   616,   949,   661,
     686,  1168,   634,   883,   313,   762,  -860,   528,   909,   694,
    1361,   622,   832,   532,   512,   455,   583,   613,   583,   633,
     313,   883,   141,   451,   654,   516,   883,  1365,  1393,  1153,
     515,   515,  1285,   471,   472,   683,  1159,  1062,   665,   759,
    1175,  -433,   460,   361,  1271,  1209,  1280,   852,   378,  -223,
     166,   665,   665,  1401,  -677,   610,   665,   665,  1087,   362,
     131,  1089,   967,  1169,   665,   665,  1024,  1111,   473,  1060,
    1170,   500,   144,  -655,   323,   970,  -800,  1125,   799,   657,
    1014,   644,   584,   487,   764,   952,  1024,  1112,    15,   755,
     290,  -678,  1014,   729,   729,   729,   658,  1138,  1031,   361,
     299,  1422,  1423, -1000,   611, -1000,  1095,   684,   -49,  1141,
     -49,   793,   685,  1012,  1013,   362,   756,   583,   320,   968,
     931,  1345,  -224,  -329,   855,  1044,  -434,  -710,   971,  1017,
    -801,   696,   697,  -800,  -656,  1156,   774,  -630,    22,  1032,
    1241,   924,  1139,   370,   939,  1362,   324,   800,   888,   801,
     371,   794,   488,  1341,  1126,   736,   837,   738,   853,  1025,
    1219,   727,   698,  1357,   960,   622,   501,   666,   837,  1160,
    1261,   379,   363,  1154,  1337,  1176,   290,   474,   940,  1025,
     666,   666,  1157,   945,   751,   666,   666,  -801,   321,   715,
    -396,   889,  1355,   666,   666,  1015,   953,  1099,   461,    65,
      66,   650,  1043, -1000,   309,   584,   653,  1015,  1377,   717,
     717,   717,   515,  1363,   909,  1198,  1199,  1200,  1201,   662,
     537,  1130,    69,    69,   679,   546,  1008,   920,   529,   529,
     239,   598,   627,   540,   595,   599,   760,   617,   687,   688,
     583,   676,   508,   920,   614,   380,   668,   620,   671,  1296,
     374,   624,  1338,   690,   475,   693,   634,   797,  1204,  1343,
     167,   679,  1020,   734,   742,   670,   630,   743,   890,  1298,
    1266,   963,   741,   727,   483,  1064,   838,   484,  -864,    69,
     595,   884,   595,  1332,  1047,    67,    64,   946,   838,    65,
      66,    64,  1328,  1329,    65,    66,  1049,   679,   880,   881,
     884,   715,  1326,   874,    64,  1302,   679,    65,    66,   876,
     533,   729,   456,    65,    66,   457,  1278,  1279,   884,   142,
     452,   655,   900,   884,    64,  1037,   719,   719,   719,   486,
    -199,   679,  1210,  1346,  -199,   644,  1044,   644,   774,   462,
     727,   939,  1274,  1334,   727,  1259,  1260,   848,   727,   727,
     727,  1091,    64,   313,  1088,    65,    66,   828,  1293,  1104,
    1105,  1106,   290,  1384,   833,  1387,  1374,   812,   715,  1412,
    1358,    15,   715,    16,    17,   940,   715,   715,   715,  1239,
     945,   595,  1220,   679,   961,  1359,  1243,  1221,  1222,   194,
    1223,  1313,   813,  1224,   197,  1113,  1310,   377,   323,    20,
    -882,   523,   290,   524,   290,   239,  1010,    21,   319,   584,
     378,   242,   792,  1102,   290,  1411,   290,   725,   725,   725,
     815,    22,  1314,   729,   290,   665,   584,   631,   882,   309,
      69,    25,    69,   290,  1036,    69,   735,   584,   735,   584,
     378,   740,   872,  1145,   583,   606,  1228,    29,  -882,  1352,
    1321,   822,   670,  1235,  1426, -1044,  1348,   326,  1146,    69,
     313,   583,   481,   481,   481,   529,   221,   367,   665,   816,
     324,  1229,   583,   483,   583,  -579,   484,   696,   697,  1181,
     482,   482,   482,  1330,  1092,   933,  1294,  1058,   327,  1162,
     729,   924,   924,    15,   729,  -664,    17,   491,   729,   729,
     729,   525,  1323,  1324,  1325,   665,  1065,   239,   698,  1066,
    1171,  1131,  1396,   242,   695, -1084,  1067,  1121,  1349,   321,
     499,  1101,   697,   494,   908, -1044,  1068,   644,  1069,   495,
    1216,  1070,  1071,   379,  1218,   314,  1011,  1369,  1397,   717,
    1391,  1072,   607,    22,   828,   848,   828,  1246,  1378,  1236,
     608,   315,   320,   695,   666,  1064,   679,  1316,   551,   552,
     696,   697,   924,   379,  1404,    30,   609,   803,   517,    31,
    1405,   316,    64,    64,   194,  -431,    65,    66,   666,   197,
     239,  1395,  1425,  1144, -1044,   203,   584,  1416,   205,   679,
    1319,   698,   317,  1150,   804,   817,   584,   666,   602,  1415,
     603,  1395,   127,   604,   128,  1051,   717,   380,  1427,   606,
     717,   907,  1419,   908,   717,   717,   717,   471,   472,    70,
     121,   583,   321,   908,  1417,  1418,   505,  -629,   584,   242,
     538,   583,   727,  1114,   666,   290,   519,   380,  -900,   917,
    1166,  1167,  1183,  1047,   818,   584,  1086,   519,   521,  1395,
    1395,   545,   473,   924,    65,    66,   719,   290,   213,  1063,
     715,   954,   956,   583,   955,   976,   957,   977,  -993,   527,
     741,   236,   237,   238,   481,   240,   194,   727,   651,   656,
     583,   197,  1305,  -375,   660,  -375,   539,  1185,  1312,  1186,
    1208,  1190,   482,  1191, -1056, -1056,  -875,   213,    64,    29,
     290,    65,    66,   664,   194,   715,   753,   935,   595,   197,
     936,  1244,  1000,  1247,   608,  1249,   937,  1238,   999,  1240,
    1113,  1113,  1113,   719,   749,   595,   672,   719,   745,   750,
     609,   719,   719,   719,  1136,   809,   595,  1137,   644,   644,
    1253,   938,    64,   829,   638,    65,    66,   725,  1317,   870,
    1115,   130,   877,  1320,  1269,   143,   879,   584,   898,  1305,
     163,   474,   901,   906,   699,   700,   290,   701,   702,   703,
     704,  1250,   918,  1379,   920,    64,  1380,   919,    65,    66,
      15,    64,   729,    17,    65,    66,  1065,  -865,   927,  1066,
     928,   946,   583,   958,  1076,  1283,  1067,   965,   584,  1178,
     973,  1019,  1029,  1040,  1048,  1381,  1068,   290,  1069,   290,
    1052,  1070,  1071,  1364,   725,  1059,    21,  1080,   725,  1082,
    1084,  1072,   725,   725,   725,  1122,  1295,   729,  1299,  1107,
      22,   290,  1149,   583,  1151,   679,  1164,  1173,   475,  1188,
      25,  1174,  1121,  1121,  1121,  1301,  1180,  1193,  1194,  1251,
      64,  1205,    64,  1212,   290,  1215,   481,  1257,  1318,  1217,
    1242,  1263,  1270,   481,  1245,  1276,   668,  1272,   908,  1281,
      61,  1304,  1307,  1290,   482,  1308,    59,   360,  1339,  1403,
    1421,   482,  1424,  1179,  1018,   595,  1061,  1042,   444,   834,
     831,  1252,  1039,  1041,  1195,   595,   369,  1184,   717,   823,
     632,  1344,   622,  1050,   584,   246,   194,  1342,  1132,   934,
     252,   197,   951,  1291,  1134,    69,    69,   203,  1135,   522,
     205,   529,   529,  1093,   732,   914,  1351,   595,   915,  1370,
    1371,  1353,  1372,  1373,  1356,  1402,  1232,   916,   468,   583,
    1368,   262,   695,   717,   595,   511,   509,   926,   942,   696,
     697,  1386,  1262,   165,   584,  1127,  1100,  1297,  1114,  1114,
    1114,  1300,  1214,   481,   873,  1303,  1354,  1192,   518,  1306,
    1172,   781,   194,  1038,  1202,   791,  1392,   197,  1311,  1383,
     698,   482,   758,   203,   752,  1009,   205,  1408,  1398,   583,
     744,   739,   291,  1322,   921,  1399,  1410,   465,  1108,  1406,
     294,  1275,   584,   236,   237,   238,  1289,   240,   541,   544,
    1288,     2,     3,  1286,     4,   719,     5,     6,     7,     8,
    1268,     9,    10,    11,    12,   979,   691,   623,   754,     0,
       0,     0,     0,     0,     0,     0,     0,   583,     0,   517,
       0,     0,   182,    13,     0,     0,   183,     0,     0,   185,
       0,     0,     0,   186,   935,     0,   595,   936,     0,     0,
     719,     0,     0,   937,     0,     0,     0,     0,     0,   236,
     237,   238,   239,   240,     0,  1115,  1115,  1115,   242,     0,
       0,     0,     0,     0,     0,  -875,   213,     0,   938,   196,
       0,   198,   199,     0,     0,     0,     0,   595,     0,     0,
     146,     0,     0,     0,     0,  1096,   725,   209,   171,  1400,
     173,   174,   175,   176,     0,   298,     0,   300,   290,   301,
     302,   303,   304,   305,     0,     0,     0,     0,     0,     0,
       0,     0,  1076,  1413,     0,     0,     0,   216,   217,   218,
       0,   219,   220,     0,  1414,   222,     0,     0,     0,     0,
       0,   725,     0,   699,   700,     0,   701,   702,   703,   704,
       0,    14,    15,     0,    16,    17,     0,   229,    18,     0,
      64,     0,     0,    65,    66,     0,     0,   324,     0,   233,
     234,     0,  -578,     0,     0,     0,     0,     0,    19,     0,
      20,     0,     0,     0,     0,  1335,     0,   695,    21,     0,
       0,     0,     0,   595,   696,   697,     0,     0,     0,    65,
      66,     0,    22,    23,     0,     0,     0,    24,     0,     0,
       0,     0,    25,     0,  1385,     0,     0,  1366,     0,    26,
      27,    28,     0,     0,     0,   698,     0,     0,    29,   636,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,   595,  1097,     0,     0,     0,    67,   147,
     148,   149,   150,   151,   152,   153,   154,   155,     0,     0,
     156,   157,   158,   159,   160,     0,     0,     0,     0,     0,
       0,   194,     0,     0,     0,     0,   197,     0,     0,     0,
       0,     0,   203,     0,     0,   205,     0,     0,     0,     0,
      30,   595,     0,   383,    31,   290,   384,   385,   637,   -95,
     388,   389,   390,   391,     0,   392,   393,   394,    32,   395,
     396,     0,   397,     0,   398,   399,   400,   401,   402,     0,
     403,     0,   404,     0,   405,   406,   407,     0,   408,     0,
     409,   213,   410,     0,   411,   412,   413,   414,     0,     0,
     415,   416,     0,   417,   418,     0,   419,     0,   420,     0,
     421,     0,   422,     0,   423,     0,   424,   425,   638,     0,
     673,     0,     0,     0,     0,     0,     0,     0,   236,   237,
     238,   239,   240,     0,     0,     0,     0,   242,     0,     0,
       0,     0,  -204,     0,     0,   427,     0,   428,     0,     0,
       0,   679,  1098,     0,     0,     0,     0,     0,   699,   700,
       0,   701,   702,   703,   704,     0,   429,     0,     0,     0,
       0,     0,     0,     0,     0,    64,     0,     0,    65,    66,
       0,     0,     0,     0,    74,     0,     0,    75,    76,    77,
       0,    78,     0,    79,    80,     0,    81,    82,    83,     0,
      84,    85,     0,    86,     0,    87,    88,    89,    90,    91,
       0,    92,     0,    93,     0,    94,    95,    96,     0,    97,
       0,    98,     0,    99,     0,   100,   101,   102,   103,   104,
       0,   105,   106,     0,   107,   108,     0,   109,     0,   110,
       0,   111,     0,   112,     0,   113,     0,   114,   115,   116,
     181,     0,     0,   182,     0,     0,     0,   183,     0,   184,
     185,     0,     0,     0,   186,   187,   188,     0,   189,   190,
      15,     0,   191,    17,   192,     0,   430,   431,   432,   433,
     434,     0,     0,   435,     0,   436,   437,     0,   438,     0,
       0,     0,   439,   440,   441,   442,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   466,   203,     0,     0,
     205,   206,     0,   207,     0,   208,     0,     0,   209,     0,
      22,     0,     0,   117,     0,     0,   210,     0,   211,   212,
     177,   118,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   467,   216,   217,
     218,     0,   219,   220,     0,   221,   222,     0,     0,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,   119,     0,     0,   232,     0,     0,     0,   134,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   178,
       0,   179,   242,   135,     0,  -266,     0,   180,     0,     0,
   -1083,     0,     0,     0,     0,     0,     0,     0,  -266,   483,
      65,    66,   484,     0,     0,     0,     0,     0,     0,     0,
    -266,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     136,     0,     0,     0,     0,     0,     0,   137,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     181,     0,     0,   182,     0,     0,     0,   183,     0,   184,
     185,     0,     0,     0,   186,   187,   188,     0,   189,   190,
      15,   695,   191,    17,   192,     0,     0,     0,   696,   697,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   193,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   698,
     205,   206,     0,   207,     0,   208,     0,     0,   209,     0,
      22,    23,  -999,     0,  -999,    24,   210,     0,   211,   212,
       0,  -266,  -875,   213,     0,     0,     0,    26,    27,    28,
       0,     0,     0,     0,     0,   214,  -992,   215,   216,   217,
     218,     0,   219,   220,     0,   221,   222,   223,     0,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,     0,     0,     0,   232,     0,     0,     0,     0,
     233,   234,   235,   236,   237,   238,   239,   240,   241,     0,
       0,  1035,   242,     0,   547,  -266,     0,     0,     0,   548,
       0,     0,     0,     0,  -875,   213,  -723,   243,  -723,  -723,
      65,    66,  -999,     0,     0,  -723,     0,     0,     0,  -723,
       0,     0,     0,     0,  -723,  -723,     0,     0,     0,     0,
       0,     0,     0,  -723,   549,  -723,     0,     0,     0,  -723,
       0,     0,     0,   550,  -723,     0,  -723,     0,     0,   551,
     552,  -723,  -723,     0,     0,     0,     0,  -266,     0,     0,
       0,  -266,     0,     0,  -266,     0,   138,     0,     0,    65,
      66,     0,   699,   700,     0,   701,   702,   703,   704,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
       0,     0,    65,    66,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   553,     0,     0,  -723,     0,   554,     0,  -723,     0,
     555,  -723,     0,     0,     0,  -723,  -723,  -723,     0,  -723,
     556,  -723,     0,   557,  -723,  -723,     0,     0,     0,     0,
       0,     0,     0,  -849,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  -849,   194,   558,  -723,
    -723,  -723,   197,  -723,  -723,  -723,  -723,   559,   203,     0,
       0,   560,     0,     0,   334,     0,   561,   562,     0,  -723,
       0,  -723,     0,     0,   563,     0,     0,   564,     0,   565,
     566,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   567,   568,     0,     0,  -849,     0,     0,   569,  -723,
    -723,  -723,   340,  -849,     0,   341,     0,  -723,     0,     0,
     342,     0,   343,   570,     0,     0,   571,   572,     0,   573,
       0,   574,   348,     0,   349,   350,     0,   351,   352,  -723,
       0,   575,   576,     0,     0,     0,   577,   356,     0,     0,
       0,  -723,  -723,  -723,   578,   579,   580,     0,   240,   581,
    -723,  -723,  -723,     0,  -723,  -723,  -723,  -723,  1142,     0,
       0,   547,  -849,     0,     0,     0,   548,   679,   582,     0,
       0,  -723,  -723,  -723,     0,  -723,  -723,     0,   935,     0,
       0,   936,  -723,     0,     0,     0,  -723,   937,     0,     0,
       0,  -723,  -723,     0,     0,     0,     0,     0,     0,     0,
    1143,   549,  -723,     0,     0,     0,  -723,     0,     0,     0,
     550,  -723,   938,  -723,     0,     0,   551,   552,  -723,  -723,
       0,  -849,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -849,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   553,     0,
       0,  -723,     0,   554,     0,  -723,     0,   555,  -723,     0,
       0,     0,  -723,  -723,  -723,     0,  -723,   556,  -723,     0,
     557,  -723,  -723,     0,     0,     0,     0,     0,     0,     0,
       0,  -849,     0,     0,     0,  -849,     0,     0,     0,     0,
       0,     0,     0,     0,   194,   558,  -723,  -723,  -723,   197,
    -723,  -723,  -723,  -723,   559,   203,     0,     0,   560,     0,
       0,   334,     0,   561,   562,     0,  -723,     0,  -723,     0,
       0,   563,     0,     0,   564,     0,   565,   566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   567,   568,
       0,     0,     0,     0,     0,   569,  -723,  -723,  -723,   340,
       0,     0,   341,     0,  -723,     0,     0,   342,     0,   343,
     570,     0,     0,   571,   572,     0,   573,     0,   574,   348,
       0,   349,   350,     0,   351,   352,  -723,     0,   575,   576,
       0,     0,     0,   577,   356,     0,     0,     0,  -723,  -723,
    -723,   578,   579,   580,     0,   240,   581,  -723,  -723,  -723,
       0,  -723,  -723,  -723,  -723,  1182,     0,     0,   547,     0,
       0,     0,     0,   548,     0,   582,     0,     0,  -723,  -723,
    -723,     0,  -723,  -723,     0,     0,     0,     0,     0,  -723,
       0,     0,     0,  -723,     0,     0,     0,     0,  -723,  -723,
       0,     0,     0,     0,     0,     0,     0,  -723,   549,  -723,
       0,     0,     0,  -723,     0,     0,     0,   550,  -723,     0,
    -723,     0,     0,   551,   552,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   553,     0,     0,  -723,     0,
     554,     0,  -723,     0,   555,  -723,     0,     0,     0,  -723,
    -723,  -723,     0,  -723,   556,  -723,     0,   557,  -723,  -723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   194,   558,  -723,  -723,  -723,   197,  -723,  -723,  -723,
    -723,   559,   203,     0,     0,   560,     0,     0,   334,     0,
     561,   562,     0,  -723,     0,  -723,     0,     0,   563,     0,
       0,   564,     0,   565,   566,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   567,   568,     0,     0,     0,
       0,     0,   569,  -723,  -723,  -723,   340,     0,     0,   341,
       0,  -723,     0,     0,   342,     0,   343,   570,     0,     0,
     571,   572,     0,   573,     0,   574,   348,     0,   349,   350,
       0,   351,   352,  -723,     0,   575,   576,     0,     0,     0,
     577,   356,     0,     0,     0,  -723,  -723,  -723,   578,   579,
     580,     0,   240,   581,  -723,  -723,  -723,     0,  -723,  -723,
    -723,  -723,  1282,     0,     0,   547,     0,     0,     0,     0,
     548,     0,   582,     0,     0,  -723,  -723,  -723,     0,  -723,
    -723,     0,     0,     0,     0,     0,  -723,     0,     0,     0,
    -723,     0,     0,     0,     0,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,  -723,   549,  -723,     0,     0,     0,
    -723,     0,     0,     0,   550,  -723,     0,  -723,     0,     0,
     551,   552,  -723,  -723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   553,     0,     0,  -723,     0,   554,     0,  -723,
       0,   555,  -723,     0,     0,     0,  -723,  -723,  -723,     0,
    -723,   556,  -723,     0,   557,  -723,  -723,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   194,   558,
    -723,  -723,  -723,   197,  -723,  -723,  -723,  -723,   559,   203,
       0,     0,   560,     0,     0,   334,     0,   561,   562,     0,
    -723,     0,  -723,     0,     0,   563,     0,     0,   564,     0,
     565,   566,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   567,   568,     0,     0,     0,     0,     0,   569,
    -723,  -723,  -723,   340,     0,     0,   341,     0,  -723,     0,
       0,   342,     0,   343,   570,     0,     0,   571,   572,     0,
     573,     0,   574,   348,     0,   349,   350,     0,   351,   352,
    -723,    73,   575,   576,   -60,     0,     0,   577,   356,   -60,
       0,     0,  -723,  -723,  -723,   578,   579,   580,     0,   240,
     581,  -723,  -723,  -723,     0,  -723,  -723,  -723,  -723,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   -60,   582,
       0,     0,  -723,  -723,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   -60,     0,     0,     0,     0,     0,   -60,
     -60,     0,     0,     0,     0,    74,     0,     0,    75,    76,
      77,     0,    78,     0,    79,    80,     0,    81,    82,    83,
       0,    84,    85,     0,    86,     0,    87,    88,    89,    90,
      91,     0,    92,     0,    93,     0,    94,    95,    96,     0,
      97,     0,    98,     0,    99,     0,   100,   101,   102,   103,
     104,     0,   105,   106,     0,   107,   108,     0,   109,     0,
     110,     0,   111,     0,   112,     0,   113,     0,   114,   115,
     116,     0,     0,     0,     0,   320,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     -60,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   -60,     0,     0,
       0,     0,   -60,     0,     0,     0,     0,   -60,     0,     0,
       0,     0,     0,     0,   -60,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   321,     0,   -60,     0,   -60,
     -60,     0,   118,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   -60,     0,     0,     0,     0,     0,   -60,     0,
       0,     0,   -60,     0,     0,   -60,     0,     0,     0,     0,
     -60,     0,   -60,   -60,     0,     0,   -60,   -60,     0,   -60,
       0,     0,   -60,     0,   -60,   -60,     0,   -60,   -60,     0,
       0,   -60,   -60,   119,     0, -1064,   -60,   -60, -1064,     0,
       0,     0, -1064,     0, -1064, -1064,     0,     0,     0, -1064,
   -1064, -1064,     0, -1064, -1064, -1064,     0, -1064, -1064, -1064,
       0,     0,     0,     0,  1231,     0,     0,     0,    64,     0,
       0,    65,    66,     0,     0,     0,     0,     0,     0,     0,
       0, -1064,   888, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064,     0,     0, -1064, -1064,     0, -1064,     0,
   -1064,     0,     0, -1064,     0, -1064,     0,     0,     0,     0,
       0, -1064,     0, -1064, -1064,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   889,     0,     0,     0,     0,
       0,     0, -1064, -1064, -1064, -1064,     0, -1064, -1064,     0,
   -1064, -1064,     0,     0,     0,     0,     0, -1064,     0,     0,
   -1064,     0,     0, -1064,     0, -1064,     0,     0,     0,     0,
       0,     0, -1064, -1064,     0, -1064, -1064,     0,     0,     0,
   -1064,     0,     0,     0,     0, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064, -1064,     0,     0,     0, -1064,     0,     0,
       0,     0,     0,     0, -1064,     0,     0, -1064,     0,     0,
       0, -1064,   890, -1064, -1064, -1064, -1064,     0, -1064, -1064,
   -1064,     0, -1064, -1064, -1064,     0, -1064, -1064, -1064,     0,
       0,     0,     0,  1375,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   -1064,   888, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064,     0,     0, -1064, -1064,     0, -1064,     0, -1064,
       0,     0, -1064,     0, -1064,     0,     0,     0,     0,     0,
   -1064,     0, -1064, -1064,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   889,     0,     0,     0,     0,     0,
       0, -1064, -1064, -1064, -1064,     0, -1064, -1064,     0, -1064,
   -1064,     0,     0,     0,     0,     0, -1064,     0,     0, -1064,
       0,     0, -1064,     0, -1064,     0,     0,     0,     0,     0,
       0, -1064, -1064,     0, -1064, -1064,     0,     0,     0, -1064,
       0,     0,     0,     0, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064, -1064,     0,     0,     0, -1064,     0,     0,     0,
       0,     0,     0, -1064,     0,     0, -1064,     0,     0,     0,
   -1064,   890, -1064, -1064, -1064, -1064,     0, -1064, -1064, -1064,
       0, -1064, -1064, -1064,     0, -1064, -1064, -1064,     0,     0,
       0,     0,   692,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1064,
     888, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064,     0,     0, -1064, -1064,     0, -1064,     0, -1064,     0,
       0, -1064,     0, -1064,     0,     0,     0,     0,     0, -1064,
       0, -1064, -1064,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   889,     0,     0,     0,     0,     0,     0,
   -1064, -1064, -1064, -1064,     0, -1064, -1064,     0, -1064, -1064,
       0,     0,     0,     0,     0, -1064,     0,     0, -1064,     0,
       0, -1064,     0, -1064,     0,     0,     0,     0,     0,     0,
   -1064, -1064,     0, -1064, -1064,     0,     0,     0, -1064,     0,
       0,     0,     0, -1064, -1064, -1064, -1064, -1064, -1064, -1064,
   -1064, -1064,     0,     0,     0, -1064,     0,     0,     0,     0,
       0,     0,   181,     0,     0,   182,     0,     0,     0,   183,
     890,   184,   185, -1064, -1064,     0,   186,   187,   188,     0,
     189,   190,    15,     0,   191,    17,   192,     0,     0,     0,
     733,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   194,     0,
      20,   195,   196,   197,   198,   199,   200,   201,   466,   203,
       0,     0,   205,   206,     0,   207,     0,   208,     0,     0,
     209,     0,    22,     0,     0,     0,     0,     0,   210,     0,
     211,   212,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   467,
     216,   217,   218,     0,   219,   220,     0,   221,   222,     0,
       0,     0,     0,     0,   224,     0,     0,   225,     0,     0,
     226,     0,   227,     0,     0,     0,     0,     0,     0,   228,
     229,     0,   230,   231,     0,     0,     0,   232,     0,     0,
       0,     0,   233,   234,   235,   236,   237,   238,   239,   240,
     241,     0,     0,     0,   242,     0,     0,     0,     0,     0,
     181,     0,     0,   182,     0,     0,     0,   183,   679,   184,
     185,     0,    65,    66,   186,   187,   188,     0,   189,   190,
      15,     0,   191,    17,   192,     0,   547,     0,     0,     0,
       0,   548,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   194,     0,    20,   195,
     196,   197,   198,   199,   200,   201,   466,   203,     0,     0,
     205,   206,     0,   207,     0,   208,   549,     0,   209,     0,
      22,     0,     0,     0,     0,   550,   210,     0,   211,   212,
       0,   551,   552,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -709,     0,     0,     0,   467,   216,   217,
     218,     0,   219,   220,     0,   221,   222,     0,     0,     0,
       0,     0,   224,     0,     0,   225,     0,     0,   226,     0,
     227,     0,     0,     0,     0,     0,     0,   228,   229,     0,
     230,   231,     0,     0,     0,   232,     0,     0,     0,     0,
     233,   234,   235,   236,   237,   238,   239,   240,   241,     0,
       0,     0,   242,   553,     0,     0,     0,     0,   554,     0,
       0,     0,   555,     0,     0,     0,     0,     0,     0,     0,
      65,    66,   556,     0,     0,   557,     0,     0,     0,     0,
       0,   547,     0,     0,     0,     0,   548,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
     558,     0,     0,     0,   197,     0,     0,     0,     0,   559,
     203,     0,     0,   560,     0,     0,   334,     0,   561,   562,
       0,   549,     0,     0,     0,     0,   563,     0,     0,   564,
     550,   565,   566,     0,     0,     0,   551,   552,     0,     0,
       0,     0,     0,   567,   568,     0,     0,     0,     0,     0,
     569,     0,     0,     0,   340,     0,     0,   341,     0,     0,
       0,     0,   342,     0,   343,   570,     0,     0,   571,   572,
       0,   573,     0,   574,   348,     0,   349,   350,     0,   351,
     352,     0,     0,   575,   576,     0,     0,     0,   577,   356,
       0,     0,     0,     0,     0,     0,   578,   579,   580,     0,
     240,   581,     0,     0,     0,     0,     0,     0,   553,     0,
       0,     0,     0,   554,     0,     0,     0,   555,  -807,     0,
     582,     0,     0,     0,     0,     0,     0,   556,     0,     0,
     557,  -807,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   980,   981,     0,   194,   558,     0,     0,     0,   197,
       0,     0,     0,     0,   559,   203,     0,   982,   560,     0,
       0,   334,     0,   561,   562,     0,     0,     0,     0,     0,
    -807,   563,     0,     0,   564,     0,   565,   566,  -807,     0,
       0,     0,     0,     0,     0,   983,     0,     0,   567,   568,
       0,     0,   980,   981,     0,   569,     0,     0,     0,   340,
       0,     0,   341,     0,     0,     0,     0,   342,   982,   343,
     570,     0,     0,   571,   572,     0,   573,     0,   574,   348,
       0,   349,   350,     0,   351,   352,     0,     0,   575,   576,
       0,     0,     0,   577,   356,     0,   983,  -807,     0,     0,
       0,   578,   579,   580,     0,   240,   581,     0,     0,     0,
       0,     0,     0,   187,   188,     0,   189,   984,     0,     0,
       0,   985,   192,     0,   986,   582,     0,     0,   987,     0,
       0,     0,     0,     0,    15,     0,     0,    17,     0,     0,
       0,   547,     0,     0,     0,     0,   548,   195,     0,     0,
       0,     0,   200,   201,     0,     0,  -807,     0,     0,     0,
       0,     0,    20,     0,   988,     0,   989,   990,   984,     0,
       0,     0,   985,     0,     0,   986,     0,     0,     0,   987,
       0,   549,   991,     0,    22,     0,     0,     0,     0,     0,
     550,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -807,     0,     0,     0,     0,
       0,     0,   992,   993,   994,   988,     0,   989,   990,     0,
     995,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   991,     0,     0,     0,     0,     0,     0,
     235,     0,   996,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   997,   998,  -807,     0,     0,     0,
    -807,   328,     0,   992,   993,   994,   329,     0,   553,     0,
       0,   995,     0,   554,     0,     0,     0,   555,     0,     0,
       0,     0,     0,     0,    65,    66,     0,   556,     0,     0,
     557,     0,     0,   996,     0,   330,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   997,   998,     0,     0,     0,
     331,     0,     0,     0,   194,     0,     0,     0,     0,   197,
       0,     0,     0,     0,   559,   203,     0,     0,   560,     0,
       0,   334,  1407,   561,   562,     0,     0,     0,   328,     0,
       0,   563,     0,   329,   564,     0,   565,   566,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   567,   568,
       0,     0,     0,     0,     0,   569,     0,     0,     0,   340,
       0,     0,   341,     0,     0,     0,     0,   342,     0,   343,
     570,     0,     0,   571,   572,     0,   573,   331,   574,   348,
       0,   349,   350,     0,   351,   352,     0,     0,   575,   576,
       0,   766,     0,   577,   356,     0,     0,   332,     0,  1206,
     767,   578,   579,   580,   768,   240,   581,     0,     0,     0,
    -715,     0,     0,     0,     0,     0,     0,     0,  -715,     0,
    -715,     0,     0,     0,   769,     0,     0,     0,     0,   770,
       0,   771,     0,     0,   333,     0,   772,     0,     0,     0,
       0,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   335,     0,   336,   337,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   338,
       0,     0,     0,     0,   332,   339,     0,     0,     0,   340,
       0,     0,   341,     0,     0,     0,     0,   342,     0,   343,
     344,     0,     0,   345,   346,     0,   347,     0,     0,   348,
       0,   349,   350,     0,   351,   352,     0,     0,   353,   354,
       0,   333,     0,   355,   356,     0,     0,     0,   334,     0,
       0,   187,   188,     0,   189,     0,     0,     0,     0,     0,
     192,   335,     0,   336,   337,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   338,     0,     0,     0,
       0,     0,   339,     0,     0,   195,   340,     0,     0,   341,
     200,   201,     0,     0,   342,     0,   343,   344,     0,     0,
     345,   346,     0,   347,     0,     0,   348,     0,   349,   350,
       0,   351,   352,     0,     0,   353,   354,     0,     0,     0,
     355,   356,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   235,     0,
       0,     0,     0,     0,     0,   773,   699,   700,     0,   701,
     702,   703,   704,   383,     0,     0,   384,   385,   842,   843,
     388,   389,   390,   391,     0,   392,   393,   394,     0,   395,
     396,     0,   397,     0,   398,   399,   400,   401,   402,     0,
     403,     0,   404,     0,   405,   406,   407,     0,   408,     0,
     409,     0,   410,     0,   411,   412,   413,   414,     0,     0,
     415,   416,     0,   417,   418,     0,   419,     0,   420,     0,
     421,     0,   422,     0,   423,     0,   424,   425,   844,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   427,   845,   428,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   846,   847,     0,
       0,     0,     0,     0,     0,     0,   429,     0,   383,     0,
       0,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,     0,   395,   396,     0,   397,     0,   398,
     399,   400,   401,   402,     0,   403,     0,   404,     0,   405,
     406,   407,     0,   408,     0,   409,     0,   410,     0,   411,
     412,   413,   414,     0,     0,   415,   416,     0,   417,   418,
       0,   419,     0,   420,     0,   421,     0,   422,     0,   423,
       0,   424,   425,   426,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     427,     0,   428,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   430,   431,   432,   433,
     434,   429,     0,   435,     0,   436,   437,     0,   438,     0,
       0,     0,   439,   440,   441,   442,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   383,     0,     0,   384,   385,
     645,   387,   388,   389,   390,   391,     0,   392,   393,   394,
       0,   395,   396,     0,   397,     0,   398,   399,   400,   401,
     402,     0,   403,     0,   404,     0,   405,   406,   407,     0,
     408,     0,   409,     0,   410,     0,   411,   412,   413,   414,
       0,     0,   415,   416,     0,   417,   418,     0,   419,     0,
     420,     0,   421,     0,   422,     0,   423,     0,   424,   425,
     426,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   430,   431,   432,   433,   434,     0,   427,   435,   428,
     436,   437,     0,   438,     0,     0,     0,   439,   440,   441,
     442,     0,   383,     0,     0,   384,   385,   824,   429,   388,
     389,   390,   391,     0,   392,   393,   394,     0,   395,   396,
       0,   397,     0,   398,   399,   400,   401,   402,     0,   403,
       0,   404,     0,   405,   406,   407,     0,   408,     0,   409,
       0,   410,     0,   411,   412,   413,   414,     0,     0,   415,
     416,     0,   417,   418,     0,   419,     0,   420,     0,   421,
       0,   422,     0,   423,     0,   424,   425,   426,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   427,     0,   428,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   429,     0,     0,   430,   431,
     432,   433,   434,     0,     0,   435,     0,   436,   437,     0,
     438,     0,     0,     0,   439,   440,   441,   442,     0,   383,
       0,     0,   384,   385,   637,     0,   388,   389,   390,   391,
       0,   392,   393,   394,     0,   395,   396,     0,   397,     0,
     398,   399,   400,   401,   402,     0,   403,     0,   404,     0,
     405,   406,   407,     0,   408,     0,   409,     0,   410,     0,
     411,   412,   413,   414,     0,     0,   415,   416,     0,   417,
     418,     0,   419,     0,   420,     0,   421,     0,   422,     0,
     423,     0,   424,   425,   830,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   430,   431,   432,   433,   434,
       0,   427,   435,   428,   436,   437,     0,   438,     0,     0,
       0,   439,   440,   441,   442,     0,   383,     0,     0,   384,
     385,   637,   429,   388,   389,   390,   391,     0,   392,   393,
     394,     0,   395,   396,     0,   397,     0,   398,   399,   400,
     401,   402,     0,   403,     0,   404,     0,   405,   406,   407,
       0,   408,     0,   409,     0,   410,     0,   411,   412,   413,
     414,     0,     0,   415,   416,     0,   417,   418,     0,   419,
       0,   420,     0,   421,     0,   422,     0,   423,     0,   424,
     425,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   427,     0,
     428,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   429,
       0,     0,   430,   431,   432,   433,   434,     0,     0,   435,
       0,   436,   437,     0,   438,     0,     0,     0,   439,   440,
     441,   442,     0,     0,     0,     0,     0,     0,     0,     0,
     180,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   181,     0,     0,   182,     0,     0,     0,
     183,     0,   184,   185,     0,     0,     0,   186,   187,   188,
       0,   189,   190,    15,     0,   191,    17,   192,     0,   430,
     431,   432,   433,   434,     0,     0,   435,     0,   436,   437,
       0,   438,     0,     0,     0,   439,   440,   441,   442,   194,
       0,    20,   195,   196,   197,   198,   199,   200,   201,   466,
     203,     0,     0,   205,   206,     0,   207,     0,   208,     0,
       0,   209,     0,    22,     0,     0,     0,     0,     0,   210,
       0,   211,   212,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     467,   216,   217,   218,     0,   219,   220,     0,   221,   222,
       0,     0,     0,     0,     0,   224,     0,     0,   225,     0,
       0,   226,     0,   227,     0,     0,     0,     0,     0,     0,
     228,   229,     0,   230,   231,     0,     0,     0,   232,     0,
       0,     0,     0,   233,   234,   235,   236,   237,   238,   239,
     240,   241,     0,     0,     0,   242,     0,     0,     0,     0,
       0,   181,     0,     0,   182,     0,     0,     0,   183,     0,
     184,   185,     0,    65,    66,   186,   187,   188,     0,   189,
     190,    15,     0,   191,    17,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   194,     0,    20,
     195,   196,   197,   198,   199,   200,   201,   466,   203,     0,
       0,   205,   206,     0,   207,     0,   208,     0,     0,   209,
       0,    22,     0,     0,     0,     0,     0,   210,     0,   211,
     212,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   467,   216,
     217,   218,     0,   219,   220,     0,   221,   222,     0,     0,
       0,     0,     0,   224,     0,     0,   225,     0,     0,   226,
       0,   227,     0,     0,     0,     0,     0,     0,   228,   229,
       0,   230,   231,     0,     0,     0,   232,     0,     0,     0,
       0,   233,   234,   235,   236,   237,   238,   239,   240,   241,
       0,     0,   182,   242,     0,     0,   183,     0,     0,   185,
       0,     0,     0,   186,   935,     0,     0,   936,     0,     0,
       0,    65,    66,   937,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   938,   196,
       0,   198,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   181,   209,     0,     0,
       0,     0,     0,     0,     0,   184,     0,     0,     0,     0,
       0,   187,   188,     0,   189,   190,     0,     0,   191,     0,
     192,     0,     0,     0,     0,     0,     0,   216,   217,   218,
       0,   219,   220,     0,     0,   222,     0,     0,     0,     0,
       0,     0,   194,     0,     0,   195,     0,   197,     0,     0,
     200,   201,   466,   203,     0,     0,   205,   229,     0,   207,
       0,   208,     0,     0,     0,     0,     0,     0,     0,   233,
     234,     0,   210,     0,   211,   212,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   467,     0,     0,     0,     0,     0,    65,
      66,   221,     0,     0,     0,     0,     0,     0,   224,     0,
       0,   225,     0,     0,   226,     0,   227,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   230,   231,     0,     0,
       0,   232,     0,     0,     0,     0,     0,     0,   235,   236,
     237,   238,   239,   240,   241,     0,     0,     0,   242
};

static const yytype_int16 yycheck[] =
{
       4,     5,     6,    35,    12,     1,     4,     5,     6,   178,
     286,     1,   318,   477,    67,   318,   120,   155,   274,   326,
     327,   742,   909,   505,   506,   507,   180,   206,   307,   492,
     126,    35,    40,   975,   179,   506,    40,    35,   184,   218,
     767,   729,   642,   816,   180,     1,   773,   942,     1,   882,
     318,   505,   506,   507,   887,     1,   919,   932,   364,     1,
     366,   364,     1,   366,     1,   696,   697,   698,     1,     1,
     249,     1,     1,     1,     1,   264,    42,     1,     1,     1,
     495,     1,   377,     1,    65,    78,    67,     1,   708,   504,
       1,   359,   641,     1,   273,     1,   364,     1,   366,     1,
      65,     1,     1,     1,     1,   278,     1,     1,    75,     1,
     277,   278,     1,    77,    78,     1,     1,   875,     1,     1,
       1,    71,     1,     1,  1143,     1,  1171,     1,    30,    71,
       1,     1,     1,  1369,    71,    23,     1,     1,   896,    17,
     299,   899,     1,    63,     1,     1,    55,   920,   112,   870,
      70,     1,   226,    71,     1,     1,     1,   933,     1,   465,
      21,   386,   465,     1,   579,   187,    55,   925,   151,     1,
     178,    71,    21,   505,   506,   507,   468,     1,    17,     1,
     293,  1417,  1418,   203,    72,   205,   907,    73,    71,   965,
      73,     1,    78,   800,   801,    17,    28,   465,     1,    58,
       1,     1,    71,    73,    70,   832,    71,    71,    54,    58,
       1,    77,    78,    58,    71,     1,   587,    73,   201,    58,
    1095,   909,    46,    52,   745,   136,    73,    70,   178,    72,
      59,    41,    70,  1278,  1129,   514,   178,   516,   112,   148,
      70,   723,   108,     1,    78,   513,    96,   130,   178,   134,
    1125,   153,   130,   145,  1273,   136,   264,   221,   745,   148,
     130,   130,    48,   745,   543,   130,   130,    58,    71,   723,
      71,   221,  1306,   130,   130,   136,   298,   908,   157,   301,
     302,   450,   831,   303,    46,   588,   459,   136,  1322,   505,
     506,   507,   459,   204,   914,  1053,  1054,  1055,  1056,   221,
     308,     1,   306,   307,   297,   313,   788,   288,   306,   307,
     277,   319,   365,   309,   318,   319,   198,   241,   497,   498,
     588,   490,   511,   288,   228,   227,   480,   256,   482,  1204,
     296,   363,  1274,   502,   298,   504,   631,   270,  1059,  1281,
     211,   297,   806,   512,   523,   481,   299,   526,   298,  1212,
     289,   766,   521,   835,   300,     1,   298,   303,   290,   363,
     364,   298,   366,   291,   835,   363,   298,   290,   298,   301,
     302,   298,  1259,  1260,   301,   302,   840,   297,   685,   686,
     298,   835,  1257,   675,   298,  1218,   297,   301,   302,   681,
     298,   723,   298,   301,   302,   301,  1169,  1170,   298,   298,
     298,   298,   694,   298,   298,   820,   505,   506,   507,   555,
     289,   297,   288,   213,   293,   640,  1043,   642,   789,   298,
     902,   942,  1149,     1,   906,  1123,  1124,   652,   910,   911,
     912,   902,   298,    65,   897,   301,   302,   637,  1196,   910,
     911,   912,   450,  1330,  1044,  1340,  1321,     1,   902,  1391,
     208,   151,   906,   153,   154,   942,   910,   911,   912,  1090,
     942,   465,   292,   297,   298,   223,  1097,   297,   298,   177,
     300,    77,    26,   303,   182,   929,  1234,    17,     1,   179,
      17,   203,   490,   205,   492,   277,   792,   187,    65,   792,
      30,   283,    17,   908,   502,  1390,   504,   505,   506,   507,
      14,   201,   108,   835,   512,     1,   809,    17,   687,    46,
     514,   211,   516,   521,   820,   519,   514,   820,   516,   822,
      30,   519,   667,     1,   792,   148,   222,   227,    65,     1,
    1251,   627,   668,     1,  1421,     1,  1294,    72,    16,   543,
      65,   809,   696,   697,   698,   543,   236,   112,     1,    63,
      73,   247,   820,   300,   822,    78,   303,    77,    78,  1023,
     696,   697,   698,  1261,     1,   744,  1197,   859,    72,   984,
     902,  1259,  1260,   151,   906,    71,   154,    65,   910,   911,
     912,   303,  1254,  1255,  1256,     1,   232,   277,   108,   235,
    1005,   291,  1350,   283,    70,    81,   242,   929,  1296,    71,
      70,   908,    78,    72,    72,    71,   252,   832,   254,    72,
    1074,   257,   258,   153,  1078,     1,   795,  1315,    71,   835,
    1347,   267,   245,   201,   824,   850,   826,   150,  1326,    97,
     253,    17,     1,    70,   130,     1,   297,   298,    59,    60,
      77,    78,  1330,   153,  1378,   289,   269,    27,   924,   293,
    1384,    37,   298,   298,   177,    71,   301,   302,   130,   182,
     277,  1349,  1420,   969,   130,   188,   969,  1401,   191,   297,
     298,   108,    58,   979,    54,   189,   979,   130,    31,  1400,
      33,  1369,     1,    36,     3,   854,   902,   227,  1422,   148,
     906,    70,  1413,    72,   910,   911,   912,    77,    78,     4,
       5,   969,    71,    72,  1402,  1403,   130,    73,  1011,   283,
       1,   979,  1194,   929,   130,   723,    65,   227,    67,   723,
     999,  1000,  1028,  1194,   238,  1028,   895,    65,   213,  1417,
    1418,   298,   112,  1421,   301,   302,   835,   745,   214,   877,
    1194,   749,   750,  1011,   187,    43,   750,    45,   227,    81,
     919,   274,   275,   276,   908,   278,   177,  1239,    70,   298,
    1028,   182,  1226,    70,   298,    72,    57,    18,  1239,    20,
    1062,    54,   908,    56,   297,   298,   213,   214,   298,   227,
     788,   301,   302,    73,   177,  1239,   245,   146,   792,   182,
     149,  1098,   788,  1100,   253,  1102,   155,  1089,   788,  1091,
    1254,  1255,  1256,   902,    65,   809,   290,   906,   288,    65,
     269,   910,   911,   912,   952,    70,   820,   955,  1043,  1044,
    1112,   180,   298,    71,   130,   301,   302,   835,  1243,    70,
     929,    10,   227,  1248,  1140,    14,    73,  1140,    71,  1303,
      19,   221,   106,   130,   281,   282,   854,   284,   285,   286,
     287,  1107,    67,   246,   288,   298,   249,   213,   301,   302,
     151,   298,  1194,   154,   301,   302,   232,   290,   290,   235,
     290,   290,  1140,    40,   878,  1181,   242,    70,  1181,  1017,
      39,    73,   213,    71,    71,   278,   252,   895,   254,   897,
     106,   257,   258,  1308,   902,    70,   187,    70,   906,    71,
      71,   267,   910,   911,   912,    71,  1198,  1239,  1215,    78,
     201,   919,    35,  1181,    50,   297,    51,    71,   298,    22,
     211,    73,  1254,  1255,  1256,  1217,    71,    71,   130,  1108,
     298,    71,   298,    70,   942,    73,  1090,  1116,  1245,    71,
      73,   289,    71,  1097,    78,    46,  1100,   298,    72,    71,
     946,    71,    70,     1,  1090,   112,   946,  1061,   153,    71,
      71,  1097,    71,  1020,   804,   969,   871,   829,   142,   648,
     640,  1109,   824,   826,  1049,   979,   132,  1030,  1194,   631,
     376,  1287,  1250,   850,  1287,    40,   177,  1279,   946,     1,
      40,   182,   748,  1194,   946,   999,  1000,   188,   946,   295,
     191,   999,  1000,   906,   507,   723,  1298,  1011,   723,  1316,
    1317,  1303,  1319,  1320,  1306,  1374,  1085,   723,   178,  1287,
    1312,    40,    70,  1239,  1028,   268,   264,   736,   745,    77,
      78,  1337,  1127,    20,  1337,   942,   908,  1206,  1254,  1255,
    1256,  1216,  1070,  1197,   668,  1219,  1305,  1038,   288,  1228,
    1011,   587,   177,   822,  1058,   588,  1348,   182,  1237,  1327,
     108,  1197,   555,   188,   547,   789,   191,  1389,  1360,  1337,
     527,   516,    40,  1252,   727,  1367,  1389,   172,   919,  1385,
      40,  1152,  1385,   274,   275,   276,  1192,   278,   309,   311,
    1191,     0,     1,  1184,     3,  1194,     5,     6,     7,     8,
    1135,    10,    11,    12,    13,   786,   503,   359,   550,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1385,    -1,  1395,
      -1,    -1,   134,    32,    -1,    -1,   138,    -1,    -1,   141,
      -1,    -1,    -1,   145,   146,    -1,  1140,   149,    -1,    -1,
    1239,    -1,    -1,   155,    -1,    -1,    -1,    -1,    -1,   274,
     275,   276,   277,   278,    -1,  1254,  1255,  1256,   283,    -1,
      -1,    -1,    -1,    -1,    -1,   213,   214,    -1,   180,   181,
      -1,   183,   184,    -1,    -1,    -1,    -1,  1181,    -1,    -1,
       1,    -1,    -1,    -1,    -1,     1,  1194,   199,    34,  1368,
      36,    37,    38,    39,    -1,    41,    -1,    43,  1206,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1216,  1392,    -1,    -1,    -1,   229,   230,   231,
      -1,   233,   234,    -1,  1393,   237,    -1,    -1,    -1,    -1,
      -1,  1239,    -1,   281,   282,    -1,   284,   285,   286,   287,
      -1,   150,   151,    -1,   153,   154,    -1,   259,   157,    -1,
     298,    -1,    -1,   301,   302,    -1,    -1,    73,    -1,   271,
     272,    -1,    78,    -1,    -1,    -1,    -1,    -1,   177,    -1,
     179,    -1,    -1,    -1,    -1,  1271,    -1,    70,   187,    -1,
      -1,    -1,    -1,  1287,    77,    78,    -1,    -1,    -1,   301,
     302,    -1,   201,   202,    -1,    -1,    -1,   206,    -1,    -1,
      -1,    -1,   211,    -1,  1336,    -1,    -1,  1311,    -1,   218,
     219,   220,    -1,    -1,    -1,   108,    -1,    -1,   227,     1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1336,  1337,   150,    -1,    -1,    -1,  1336,   160,
     161,   162,   163,   164,   165,   166,   167,   168,    -1,    -1,
     171,   172,   173,   174,   175,    -1,    -1,    -1,    -1,    -1,
      -1,   177,    -1,    -1,    -1,    -1,   182,    -1,    -1,    -1,
      -1,    -1,   188,    -1,    -1,   191,    -1,    -1,    -1,    -1,
     289,  1385,    -1,    65,   293,  1393,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,   307,    81,
      82,    -1,    84,    -1,    86,    87,    88,    89,    90,    -1,
      92,    -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,
     102,   214,   104,    -1,   106,   107,   108,   109,    -1,    -1,
     112,   113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,
     122,    -1,   124,    -1,   126,    -1,   128,   129,   130,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   274,   275,
     276,   277,   278,    -1,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,   293,    -1,    -1,   157,    -1,   159,    -1,    -1,
      -1,   297,   298,    -1,    -1,    -1,    -1,    -1,   281,   282,
      -1,   284,   285,   286,   287,    -1,   178,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,   301,   302,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,    70,
      -1,    72,    -1,    74,    75,    -1,    77,    78,    79,    -1,
      81,    82,    -1,    84,    -1,    86,    87,    88,    89,    90,
      -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,   100,
      -1,   102,    -1,   104,    -1,   106,   107,   108,   109,   110,
      -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,   130,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,
     141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,   288,   289,   290,   291,
     292,    -1,    -1,   295,    -1,   297,   298,    -1,   300,    -1,
      -1,    -1,   304,   305,   306,   307,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,    -1,
     191,   192,    -1,   194,    -1,   196,    -1,    -1,   199,    -1,
     201,    -1,    -1,   204,    -1,    -1,   207,    -1,   209,   210,
       1,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,   237,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,   263,    -1,    -1,   266,    -1,    -1,    -1,     1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    70,
      -1,    72,   283,    15,    -1,    17,    -1,    78,    -1,    -1,
      81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,   300,
     301,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,   140,
     141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,   150,
     151,    70,   153,   154,   155,    -1,    -1,    -1,    77,    78,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   176,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   108,
     191,   192,    -1,   194,    -1,   196,    -1,    -1,   199,    -1,
     201,   202,   203,    -1,   205,   206,   207,    -1,   209,   210,
      -1,   153,   213,   214,    -1,    -1,    -1,   218,   219,   220,
      -1,    -1,    -1,    -1,    -1,   226,   227,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,   237,   238,    -1,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
      -1,     1,   283,    -1,     4,   227,    -1,    -1,    -1,     9,
      -1,    -1,    -1,    -1,   213,   214,    16,   298,    18,    19,
     301,   302,   303,    -1,    -1,    25,    -1,    -1,    -1,    29,
      -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    53,    54,    -1,    56,    -1,    -1,    59,
      60,    61,    62,    -1,    -1,    -1,    -1,   289,    -1,    -1,
      -1,   293,    -1,    -1,   296,    -1,   298,    -1,    -1,   301,
     302,    -1,   281,   282,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,    -1,
     140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
      -1,   191,    -1,    -1,   194,    -1,   196,   197,    -1,   199,
      -1,   201,    -1,    -1,   204,    -1,    -1,   207,    -1,   209,
     210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   221,   222,    -1,    -1,    63,    -1,    -1,   228,   229,
     230,   231,   232,    71,    -1,   235,    -1,   237,    -1,    -1,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,   249,
      -1,   251,   252,    -1,   254,   255,    -1,   257,   258,   259,
      -1,   261,   262,    -1,    -1,    -1,   266,   267,    -1,    -1,
      -1,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,    -1,   284,   285,   286,   287,     1,    -1,
      -1,     4,   130,    -1,    -1,    -1,     9,   297,   298,    -1,
      -1,   301,   302,    16,    -1,    18,    19,    -1,   146,    -1,
      -1,   149,    25,    -1,    -1,    -1,    29,   155,    -1,    -1,
      -1,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      43,    44,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,   180,    56,    -1,    -1,    59,    60,    61,    62,
      -1,   189,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,   134,    -1,   136,    -1,   138,    -1,   140,   141,    -1,
      -1,    -1,   145,   146,   147,    -1,   149,   150,   151,    -1,
     153,   154,   155,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   289,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,    -1,    -1,   191,    -1,
      -1,   194,    -1,   196,   197,    -1,   199,    -1,   201,    -1,
      -1,   204,    -1,    -1,   207,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,    -1,    -1,    -1,    -1,   228,   229,   230,   231,   232,
      -1,    -1,   235,    -1,   237,    -1,    -1,   240,    -1,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    -1,   251,   252,
      -1,   254,   255,    -1,   257,   258,   259,    -1,   261,   262,
      -1,    -1,    -1,   266,   267,    -1,    -1,    -1,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
      -1,   284,   285,   286,   287,     1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,     9,    -1,   298,    -1,    -1,   301,   302,
      16,    -1,    18,    19,    -1,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,    -1,
      56,    -1,    -1,    59,    60,    61,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   131,    -1,    -1,   134,    -1,
     136,    -1,   138,    -1,   140,   141,    -1,    -1,    -1,   145,
     146,   147,    -1,   149,   150,   151,    -1,   153,   154,   155,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,    -1,   191,    -1,    -1,   194,    -1,
     196,   197,    -1,   199,    -1,   201,    -1,    -1,   204,    -1,
      -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,   222,    -1,    -1,    -1,
      -1,    -1,   228,   229,   230,   231,   232,    -1,    -1,   235,
      -1,   237,    -1,    -1,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,   249,    -1,   251,   252,    -1,   254,   255,
      -1,   257,   258,   259,    -1,   261,   262,    -1,    -1,    -1,
     266,   267,    -1,    -1,    -1,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,    -1,   284,   285,
     286,   287,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
       9,    -1,   298,    -1,    -1,   301,   302,    16,    -1,    18,
      19,    -1,    -1,    -1,    -1,    -1,    25,    -1,    -1,    -1,
      29,    -1,    -1,    -1,    -1,    34,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    53,    54,    -1,    56,    -1,    -1,
      59,    60,    61,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,   136,    -1,   138,
      -1,   140,   141,    -1,    -1,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,    -1,   191,    -1,    -1,   194,    -1,   196,   197,    -1,
     199,    -1,   201,    -1,    -1,   204,    -1,    -1,   207,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,   228,
     229,   230,   231,   232,    -1,    -1,   235,    -1,   237,    -1,
      -1,   240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,
     249,    -1,   251,   252,    -1,   254,   255,    -1,   257,   258,
     259,     1,   261,   262,     4,    -1,    -1,   266,   267,     9,
      -1,    -1,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,    -1,   284,   285,   286,   287,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,   298,
      -1,    -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    59,
      60,    -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,
      70,    -1,    72,    -1,    74,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    84,    -1,    86,    87,    88,    89,
      90,    -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,
     100,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
     110,    -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,
     120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     150,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,    -1,
      -1,    -1,   182,    -1,    -1,    -1,    -1,   187,    -1,    -1,
      -1,    -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   204,    71,    -1,   207,    -1,   209,
     210,    -1,   212,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   222,    -1,    -1,    -1,    -1,    -1,   228,    -1,
      -1,    -1,   232,    -1,    -1,   235,    -1,    -1,    -1,    -1,
     240,    -1,   242,   243,    -1,    -1,   246,   247,    -1,   249,
      -1,    -1,   252,    -1,   254,   255,    -1,   257,   258,    -1,
      -1,   261,   262,   263,    -1,   131,   266,   267,   134,    -1,
      -1,    -1,   138,    -1,   140,   141,    -1,    -1,    -1,   145,
     146,   147,    -1,   149,   150,   151,    -1,   153,   154,   155,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,   298,    -1,
      -1,   301,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,    -1,    -1,   191,   192,    -1,   194,    -1,
     196,    -1,    -1,   199,    -1,   201,    -1,    -1,    -1,    -1,
      -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,
      -1,    -1,   228,   229,   230,   231,    -1,   233,   234,    -1,
     236,   237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,
     246,    -1,    -1,   249,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,   258,   259,    -1,   261,   262,    -1,    -1,    -1,
     266,    -1,    -1,    -1,    -1,   271,   272,   273,   274,   275,
     276,   277,   278,   279,    -1,    -1,    -1,   283,    -1,    -1,
      -1,    -1,    -1,    -1,   131,    -1,    -1,   134,    -1,    -1,
      -1,   138,   298,   140,   141,   301,   302,    -1,   145,   146,
     147,    -1,   149,   150,   151,    -1,   153,   154,   155,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,    -1,    -1,   191,   192,    -1,   194,    -1,   196,
      -1,    -1,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,
     207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,
      -1,   228,   229,   230,   231,    -1,   233,   234,    -1,   236,
     237,    -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,   246,
      -1,    -1,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,
      -1,   258,   259,    -1,   261,   262,    -1,    -1,    -1,   266,
      -1,    -1,    -1,    -1,   271,   272,   273,   274,   275,   276,
     277,   278,   279,    -1,    -1,    -1,   283,    -1,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,
     138,   298,   140,   141,   301,   302,    -1,   145,   146,   147,
      -1,   149,   150,   151,    -1,   153,   154,   155,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,    -1,    -1,   191,   192,    -1,   194,    -1,   196,    -1,
      -1,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,
      -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   221,    -1,    -1,    -1,    -1,    -1,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,   237,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,   246,    -1,
      -1,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
     258,   259,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,
      -1,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,
     298,   140,   141,   301,   302,    -1,   145,   146,   147,    -1,
     149,   150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
      -1,    -1,   191,   192,    -1,   194,    -1,   196,    -1,    -1,
     199,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,    -1,
     209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,
     229,   230,   231,    -1,   233,   234,    -1,   236,   237,    -1,
      -1,    -1,    -1,    -1,   243,    -1,    -1,   246,    -1,    -1,
     249,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,   258,
     259,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,    -1,
      -1,    -1,   271,   272,   273,   274,   275,   276,   277,   278,
     279,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,    -1,
     131,    -1,    -1,   134,    -1,    -1,    -1,   138,   297,   140,
     141,    -1,   301,   302,   145,   146,   147,    -1,   149,   150,
     151,    -1,   153,   154,   155,    -1,     4,    -1,    -1,    -1,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,    -1,    -1,
     191,   192,    -1,   194,    -1,   196,    44,    -1,   199,    -1,
     201,    -1,    -1,    -1,    -1,    53,   207,    -1,   209,   210,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,   228,   229,   230,
     231,    -1,   233,   234,    -1,   236,   237,    -1,    -1,    -1,
      -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,    -1,
     261,   262,    -1,    -1,    -1,   266,    -1,    -1,    -1,    -1,
     271,   272,   273,   274,   275,   276,   277,   278,   279,    -1,
      -1,    -1,   283,   131,    -1,    -1,    -1,    -1,   136,    -1,
      -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     301,   302,   150,    -1,    -1,   153,    -1,    -1,    -1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,
     178,    -1,    -1,    -1,   182,    -1,    -1,    -1,    -1,   187,
     188,    -1,    -1,   191,    -1,    -1,   194,    -1,   196,   197,
      -1,    44,    -1,    -1,    -1,    -1,   204,    -1,    -1,   207,
      53,   209,   210,    -1,    -1,    -1,    59,    60,    -1,    -1,
      -1,    -1,    -1,   221,   222,    -1,    -1,    -1,    -1,    -1,
     228,    -1,    -1,    -1,   232,    -1,    -1,   235,    -1,    -1,
      -1,    -1,   240,    -1,   242,   243,    -1,    -1,   246,   247,
      -1,   249,    -1,   251,   252,    -1,   254,   255,    -1,   257,
     258,    -1,    -1,   261,   262,    -1,    -1,    -1,   266,   267,
      -1,    -1,    -1,    -1,    -1,    -1,   274,   275,   276,    -1,
     278,   279,    -1,    -1,    -1,    -1,    -1,    -1,   131,    -1,
      -1,    -1,    -1,   136,    -1,    -1,    -1,   140,     1,    -1,
     298,    -1,    -1,    -1,    -1,    -1,    -1,   150,    -1,    -1,
     153,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    -1,   177,   178,    -1,    -1,    -1,   182,
      -1,    -1,    -1,    -1,   187,   188,    -1,    34,   191,    -1,
      -1,   194,    -1,   196,   197,    -1,    -1,    -1,    -1,    -1,
      63,   204,    -1,    -1,   207,    -1,   209,   210,    71,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,   221,   222,
      -1,    -1,    18,    19,    -1,   228,    -1,    -1,    -1,   232,
      -1,    -1,   235,    -1,    -1,    -1,    -1,   240,    34,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    -1,   251,   252,
      -1,   254,   255,    -1,   257,   258,    -1,    -1,   261,   262,
      -1,    -1,    -1,   266,   267,    -1,    62,   130,    -1,    -1,
      -1,   274,   275,   276,    -1,   278,   279,    -1,    -1,    -1,
      -1,    -1,    -1,   146,   147,    -1,   149,   134,    -1,    -1,
      -1,   138,   155,    -1,   141,   298,    -1,    -1,   145,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    -1,   154,    -1,    -1,
      -1,     4,    -1,    -1,    -1,    -1,     9,   180,    -1,    -1,
      -1,    -1,   185,   186,    -1,    -1,   189,    -1,    -1,    -1,
      -1,    -1,   179,    -1,   181,    -1,   183,   184,   134,    -1,
      -1,    -1,   138,    -1,    -1,   141,    -1,    -1,    -1,   145,
      -1,    44,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,
      53,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   238,    -1,    -1,    -1,    -1,
      -1,    -1,   229,   230,   231,   181,    -1,   183,   184,    -1,
     237,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   199,    -1,    -1,    -1,    -1,    -1,    -1,
     273,    -1,   259,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   271,   272,   289,    -1,    -1,    -1,
     293,     4,    -1,   229,   230,   231,     9,    -1,   131,    -1,
      -1,   237,    -1,   136,    -1,    -1,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,   301,   302,    -1,   150,    -1,    -1,
     153,    -1,    -1,   259,    -1,    38,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   271,   272,    -1,    -1,    -1,
      53,    -1,    -1,    -1,   177,    -1,    -1,    -1,    -1,   182,
      -1,    -1,    -1,    -1,   187,   188,    -1,    -1,   191,    -1,
      -1,   194,   298,   196,   197,    -1,    -1,    -1,     4,    -1,
      -1,   204,    -1,     9,   207,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   221,   222,
      -1,    -1,    -1,    -1,    -1,   228,    -1,    -1,    -1,   232,
      -1,    -1,   235,    -1,    -1,    -1,    -1,   240,    -1,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    53,   251,   252,
      -1,   254,   255,    -1,   257,   258,    -1,    -1,   261,   262,
      -1,    16,    -1,   266,   267,    -1,    -1,   150,    -1,    75,
      25,   274,   275,   276,    29,   278,   279,    -1,    -1,    -1,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    54,
      -1,    56,    -1,    -1,   187,    -1,    61,    -1,    -1,    -1,
      -1,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   207,    -1,   209,   210,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   222,
      -1,    -1,    -1,    -1,   150,   228,    -1,    -1,    -1,   232,
      -1,    -1,   235,    -1,    -1,    -1,    -1,   240,    -1,   242,
     243,    -1,    -1,   246,   247,    -1,   249,    -1,    -1,   252,
      -1,   254,   255,    -1,   257,   258,    -1,    -1,   261,   262,
      -1,   187,    -1,   266,   267,    -1,    -1,    -1,   194,    -1,
      -1,   146,   147,    -1,   149,    -1,    -1,    -1,    -1,    -1,
     155,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   222,    -1,    -1,    -1,
      -1,    -1,   228,    -1,    -1,   180,   232,    -1,    -1,   235,
     185,   186,    -1,    -1,   240,    -1,   242,   243,    -1,    -1,
     246,   247,    -1,   249,    -1,    -1,   252,    -1,   254,   255,
      -1,   257,   258,    -1,    -1,   261,   262,    -1,    -1,    -1,
     266,   267,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   273,    -1,
      -1,    -1,    -1,    -1,    -1,   280,   281,   282,    -1,   284,
     285,   286,   287,    65,    -1,    -1,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    77,    78,    79,    -1,    81,
      82,    -1,    84,    -1,    86,    87,    88,    89,    90,    -1,
      92,    -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,
     102,    -1,   104,    -1,   106,   107,   108,   109,    -1,    -1,
     112,   113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,
     122,    -1,   124,    -1,   126,    -1,   128,   129,   130,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   157,   158,   159,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   169,   170,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   178,    -1,    65,    -1,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      77,    78,    79,    -1,    81,    82,    -1,    84,    -1,    86,
      87,    88,    89,    90,    -1,    92,    -1,    94,    -1,    96,
      97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,   106,
     107,   108,   109,    -1,    -1,   112,   113,    -1,   115,   116,
      -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     157,    -1,   159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   288,   289,   290,   291,
     292,   178,    -1,   295,    -1,   297,   298,    -1,   300,    -1,
      -1,    -1,   304,   305,   306,   307,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    77,    78,    79,
      -1,    81,    82,    -1,    84,    -1,    86,    87,    88,    89,
      90,    -1,    92,    -1,    94,    -1,    96,    97,    98,    -1,
     100,    -1,   102,    -1,   104,    -1,   106,   107,   108,   109,
      -1,    -1,   112,   113,    -1,   115,   116,    -1,   118,    -1,
     120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,   129,
     130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   288,   289,   290,   291,   292,    -1,   157,   295,   159,
     297,   298,    -1,   300,    -1,    -1,    -1,   304,   305,   306,
     307,    -1,    65,    -1,    -1,    68,    69,    70,   178,    72,
      73,    74,    75,    -1,    77,    78,    79,    -1,    81,    82,
      -1,    84,    -1,    86,    87,    88,    89,    90,    -1,    92,
      -1,    94,    -1,    96,    97,    98,    -1,   100,    -1,   102,
      -1,   104,    -1,   106,   107,   108,   109,    -1,    -1,   112,
     113,    -1,   115,   116,    -1,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,   126,    -1,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   157,    -1,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,    -1,   288,   289,
     290,   291,   292,    -1,    -1,   295,    -1,   297,   298,    -1,
     300,    -1,    -1,    -1,   304,   305,   306,   307,    -1,    65,
      -1,    -1,    68,    69,    70,    -1,    72,    73,    74,    75,
      -1,    77,    78,    79,    -1,    81,    82,    -1,    84,    -1,
      86,    87,    88,    89,    90,    -1,    92,    -1,    94,    -1,
      96,    97,    98,    -1,   100,    -1,   102,    -1,   104,    -1,
     106,   107,   108,   109,    -1,    -1,   112,   113,    -1,   115,
     116,    -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,
     126,    -1,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   288,   289,   290,   291,   292,
      -1,   157,   295,   159,   297,   298,    -1,   300,    -1,    -1,
      -1,   304,   305,   306,   307,    -1,    65,    -1,    -1,    68,
      69,    70,   178,    72,    73,    74,    75,    -1,    77,    78,
      79,    -1,    81,    82,    -1,    84,    -1,    86,    87,    88,
      89,    90,    -1,    92,    -1,    94,    -1,    96,    97,    98,
      -1,   100,    -1,   102,    -1,   104,    -1,   106,   107,   108,
     109,    -1,    -1,   112,   113,    -1,   115,   116,    -1,   118,
      -1,   120,    -1,   122,    -1,   124,    -1,   126,    -1,   128,
     129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,    -1,
     159,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   178,
      -1,    -1,   288,   289,   290,   291,   292,    -1,    -1,   295,
      -1,   297,   298,    -1,   300,    -1,    -1,    -1,   304,   305,
     306,   307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   131,    -1,    -1,   134,    -1,    -1,    -1,
     138,    -1,   140,   141,    -1,    -1,    -1,   145,   146,   147,
      -1,   149,   150,   151,    -1,   153,   154,   155,    -1,   288,
     289,   290,   291,   292,    -1,    -1,   295,    -1,   297,   298,
      -1,   300,    -1,    -1,    -1,   304,   305,   306,   307,   177,
      -1,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,    -1,    -1,   191,   192,    -1,   194,    -1,   196,    -1,
      -1,   199,    -1,   201,    -1,    -1,    -1,    -1,    -1,   207,
      -1,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     228,   229,   230,   231,    -1,   233,   234,    -1,   236,   237,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,   246,    -1,
      -1,   249,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
     258,   259,    -1,   261,   262,    -1,    -1,    -1,   266,    -1,
      -1,    -1,    -1,   271,   272,   273,   274,   275,   276,   277,
     278,   279,    -1,    -1,    -1,   283,    -1,    -1,    -1,    -1,
      -1,   131,    -1,    -1,   134,    -1,    -1,    -1,   138,    -1,
     140,   141,    -1,   301,   302,   145,   146,   147,    -1,   149,
     150,   151,    -1,   153,   154,   155,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   177,    -1,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,    -1,
      -1,   191,   192,    -1,   194,    -1,   196,    -1,    -1,   199,
      -1,   201,    -1,    -1,    -1,    -1,    -1,   207,    -1,   209,
     210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   228,   229,
     230,   231,    -1,   233,   234,    -1,   236,   237,    -1,    -1,
      -1,    -1,    -1,   243,    -1,    -1,   246,    -1,    -1,   249,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,   258,   259,
      -1,   261,   262,    -1,    -1,    -1,   266,    -1,    -1,    -1,
      -1,   271,   272,   273,   274,   275,   276,   277,   278,   279,
      -1,    -1,   134,   283,    -1,    -1,   138,    -1,    -1,   141,
      -1,    -1,    -1,   145,   146,    -1,    -1,   149,    -1,    -1,
      -1,   301,   302,   155,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   180,   181,
      -1,   183,   184,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   131,   199,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,
      -1,   146,   147,    -1,   149,   150,    -1,    -1,   153,    -1,
     155,    -1,    -1,    -1,    -1,    -1,    -1,   229,   230,   231,
      -1,   233,   234,    -1,    -1,   237,    -1,    -1,    -1,    -1,
      -1,    -1,   177,    -1,    -1,   180,    -1,   182,    -1,    -1,
     185,   186,   187,   188,    -1,    -1,   191,   259,    -1,   194,
      -1,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   271,
     272,    -1,   207,    -1,   209,   210,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,    -1,    -1,    -1,    -1,    -1,   301,
     302,   236,    -1,    -1,    -1,    -1,    -1,    -1,   243,    -1,
      -1,   246,    -1,    -1,   249,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,   258,    -1,    -1,   261,   262,    -1,    -1,
      -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,   273,   274,
     275,   276,   277,   278,   279,    -1,    -1,    -1,   283
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   309,     0,     1,     3,     5,     6,     7,     8,    10,
      11,    12,    13,    32,   150,   151,   153,   154,   157,   177,
     179,   187,   201,   202,   206,   211,   218,   219,   220,   227,
     289,   293,   307,   310,   311,   312,   313,   328,   329,   348,
     350,   351,   354,   364,   365,   366,   370,   376,   377,   378,
     383,   391,   392,   395,   397,   414,   417,   424,   425,   522,
     530,   531,   677,   696,   298,   301,   302,   622,   625,   633,
     638,   641,   643,     1,    65,    68,    69,    70,    72,    74,
      75,    77,    78,    79,    81,    82,    84,    86,    87,    88,
      89,    90,    92,    94,    96,    97,    98,   100,   102,   104,
     106,   107,   108,   109,   110,   112,   113,   115,   116,   118,
     120,   122,   124,   126,   128,   129,   130,   204,   212,   263,
     325,   638,   642,   657,     1,   638,   640,     1,     3,   651,
     651,   299,   367,   368,     1,    15,    52,    59,   298,   374,
     625,     1,   298,   651,   226,   704,     1,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   171,   172,   173,   174,
     175,   355,   363,   651,   529,   530,     1,   211,   676,   426,
     352,   696,   640,   696,   696,   696,   696,     1,    70,    72,
      78,   131,   134,   138,   140,   141,   145,   146,   147,   149,
     150,   153,   155,   176,   177,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   191,   192,   194,   196,   199,
     207,   209,   210,   214,   226,   228,   229,   230,   231,   233,
     234,   236,   237,   238,   243,   246,   249,   251,   258,   259,
     261,   262,   266,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   283,   298,   379,   381,   383,   384,   387,   389,
     390,   407,   414,   415,   423,   439,   441,   442,   444,   468,
     469,   471,   479,   505,   507,   508,   509,   510,   511,   512,
     514,   515,   516,   518,   519,   520,   521,   522,   531,   534,
     535,   537,   539,   540,   542,   550,   552,   553,   562,   563,
     625,   630,   631,   633,   664,   665,   669,   711,   696,   293,
     696,   696,   696,   696,   696,   696,   396,   393,   398,    46,
     679,   680,   681,    65,     1,    17,    37,    58,   647,    65,
       1,    71,   691,     1,    73,   687,    72,    72,     4,     9,
      38,    53,   150,   187,   194,   207,   209,   210,   222,   228,
     232,   235,   240,   242,   243,   246,   247,   249,   252,   254,
     255,   257,   258,   261,   262,   266,   267,   326,   327,   536,
     590,     1,    17,   130,   646,   314,   646,   112,   369,   368,
      52,    59,   375,    42,   296,   666,   667,    17,    30,   153,
     227,   371,   373,    65,    68,    69,    70,    71,    72,    73,
      74,    75,    77,    78,    79,    81,    82,    84,    86,    87,
      88,    89,    90,    92,    94,    96,    97,    98,   100,   102,
     104,   106,   107,   108,   109,   112,   113,   115,   116,   118,
     120,   122,   124,   126,   128,   129,   130,   157,   159,   178,
     288,   289,   290,   291,   292,   295,   297,   298,   300,   304,
     305,   306,   307,   330,   331,   340,   341,   342,   343,   347,
     418,     1,   298,   627,   627,     1,   298,   301,   620,   621,
       1,   157,   298,   353,   628,   647,   187,   228,   468,   505,
     664,    77,    78,   112,   221,   298,   408,   409,   410,   532,
     533,   534,   550,   300,   303,   593,   698,     1,    70,   673,
     673,    65,   349,   673,    72,    72,   538,   554,   564,    70,
       1,    96,   674,   385,   673,   130,   470,   416,   508,   510,
     506,   507,   673,   536,   541,   542,   541,   553,   563,    65,
     632,   213,   425,   203,   205,   303,   661,    81,     1,   622,
     623,   623,     1,   298,   400,   401,   402,   625,     1,    57,
     531,   677,   692,   693,   679,   298,   625,     4,     9,    44,
      53,    59,    60,   131,   136,   140,   150,   153,   178,   187,
     191,   196,   197,   204,   207,   209,   210,   221,   222,   228,
     243,   246,   247,   249,   251,   261,   262,   266,   274,   275,
     276,   279,   298,   535,   537,   567,   586,   587,   588,   589,
     590,   591,   595,   601,   602,   633,   639,   709,   625,   633,
     687,   687,    31,    33,    36,   592,   148,   245,   253,   269,
      23,    72,   318,     1,   228,   710,     1,   241,   660,     1,
     256,   708,   535,   709,   640,   315,   567,   681,   567,     1,
     299,    17,   373,     1,   371,   372,     1,    70,   130,   335,
     336,   337,   338,   339,   340,    70,   331,   332,   333,   334,
     505,    70,   356,   541,     1,   298,   298,   567,   691,   380,
     298,     1,   221,   700,    73,     1,   130,   655,   534,   549,
     550,   534,   290,     1,   698,   699,   505,   415,     1,   297,
     705,   706,   543,     1,    73,    78,   705,   673,   673,   445,
     505,   704,     1,   505,   705,    70,    77,    78,   108,   281,
     282,   284,   285,   286,   287,   429,   430,   432,   434,   435,
     437,   443,   462,   464,   465,   467,   472,   474,   475,   477,
     478,   479,   481,   577,   622,   625,   630,   631,   633,   634,
     432,   428,   429,     1,   505,   622,   623,   624,   623,   624,
     622,   505,   673,   673,   621,   288,   523,   394,   399,    65,
      65,   623,   592,   245,   710,     1,    28,   659,   593,     1,
     198,   672,    78,   596,   705,   681,    16,    25,    29,    49,
      54,    56,    61,   280,   509,   568,   571,   572,   573,   575,
     576,   577,   583,   597,   598,   599,   600,   603,   604,   605,
     606,   589,    17,     1,    41,   671,     1,   270,   644,     1,
      70,    72,   319,    27,    54,   320,   321,   322,   410,    70,
     578,   579,     1,    26,   656,    14,    63,   189,   238,   316,
     317,   324,   646,   372,    70,   344,   345,   346,   347,    71,
     130,   337,   336,   339,   334,   419,     1,   178,   298,   357,
     358,   359,    70,    71,   130,   158,   169,   170,   340,   360,
     361,   362,     1,   112,   663,    70,   467,   474,   477,   482,
     483,   484,   485,   486,   488,   489,   491,   493,   495,   634,
      70,   411,   410,   549,   691,   513,   691,   227,   544,    73,
     687,   687,   673,     1,   298,   557,   565,   566,   178,   221,
     298,   457,   458,   459,   626,   701,   382,   386,    71,   388,
     691,   106,   463,   532,   532,   532,   130,    70,    72,   436,
     466,   473,   476,   433,   434,   443,   465,   633,    67,   213,
     288,   635,   635,   551,   552,   517,   523,   290,   290,   480,
     457,     1,   440,   673,     1,   146,   149,   155,   180,   514,
     516,   524,   526,   527,   528,   631,   290,   404,   405,     1,
     403,   405,   187,   298,   625,   187,   625,   633,    40,   594,
      78,   298,   569,   705,   578,    70,   574,     1,    58,   702,
       1,    54,   688,    39,   570,   578,    43,    45,   675,   702,
      18,    19,    34,    62,   134,   138,   141,   145,   181,   183,
     184,   199,   229,   230,   231,   237,   259,   271,   272,   522,
     531,   607,   608,   609,   610,   611,   613,   614,   631,   606,
     567,   673,   320,   320,    21,   136,   323,    58,   323,    73,
     655,   567,   580,   581,    55,   148,   584,   585,   689,   213,
     683,    17,    58,   648,   706,     1,   567,   705,   587,   344,
      71,   346,   332,   336,   338,   420,   421,   432,    71,   655,
     362,   505,   106,   490,   492,   494,   496,   436,   691,    70,
     457,   325,   482,   627,     1,   232,   235,   242,   252,   254,
     257,   258,   267,   545,   546,   547,   633,   555,   556,   557,
      70,   558,    71,   557,    71,   655,   505,   482,   415,   482,
     438,   432,     1,   430,   431,   457,     1,   150,   298,   532,
     533,   687,   705,   551,   432,   432,   432,    78,   657,   662,
     699,   706,   482,   467,   474,   477,   497,   498,   499,   501,
     503,   634,    71,   446,   446,   440,   527,   528,   525,   526,
       1,   291,   391,   406,   417,   424,   627,   627,     1,    46,
     678,   440,     1,    43,   567,     1,    16,   645,   584,    35,
     567,    50,   612,     1,   145,   670,     1,    48,   684,     1,
     134,   652,   705,   707,    51,   685,   623,   623,     1,    63,
      70,   705,   580,    71,    73,     1,   136,   658,   627,   322,
      71,   655,     1,   567,   681,    18,    20,   649,    22,   650,
      54,    56,   583,    71,   130,   359,   427,   487,   482,   482,
     482,   482,   633,   637,   457,    71,    75,   412,   691,     1,
     288,   654,    70,   548,   548,    73,   655,    71,   655,    70,
     292,   297,   298,   300,   303,   559,   560,   561,   222,   247,
     451,     1,   459,   461,   460,     1,    97,   668,   691,   532,
     691,   446,    73,   532,   687,    78,   150,   687,   697,   687,
     536,   673,   627,   691,   500,   502,   504,   673,   447,   451,
     451,   446,   525,   289,   695,     1,   289,   694,   694,   567,
      71,   678,   298,   629,   578,   670,    46,   615,   706,   706,
     649,    71,     1,   567,   582,     1,   689,   690,   688,   675,
       1,   421,   422,   482,   532,   691,   446,   505,   699,   687,
     547,   691,   557,   560,    71,   655,   673,    70,   112,   455,
     482,   673,   432,    77,   108,   450,   298,   705,   687,   298,
     705,   457,   673,   497,   497,   497,   446,   448,   551,   551,
     451,     1,   291,   686,     1,   531,   653,   678,   584,   153,
     703,   649,   691,   584,   567,     1,   213,   682,   482,   451,
     413,   691,     1,   691,   561,   458,   691,     1,   208,   223,
     452,     1,   136,   204,   705,     1,   633,   636,   691,   451,
     687,   687,   687,   687,   446,     1,   456,   458,   451,   246,
     249,   278,   449,   535,   551,   640,   567,   527,   616,   617,
     618,   578,   691,    75,   453,   552,   482,    71,   691,   691,
     673,   453,   450,    71,   455,   455,   567,   298,   608,   619,
     639,   527,   584,   673,   505,   457,   455,   451,   451,   457,
     454,    71,   453,   453,    71,   482,   551,   455
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   308,   309,   309,   310,   310,   310,   310,   310,   310,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     311,   311,   312,   312,   312,   312,   312,   313,   314,   313,
     313,   313,   313,   315,   315,   315,   316,   316,   316,   317,
     317,   317,   318,   318,   318,   319,   319,   319,   320,   320,
     321,   321,   322,   322,   322,   322,   323,   323,   323,   324,
     325,   325,   326,   326,   327,   327,   327,   327,   327,   327,
     327,   327,   327,   327,   327,   327,   327,   327,   327,   327,
     327,   328,   329,   329,   330,   330,   330,   331,   331,   332,
     332,   333,   333,   334,   334,   335,   335,   335,   335,   335,
     335,   335,   336,   336,   337,   337,   338,   338,   339,   339,
     340,   340,   340,   340,   340,   340,   340,   341,   341,   342,
     342,   342,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   343,   343,
     344,   344,   345,   345,   346,   346,   347,   347,   348,   348,
     348,   348,   348,   348,   348,   348,   348,   348,   348,   348,
     349,   348,   348,   348,   348,   348,   350,   352,   351,   353,
     353,   353,   353,   353,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   354,   354,   354,   354,   354,   354,
     355,   356,   356,   357,   357,   358,   358,   359,   359,   359,
     360,   360,   361,   361,   362,   362,   362,   362,   362,   362,
     362,   363,   364,   365,   366,   366,   367,   367,   368,   369,
     369,   369,   370,   370,   370,   370,   370,   370,   370,   371,
     371,   371,   372,   372,   373,   373,   374,   374,   374,   374,
     375,   375,   375,   376,   377,   378,   380,   379,   379,   382,
     381,   383,   383,   383,   383,   385,   386,   384,   387,   388,
     387,   387,   389,   389,   390,   391,   391,   391,   393,   394,
     392,   396,   395,   398,   399,   397,   400,   400,   400,   401,
     401,   401,   401,   402,   402,   402,   402,   403,   403,   404,
     404,   405,   405,   406,   406,   406,   406,   407,   408,   408,
     409,   409,   410,   410,   410,   410,   410,   410,   411,   411,
     412,   413,   412,   414,   416,   415,   418,   419,   417,   420,
     420,   421,   422,   422,   423,   424,   426,   427,   425,   428,
     428,   429,   429,   430,   431,   431,   432,   432,   432,   432,
     432,   433,   433,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   435,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   436,   438,   437,   439,   440,   440,   441,   442,
     443,   445,   444,   447,   446,   448,   448,   449,   449,   449,
     449,   450,   450,   450,   451,   451,   451,   451,   451,   452,
     452,   452,   453,   454,   453,   453,   455,   455,   455,   455,
     455,   456,   456,   457,   457,   458,   458,   460,   459,   459,
     459,   461,   461,   463,   462,   464,   466,   465,   467,   468,
     468,   470,   469,   471,   473,   472,   474,   476,   475,   477,
     477,   478,   480,   479,   481,   482,   482,   483,   483,   483,
     483,   484,   484,   484,   484,   484,   485,   487,   486,   488,
     490,   489,   492,   491,   494,   493,   496,   495,   497,   497,
     498,   498,   498,   498,   500,   499,   502,   501,   504,   503,
     505,   505,   505,   506,   506,   507,   507,   508,   508,   508,
     508,   509,   509,   509,   509,   509,   509,   509,   509,   510,
     510,   511,   511,   511,   511,   513,   512,   514,   514,   515,
     515,   515,   515,   515,   515,   515,   515,   515,   515,   515,
     515,   515,   515,   517,   516,   516,   518,   518,   519,   519,
     520,   520,   521,   521,   522,   523,   523,   523,   524,   524,
     524,   525,   525,   526,   526,   527,   527,   527,   527,   528,
     528,   528,   529,   529,   530,   530,   531,   531,   532,   532,
     533,   533,   533,   534,   534,   534,   534,   534,   534,   534,
     535,   535,   536,   536,   537,   537,   538,   538,   538,   538,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     540,   540,   541,   541,   543,   542,   542,   544,   544,   545,
     545,   546,   546,   547,   547,   547,   547,   547,   547,   547,
     547,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     551,   552,   552,   554,   553,   555,   555,   556,   556,   557,
     557,   558,   558,   559,   559,   560,   560,   561,   561,   561,
     561,   561,   561,   562,   562,   564,   563,   565,   565,   566,
     566,   567,   567,   567,   568,   568,   569,   569,   569,   569,
     570,   570,   571,   572,   573,   574,   574,   575,   576,   576,
     577,   577,   577,   577,   577,   577,   578,   578,   579,   580,
     580,   581,   581,   582,   582,   583,   583,   583,   584,   584,
     585,   585,   586,   587,   587,   588,   588,   589,   589,   589,
     590,   590,   590,   590,   590,   590,   590,   590,   590,   590,
     590,   590,   590,   590,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   591,   591,   591,   591,   591,   591,   591,
     591,   591,   591,   592,   592,   592,   593,   594,   594,   595,
     595,   595,   595,   595,   595,   595,   596,   596,   597,   597,
     597,   597,   597,   597,   597,   597,   598,   598,   598,   599,
     600,   600,   601,   602,   602,   602,   603,   603,   604,   604,
     605,   605,   606,   607,   607,   607,   607,   608,   608,   609,
     609,   609,   609,   609,   609,   609,   609,   609,   609,   609,
     609,   609,   609,   609,   609,   610,   610,   610,   610,   611,
     611,   611,   612,   612,   613,   614,   615,   615,   616,   616,
     617,   617,   618,   618,   619,   619,   620,   620,   621,   621,
     622,   622,   623,   623,   624,   624,   625,   625,   626,   627,
     627,   628,   628,   629,   629,   630,   630,   631,   632,   632,
     633,   633,   633,   634,   635,   635,   636,   636,   637,   637,
     638,   639,   640,   640,   641,   641,   642,   642,   643,   643,
     643,   644,   644,   645,   645,   646,   646,   647,   647,   647,
     647,   648,   648,   648,   649,   649,   649,   650,   650,   651,
     651,   652,   652,   653,   653,   654,   654,   655,   655,   656,
     656,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   657,
     657,   657,   657,   657,   657,   657,   657,   657,   657,   658,
     658,   659,   659,   660,   660,   661,   661,   662,   663,   663,
     664,   664,   665,   665,   666,   667,   667,   668,   668,   669,
     669,   670,   670,   671,   671,   672,   672,   673,   673,   674,
     674,   675,   675,   675,   676,   676,   677,   677,   678,   678,
     679,   680,   680,   681,   681,   682,   682,   683,   683,   684,
     684,   685,   685,   686,   686,   687,   687,   688,   688,   689,
     689,   690,   690,   691,   691,   692,   692,   692,   693,   693,
     694,   694,   695,   695,   696,   696,   697,   697,   698,   698,
     699,   699,   700,   700,   701,   701,   702,   702,   703,   703,
     704,   704,   705,   706,   706,   707,   707,   708,   708,   709,
     709,   710,   710,   711,   711
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     2,     2,     2,     2,     2,     1,     1,
       4,     4,     2,     2,     2,     2,     1,     4,     0,    11,
       6,     9,     2,     1,     2,     2,     3,     2,     2,     2,
       1,     1,     0,     2,     3,     3,     3,     1,     0,     1,
       3,     1,     2,     2,     3,     1,     0,     2,     1,     3,
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     4,     3,     2,     0,     2,     4,     1,     1,     0,
       1,     2,     1,     1,     1,     0,     1,     1,     2,     3,
       2,     1,     2,     1,     3,     1,     2,     1,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     3,     1,     1,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       0,     4,     2,     3,     2,     2,     1,     0,     3,     0,
       1,     2,     2,     1,     1,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     0,
       2,     2,     3,     4,     4,     5,     3,     2,     2,     1,
       1,     1,     1,     1,     0,     1,     0,     2,     1,     1,
       0,     1,     1,     1,     1,     1,     0,     6,     3,     0,
       9,     1,     1,     1,     1,     0,     0,     5,     4,     0,
       6,     4,     1,     1,     4,     1,     1,     1,     0,     0,
       5,     0,     4,     0,     0,     5,     1,     1,     1,     3,
       3,     4,     1,     3,     3,     4,     1,     1,     1,     0,
       1,     2,     4,     1,     2,     2,     1,     6,     0,     1,
       3,     1,     1,     2,     1,     1,     1,     2,     0,     3,
       0,     0,     4,     1,     0,     3,     0,     0,     6,     3,
       1,     1,     1,     1,     1,     1,     0,     0,     8,     0,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     3,     2,     3,     3,     3,     5,     5,     4,
       5,     5,     3,     0,    10,     9,     0,     1,     7,     7,
       8,     0,     7,     0,     3,     0,     2,     1,     1,     1,
       1,     0,     1,     1,     0,     1,     4,     3,     4,     1,
       1,     1,     0,     0,     4,     1,     0,     2,     2,     2,
       2,     1,     1,     0,     1,     3,     1,     0,     4,     1,
       1,     1,     1,     0,     4,    10,     0,     3,     2,     3,
       1,     0,     3,     2,     0,     3,     4,     0,     3,     2,
       2,     2,     0,     9,     9,     0,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     0,     9,     6,
       0,     4,     0,     3,     0,     3,     0,     3,     0,     1,
       1,     1,     1,     1,     0,     3,     0,     3,     0,     3,
       1,     2,     1,     0,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     1,     1,     1,     1,     0,     6,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     6,     3,     1,     1,     1,     1,
       3,     4,     4,     4,     2,     0,     2,     2,     1,     3,
       2,     0,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     0,     1,
       3,     2,     2,     1,     1,     1,     1,     1,     2,     1,
       1,     1,     0,     2,     1,     1,     2,     3,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     7,     1,     0,     3,     0,
       1,     3,     1,     1,     2,     1,     2,     1,     1,     1,
       1,     1,     1,     0,     3,     0,     1,     1,     1,     0,
       1,     2,     1,     0,     7,     0,     1,     3,     1,     2,
       1,     0,     3,     0,     1,     3,     1,     1,     1,     1,
       1,     3,     1,     2,     1,     0,     5,     0,     1,     2,
       1,     1,     1,     1,     4,     6,     0,     1,     1,     1,
       0,     1,     3,     2,     2,     0,     3,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     3,     0,
       1,     3,     1,     1,     1,     0,     1,     2,     0,     1,
       2,     2,     2,     0,     1,     2,     1,     1,     1,     1,
       2,     1,     1,     2,     1,     2,     1,     2,     1,     1,
       3,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     7,     3,     3,
       1,     2,     6,     3,     1,     1,     2,     1,     0,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     2,     1,
       1,     2,     2,     1,     1,     3,     4,     4,     2,     1,
       2,     3,     0,     1,     2,     3,     0,     3,     2,     1,
       0,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       1,     2,     1,     0,     1,     0,     2,     2,     0,     2,
       3,     3,     1,     2,     0,     2,     1,     1,     0,     1,
       2,     2,     1,     1,     0,     1,     3,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     0,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     3,     0,     1,     1,     0,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     2,     1,     1,
       3,     2,     1,     0,     1,     1,     1,     0,     1,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     1,     1,     0,     1,
       0,     1,     1,     1,     1,     0,     1,     1,     1,     1,
       2,     1,     1,     0,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_Y_CONSTRUCTOR_SNAME: /* Y_CONSTRUCTOR_SNAME  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5132 "parser.c"
        break;

    case YYSYMBOL_Y_DESTRUCTOR_SNAME: /* Y_DESTRUCTOR_SNAME  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5138 "parser.c"
        break;

    case YYSYMBOL_Y_OPERATOR_SNAME: /* Y_OPERATOR_SNAME  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5144 "parser.c"
        break;

    case YYSYMBOL_Y_CHAR_LIT: /* Y_CHAR_LIT  */
#line 1916 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5150 "parser.c"
        break;

    case YYSYMBOL_Y_GLOB: /* Y_GLOB  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5156 "parser.c"
        break;

    case YYSYMBOL_Y_NAME: /* Y_NAME  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5162 "parser.c"
        break;

    case YYSYMBOL_Y_SET_OPTION: /* Y_SET_OPTION  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5168 "parser.c"
        break;

    case YYSYMBOL_Y_STR_LIT: /* Y_STR_LIT  */
#line 1916 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5174 "parser.c"
        break;

    case YYSYMBOL_capturing_paren_capture_decl_list_english_opt: /* capturing_paren_capture_decl_list_english_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5180 "parser.c"
        break;

    case YYSYMBOL_paren_capture_decl_list_english: /* paren_capture_decl_list_english  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5186 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english_opt: /* capture_decl_list_english_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5192 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_english: /* capture_decl_list_english  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5198 "parser.c"
        break;

    case YYSYMBOL_p_extra_token_except_lparen: /* p_extra_token_except_lparen  */
#line 1912 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5204 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens_opt: /* p_extra_tokens_opt  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5210 "parser.c"
        break;

    case YYSYMBOL_p_extra_tokens: /* p_extra_tokens  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5216 "parser.c"
        break;

    case YYSYMBOL_p_extra_token: /* p_extra_token  */
#line 1912 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5222 "parser.c"
        break;

    case YYSYMBOL_p_arg_list_opt: /* p_arg_list_opt  */
#line 1909 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5228 "parser.c"
        break;

    case YYSYMBOL_p_comma_arg_list: /* p_comma_arg_list  */
#line 1909 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5234 "parser.c"
        break;

    case YYSYMBOL_p_arg_list: /* p_arg_list  */
#line 1909 "parser.y"
            { DTRACE; p_arg_list_cleanup( ((*yyvaluep).p_arg_list) );   FREE( ((*yyvaluep).p_arg_list) ); }
#line 5240 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens: /* p_arg_tokens  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5246 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_as_list: /* p_arg_token_as_list  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5252 "parser.c"
        break;

    case YYSYMBOL_p_arg_token: /* p_arg_token  */
#line 1912 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5258 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma_opt: /* p_arg_tokens_with_comma_opt  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5264 "parser.c"
        break;

    case YYSYMBOL_p_arg_tokens_with_comma: /* p_arg_tokens_with_comma  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5270 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma_as_list: /* p_arg_token_with_comma_as_list  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5276 "parser.c"
        break;

    case YYSYMBOL_p_arg_token_with_comma: /* p_arg_token_with_comma  */
#line 1912 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5282 "parser.c"
        break;

    case YYSYMBOL_help_what_opt: /* help_what_opt  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5288 "parser.c"
        break;

    case YYSYMBOL_p_paren_param_list_opt: /* p_paren_param_list_opt  */
#line 1911 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5294 "parser.c"
        break;

    case YYSYMBOL_p_param_list_opt: /* p_param_list_opt  */
#line 1911 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5300 "parser.c"
        break;

    case YYSYMBOL_p_param_list: /* p_param_list  */
#line 1911 "parser.y"
            { DTRACE; p_param_list_cleanup( ((*yyvaluep).p_param_list) ); FREE( ((*yyvaluep).p_param_list) ); }
#line 5306 "parser.c"
        break;

    case YYSYMBOL_p_param: /* p_param  */
#line 1910 "parser.y"
            { DTRACE; p_param_free( ((*yyvaluep).p_param) );                     }
#line 5312 "parser.c"
        break;

    case YYSYMBOL_p_replace_list_opt: /* p_replace_list_opt  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5318 "parser.c"
        break;

    case YYSYMBOL_p_replace_list: /* p_replace_list  */
#line 1913 "parser.y"
            { DTRACE; p_token_list_cleanup( ((*yyvaluep).p_token_list) ); FREE( ((*yyvaluep).p_token_list) ); }
#line 5324 "parser.c"
        break;

    case YYSYMBOL_p_replace_token: /* p_replace_token  */
#line 1912 "parser.y"
            { DTRACE; p_token_free( ((*yyvaluep).p_token) );                     }
#line 5330 "parser.c"
        break;

    case YYSYMBOL_set_option_value_opt: /* set_option_value_opt  */
#line 1916 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5336 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c_exp: /* namespace_sname_c_exp  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5342 "parser.c"
        break;

    case YYSYMBOL_namespace_sname_c: /* namespace_sname_c  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5348 "parser.c"
        break;

    case YYSYMBOL_namespace_typedef_sname_c: /* namespace_typedef_sname_c  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5354 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c_opt: /* capture_decl_list_c_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5360 "parser.c"
        break;

    case YYSYMBOL_capture_decl_list_c: /* capture_decl_list_c  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5366 "parser.c"
        break;

    case YYSYMBOL_lambda_param_c_ast_list_opt: /* lambda_param_c_ast_list_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5372 "parser.c"
        break;

    case YYSYMBOL_decl_list_c: /* decl_list_c  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5378 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_exp: /* param_c_ast_list_exp  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5384 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list_opt: /* param_c_ast_list_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5390 "parser.c"
        break;

    case YYSYMBOL_param_c_ast_list: /* param_c_ast_list  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5396 "parser.c"
        break;

    case YYSYMBOL_pc99_pointer_decl_list_c: /* pc99_pointer_decl_list_c  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5402 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english_opt: /* paren_param_decl_list_english_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5408 "parser.c"
        break;

    case YYSYMBOL_paren_param_decl_list_english: /* paren_param_decl_list_english  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5414 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english_opt: /* param_decl_list_english_opt  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5420 "parser.c"
        break;

    case YYSYMBOL_param_decl_list_english: /* param_decl_list_english  */
#line 1907 "parser.y"
            { DTRACE; c_ast_list_cleanup( &((*yyvaluep).ast_list) );              }
#line 5426 "parser.c"
        break;

    case YYSYMBOL_any_name: /* any_name  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5432 "parser.c"
        break;

    case YYSYMBOL_any_name_exp: /* any_name_exp  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5438 "parser.c"
        break;

    case YYSYMBOL_any_sname_c: /* any_sname_c  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5444 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_exp: /* any_sname_c_exp  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5450 "parser.c"
        break;

    case YYSYMBOL_any_sname_c_opt: /* any_sname_c_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5456 "parser.c"
        break;

    case YYSYMBOL_name_exp: /* name_exp  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5462 "parser.c"
        break;

    case YYSYMBOL_name_cat: /* name_cat  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5468 "parser.c"
        break;

    case YYSYMBOL_name_opt: /* name_opt  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5474 "parser.c"
        break;

    case YYSYMBOL_oper_sname_c_opt: /* oper_sname_c_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5480 "parser.c"
        break;

    case YYSYMBOL_sub_scope_sname_c_opt: /* sub_scope_sname_c_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5486 "parser.c"
        break;

    case YYSYMBOL_sname_c: /* sname_c  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5492 "parser.c"
        break;

    case YYSYMBOL_sname_c_exp: /* sname_c_exp  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5498 "parser.c"
        break;

    case YYSYMBOL_sname_c_opt: /* sname_c_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5504 "parser.c"
        break;

    case YYSYMBOL_sname_english: /* sname_english  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5510 "parser.c"
        break;

    case YYSYMBOL_sname_english_exp: /* sname_english_exp  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5516 "parser.c"
        break;

    case YYSYMBOL_sname_english_opt: /* sname_english_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5522 "parser.c"
        break;

    case YYSYMBOL_sname_list_english: /* sname_list_english  */
#line 1915 "parser.y"
            { DTRACE; c_sname_list_cleanup( &((*yyvaluep).sname_list) );            }
#line 5528 "parser.c"
        break;

    case YYSYMBOL_typedef_sname_c: /* typedef_sname_c  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5534 "parser.c"
        break;

    case YYSYMBOL_destructor_sname: /* destructor_sname  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5540 "parser.c"
        break;

    case YYSYMBOL_glob: /* glob  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5546 "parser.c"
        break;

    case YYSYMBOL_glob_opt: /* glob_opt  */
#line 1908 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).name) );                             }
#line 5552 "parser.c"
        break;

    case YYSYMBOL_of_scope_english: /* of_scope_english  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5558 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english: /* of_scope_list_english  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5564 "parser.c"
        break;

    case YYSYMBOL_of_scope_list_english_opt: /* of_scope_list_english_opt  */
#line 1914 "parser.y"
            { DTRACE; c_sname_cleanup( &((*yyvaluep).sname) );                 }
#line 5570 "parser.c"
        break;

    case YYSYMBOL_str_lit: /* str_lit  */
#line 1916 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5576 "parser.c"
        break;

    case YYSYMBOL_str_lit_exp: /* str_lit_exp  */
#line 1916 "parser.y"
            { DTRACE; FREE( ((*yyvaluep).str_val) );                             }
#line 5582 "parser.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* command_list: command_list command  */
#line 1924 "parser.y"
    { //
      // We get here only after a successful parse.
      //
      parse_cleanup( /*fatal_error=*/false );
    }
#line 5881 "parser.c"
    break;

  case 19: /* command: error  */
#line 1948 "parser.y"
    {
      if ( lexer_printable_token() != NULL )
        elaborate_error_dym( DYM_COMMANDS, "unexpected token" );
      else
        elaborate_error( "unexpected end of command" );
    }
#line 5892 "parser.c"
    break;

  case 20: /* cast_command: Y_cast sname_english_opt as_into_to_exp decl_english_ast  */
#line 1967 "parser.y"
    {
      DUMP_START( "cast_command",
                  "CAST sname_english_opt {AS|[IN]TO} decl_english_ast" );
      DUMP_SNAME( "sname_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5914 "parser.c"
    break;

  case 21: /* cast_command: new_style_cast_english sname_english_exp as_into_to_exp decl_english_ast  */
#line 1990 "parser.y"
    {
      DUMP_START( "cast_command",
                  "new_style_cast_english sname_english_exp {AS|[IN]TO} "
                  "decl_english_ast" );
      DUMP_STR( "new_style_cast_english", c_cast_gibberish( (yyvsp[-3].cast_kind) ) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-2].sname) );
      cast_ast->cast.kind = (yyvsp[-3].cast_kind);
      cast_ast->cast.to_ast = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_gibberish( cast_ast, C_GIB_PRINT_CAST, stdout );
    }
#line 5938 "parser.c"
    break;

  case 22: /* new_style_cast_english: Y_const cast_exp  */
#line 2012 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 5944 "parser.c"
    break;

  case 23: /* new_style_cast_english: Y_dynamic cast_exp  */
#line 2013 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 5950 "parser.c"
    break;

  case 24: /* new_style_cast_english: Y_reinterpret cast_exp  */
#line 2014 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 5956 "parser.c"
    break;

  case 25: /* new_style_cast_english: Y_static cast_exp  */
#line 2015 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 5962 "parser.c"
    break;

  case 27: /* declare_command: Y_declare sname_list_english as_exp alignas_or_width_decl_english_ast  */
#line 2027 "parser.y"
    {
      if ( (yyvsp[0].ast)->kind == K_NAME ) {
        //
        // This checks for a case like:
        //
        //      declare x as y
        //
        // i.e., declaring a variable name as another name (unknown type).
        // This can get this far due to the nature of the C/C++ grammar.
        //
        // This check has to be done now in the parser rather than later in the
        // AST because the name of the AST node needs to be set to the variable
        // name, but the AST node is itself a name and overwriting it would
        // lose information.
        //
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
        PARSE_ABORT();
      }

      DUMP_START( "declare_command",
                  "DECLARE sname_list_english AS "
                  "alignas_or_width_decl_english_ast" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_AST( "alignas_or_width_decl_english_ast", (yyvsp[0].ast) );

      (yyvsp[0].ast)->loc = (yylsp[-2]);

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      // To check the declaration, it needs a name: just dup the first one.
      c_sname_t temp_sname = c_sname_dup( slist_front( &(yyvsp[-2].sname_list) ) );
      c_sname_set( &(yyvsp[0].ast)->sname, &temp_sname );

      bool ok = c_ast_check( (yyvsp[0].ast) );

      if ( ok ) {
        //
        // Ensure that none of the names aren't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> declare S as int // error: "S": previously declared
        //
        // This check is done now in the parser rather than later in the AST
        // since similar checks are also done here in the parser.
        //
        FOREACH_SLIST_NODE( sname_node, &(yyvsp[-2].sname_list) ) {
          c_sname_t const *const sname = sname_node->data;
          if ( sname_is_type( sname, &(yyvsp[0].ast)->loc ) ) {
            ok = false;
            break;
          }
        } // for
      }

      if ( ok )
        c_sname_list_ast_gibberish( &(yyvsp[-2].sname_list), (yyvsp[0].ast), stdout );

      c_sname_list_cleanup( &(yyvsp[-2].sname_list) );
      PARSE_ASSERT( ok );
      PUTC( '\n' );
    }
#line 6031 "parser.c"
    break;

  case 28: /* $@1: %empty  */
#line 2096 "parser.y"
    { //
      // This check is done now in the parser right here mid-rule rather than
      // later in the end-rule action or in the AST since it yields a better
      // error message since otherwise it would warn that "operator" is a
      // keyword in C++98 which skims right past the bigger error that operator
      // overloading isn't supported in C.
      //
      if ( !IS_SUPPORTED( operator ) ) {
        print_error( &(yylsp[0]),
          "operator overloading not supported%s\n",
          C_LANG_WHICH( operator )
        );
        PARSE_ABORT();
      }
    }
#line 6051 "parser.c"
    break;

  case 29: /* declare_command: Y_declare c_operator $@1 of_scope_list_english_opt as_exp type_qualifier_list_english_type_opt ref_qualifier_english_stid_opt member_or_non_member_opt operator_exp paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2117 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-9].op_id) );

      DUMP_START( "declare_command",
                  "DECLARE c_operator of_scope_list_english_opt AS "
                  "type_qualifier_list_english_type_opt "
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "OPERATOR paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-7].sname) );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-5].type) );
      DUMP_TID( "ref_qualifier_english_stid_opt", (yyvsp[-4].tid) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );
      DUMP_END();

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yylsp[-9]) );
      c_sname_set( &oper_ast->sname, &(yyvsp[-7].sname) );
      PARSE_ASSERT( c_type_add( &oper_ast->type, &(yyvsp[-5].type), &(yylsp[-5]) ) );
      PARSE_ASSERT(
        c_type_add_tid( &oper_ast->type, (yyvsp[-4].tid), &(yylsp[-4]) )
      );
      oper_ast->oper.operator = operator;
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      oper_ast->oper.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), oper_ast );

      PARSE_ASSERT( c_ast_check( oper_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( oper_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6094 "parser.c"
    break;

  case 30: /* declare_command: Y_declare storage_class_subset_english_type_opt Y_lambda capturing_paren_capture_decl_list_english_opt paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 2163 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "LAMBDA capturing_paren_capture_decl_list_english_opt "
                  "paren_param_decl_list_english_opt"
                  "returning_english_ast_opt" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-4].type) );
      DUMP_AST_LIST( "capturing_paren_capture_decl_list_english_opt",
                     (yyvsp[-2].ast_list) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_gibberish( lambda_ast, C_GIB_PRINT_DECL, stdout );
      PUTC( '\n' );
    }
#line 6126 "parser.c"
    break;

  case 31: /* declare_command: Y_declare storage_class_subset_english_type_opt cv_qualifier_list_stid_opt user_defined conversion_exp operator_opt of_scope_list_english_opt returning_exp decl_english_ast  */
#line 2198 "parser.y"
    {
      DUMP_START( "declare_command",
                  "DECLARE storage_class_subset_english_type_opt "
                  "cv_qualifier_list_stid_opt "
                  "USER-DEFINED CONVERSION [OPERATOR] "
                  "of_scope_list_english_opt "
                  "RETURNING decl_english_ast" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-7].type) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      c_sname_set( &udc_ast->sname, &(yyvsp[-2].sname) );
      udc_ast->type = c_type_or( &(yyvsp[-7].type), &C_TYPE_LIT_S( (yyvsp[-6].tid) ) );
      c_ast_set_parent( (yyvsp[0].ast), udc_ast );

      DUMP_AST( "$$_ast", udc_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( udc_ast ) );
      unsigned decl_flags = C_GIB_PRINT_DECL;
      if ( opt_semicolon )
        decl_flags |= C_GIB_OPT_SEMICOLON;
      c_ast_gibberish( udc_ast, decl_flags, stdout );
      PUTC( '\n' );
    }
#line 6158 "parser.c"
    break;

  case 32: /* declare_command: Y_declare error  */
#line 2227 "parser.y"
    {
      if ( OPT_LANG_IS( operator ) )
        elaborate_error( "name or operator expected" );
      else
        elaborate_error( "name expected" );
    }
#line 6169 "parser.c"
    break;

  case 34: /* alignas_or_width_decl_english_ast: decl_english_ast alignas_specifier_english  */
#line 2239 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast alignas_specifier_english" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_ALIGN( "alignas_specifier_english", (yyvsp[0].align) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->align = (yyvsp[0].align);
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6187 "parser.c"
    break;

  case 35: /* alignas_or_width_decl_english_ast: decl_english_ast width_specifier_english_uint  */
#line 2254 "parser.y"
    {
      DUMP_START( "alignas_or_width_decl_english_ast",
                  "decl_english_ast width_specifier_english_uint" );
      DUMP_AST( "decl_english_ast", (yyvsp[-1].ast) );
      DUMP_INT( "width_specifier_english_uint", (yyvsp[0].uint_val) );

      //
      // This check has to be done now in the parser rather than later in the
      // AST since we need to use the builtin union member now.
      //
      if ( !c_ast_is_integral( (yyvsp[-1].ast) ) ) {
        print_error( &(yylsp[0]), "invalid bit-field type " );
        print_ast_type_aka( (yyvsp[-1].ast), stderr );
        EPRINTF( "; must be an integral %stype\n",
          OPT_LANG_IS( enum_BITFIELDS ) ? "or enumeration " : ""
        );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      (yyval.ast)->bit_field.bit_width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 6218 "parser.c"
    break;

  case 36: /* alignas_specifier_english: aligned_english uint_lit bytes_opt  */
#line 2284 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-2]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);
    }
#line 6228 "parser.c"
    break;

  case 37: /* alignas_specifier_english: aligned_english decl_english_ast  */
#line 2290 "parser.y"
    {
      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-1]);
      (yyval.align).type_ast = (yyvsp[0].ast);
    }
#line 6238 "parser.c"
    break;

  case 38: /* alignas_specifier_english: aligned_english error  */
#line 2296 "parser.y"
    {
      (yyval.align) = (c_alignas_t){ 0 };
      (yyval.align).loc = (yylsp[-1]);
      elaborate_error( "integer or type expected" );
    }
#line 6248 "parser.c"
    break;

  case 42: /* capturing_paren_capture_decl_list_english_opt: %empty  */
#line 2310 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6254 "parser.c"
    break;

  case 43: /* capturing_paren_capture_decl_list_english_opt: Y_capturing paren_capture_decl_list_english  */
#line 2312 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
    }
#line 6262 "parser.c"
    break;

  case 44: /* capturing_paren_capture_decl_list_english_opt: '[' capture_decl_list_english_opt ']'  */
#line 2316 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6270 "parser.c"
    break;

  case 45: /* paren_capture_decl_list_english: '[' capture_decl_list_english_opt ']'  */
#line 2323 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6278 "parser.c"
    break;

  case 46: /* paren_capture_decl_list_english: '(' capture_decl_list_english_opt ')'  */
#line 2327 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-1].ast_list);
    }
#line 6286 "parser.c"
    break;

  case 47: /* paren_capture_decl_list_english: error  */
#line 2331 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "'[' or '(' expected\n" );
    }
#line 6295 "parser.c"
    break;

  case 48: /* capture_decl_list_english_opt: %empty  */
#line 2338 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 6301 "parser.c"
    break;

  case 50: /* capture_decl_list_english: capture_decl_list_english comma_exp capture_decl_english_ast  */
#line 2345 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_list_english ',' capture_decl_english_ast" );
      DUMP_AST_LIST( "capture_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6318 "parser.c"
    break;

  case 51: /* capture_decl_list_english: capture_decl_english_ast  */
#line 2359 "parser.y"
    {
      DUMP_START( "capture_decl_list_english",
                  "capture_decl_english_ast" );
      DUMP_AST( "capture_decl_english_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 6334 "parser.c"
    break;

  case 52: /* capture_decl_english_ast: Y_copy capture_default_opt  */
#line 2374 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 6343 "parser.c"
    break;

  case 53: /* capture_decl_english_ast: Y_reference capture_default_opt  */
#line 2379 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6352 "parser.c"
    break;

  case 54: /* capture_decl_english_ast: Y_reference Y_to name_exp  */
#line 2384 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 6362 "parser.c"
    break;

  case 59: /* width_specifier_english_uint: Y_width uint_lit_exp bits_opt  */
#line 2400 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[-1].uint_val) == 0 ) {
        print_error( &(yylsp[-1]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 6377 "parser.c"
    break;

  case 60: /* storage_class_subset_english_type_opt: %empty  */
#line 2413 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 6383 "parser.c"
    break;

  case 61: /* storage_class_subset_english_type_opt: storage_class_subset_english_type_opt storage_class_subset_english_type  */
#line 2416 "parser.y"
    {
      DUMP_START( "storage_class_subset_english_type_opt",
                  "storage_class_subset_english_type_opt "
                  "storage_class_subset_english_type" );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_TYPE( "storage_class_subset_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 6401 "parser.c"
    break;

  case 62: /* storage_class_subset_english_type: attribute_english_atid  */
#line 2432 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 6407 "parser.c"
    break;

  case 63: /* storage_class_subset_english_type: storage_class_subset_english_stid  */
#line 2434 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 6415 "parser.c"
    break;

  case 64: /* storage_class_subset_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 2455 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 6423 "parser.c"
    break;

  case 74: /* storage_class_subset_english_stid: Y_no Y_except  */
#line 2467 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 6429 "parser.c"
    break;

  case 80: /* storage_class_subset_english_stid: Y_pure virtual_stid_exp  */
#line 2473 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 6435 "parser.c"
    break;

  case 81: /* define_command: Y_define sname_english_exp as_exp decl_english_ast  */
#line 2480 "parser.y"
    {
      DUMP_START( "define_command",
                  "DEFINE sname_english AS decl_english_ast" );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      c_sname_set( &(yyvsp[0].ast)->sname, &(yyvsp[-2].sname) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      if ( !c_tid_is_any( (yyvsp[0].ast)->type.stids, TS_typedef ) ) {
        //
        // Explicitly add TS_typedef (if it doesn't have it already) to
        // prohibit cases like:
        //
        //      define eint as extern int
        //      define rint as register int
        //      define sint as static int
        //      ...
        //
        // i.e., a defined type with a storage class.  Once the semantic checks
        // pass, remove the TS_typedef.
        //
        PARSE_ASSERT(
          c_type_add( &(yyvsp[0].ast)->type, &T_TS_typedef, &(yylsp[0]) )
        );
      }
      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      if ( c_tid_is_any( (yyvsp[0].ast)->type.btids, TB_ANY_SCOPE ) )
        c_sname_set_local_type( &(yyvsp[0].ast)->sname, &(yyvsp[0].ast)->type );
      c_sname_fill_in_namespaces( &(yyvsp[0].ast)->sname );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &(yyvsp[0].ast)->sname, &(yylsp[-2]) ) );
      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_ENG_DECL ) );
    }
#line 6484 "parser.c"
    break;

  case 82: /* expand_command: Y_expand Y_NAME expand_command2  */
#line 2530 "parser.y"
    {
      p_arg_list_t   *const arg_list   = (yyvsp[0].ptrs)[0];
      p_token_list_t *const extra_list = (yyvsp[0].ptrs)[1];

      DUMP_START( "expand_command", "EXPAND NAME arg_list_opt extra_list_opt" );
      DUMP_STR( "name", (yyvsp[-1].name) );
      DUMP_MACRO_ARG_LIST( "arg_list", arg_list );
      DUMP_MACRO_TOKEN_LIST( "extra_list", extra_list );
      DUMP_END();

      bool const ok =
        p_macro_expand( (yyvsp[-1].name), &(yylsp[-1]), arg_list, extra_list, stdout );
      p_arg_list_cleanup( arg_list );
      free( arg_list );
      p_token_list_cleanup( extra_list );
      free( extra_list );
      free( (yyvsp[-1].name) );
      PARSE_ASSERT( ok );
    }
#line 6508 "parser.c"
    break;

  case 83: /* expand_command: Y_expand error  */
#line 2551 "parser.y"
    {
      elaborate_error( "macro name expected" );
    }
#line 6516 "parser.c"
    break;

  case 84: /* expand_command2: %empty  */
#line 2557 "parser.y"
                                  { (yyval.ptrs)[0] = (yyval.ptrs)[1] = NULL; }
#line 6522 "parser.c"
    break;

  case 85: /* expand_command2: p_extra_token_except_lparen p_extra_tokens_opt  */
#line 2573 "parser.y"
    {
      if ( (yyvsp[0].p_token_list) == NULL ) {
        (yyvsp[0].p_token_list) = MALLOC( p_token_list_t, 1 );
        slist_init( (yyvsp[0].p_token_list) );
      }
      slist_push_front( (yyvsp[0].p_token_list), (yyvsp[-1].p_token) );

      (yyval.ptrs)[0] = NULL;
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6537 "parser.c"
    break;

  case 86: /* expand_command2: '(' p_arg_list_opt ')' p_extra_tokens_opt  */
#line 2585 "parser.y"
    {
      (yyval.ptrs)[0] = (yyvsp[-2].p_arg_list);
      (yyval.ptrs)[1] = (yyvsp[0].p_token_list);
    }
#line 6546 "parser.c"
    break;

  case 88: /* p_extra_token_except_lparen: ')'  */
#line 2594 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 6554 "parser.c"
    break;

  case 89: /* p_extra_tokens_opt: %empty  */
#line 2600 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 6560 "parser.c"
    break;

  case 91: /* p_extra_tokens: p_extra_tokens p_extra_token  */
#line 2606 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6569 "parser.c"
    break;

  case 92: /* p_extra_tokens: p_extra_token  */
#line 2611 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6579 "parser.c"
    break;

  case 94: /* p_extra_token: '('  */
#line 2621 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 6587 "parser.c"
    break;

  case 95: /* p_arg_list_opt: %empty  */
#line 2628 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6596 "parser.c"
    break;

  case 97: /* p_arg_list_opt: p_comma_arg_list  */
#line 2646 "parser.y"
    {
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6609 "parser.c"
    break;

  case 98: /* p_arg_list_opt: p_comma_arg_list p_arg_list  */
#line 2666 "parser.y"
    {
      slist_push_back( (yyvsp[-1].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[0].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );
    }
#line 6620 "parser.c"
    break;

  case 99: /* p_arg_list_opt: p_comma_arg_list p_arg_list p_comma_arg_list  */
#line 2688 "parser.y"
    {
      slist_push_back( (yyvsp[-2].p_arg_list), p_token_list_new_placemarker() );
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );

      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_list_front( (yyval.p_arg_list), (yyvsp[-2].p_arg_list) );
      slist_push_list_back ( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6633 "parser.c"
    break;

  case 100: /* p_arg_list_opt: p_arg_list p_comma_arg_list  */
#line 2708 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyvsp[0].p_arg_list), p_token_list_new_placemarker() );
      slist_push_list_back( (yyval.p_arg_list), (yyvsp[0].p_arg_list) );
    }
#line 6643 "parser.c"
    break;

  case 101: /* p_arg_list_opt: error  */
#line 2715 "parser.y"
    {
      (yyval.p_arg_list) = NULL;
      elaborate_error( "macro argument expected" );
    }
#line 6652 "parser.c"
    break;

  case 102: /* p_comma_arg_list: p_comma_arg_list ','  */
#line 2723 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-1].p_arg_list);
      slist_push_back( (yyval.p_arg_list), p_token_list_new_placemarker() );
    }
#line 6661 "parser.c"
    break;

  case 103: /* p_comma_arg_list: ','  */
#line 2728 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
    }
#line 6670 "parser.c"
    break;

  case 104: /* p_arg_list: p_arg_list p_comma_arg_list p_arg_tokens  */
#line 2749 "parser.y"
    {
      (yyval.p_arg_list) = (yyvsp[-2].p_arg_list);

      if ( !slist_empty( (yyvsp[-1].p_arg_list) ) )
        slist_push_list_back( (yyval.p_arg_list), (yyvsp[-1].p_arg_list) );

      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6683 "parser.c"
    break;

  case 105: /* p_arg_list: p_arg_tokens  */
#line 2759 "parser.y"
    {
      (yyval.p_arg_list) = MALLOC( p_arg_list_t, 1 );
      slist_init( (yyval.p_arg_list) );
      slist_push_back( (yyval.p_arg_list), (yyvsp[0].p_token_list) );
    }
#line 6693 "parser.c"
    break;

  case 106: /* p_arg_tokens: p_arg_tokens p_arg_token_as_list  */
#line 2768 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6702 "parser.c"
    break;

  case 108: /* p_arg_token_as_list: p_arg_token  */
#line 2777 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6712 "parser.c"
    break;

  case 109: /* p_arg_token_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2783 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6722 "parser.c"
    break;

  case 110: /* p_arg_token: Y_CHAR_LIT  */
#line 2792 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CHAR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6730 "parser.c"
    break;

  case 111: /* p_arg_token: Y_NAME  */
#line 2796 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_IDENTIFIER, &(yylsp[0]), (yyvsp[0].name) );
    }
#line 6738 "parser.c"
    break;

  case 112: /* p_arg_token: p_num_lit  */
#line 2800 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_NUM_LIT, &(yylsp[0]), check_strdup( lexer_token ) );
    }
#line 6746 "parser.c"
    break;

  case 113: /* p_arg_token: Y_PRE_SPACE  */
#line 2804 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_SPACE, &(yylsp[0]), /*literal=*/NULL );
    }
#line 6754 "parser.c"
    break;

  case 114: /* p_arg_token: Y_STR_LIT  */
#line 2808 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_STR_LIT, &(yylsp[0]), (yyvsp[0].str_val) );
    }
#line 6762 "parser.c"
    break;

  case 115: /* p_arg_token: p_other  */
#line 2812 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_OTHER, &(yylsp[0]), lexer_token );
    }
#line 6770 "parser.c"
    break;

  case 116: /* p_arg_token: p_punctuator  */
#line 2816 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), lexer_token );
    }
#line 6778 "parser.c"
    break;

  case 170: /* p_arg_tokens_with_comma_opt: %empty  */
#line 2888 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
    }
#line 6787 "parser.c"
    break;

  case 172: /* p_arg_tokens_with_comma: p_arg_tokens_with_comma p_arg_token_with_comma_as_list  */
#line 2908 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_list_back( (yyval.p_token_list), (yyvsp[0].p_token_list) );
    }
#line 6796 "parser.c"
    break;

  case 174: /* p_arg_token_with_comma_as_list: p_arg_token_with_comma  */
#line 2917 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 6806 "parser.c"
    break;

  case 175: /* p_arg_token_with_comma_as_list: '(' p_arg_tokens_with_comma_opt ')'  */
#line 2923 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_front( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[-2]), "(" ) );
      slist_push_back ( (yyval.p_token_list), p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" ) );
    }
#line 6816 "parser.c"
    break;

  case 177: /* p_arg_token_with_comma: ','  */
#line 2933 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 6824 "parser.c"
    break;

  case 188: /* explain_command: explain pc99_pointer_decl_list_c  */
#line 3000 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 6833 "parser.c"
    break;

  case 190: /* $@2: %empty  */
#line 3018 "parser.y"
                       { in_attr.is_typename = true; }
#line 6839 "parser.c"
    break;

  case 193: /* explain_command: explain extern_linkage_c_stid_opt using_decl_c_ast  */
#line 3039 "parser.y"
    {
      DUMP_START( "explain_command",
                  "EXPLAIN extern_linkage_c_stid_opt using_decl_c_ast" );
      DUMP_TID( "extern_linkage_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "using_decl_c_ast", (yyvsp[0].ast) );

      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) )
      );

      DUMP_AST( "$$_ast", (yyvsp[0].ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast) ) );
      c_ast_english( (yyvsp[0].ast), C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 6861 "parser.c"
    break;

  case 194: /* explain_command: explain sname_c  */
#line 3062 "parser.y"
    {
      print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].sname) );
      c_sname_cleanup( &(yyvsp[0].sname) );
      PARSE_ABORT();
    }
#line 6871 "parser.c"
    break;

  case 195: /* explain_command: explain error  */
#line 3069 "parser.y"
    {
      elaborate_error( "cast or declaration expected" );
    }
#line 6879 "parser.c"
    break;

  case 196: /* explain: Y_explain  */
#line 3076 "parser.y"
    { //
      // Set our mode to deciphering gibberish into English and specifically
      // tell the lexer to return cdecl keywords (e.g., "func") as ordinary
      // names, otherwise gibberish like:
      //
      //      int func(void);
      //
      // would result in a parser error.
      //
      gibberish_to_english();
    }
#line 6895 "parser.c"
    break;

  case 197: /* $@3: %empty  */
#line 3093 "parser.y"
    { //
      // We want cdecl commands (like "declare", etc.), other cdecl keywords
      // (like "cast", "commands", "english", "options", etc.), and C/C++
      // keywords (like "const", "static", "typedef", etc.) all to be returned
      // as just strings so we don't have to enumerate all the possible tokens
      // in the grammar.
      //
      lexer_find &= ~(LEXER_FIND_C_KEYWORDS | LEXER_FIND_CDECL_KEYWORDS);
    }
#line 6909 "parser.c"
    break;

  case 198: /* help_command: '?' $@3 help_what_opt  */
#line 3103 "parser.y"
    {
      bool const ok = print_help( (yyvsp[0].name), &(yylsp[0]) );
      free( (yyvsp[0].name) );
      PARSE_ASSERT( ok );
    }
#line 6919 "parser.c"
    break;

  case 199: /* help_what_opt: %empty  */
#line 3111 "parser.y"
                                  { (yyval.name) = NULL; }
#line 6925 "parser.c"
    break;

  case 201: /* help_what_opt: '#' Y_NAME  */
#line 3113 "parser.y"
                                  { (yyval.name) = str_realloc_pcat( "#", "", (yyvsp[0].name) ); }
#line 6931 "parser.c"
    break;

  case 202: /* help_what_opt: '#' error  */
#line 3115 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 6940 "parser.c"
    break;

  case 203: /* help_what_opt: error  */
#line 3120 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error(
        "<command>, \"commands\", \"english\", or \"options\" expected"
      );
    }
#line 6951 "parser.c"
    break;

  case 207: /* preprocessor_command: '#' Y_PRE_elif  */
#line 3137 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elif\"" );
      PARSE_ABORT();
    }
#line 6960 "parser.c"
    break;

  case 208: /* preprocessor_command: '#' Y_PRE_elifdef  */
#line 3142 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6969 "parser.c"
    break;

  case 209: /* preprocessor_command: '#' Y_PRE_elifndef  */
#line 3147 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#elifdef\"" );
      PARSE_ABORT();
    }
#line 6978 "parser.c"
    break;

  case 210: /* preprocessor_command: '#' Y_PRE_else  */
#line 3152 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#else\"" );
      PARSE_ABORT();
    }
#line 6987 "parser.c"
    break;

  case 211: /* preprocessor_command: '#' Y_PRE_embed  */
#line 3157 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#embed\"" );
      PARSE_ABORT();
    }
#line 6996 "parser.c"
    break;

  case 212: /* preprocessor_command: '#' Y_PRE_error  */
#line 3162 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#error\"" );
      PARSE_ABORT();
    }
#line 7005 "parser.c"
    break;

  case 213: /* preprocessor_command: '#' Y_PRE_if  */
#line 3167 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#if\"" );
      PARSE_ABORT();
    }
#line 7014 "parser.c"
    break;

  case 214: /* preprocessor_command: '#' Y_PRE_ifdef  */
#line 3172 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifdef\"" );
      PARSE_ABORT();
    }
#line 7023 "parser.c"
    break;

  case 215: /* preprocessor_command: '#' Y_PRE_ifndef  */
#line 3177 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#ifndef\"" );
      PARSE_ABORT();
    }
#line 7032 "parser.c"
    break;

  case 216: /* preprocessor_command: '#' Y_PRE_line  */
#line 3182 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#line\"" );
      PARSE_ABORT();
    }
#line 7041 "parser.c"
    break;

  case 217: /* preprocessor_command: '#' Y_PRE_pragma  */
#line 3187 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#pragma\"" );
      PARSE_ABORT();
    }
#line 7050 "parser.c"
    break;

  case 218: /* preprocessor_command: '#' Y_PRE_warning  */
#line 3192 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "\"#warning\"" );
      PARSE_ABORT();
    }
#line 7059 "parser.c"
    break;

  case 219: /* preprocessor_command: '#' error  */
#line 3197 "parser.y"
    {
      elaborate_error( "\"#define\", \"#include\", or \"#undef\" expected" );
    }
#line 7067 "parser.c"
    break;

  case 220: /* p_define: Y_PRE_define name_exp p_paren_param_list_opt p_replace_list_opt  */
#line 3205 "parser.y"
    {
      DUMP_START( "p_define",
                  "#define NAME p_paren_param_list_opt p_replace_list_opt" );
      DUMP_STR( "name", (yyvsp[-2].name) );
      DUMP_MACRO_PARAM_LIST( "p_paren_param_list_opt", (yyvsp[-1].p_param_list) );
      DUMP_MACRO_TOKEN_LIST( "p_replace_list_opt", (yyvsp[0].p_token_list) );

      c_typedef_t const *const tdef = c_typedef_find_name( (yyvsp[-2].name) );
      if ( tdef != NULL ) {
        if ( tdef->is_predefined ) {
          print_warning( &(yylsp[-2]),
            "\"%s\" is a predefined type since %s\n",
            (yyvsp[-2].name),
            c_lang_name( c_lang_oldest( tdef->lang_ids ) )
          );
        }
        else {
          print_warning( &(yylsp[-2]),
            "\"%s\" previously defined as type (\"",
            (yyvsp[-2].name)
          );
          print_type_decl( tdef, tdef->decl_flags, stderr );
          EPUTS( "\")\n" );
        }
      }

      p_macro_t *const macro =
        p_macro_define( (yyvsp[-2].name), &(yylsp[-2]), (yyvsp[-1].p_param_list), (yyvsp[0].p_token_list) );
      p_param_list_cleanup( (yyvsp[-1].p_param_list) );
      free( (yyvsp[-1].p_param_list) );
      p_token_list_cleanup( (yyvsp[0].p_token_list) );
      free( (yyvsp[0].p_token_list) );
      PARSE_ASSERT( macro != NULL );

      DUMP_MACRO( "macro", macro );
      DUMP_END();
    }
#line 7109 "parser.c"
    break;

  case 221: /* p_paren_param_list_opt: %empty  */
#line 3244 "parser.y"
                                  { (yyval.p_param_list) = NULL; }
#line 7115 "parser.c"
    break;

  case 222: /* p_paren_param_list_opt: '(' p_param_list_opt ')'  */
#line 3245 "parser.y"
                                  { (yyval.p_param_list) = (yyvsp[-1].p_param_list); }
#line 7121 "parser.c"
    break;

  case 223: /* p_param_list_opt: %empty  */
#line 3249 "parser.y"
    { //
      // Use an empty list to distinguish a macro with an empty parameter list
      // from one with no parameter list.
      //
      //      #define M   X       // no parameter list: use NULL
      //      #define F() #X      // empty parameter list: use empty list
      //
      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
    }
#line 7136 "parser.c"
    break;

  case 225: /* p_param_list: p_param_list comma_exp p_param  */
#line 3264 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_MACRO_PARAM_LIST( "p_param_list", (yyvsp[-2].p_param_list) );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = (yyvsp[-2].p_param_list);
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7152 "parser.c"
    break;

  case 226: /* p_param_list: p_param  */
#line 3277 "parser.y"
    {
      DUMP_START( "p_param_list", "p_param" );
      DUMP_STR( "p_param", (yyvsp[0].p_param)->name );

      (yyval.p_param_list) = MALLOC( p_param_list_t, 1 );
      slist_init( (yyval.p_param_list) );
      slist_push_back( (yyval.p_param_list), (yyvsp[0].p_param) );

      DUMP_MACRO_PARAM_LIST( "$$_list", (yyval.p_param_list) );
      DUMP_END();
    }
#line 7168 "parser.c"
    break;

  case 227: /* p_param: Y_NAME  */
#line 3292 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = (yyvsp[0].name), .loc = (yylsp[0]) };
    }
#line 7177 "parser.c"
    break;

  case 228: /* p_param: "..."  */
#line 3297 "parser.y"
    {
      (yyval.p_param) = MALLOC( p_param_t, 1 );
      *(yyval.p_param) = (p_param_t){ .name = check_strdup( L_ellipsis ), .loc = (yylsp[0]) };
    }
#line 7186 "parser.c"
    break;

  case 229: /* p_param: error  */
#line 3302 "parser.y"
    {
      (yyval.p_param) = NULL;
      if ( OPT_LANG_IS( VARIADIC_MACROS ) )
        elaborate_error( "parameter name or \"...\" expected" );
      else
        elaborate_error( "parameter name expected" );
    }
#line 7198 "parser.c"
    break;

  case 230: /* p_replace_list_opt: %empty  */
#line 3312 "parser.y"
                                  { (yyval.p_token_list) = NULL; }
#line 7204 "parser.c"
    break;

  case 232: /* p_replace_list: p_replace_list p_replace_token  */
#line 3318 "parser.y"
    {
      (yyval.p_token_list) = (yyvsp[-1].p_token_list);
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7213 "parser.c"
    break;

  case 233: /* p_replace_list: p_replace_token  */
#line 3324 "parser.y"
    {
      (yyval.p_token_list) = MALLOC( p_token_list_t, 1 );
      slist_init( (yyval.p_token_list) );
      slist_push_back( (yyval.p_token_list), (yyvsp[0].p_token) );
    }
#line 7223 "parser.c"
    break;

  case 234: /* p_replace_token: p_arg_token  */
#line 3333 "parser.y"
    {
      if ( p_token_is_punct( (yyvsp[0].p_token), '#' ) ) {
        //
        // A '#' macro argument token is an ordinary '#', but as a replacement
        // token, retroactively make it P_STRINGIFY.
        //
        (yyvsp[0].p_token)->kind = P_STRINGIFY;
      }
      (yyval.p_token) = (yyvsp[0].p_token);
    }
#line 7238 "parser.c"
    break;

  case 235: /* p_replace_token: '('  */
#line 3344 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "(" );
    }
#line 7246 "parser.c"
    break;

  case 236: /* p_replace_token: ')'  */
#line 3348 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), ")" );
    }
#line 7254 "parser.c"
    break;

  case 237: /* p_replace_token: ','  */
#line 3352 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_PUNCTUATOR, &(yylsp[0]), "," );
    }
#line 7262 "parser.c"
    break;

  case 238: /* p_replace_token: "##"  */
#line 3356 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P_CONCAT, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7270 "parser.c"
    break;

  case 239: /* p_replace_token: Y_PRE___VA_ARGS__  */
#line 3360 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_ARGS__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7278 "parser.c"
    break;

  case 240: /* p_replace_token: Y_PRE___VA_OPT__  */
#line 3364 "parser.y"
    {
      (yyval.p_token) = p_token_new_loc( P___VA_OPT__, &(yylsp[0]), /*literal=*/NULL );
    }
#line 7286 "parser.c"
    break;

  case 241: /* p_undef: Y_PRE_undef name_exp  */
#line 3371 "parser.y"
    {
      PARSE_ASSERT( p_macro_undef( (yyvsp[0].name), &(yylsp[0]) ) );
    }
#line 7294 "parser.c"
    break;

  case 242: /* quit_command: Y_quit  */
#line 3379 "parser.y"
                                  { cdecl_quit(); }
#line 7300 "parser.c"
    break;

  case 244: /* set_command: Y_set  */
#line 3392 "parser.y"
    {
      PARSE_ASSERT( set_option( NULL, NULL, NULL, NULL ) );
    }
#line 7308 "parser.c"
    break;

  case 248: /* set_option: Y_SET_OPTION set_option_value_opt  */
#line 3405 "parser.y"
    {
      bool const ok = set_option( (yyvsp[-1].name), &(yylsp[-1]), (yyvsp[0].str_val), &(yylsp[0]) );
      free( (yyvsp[-1].name) );
      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 7319 "parser.c"
    break;

  case 249: /* set_option_value_opt: %empty  */
#line 3414 "parser.y"
                                  { (yyval.str_val) = NULL; }
#line 7325 "parser.c"
    break;

  case 250: /* set_option_value_opt: '=' Y_SET_OPTION  */
#line 3415 "parser.y"
                                  { (yyval.str_val) = (yyvsp[0].name); (yyloc) = (yylsp[0]); }
#line 7331 "parser.c"
    break;

  case 251: /* set_option_value_opt: '=' error  */
#line 3417 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "option value expected" );
    }
#line 7340 "parser.c"
    break;

  case 252: /* show_command: Y_show any_typedef show_format_opt  */
#line 3427 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef show_format_opt" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-1].tdef)->ast );
      DUMP_INT( "show_format_opt", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-1].tdef), (yyvsp[0].flags), stdout );
    }
#line 7353 "parser.c"
    break;

  case 253: /* show_command: Y_show any_typedef Y_as show_format_exp  */
#line 3437 "parser.y"
    {
      DUMP_START( "show_command", "SHOW any_typedef AS show_format_exp" );
      DUMP_AST( "any_typedef__ast", (yyvsp[-2].tdef)->ast );
      DUMP_INT( "show_format_exp", (yyvsp[0].flags) );
      DUMP_END();

      show_type( (yyvsp[-2].tdef), (yyvsp[0].flags), stdout );
    }
#line 7366 "parser.c"
    break;

  case 254: /* show_command: Y_show show_types_opt glob_opt show_format_opt  */
#line 3447 "parser.y"
    {
      show_types( (yyvsp[-2].show), (yyvsp[-1].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-1].name) );
    }
#line 7375 "parser.c"
    break;

  case 255: /* show_command: Y_show show_types_opt glob_opt Y_as show_format_exp  */
#line 3453 "parser.y"
    {
      show_types( (yyvsp[-3].show), (yyvsp[-2].name), (yyvsp[0].flags), stdout );
      free( (yyvsp[-2].name) );
    }
#line 7384 "parser.c"
    break;

  case 256: /* show_command: Y_show show_types_opt Y_macros  */
#line 3459 "parser.y"
    {
      show_macros( (yyvsp[-1].show), stdout );
    }
#line 7392 "parser.c"
    break;

  case 257: /* show_command: Y_show Y_NAME  */
#line 3464 "parser.y"
    {
      bool ok = false;

      //
      // Check to see if $name is a macro here rather than in the lexer since
      // this is the only place in the cdecl grammar where a name can be a
      // macro since cdecl doesn't support using macros everywhere.
      //
      p_macro_t const *const macro = p_macro_find( (yyvsp[0].name) );
      if ( macro == NULL ) {
        print_error( &(yylsp[0]), "\"%s\": no such type or macro defined", (yyvsp[0].name) );
        print_suggestions( DYM_C_MACROS | DYM_C_TYPES, (yyvsp[0].name) );
        EPUTC( '\n' );
      }
      else if ( !(ok = show_macro( macro, stdout )) ) {
        c_lang_id_t const lang_ids = (*macro->dyn_fn)( /*ptoken=*/NULL );
        print_error( &(yylsp[0]),
          "\"%s\" not supported%s\n",
          (yyvsp[0].name), c_lang_which( lang_ids )
        );
      }

      free( (yyvsp[0].name) );
      if ( !ok )
        PARSE_ABORT();
    }
#line 7423 "parser.c"
    break;

  case 258: /* show_command: Y_show error  */
#line 3492 "parser.y"
    {
      elaborate_error(
        "type name or \"all\", \"predefined\", or \"user\" expected"
      );
    }
#line 7433 "parser.c"
    break;

  case 259: /* show_format: Y_english  */
#line 3500 "parser.y"
                                  { (yyval.flags) = C_ENG_DECL; }
#line 7439 "parser.c"
    break;

  case 260: /* show_format: Y_typedef  */
#line 3501 "parser.y"
                                  { (yyval.flags) = C_GIB_TYPEDEF; }
#line 7445 "parser.c"
    break;

  case 261: /* show_format: Y_using  */
#line 3503 "parser.y"
    {
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }
      (yyval.flags) = C_GIB_USING;
    }
#line 7460 "parser.c"
    break;

  case 263: /* show_format_exp: error  */
#line 3518 "parser.y"
    {
      if ( OPT_LANG_IS( using_DECLS ) )
        elaborate_error( "\"english\", \"typedef\", or \"using\" expected" );
      else
        elaborate_error( "\"english\" or \"typedef\" expected" );
    }
#line 7471 "parser.c"
    break;

  case 264: /* show_format_opt: %empty  */
#line 3527 "parser.y"
                                  { (yyval.flags) = 0/*as declared*/; }
#line 7477 "parser.c"
    break;

  case 266: /* show_types_opt: %empty  */
#line 3532 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7483 "parser.c"
    break;

  case 267: /* show_types_opt: Y_all predefined_or_user_types_opt  */
#line 3534 "parser.y"
    {
      (yyval.show) = (yyvsp[0].show) | CDECL_SHOW_OPT_IGNORE_LANG;
    }
#line 7491 "parser.c"
    break;

  case 268: /* show_types_opt: Y_predefined  */
#line 3537 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7497 "parser.c"
    break;

  case 269: /* show_types_opt: Y_user  */
#line 3538 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7503 "parser.c"
    break;

  case 270: /* predefined_or_user_types_opt: %empty  */
#line 3543 "parser.y"
    {
      (yyval.show) = CDECL_SHOW_PREDEFINED | CDECL_SHOW_USER_DEFINED;
    }
#line 7511 "parser.c"
    break;

  case 271: /* predefined_or_user_types_opt: Y_predefined  */
#line 3546 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_PREDEFINED; }
#line 7517 "parser.c"
    break;

  case 272: /* predefined_or_user_types_opt: Y_user  */
#line 3547 "parser.y"
                                  { (yyval.show) = CDECL_SHOW_USER_DEFINED; }
#line 7523 "parser.c"
    break;

  case 276: /* $@4: %empty  */
#line 3576 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7531 "parser.c"
    break;

  case 277: /* c_style_cast_expr_c: '(' type_c_ast $@4 cast_c_astp_opt rparen_exp sname_c_opt  */
#line 3580 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN '(' type_c_ast cast_c_astp_opt ')' sname_c_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-4].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-2].ast_pair) );
      DUMP_SNAME( "sname_c_opt", (yyvsp[0].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[0].sname) );
      cast_ast->cast.kind = C_CAST_C;
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-4].ast), (yyvsp[-2].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7558 "parser.c"
    break;

  case 278: /* c_style_cast_expr_c: '(' pc99_pointer_decl_list_c rparen_exp  */
#line 3613 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[-1].ast_list) ) );
      c_ast_list_english( &(yyvsp[-1].ast_list), stdout );
    }
#line 7567 "parser.c"
    break;

  case 279: /* $@5: %empty  */
#line 3623 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 7575 "parser.c"
    break;

  case 280: /* new_style_cast_expr_c: new_style_cast_c lt_exp type_c_ast $@5 cast_c_astp_opt gt_exp lparen_exp sname_c_exp rparen_exp  */
#line 3627 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "explain_command",
                  "EXPLAIN new_style_cast_c"
                  "'<' type_c_ast cast_c_astp_opt '>' '(' sname ')'" );
      DUMP_STR( "new_style_cast_c", c_cast_english( (yyvsp[-8].cast_kind) ) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_SNAME( "sname_c_exp", (yyvsp[-1].sname) );

      c_ast_t *const cast_ast = c_ast_new_gc( K_CAST, &(yyloc) );
      cast_ast->sname = c_sname_move( &(yyvsp[-1].sname) );
      cast_ast->cast.kind = (yyvsp[-8].cast_kind);
      cast_ast->cast.to_ast =
        c_ast_patch_placeholder( (yyvsp[-6].ast), (yyvsp[-4].ast_pair).ast );

      DUMP_AST( "$$_ast", cast_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( cast_ast ) );
      c_ast_english( cast_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 7604 "parser.c"
    break;

  case 281: /* new_style_cast_c: Y_const_cast  */
#line 3654 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_CONST;        }
#line 7610 "parser.c"
    break;

  case 282: /* new_style_cast_c: Y_dynamic_cast  */
#line 3655 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_DYNAMIC;      }
#line 7616 "parser.c"
    break;

  case 283: /* new_style_cast_c: Y_reinterpret_cast  */
#line 3656 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_REINTERPRET;  }
#line 7622 "parser.c"
    break;

  case 284: /* new_style_cast_c: Y_static_cast  */
#line 3657 "parser.y"
                                  { (yyval.cast_kind) = C_CAST_STATIC;       }
#line 7628 "parser.c"
    break;

  case 285: /* $@6: %empty  */
#line 3667 "parser.y"
                                  { in_attr.align = (yyvsp[0].align); }
#line 7634 "parser.c"
    break;

  case 286: /* $@7: %empty  */
#line 3668 "parser.y"
                                  { in_attr.is_typename = (yyvsp[0].flag); }
#line 7640 "parser.c"
    break;

  case 288: /* alignas_specifier_c: alignas lparen_exp uint_lit rparen_exp  */
#line 3674 "parser.y"
    {
      DUMP_START( "alignas_specifier_c", "ALIGNAS '(' uint_lit ')'" );
      DUMP_INT( "uint_lit", (yyvsp[-1].uint_val) );

      (yyval.align).kind = C_ALIGNAS_BYTES;
      (yyval.align).loc = (yylsp[-3]);
      (yyval.align).bytes = (yyvsp[-1].uint_val);

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7656 "parser.c"
    break;

  case 289: /* $@8: %empty  */
#line 3686 "parser.y"
                                            { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 7662 "parser.c"
    break;

  case 290: /* alignas_specifier_c: alignas lparen_exp type_c_ast $@8 cast_c_astp_opt rparen_exp  */
#line 3688 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "alignas_specifier_c",
                  "ALIGNAS '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.align).kind = C_ALIGNAS_TYPE;
      (yyval.align).loc = (yylsp[-5]);
      (yyval.align).type_ast = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_ALIGN( "$$_align", (yyval.align) );
      DUMP_END();
    }
#line 7682 "parser.c"
    break;

  case 291: /* alignas_specifier_c: alignas lparen_exp error ')'  */
#line 3705 "parser.y"
    {
      elaborate_error( "integer or type expected" );
    }
#line 7690 "parser.c"
    break;

  case 294: /* asm_declaration_c: Y_asm lparen_exp str_lit_exp rparen_exp  */
#line 3719 "parser.y"
    {
      free( (yyvsp[-1].str_val) );
      UNSUPPORTED( &(yylsp[-3]), "asm declarations" );
      PARSE_ABORT();
    }
#line 7700 "parser.c"
    break;

  case 298: /* $@9: %empty  */
#line 3739 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7709 "parser.c"
    break;

  case 299: /* $@10: %empty  */
#line 3744 "parser.y"
    {
      c_type_t const *const cur_type =
        c_sname_local_type( &in_attr.scope_sname );
      if ( c_tid_is_any( cur_type->btids, TB_ANY_CLASS ) ) {
        char const *const cur_name = c_sname_local_name( &in_attr.scope_sname );
        char const *const mbr_name = c_sname_local_name( &(yyvsp[0].sname) );
        if ( strcmp( mbr_name, cur_name ) == 0 ) {
          print_error( &(yylsp[0]),
            "\"%s\": member has the same name as its enclosing %s\n",
            mbr_name, c_type_name_c( cur_type )
          );
          c_sname_cleanup( &(yyvsp[0].sname) );
          PARSE_ABORT();
        }
      }

      DUMP_START( "class_struct_union_declaration_c",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &in_attr.scope_sname, &C_TYPE_LIT_B( (yyvsp[-2].tid) )
      );
      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );

      c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[0]) );
      csu_ast->sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name(
        &csu_ast->csu.csu_sname,
        check_strdup( c_sname_local_name( &in_attr.scope_sname ) )
      );
      csu_ast->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", csu_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( csu_ast, C_GIB_TYPEDEF ) );
    }
#line 7755 "parser.c"
    break;

  case 301: /* $@11: %empty  */
#line 3793 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[0]) ) );
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7764 "parser.c"
    break;

  case 302: /* enum_declaration_c: enum_btids $@11 any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 3798 "parser.y"
    {
      DUMP_START( "enum_declaration_c",
                  "enum_btids any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_t enum_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_sname( &enum_sname, &(yyvsp[-1].sname) );
      c_sname_set_local_type( &enum_sname, &C_TYPE_LIT_B( (yyvsp[-3].tid) ) );
      if ( !c_sname_check( &enum_sname, &(yylsp[-1]) ) ) {
        c_sname_cleanup( &enum_sname );
        PARSE_ABORT();
      }

      c_ast_t *const enum_ast = c_ast_new_gc( K_ENUM, &(yylsp[-1]) );
      enum_ast->sname = enum_sname;
      enum_ast->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), enum_ast );
      c_sname_append_name(
        &enum_ast->enum_.enum_sname,
        check_strdup( c_sname_local_name( &enum_sname ) )
      );

      DUMP_AST( "$$_ast", enum_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( enum_ast, C_GIB_TYPEDEF ) );
    }
#line 7798 "parser.c"
    break;

  case 303: /* $@12: %empty  */
#line 3834 "parser.y"
    {
      gibberish_to_english();           // see the comment in "explain"
    }
#line 7806 "parser.c"
    break;

  case 304: /* $@13: %empty  */
#line 3838 "parser.y"
    {
      DUMP_START( "namespace_declaration_c",
                  "namespace_type namespace_sname_c_exp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_TYPE( "namespace_type", (yyvsp[-2].type) );
      DUMP_SNAME( "namespace_sname_c_exp", (yyvsp[0].sname) );

      //
      // Nested namespace declarations are supported only in C++17 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the AST has no "memory" of how a namespace was
      // constructed.
      //
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 && !IS_SUPPORTED( NESTED_namespace ) ) {
        print_error( &(yylsp[0]),
          "nested namespace declarations not supported%s\n",
          C_LANG_WHICH( NESTED_namespace )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }

      //
      // The namespace type (plain namespace or inline namespace) has to be
      // split across the namespace sname: only the storage classes (for
      // TS_inline) has to be or'd with the first scope-type of the sname ...
      //
      c_type_t const *const sname_first_type = c_sname_first_type( &(yyvsp[0].sname) );
      c_sname_set_first_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_first_type->btids,
          sname_first_type->stids | (yyvsp[-2].type).stids,
          sname_first_type->atids
        )
      );
      //
      // ... and only the base types (for TB_namespace) has to be or'd with the
      // local scope type of the sname.
      //
      c_type_t const *const sname_local_type = c_sname_local_type( &(yyvsp[0].sname) );
      c_sname_set_local_type(
        &(yyvsp[0].sname),
        &C_TYPE_LIT(
          sname_local_type->btids | (yyvsp[-2].type).btids,
          sname_local_type->stids,
          sname_local_type->atids
        )
      );

      c_sname_append_sname( &in_attr.scope_sname, &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyvsp[0].sname) );
      DUMP_END();

      PARSE_ASSERT( c_sname_check( &in_attr.scope_sname, &(yylsp[0]) ) );
    }
#line 7870 "parser.c"
    break;

  case 308: /* namespace_sname_c_exp: error  */
#line 3904 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 7879 "parser.c"
    break;

  case 309: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_NAME  */
#line 3917 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7896 "parser.c"
    break;

  case 310: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON any_typedef  */
#line 3931 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "namespace_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7914 "parser.c"
    break;

  case 311: /* namespace_sname_c: namespace_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 3946 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "sname_c '::' NAME INLINE NAME" );
      DUMP_SNAME( "namespace_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7933 "parser.c"
    break;

  case 312: /* namespace_sname_c: Y_NAME  */
#line 3962 "parser.y"
    {
      DUMP_START( "namespace_sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_namespace ) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7948 "parser.c"
    break;

  case 313: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON sname_c  */
#line 3981 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7965 "parser.c"
    break;

  case 314: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON any_typedef  */
#line 3995 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 7984 "parser.c"
    break;

  case 315: /* namespace_typedef_sname_c: namespace_typedef_sname_c Y_COLON_COLON Y_inline name_exp  */
#line 4012 "parser.y"
    {
      DUMP_START( "namespace_typedef_sname_c",
                  "namespace_typedef_sname_c '::' INLINE NAME" );
      DUMP_SNAME( "namespace_typedef_sname_c", (yyvsp[-3].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-3].sname);
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );
      c_sname_set_local_type( &(yyval.sname),
        &C_TYPE_LIT( TB_namespace, (yyvsp[-1].tid), TA_NONE )
      );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 8004 "parser.c"
    break;

  case 316: /* namespace_typedef_sname_c: any_typedef  */
#line 4028 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 8010 "parser.c"
    break;

  case 318: /* brace_in_scope_declaration_c_exp: error  */
#line 4034 "parser.y"
    {
      punct_expected( '{' );
    }
#line 8018 "parser.c"
    break;

  case 326: /* in_scope_declaration_c_exp: error  */
#line 4054 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8026 "parser.c"
    break;

  case 327: /* lambda_declaration_c: '[' capture_decl_list_c_opt ']' lambda_param_c_ast_list_opt storage_class_subset_english_type_opt lambda_return_type_c_ast_opt  */
#line 4066 "parser.y"
    {
      DUMP_START( "lambda_declaration_c",
                  "'[' capture_decl_list_c_opt ']' "
                  "lambda_param_c_ast_list_opt "
                  "lambda_return_type_c_ast_opt" );
      DUMP_AST_LIST( "capture_decl_list_c_opt", (yyvsp[-4].ast_list) );
      DUMP_AST_LIST( "lambda_param_c_ast_list_opt", (yyvsp[-2].ast_list) );
      DUMP_TYPE( "storage_class_subset_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "lambda_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_ast_t *const lambda_ast = c_ast_new_gc( K_LAMBDA, &(yyloc) );
      lambda_ast->type = (yyvsp[-1].type);
      c_ast_list_set_param_of( &(yyvsp[-4].ast_list), lambda_ast );
      lambda_ast->lambda.capture_ast_list = slist_move( &(yyvsp[-4].ast_list) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), lambda_ast );
      lambda_ast->lambda.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), lambda_ast );

      DUMP_AST( "$$_ast", lambda_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( lambda_ast ) );
      c_ast_english( lambda_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8056 "parser.c"
    break;

  case 328: /* capture_decl_list_c_opt: %empty  */
#line 4094 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8062 "parser.c"
    break;

  case 330: /* capture_decl_list_c: capture_decl_list_c comma_exp capture_decl_c_ast  */
#line 4101 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_list_c ',' "
                  "capture_decl_c_ast" );
      DUMP_AST_LIST( "capture_decl_list_c", (yyvsp[-2].ast_list) );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8080 "parser.c"
    break;

  case 331: /* capture_decl_list_c: capture_decl_c_ast  */
#line 4116 "parser.y"
    {
      DUMP_START( "capture_decl_list_c",
                  "capture_decl_c_ast" );
      DUMP_AST( "capture_decl_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 8096 "parser.c"
    break;

  case 332: /* capture_decl_c_ast: '&'  */
#line 4131 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8105 "parser.c"
    break;

  case 333: /* capture_decl_c_ast: '&' Y_NAME  */
#line 4136 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
      (yyval.ast)->capture.kind = C_CAPTURE_REFERENCE;
    }
#line 8115 "parser.c"
    break;

  case 334: /* capture_decl_c_ast: '='  */
#line 4142 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_COPY;
    }
#line 8124 "parser.c"
    break;

  case 335: /* capture_decl_c_ast: Y_NAME  */
#line 4147 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );
    }
#line 8133 "parser.c"
    break;

  case 336: /* capture_decl_c_ast: Y_this  */
#line 4152 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_THIS;
    }
#line 8142 "parser.c"
    break;

  case 337: /* capture_decl_c_ast: '*' this_exp  */
#line 4157 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_CAPTURE, &(yyloc) );
      (yyval.ast)->capture.kind = C_CAPTURE_STAR_THIS;
    }
#line 8151 "parser.c"
    break;

  case 338: /* lambda_param_c_ast_list_opt: %empty  */
#line 4164 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 8157 "parser.c"
    break;

  case 339: /* lambda_param_c_ast_list_opt: '(' param_c_ast_list_opt ')'  */
#line 4165 "parser.y"
                                  { (yyval.ast_list) = (yyvsp[-1].ast_list); }
#line 8163 "parser.c"
    break;

  case 340: /* lambda_return_type_c_ast_opt: %empty  */
#line 4169 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 8169 "parser.c"
    break;

  case 341: /* $@14: %empty  */
#line 4170 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8175 "parser.c"
    break;

  case 342: /* lambda_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@14 cast_c_astp_opt  */
#line 4172 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "lambda_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8193 "parser.c"
    break;

  case 343: /* template_declaration_c: Y_template  */
#line 4191 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "template declarations" );
      PARSE_ABORT();
    }
#line 8202 "parser.c"
    break;

  case 344: /* $@15: %empty  */
#line 4200 "parser.y"
                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 8208 "parser.c"
    break;

  case 345: /* typed_declaration_c: type_c_ast $@15 decl_list_c_opt  */
#line 4201 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8216 "parser.c"
    break;

  case 346: /* $@16: %empty  */
#line 4210 "parser.y"
    {
      PARSE_ASSERT( is_nested_type_ok( &(yylsp[-1]) ) );
      in_attr.is_typename = (yyvsp[0].flag);
      gibberish_to_english();           // see the comment in "explain"
    }
#line 8226 "parser.c"
    break;

  case 347: /* $@17: %empty  */
#line 4216 "parser.y"
    {
      PARSE_ASSERT( !in_attr.is_typename || c_ast_is_typename_ok( (yyvsp[0].ast) ) );
      // see the comment in "define_command" about TS_typedef
      PARSE_ASSERT(
        c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) )
      );
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8239 "parser.c"
    break;

  case 348: /* typedef_declaration_c: Y_typedef typename_flag_opt $@16 type_c_ast $@17 typedef_decl_list_c  */
#line 4225 "parser.y"
    {
      ia_type_ast_pop();
    }
#line 8247 "parser.c"
    break;

  case 351: /* typedef_decl_c: decl_c_astp  */
#line 4238 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_decl_c", "decl_c_astp" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      c_ast_t *const decl_ast = (yyvsp[0].ast_pair).ast;
      c_ast_t *typedef_ast;
      c_sname_t temp_sname;

      if ( decl_ast->kind == K_TYPEDEF ) {
        //
        // This is for either of the following cases:
        //
        //      typedef int int32_t;
        //      typedef int32_t int_least32_t;
        //
        // that is: any type name followed by an existing typedef name.
        //
        typedef_ast = type_ast;
        if ( c_sname_empty( &typedef_ast->sname ) )
          typedef_ast->sname = c_sname_dup( &decl_ast->tdef.for_ast->sname );
      }
      else {
        //
        // This is for either of the following cases:
        //
        //      typedef int foo;
        //      typedef int32_t foo;
        //
        // that is: any type name followed by a new name.
        //
        typedef_ast = c_ast_patch_placeholder( type_ast, decl_ast );
        temp_sname = c_ast_move_sname( decl_ast );
        c_sname_set( &typedef_ast->sname, &temp_sname );
      }

      PARSE_ASSERT( c_ast_check( typedef_ast ) );
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( typedef_ast, &T_TS_typedef ) );

      if ( c_sname_count( &typedef_ast->sname ) > 1 ) {
        print_error( &(yylsp[0]),
          "typedef names can not be scoped; "
          "use: namespace %s { typedef ... }\n",
          c_sname_scope_name( &typedef_ast->sname )
        );
        PARSE_ABORT();
      }

      temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_prepend_sname( &typedef_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", typedef_ast );
      DUMP_END();

      PARSE_ASSERT( define_type( typedef_ast, C_GIB_TYPEDEF  ) );
    }
#line 8312 "parser.c"
    break;

  case 353: /* typedef_decl_c_exp: error  */
#line 4303 "parser.y"
    {
      elaborate_error( "type expected" );
    }
#line 8320 "parser.c"
    break;

  case 354: /* user_defined_conversion_declaration_c: user_defined_conversion_decl_c_astp  */
#line 4312 "parser.y"
    {
      DUMP_START( "user_defined_conversion_declaration_c",
                  "user_defined_conversion_decl_c_astp" );
      DUMP_AST_PAIR( "user_defined_conversion_declaration_c", (yyvsp[0].ast_pair) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyvsp[0].ast_pair).ast ) );
      c_ast_english( (yyvsp[0].ast_pair).ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8335 "parser.c"
    break;

  case 355: /* using_declaration_c: using_decl_c_ast  */
#line 4328 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      PJL_DISCARD_RV( c_ast_take_type_any( (yyvsp[0].ast), &T_TS_typedef ) );

      PARSE_ASSERT( define_type( (yyvsp[0].ast), C_GIB_USING ) );
    }
#line 8346 "parser.c"
    break;

  case 356: /* $@18: %empty  */
#line 4338 "parser.y"
    { //
      // Using declarations are supported only in C++11 and later.  (However,
      // we always allow them in configuration files.)
      //
      // This check has to be done now in the parser rather than later in the
      // AST because using declarations are treated like typedef declarations
      // and the AST has no "memory" that such a declaration was a using
      // declaration.
      //
      if ( !IS_SUPPORTED( using_DECLS ) ) {
        print_error( &(yylsp[0]),
          "\"using\" not supported%s\n",
          C_LANG_WHICH( using_DECLS )
        );
        PARSE_ABORT();
      }

      gibberish_to_english();           // see the comment in "explain"
    }
#line 8370 "parser.c"
    break;

  case 357: /* $@19: %empty  */
#line 4359 "parser.y"
    {
      // see the comment in "define_command" about TS_typedef
      if ( !c_type_add_tid( &(yyvsp[0].ast)->type, TS_typedef, &(yylsp[0]) ) ) {
        free( (yyvsp[-3].name) );
        PARSE_ABORT();
      }
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 8383 "parser.c"
    break;

  case 358: /* using_decl_c_ast: Y_using $@18 any_name_exp attribute_specifier_list_c_atid_opt equals_exp type_c_ast $@19 cast_c_astp_opt  */
#line 4368 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "using_decl_c_ast",
                  "USING any_name_exp attribute_specifier_list_c_atid_opt '=' "
                  "type_c_ast cast_c_astp_opt" );
      DUMP_SNAME( "in_attr__scope_sname", in_attr.scope_sname );
      DUMP_STR( "any_name_exp", (yyvsp[-5].name) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-4].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      c_ast_t *const cast_ast = (yyvsp[0].ast_pair).ast;

      //
      // Ensure the type on the right-hand side doesn't have a name, e.g.:
      //
      //      using U = void (*F)();    // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the patched AST loses the name.
      //
      c_sname_t const *const sname = c_ast_find_name( cast_ast, C_VISIT_DOWN );
      if ( sname != NULL ) {
        print_error( &cast_ast->loc, "\"using\" type can not have a name\n" );
        free( (yyvsp[-5].name) );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( &in_attr.scope_sname );
      c_sname_append_name( &temp_sname, (yyvsp[-5].name) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), cast_ast );
      c_sname_set( &(yyval.ast)->sname, &temp_sname );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-4].tid), C_TPID_ATTR );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( (yyval.ast) ) );
    }
#line 8429 "parser.c"
    break;

  case 359: /* decl_list_c_opt: %empty  */
#line 4423 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_list_c_opt", "<empty>" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );

      if ( (type_ast->kind & K_ANY_ECSU) == 0 ) {
        //
        // The declaration is a non-ECSU type, e.g.:
        //
        //      int
        //
        c_loc_t const loc = lexer_loc();
        print_error( &loc, "declaration expected" );
        print_error_token_is_a( lexer_printable_token() );
        EPUTC( '\n' );
        PARSE_ABORT();
      }

      if ( in_attr.align.kind != C_ALIGNAS_NONE ) {
        print_error( &in_attr.align.loc,
          "\"%s\" invalid here\n",
          alignas_name()
        );
        PARSE_ABORT();
      }

      c_sname_t const *const ecsu_sname = &type_ast->csu.csu_sname;
      assert( !c_sname_empty( ecsu_sname ) );

      if ( c_sname_count( ecsu_sname ) > 1 ) {
        print_error( &type_ast->loc,
          "forward declaration can not have a scoped name\n"
        );
        PARSE_ABORT();
      }

      c_sname_t temp_sname = c_sname_dup( ecsu_sname );
      c_sname_set( &type_ast->sname, &temp_sname );

      DUMP_AST( "$$_ast", type_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( type_ast ) );
      c_typedef_english( &C_TYPEDEF_LIT( type_ast, C_ENG_DECL ), stdout );
      PUTC( '\n' );
    }
#line 8481 "parser.c"
    break;

  case 360: /* decl_list_c_opt: decl_list_c  */
#line 4472 "parser.y"
    {
      PARSE_ASSERT( c_ast_list_check( &(yyvsp[0].ast_list) ) );
      c_ast_list_english( &(yyvsp[0].ast_list), stdout );
    }
#line 8490 "parser.c"
    break;

  case 361: /* decl_list_c: decl_list_c ',' decl_c_exp  */
#line 4480 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8499 "parser.c"
    break;

  case 362: /* decl_list_c: decl_c  */
#line 4485 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 8508 "parser.c"
    break;

  case 363: /* decl_c: decl_c_astp  */
#line 4494 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "decl_c", "decl_c_astp" );
      switch ( in_attr.align.kind ) {
        case C_ALIGNAS_NONE:
          break;
        case C_ALIGNAS_BYTES:
          DUMP_INT( "in_attr__alignas_bytes", in_attr.align.bytes );
          break;
        case C_ALIGNAS_TYPE:
          DUMP_AST( "in_attr__alignas_type_ast", in_attr.align.type_ast );
          break;
      } // switch
      DUMP_BOOL( "in_attr__typename_flag_opt", in_attr.is_typename );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = join_type_decl( ia_type_spec_ast( type_ast ), (yyvsp[0].ast_pair).ast );
      PARSE_ASSERT( (yyval.ast) != NULL );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 8537 "parser.c"
    break;

  case 365: /* decl_c_exp: error  */
#line 4523 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 8545 "parser.c"
    break;

  case 370: /* decl_c_astp: msc_calling_convention_atid msc_calling_convention_c_astp  */
#line 4534 "parser.y"
    {
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);
      (yyval.ast_pair).ast->type.atids |= (yyvsp[-1].tid);
    }
#line 8555 "parser.c"
    break;

  case 378: /* decl2_c_astp: sname_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4553 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[-1].ast), .target_ast = NULL };
    }
#line 8563 "parser.c"
    break;

  case 379: /* decl2_c_astp: typedef_type_decl_c_ast  */
#line 4557 "parser.y"
    {
      (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), .target_ast = NULL };
    }
#line 8571 "parser.c"
    break;

  case 382: /* array_decl_c_astp: decl2_c_astp array_size_c_ast gnu_attribute_specifier_list_c_opt  */
#line 4570 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_decl_c_astp", "decl2_c_astp array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-2].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[-1].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-2]) ), (yyvsp[-1].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-2].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-2].ast_pair).ast,
          c_ast_add_array( (yyvsp[-2].ast_pair).target_ast, (yyvsp[-1].ast), of_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( (yyvsp[-2].ast_pair).ast, (yyvsp[-1].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8606 "parser.c"
    break;

  case 383: /* array_size_c_ast: '[' rbracket_exp  */
#line 4604 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8615 "parser.c"
    break;

  case 384: /* array_size_c_ast: '[' uint_lit rbracket_exp  */
#line 4609 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8625 "parser.c"
    break;

  case 385: /* array_size_c_ast: '[' Y_NAME rbracket_exp  */
#line 4615 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8635 "parser.c"
    break;

  case 386: /* array_size_c_ast: '[' type_qualifier_list_c_stid rbracket_exp  */
#line 4621 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 8645 "parser.c"
    break;

  case 387: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt uint_lit rbracket_exp  */
#line 4628 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8656 "parser.c"
    break;

  case 388: /* array_size_c_ast: '[' type_qualifier_list_c_stid static_stid_opt Y_NAME rbracket_exp  */
#line 4636 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-3].tid) | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8667 "parser.c"
    break;

  case 389: /* array_size_c_ast: '[' type_qualifier_list_c_stid_opt '*' rbracket_exp  */
#line 4643 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 8677 "parser.c"
    break;

  case 390: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt uint_lit rbracket_exp  */
#line 4650 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[-1].uint_val);
    }
#line 8689 "parser.c"
    break;

  case 391: /* array_size_c_ast: '[' Y_static type_qualifier_list_c_stid_opt Y_NAME rbracket_exp  */
#line 4659 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->type.stids =
        c_tid_check( TS_NON_EMPTY_ARRAY | (yyvsp[-2].tid), C_TPID_STORE );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[-1].name);
    }
#line 8701 "parser.c"
    break;

  case 392: /* array_size_c_ast: '[' error ']'  */
#line 4667 "parser.y"
    {
      elaborate_error( "array size expected" );
    }
#line 8709 "parser.c"
    break;

  case 393: /* $@20: %empty  */
#line 4677 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for decl_c_astp so
      // we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 8720 "parser.c"
    break;

  case 394: /* block_decl_c_astp: '(' '^' $@20 type_qualifier_list_c_stid_opt decl_c_astp rparen_exp lparen_exp param_c_ast_list_opt ')' gnu_attribute_specifier_list_c_opt  */
#line 4686 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_decl_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt decl_c_astp ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-6].tid) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-2].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-6].tid), &(yylsp[-6]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-5].ast_pair).ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-5].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 8760 "parser.c"
    break;

  case 395: /* destructor_declaration_c: virtual_stid_opt '~' any_name_exp lparen_exp no_destructor_params rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt  */
#line 4734 "parser.y"
    {
      DUMP_START( "destructor_declaration_c",
                  "virtual_stid_opt '~' any_name_exp '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "gnu_attribute_specifier_list_c_opt func_equals_c_stid_opt" );
      DUMP_TID( "virtual_stid_opt", (yyvsp[-8].tid) );
      DUMP_STR( "any_name_exp", (yyvsp[-6].name) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      c_sname_append_name( &dtor_ast->sname, (yyvsp[-6].name) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-8].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8790 "parser.c"
    break;

  case 397: /* no_destructor_params: error  */
#line 4781 "parser.y"
    { //
      // Ordinarily, we'd get an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: "int": destructors may not have parameters
      //      ("int" is a keyword)
      //
      // where the <<("int" is a keyword)>> part seems wrong since the user
      // didn't try using "int" as an ordinary identifier.  To suppress that
      // part, set lexer_token to the empty string so elaborate_error() won't
      // print it nor call print_error_token_is_a() and and we'll instead get
      // an error message like:
      //
      //      c++decl> explain ~C(int)
      //                          ^
      //      12: syntax error: destructors may not have parameters
      //
      lexer_token = "";
      elaborate_error( "destructors may not have parameters" );
    }
#line 8816 "parser.c"
    break;

  case 398: /* file_scope_constructor_declaration_c: inline_stid_opt Y_CONSTRUCTOR_SNAME lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4811 "parser.y"
    {
      DUMP_START( "file_scope_constructor_declaration_c",
                  "inline_opt CONSTRUCTOR_SNAME '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "CONSTRUCTOR_SNAME", (yyvsp[-5].sname) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const ctor_ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      ctor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      ctor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ctor_ast );
      ctor_ast->ctor.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ctor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ctor_ast ) );
      c_ast_english( ctor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8849 "parser.c"
    break;

  case 399: /* file_scope_destructor_declaration_c: inline_stid_opt destructor_sname lparen_exp no_destructor_params rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt gnu_attribute_specifier_list_c_opt  */
#line 4848 "parser.y"
    {
      DUMP_START( "file_scope_destructor_declaration_c",
                  "inline_opt destructor_sname '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt" );
      DUMP_TID( "inline_stid_opt", (yyvsp[-6].tid) );
      DUMP_SNAME( "destructor_sname", (yyvsp[-5].sname) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_sname_set_scope_type( &(yyvsp[-5].sname), &C_TYPE_LIT_B( TB_class ) );

      c_ast_t *const dtor_ast = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );
      dtor_ast->sname = c_sname_move( &(yyvsp[-5].sname) );
      dtor_ast->type.stids = c_tid_check(
        (yyvsp[-6].tid) | (yyvsp[-2].tid) | (yyvsp[-1].tid),
        C_TPID_STORE
      );

      DUMP_AST( "$$_ast", dtor_ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( dtor_ast ) );
      c_ast_english( dtor_ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 8879 "parser.c"
    break;

  case 400: /* func_decl_c_astp: decl2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 4892 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_decl_c_astp",
                  "decl2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "decl2_c_astp", (yyvsp[-7].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const func_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      bool const assume_constructor =
        // + The type is likely for a constructor; and:
        c_ast_is_likely_ctor( type_ast ) &&

        // + The new type does _not_ have any non-constructor storage classes.
        !c_tid_is_any( func_stids, TS_FUNC_LIKE_NOT_CTOR );

      c_ast_t *const func_ast =
        c_ast_new_gc( assume_constructor ? K_CONSTRUCTOR : K_FUNCTION, &(yyloc) );
      func_ast->type.stids = func_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );

      c_ast_t *const decl_ast = (yyvsp[-7].ast_pair).ast;

      if ( assume_constructor ) {
        assert( (yyvsp[-1].ast) == NULL );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( decl_ast, func_ast, /*ret_ast=*/NULL ),
          .target_ast = NULL
        };
      }
      else {
        c_ast_t *ret_ast;
        c_ast_t *target_ast = (yyvsp[-7].ast_pair).target_ast;

        if ( target_ast != NULL && target_ast->kind != K_POINTER ) {
          //
          // This is for a case like:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       |    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast
          //
          // We replace ret_ast with decl_ast:
          //
          //      int f() ()
          //       |    |  |
          //       |    |  func
          //       X    |
          //       |    decl_ast (func)
          //       |
          //       ret_ast <- decl_ast (func)
          //
          // that is, a "function returning function" -- which is illegal
          // (since functions can't return functions) and will be caught by
          // c_ast_check_ret_type().
          //
          ret_ast = decl_ast;
          target_ast = NULL;
        }
        else {
          ret_ast = IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );
        }

        if ( target_ast != NULL ) {
          (yyval.ast_pair) = (c_ast_pair_t){
            decl_ast,
            c_ast_add_func( target_ast, func_ast, ret_ast )
          };
        }
        else {
          (yyval.ast_pair) = (c_ast_pair_t){
            c_ast_add_func( decl_ast, func_ast, ret_ast ),
            func_ast->func.ret_ast
          };
        }
      }

      c_tid_t const msc_call_atids = (yyval.ast_pair).ast->type.atids & TA_ANY_MSC_CALL;
      if ( msc_call_atids != TA_NONE ) {
        //
        // Microsoft calling conventions need to be moved from the pointer to
        // the function, e.g., change:
        //
        //      declare f as cdecl pointer to function returning void
        //
        // to:
        //
        //      declare f as pointer to cdecl function returning void
        //
        for ( c_ast_t *ast = (yyval.ast_pair).ast;
              (ast = CONST_CAST(c_ast_t*, c_ast_unpointer( ast ))) != NULL; ) {
          if ( ast->kind == K_FUNCTION ) {
            (yyval.ast_pair).ast->type.atids &= c_tid_compl( TA_ANY_MSC_CALL );
            ast->type.atids |= msc_call_atids;
          }
        } // for
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9004 "parser.c"
    break;

  case 401: /* $@21: %empty  */
#line 5023 "parser.y"
    {
      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.  That means NAME is the name of a class, so we have to
        // create a temporary class type for it so if it's used as the type of
        // a parameter, e.g.:
        //
        //      C(C const&)
        //
        // it'll be recognized as such.
        //
        c_ast_t *const csu_ast = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yylsp[-1]) );
        csu_ast->type.btids = TB_class;
        c_sname_init_name( &csu_ast->csu.csu_sname, check_strdup( (yyvsp[-1].name) ) );
        csu_ast->sname = c_sname_dup( &csu_ast->csu.csu_sname );

        in_attr.tdef_rb = c_typedef_add( csu_ast, C_GIB_TYPEDEF );
        MAYBE_UNUSED c_typedef_t const *const csu_tdef = in_attr.tdef_rb->data;
        assert( csu_tdef->ast == csu_ast );
      }
    }
#line 9031 "parser.c"
    break;

  case 402: /* pc99_func_or_constructor_declaration_c: Y_NAME '(' $@21 param_c_ast_list_opt ')' noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5047 "parser.y"
    {
      DUMP_START( "pc99_func_or_constructor_declaration_c",
                  "NAME '(' param_c_ast_list_opt ')' noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_STR( "NAME", (yyvsp[-6].name) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *ast;

      if ( OPT_LANG_IS( CONSTRUCTORS ) ) {
        //
        // Free the temporary typedef for the class.
        //
        // Note that we free only the typedef and not its AST; its AST will be
        // garbage collected.
        //
        free( c_typedef_remove( in_attr.tdef_rb ) );

        //
        // In C++, encountering a name followed by '(' declares an in-class
        // constructor.
        //
        ast = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      }
      else {
        if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
          //
          // In C99 and later, implicit int is an error.  This check has to be
          // done now in the parser rather than later in the AST since the AST
          // would have no "memory" that the return type was implicitly int.
          //
          print_error( &(yylsp[-6]),
            "implicit \"%s\" functions are illegal%s",
            c_tid_name_error( TB_int ),
            C_LANG_WHICH( IMPLICIT_int )
          );
          print_error_token_is_a( (yyvsp[-6].name) );
          if ( strcmp( (yyvsp[-6].name), L_typeof ) == 0 ||
               strcmp( (yyvsp[-6].name), L_typeof_unqual ) == 0 ) {
            EPRINTF( "; use \"%s\" instead", L_GNU___typeof__ );
          }
          else {
            print_suggestions(
              DYM_C_KEYWORDS | DYM_C_MACROS | DYM_C_TYPES,
              (yyvsp[-6].name)
            );
          }
          EPUTC( '\n' );
          free( (yyvsp[-6].name) );
          PARSE_ABORT();
        }

        //
        // In C prior to C99, encountering a name followed by '(' declares a
        // function that implicitly returns int:
        //
        //      power(x, n)             /* raise x to n-th power; n > 0 */
        //
        c_ast_t *const ret_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-6]) );
        ret_ast->type.btids = TB_int;

        ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( ret_ast, ast );
      }

      c_sname_init_name( &ast->sname, (yyvsp[-6].name) );
      ast->type.stids =
        c_tid_check( (yyvsp[-1].tid) | (yyvsp[0].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), ast );
      ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      DUMP_AST( "$$_ast", ast );
      DUMP_END();

      PARSE_ASSERT( c_ast_check( ast ) );
      c_ast_english( ast, C_ENG_DECL, stdout );
      PUTC( '\n' );
    }
#line 9116 "parser.c"
    break;

  case 403: /* $@22: %empty  */
#line 5131 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // Both "final" and "override" are matched only within member function
        // declarations.  Now that ')' has been parsed, we're within one, so
        // set the keyword context to C_KW_CTX_MBR_FUNC.
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 9131 "parser.c"
    break;

  case 404: /* rparen_func_qualifier_list_c_stid_opt: ')' $@22 func_qualifier_list_c_stid_opt  */
#line 5142 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 9140 "parser.c"
    break;

  case 405: /* func_qualifier_list_c_stid_opt: %empty  */
#line 5149 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9146 "parser.c"
    break;

  case 406: /* func_qualifier_list_c_stid_opt: func_qualifier_list_c_stid_opt func_qualifier_c_stid  */
#line 5151 "parser.y"
    {
      DUMP_START( "func_qualifier_list_c_stid_opt",
                  "func_qualifier_list_c_stid_opt func_qualifier_c_stid" );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_qualifier_c_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 9163 "parser.c"
    break;

  case 411: /* func_ref_qualifier_c_stid_opt: %empty  */
#line 5180 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9169 "parser.c"
    break;

  case 412: /* func_ref_qualifier_c_stid_opt: '&'  */
#line 5181 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 9175 "parser.c"
    break;

  case 413: /* func_ref_qualifier_c_stid_opt: Y_AMPER_AMPER  */
#line 5182 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 9181 "parser.c"
    break;

  case 414: /* noexcept_c_stid_opt: %empty  */
#line 5186 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9187 "parser.c"
    break;

  case 416: /* noexcept_c_stid_opt: Y_noexcept '(' noexcept_bool_stid_exp rparen_exp  */
#line 5189 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 9195 "parser.c"
    break;

  case 417: /* noexcept_c_stid_opt: Y_throw lparen_exp rparen_exp  */
#line 5193 "parser.y"
    {
      (yyval.tid) = (yyvsp[-2].tid);
    }
#line 9203 "parser.c"
    break;

  case 418: /* noexcept_c_stid_opt: Y_throw lparen_exp param_c_ast_list ')'  */
#line 5197 "parser.y"
    {
      c_ast_list_cleanup( &(yyvsp[-1].ast_list) );

      if ( OPT_LANG_IS( throw ) ) {
        UNSUPPORTED( &(yylsp[-1]), "dynamic exception specifications" );
      } else {
        print_error( &(yylsp[-1]),
          "dynamic exception specifications not supported%s\n",
          C_LANG_WHICH( throw )
        );
      }
      PARSE_ABORT();
    }
#line 9221 "parser.c"
    break;

  case 421: /* noexcept_bool_stid_exp: error  */
#line 5216 "parser.y"
    {
      elaborate_error( "\"true\" or \"false\" expected" );
    }
#line 9229 "parser.c"
    break;

  case 422: /* trailing_return_type_c_ast_opt: %empty  */
#line 5222 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 9235 "parser.c"
    break;

  case 423: /* $@23: %empty  */
#line 5224 "parser.y"
                                         { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9241 "parser.c"
    break;

  case 424: /* trailing_return_type_c_ast_opt: Y_MINUS_GREATER type_c_ast $@23 cast_c_astp_opt  */
#line 5226 "parser.y"
    { //
      // The function trailing return-type syntax is supported only in C++11
      // and later.  This check has to be done now in the parser rather than
      // later in the AST because the AST has no "memory" of where the return-
      // type came from.
      //
      if ( !IS_SUPPORTED( TRAILING_RETURN_TYPES ) ) {
        print_error( &(yylsp[-3]),
          "trailing return type not supported%s\n",
          C_LANG_WHICH( TRAILING_RETURN_TYPES )
        );
        PARSE_ABORT();
      }

      ia_type_ast_pop();
      c_ast_t const *const ret_ast = ia_type_ast_peek();

      DUMP_START( "trailing_return_type_c_ast_opt",
                  "'->' type_c_ast cast_c_astp_opt" );
      DUMP_AST( "in_attr__type_c_ast", ret_ast );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[0].ast_pair).ast, (yyvsp[-2].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Ensure that a function using the C++11 trailing return type syntax
      // starts with "auto":
      //
      //      void f() -> int
      //      ^
      //      error: must be "auto"
      //
      // This check has to be done now in the parser rather than later in the
      // AST because the "auto" is just a syntactic return-type placeholder in
      // C++11 and the AST node for the placeholder is discarded and never made
      // part of the AST.
      //
      if ( ret_ast->type.btids != TB_auto ) {
        print_error( &ret_ast->loc,
          "function with trailing return type must only specify \"%s\"\n",
          c_tid_name_error( TB_auto )
        );
        PARSE_ABORT();
      }
    }
#line 9295 "parser.c"
    break;

  case 425: /* trailing_return_type_c_ast_opt: gnu_attribute_specifier_list_c  */
#line 5277 "parser.y"
    {
      (yyval.ast) = NULL;
    }
#line 9303 "parser.c"
    break;

  case 426: /* func_equals_c_stid_opt: %empty  */
#line 5283 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 9309 "parser.c"
    break;

  case 427: /* func_equals_c_stid_opt: '=' Y_default  */
#line 5284 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9315 "parser.c"
    break;

  case 428: /* func_equals_c_stid_opt: '=' Y_delete  */
#line 5285 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 9321 "parser.c"
    break;

  case 429: /* func_equals_c_stid_opt: '=' uint_lit  */
#line 5287 "parser.y"
    {
      if ( (yyvsp[0].uint_val) != 0 ) {
        print_error( &(yylsp[0]), "'0' expected\n" );
        PARSE_ABORT();
      }
      (yyval.tid) = TS_PURE_virtual;
    }
#line 9333 "parser.c"
    break;

  case 430: /* func_equals_c_stid_opt: '=' error  */
#line 5295 "parser.y"
    {
      if ( OPT_LANG_IS( default_delete_FUNCS ) )
        elaborate_error( "'0', \"default\", or \"delete\" expected" );
      else
        elaborate_error( "'0' expected" );
    }
#line 9344 "parser.c"
    break;

  case 432: /* param_c_ast_list_exp: error  */
#line 5308 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      elaborate_error( "parameter list expected" );
    }
#line 9353 "parser.c"
    break;

  case 433: /* param_c_ast_list_opt: %empty  */
#line 5315 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 9359 "parser.c"
    break;

  case 435: /* param_c_ast_list: param_c_ast_list comma_exp param_c_ast_exp  */
#line 5321 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast_list ',' param_c_ast" );
      DUMP_AST_LIST( "param_c_ast_list", (yyvsp[-2].ast_list) );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9375 "parser.c"
    break;

  case 436: /* param_c_ast_list: param_c_ast  */
#line 5334 "parser.y"
    {
      DUMP_START( "param_c_ast_list", "param_c_ast" );
      DUMP_AST( "param_c_ast", (yyvsp[0].ast) );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 9390 "parser.c"
    break;

  case 437: /* $@24: %empty  */
#line 5351 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9398 "parser.c"
    break;

  case 438: /* param_c_ast: this_stid_opt type_c_ast $@24 cast_c_astp_opt  */
#line 5355 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "param_c_ast", "this_stid_opt type_c_ast cast_c_astp_opt" );
      DUMP_TID( "this_stid_opt", (yyvsp[-3].tid) );
      DUMP_AST( "type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );

      if ( (yyval.ast)->kind == K_FUNCTION ) {
        //
        // From the C11 standard, section 6.3.2.1(4):
        //
        //    [A] function designator with type "function returning type" is
        //    converted to an expression that has type "pointer to function
        //    returning type."
        //
        (yyval.ast) = c_ast_pointer( (yyval.ast), &gc_ast_list );
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-3].tid), &(yylsp[-3]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9429 "parser.c"
    break;

  case 440: /* param_c_ast: "..."  */
#line 5391 "parser.y"
    {
      DUMP_START( "param_c_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9442 "parser.c"
    break;

  case 442: /* param_c_ast_exp: error  */
#line 5404 "parser.y"
    {
      elaborate_error( "parameter declaration expected" );
    }
#line 9450 "parser.c"
    break;

  case 443: /* $@25: %empty  */
#line 5413 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 9459 "parser.c"
    break;

  case 444: /* nested_decl_c_astp: '(' $@25 decl_c_astp rparen_exp  */
#line 5418 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      DUMP_START( "nested_decl_c_astp", "'(' decl_c_astp ')'" );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9477 "parser.c"
    break;

  case 445: /* oper_decl_c_astp: oper_sname_c_opt Y_operator c_operator lparen_exp param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt func_ref_qualifier_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt func_equals_c_stid_opt  */
#line 5444 "parser.y"
    {
      c_operator_t const *const operator = c_op_get( (yyvsp[-7].op_id) );
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "oper_decl_c_astp",
                  "oper_sname_c_opt OPERATOR c_operator "
                  "'(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt "
                  "func_ref_qualifier_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-9].sname) );
      DUMP_STR( "c_operator", operator->literal );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-5].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-4].tid) );
      DUMP_TID( "func_ref_qualifier_c_stid_opt", (yyvsp[-3].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[-1].ast) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_tid_t const oper_stids = c_tid_check(
        (yyvsp[-4].tid) | (yyvsp[-3].tid) | (yyvsp[-2].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );

      c_ast_t *const oper_ast = c_ast_new_gc( K_OPERATOR, &(yyloc) );
      oper_ast->sname = c_sname_move( &(yyvsp[-9].sname) );
      oper_ast->type.stids = oper_stids;
      c_ast_list_set_param_of( &(yyvsp[-5].ast_list), oper_ast );
      oper_ast->oper.param_ast_list = slist_move( &(yyvsp[-5].ast_list) );
      oper_ast->oper.operator = operator;

      c_ast_t *const ret_ast =
        IF_ELSE( (yyvsp[-1].ast), ia_type_spec_ast( type_ast ) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func( type_ast, oper_ast, ret_ast ),
        oper_ast->oper.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9526 "parser.c"
    break;

  case 446: /* $@26: %empty  */
#line 5493 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9532 "parser.c"
    break;

  case 447: /* pointer_decl_c_astp: pointer_type_c_ast $@26 decl_c_astp  */
#line 5495 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_decl_c_astp", "pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      PJL_DISCARD_RV( c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ) );
      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9551 "parser.c"
    break;

  case 448: /* pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5514 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_type_c_ast", "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9570 "parser.c"
    break;

  case 449: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c ',' decl_list_c  */
#line 5534 "parser.y"
    {
      (yyval.ast_list) = (yyvsp[0].ast_list);
      slist_push_front( &(yyval.ast_list), (yyvsp[-2].ast) );
    }
#line 9579 "parser.c"
    break;

  case 450: /* pc99_pointer_decl_list_c: pc99_pointer_decl_c  */
#line 5539 "parser.y"
    {
      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );
    }
#line 9588 "parser.c"
    break;

  case 451: /* $@27: %empty  */
#line 5546 "parser.y"
                                      { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9594 "parser.c"
    break;

  case 452: /* pc99_pointer_decl_c: pc99_pointer_type_c_ast $@27 decl_c_astp  */
#line 5548 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pc99_pointer_decl_c",
                  "pc99_pointer_type_c_ast decl_c_astp" );
      DUMP_AST( "pc99_pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast );
      (yyval.ast)->loc = (yyloc);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9613 "parser.c"
    break;

  case 453: /* pc99_pointer_type_c_ast: '*' type_qualifier_list_c_stid_opt  */
#line 5567 "parser.y"
    {
      if ( !IS_SUPPORTED( IMPLICIT_int ) ) {
        //
        // In C99 and later, implicit int is an error.  This check has to be
        // done now in the parser rather than later in the AST since the AST
        // would have no "memory" that the return type was implicitly int.
        //
        print_error( &(yylsp[-1]),
          "implicit \"%s\" is illegal%s\n",
          c_tid_name_error( TB_int ),
          C_LANG_WHICH( IMPLICIT_int )
        );
        PARSE_ABORT();
      }

      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "pc99_pointer_type_c_ast",
                  "'*' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      if ( type_ast == NULL ) {
        type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[-1]) );
        type_ast->type.btids = TB_int;
        ia_type_ast_push( type_ast );
      }

      (yyval.ast) = c_ast_pointer( ia_type_spec_ast( type_ast ), &gc_ast_list );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9652 "parser.c"
    break;

  case 454: /* $@28: %empty  */
#line 5606 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9658 "parser.c"
    break;

  case 455: /* pointer_to_member_decl_c_astp: pointer_to_member_type_c_ast $@28 decl_c_astp  */
#line 5608 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_decl_c_astp",
                  "pointer_to_member_type_c_ast decl_c_astp" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9677 "parser.c"
    break;

  case 456: /* pointer_to_member_type_c_ast: any_sname_c Y_COLON_COLON_STAR '*' cv_qualifier_list_stid_opt  */
#line 5628 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "pointer_to_member_type_c_ast",
                  "any_sname_c '::*' cv_qualifier_list_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "any_sname_c", (yyvsp[-3].sname) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );

      c_type_t scope_type = *c_sname_local_type( &(yyvsp[-3].sname) );
      if ( !c_tid_is_any( scope_type.btids, TB_ANY_SCOPE ) ) {
        //
        // The sname has no scope-type, but we now know there's a pointer-to-
        // member of it, so it must be a class.  (It could alternatively be a
        // struct, but we have no context to know, so just pick class because
        // it's more C++-like.)
        //
        scope_type.btids = TB_class;
        c_sname_set_local_type( &(yyvsp[-3].sname), &scope_type );
      }

      // adopt sname's scope-type for the AST
      (yyval.ast)->type = c_type_or( &C_TYPE_LIT_S( (yyvsp[0].tid) ), &scope_type );

      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-3].sname) );
      c_ast_set_parent( c_ast_dup_gc( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9714 "parser.c"
    break;

  case 457: /* $@29: %empty  */
#line 5665 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 9720 "parser.c"
    break;

  case 458: /* reference_decl_c_astp: reference_type_c_ast $@29 decl_c_astp  */
#line 5667 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_decl_c_astp", "reference_type_c_ast decl_c_astp" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "decl_c_astp", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (yyvsp[0].ast_pair);
      (yyval.ast_pair).ast->loc = (yyloc);

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9738 "parser.c"
    break;

  case 459: /* reference_type_c_ast: '&' type_qualifier_list_c_stid_opt  */
#line 5685 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast",
                  "'&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9758 "parser.c"
    break;

  case 460: /* reference_type_c_ast: Y_AMPER_AMPER type_qualifier_list_c_stid_opt  */
#line 5703 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "reference_type_c_ast",
                  "'&&' type_qualifier_list_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
      (yyval.ast)->type.stids = c_tid_check( (yyvsp[0].tid), C_TPID_STORE );
      c_ast_set_parent( ia_type_spec_ast( type_ast ), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9778 "parser.c"
    break;

  case 461: /* typedef_type_decl_c_ast: typedef_type_c_ast bit_field_c_uint_opt  */
#line 5725 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "typedef_type_decl_c_ast",
                  "typedef_type_c_ast bit_field_c_uint_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      if ( c_tid_is_any( type_ast->type.stids, TS_typedef ) ) {
        //
        // If we're defining a type, return the type as-is.
        //
        (yyval.ast) = (yyvsp[-1].ast);
      }
      else {
        //
        // Otherwise, return the type that it's typedef'd as.
        //
        c_ast_t const *const raw_tdef_ast = c_ast_untypedef( (yyvsp[-1].ast) );

        //
        // But first ensure the name isn't of a previously declared type:
        //
        //      cdecl> struct S
        //      cdecl> explain int S    // error: "S": previously declared
        //
        // Note that typedef_type_c_ast is like:
        //
        //      typedef_type_c_ast: {
        //        sname: { string: "" },
        //        kind: { value: 0x20, string: "typedef" },
        //        ...
        //        type: { btid: 0x10000001, ..., string: "none" },
        //        tdef: {
        //          for_ast: {
        //            sname: { string: "S", scopes: "struct" },
        //            kind: { value: 0x8, string: "struct or union" },
        //            ...
        //            type: { btid: 0x800001, ..., string: "struct" },
        //            csu: {
        //              csu_sname: { string: "S", scopes: "none" }
        //            }
        //          }
        //        },
        //        ...
        //      }
        //
        // That is, typedef_type_c_ast has no name itself (at this point), but
        // the raw type, of course, does, so it's that name we have to check.
        //
        // This check has to be done now in the parser rather than later in the
        // AST since if this declaration were joined with a type (like `int`
        // above), the type information would be lost and we'd get this from
        // above:
        //
        //      declare S as structure S          // wrong
        //
        // Additionally, we also get here when the typedef name is used as part
        // of longer name, e.g., `S::x`:
        //
        //      c++decl> explain int S::x
        //      declare x of structure S as int   // correct
        //
        // but that name isn't of a previously declared type, so it's OK.
        //
        PARSE_ASSERT( !sname_is_type( &raw_tdef_ast->sname, &(yyvsp[-1].ast)->loc ) );

        //
        // We have to duplicate the type to set the current location.
        //
        (yyval.ast) = c_ast_dup_gc( raw_tdef_ast );
        (yyval.ast)->loc = (yyvsp[-1].ast)->loc;
      }

      PARSE_ASSERT( c_ast_set_bit_field_width( (yyval.ast), (yyvsp[0].uint_val) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 9863 "parser.c"
    break;

  case 462: /* $@30: %empty  */
#line 5812 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 9871 "parser.c"
    break;

  case 463: /* user_defined_conversion_decl_c_astp: oper_sname_c_opt Y_operator type_c_ast $@30 udc_decl_c_ast_opt lparen_exp rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt func_equals_c_stid_opt  */
#line 5818 "parser.y"
    {
      ia_type_ast_pop();

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_conversion_decl_c_astp",
                  "oper_sname_c_opt OPERATOR "
                  "type_c_ast udc_decl_c_ast_opt '(' ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "func_equals_c_stid_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_AST( "type_c_ast", (yyvsp[-6].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[-4].ast) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "func_equals_c_stid_opt", (yyvsp[0].tid) );

      c_ast_t *const udc_ast = c_ast_new_gc( K_UDEF_CONV, &(yyloc) );
      udc_ast->sname = c_sname_move( &(yyvsp[-8].sname) );
      udc_ast->type.stids = c_tid_check(
        (yyvsp[-2].tid) | (yyvsp[-1].tid) | (yyvsp[0].tid),
        C_TPID_STORE
      );
      if ( type_ast != NULL )
        c_type_or_eq( &udc_ast->type, &type_ast->type );
      udc_ast->udef_conv.to_ast = IF_ELSE( (yyvsp[-4].ast), (yyvsp[-6].ast) );

      (yyval.ast_pair) = (c_ast_pair_t){ udc_ast, udc_ast->udef_conv.to_ast };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9909 "parser.c"
    break;

  case 464: /* user_defined_literal_decl_c_astp: oper_sname_c_opt Y_operator empty_str_lit_exp name_exp lparen_exp param_c_ast_list_exp ')' noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 5861 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "user_defined_literal_decl_c_astp",
                  "oper_sname_c_opt OPERATOR '\"\"' "
                  "'(' param_c_ast_list_exp ')' noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "oper_sname_c_opt", (yyvsp[-8].sname) );
      DUMP_STR( "name", (yyvsp[-5].name) );
      DUMP_AST_LIST( "param_c_ast_list_exp", (yyvsp[-3].ast_list) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );

      c_sname_set( &type_ast->sname, &(yyvsp[-8].sname) );
      c_sname_append_name( &type_ast->sname, (yyvsp[-5].name) );

      c_ast_t *const udl_ast = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      udl_ast->type.stids = c_tid_check( (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), udl_ast );
      udl_ast->udef_lit.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_add_func(
          type_ast,
          udl_ast,
          IF_ELSE( (yyvsp[0].ast), type_ast )
        ),
        udl_ast->udef_lit.ret_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9948 "parser.c"
    break;

  case 465: /* cast_c_astp_opt: %empty  */
#line 5902 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ NULL, NULL }; }
#line 9954 "parser.c"
    break;

  case 475: /* cast2_c_astp: sname_c_ast  */
#line 5919 "parser.y"
                                  { (yyval.ast_pair) = (c_ast_pair_t){ (yyvsp[0].ast), NULL }; }
#line 9960 "parser.c"
    break;

  case 476: /* array_cast_c_astp: cast_c_astp_opt array_size_c_ast  */
#line 5930 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "array_cast_c_astp", "cast_c_astp_opt array_size_c_ast" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );
      DUMP_AST( "array_size_c_ast", (yyvsp[0].ast) );

      c_ast_set_parent(
        c_ast_new_gc( K_PLACEHOLDER, &(yylsp[-1]) ), (yyvsp[0].ast)
      );

      c_ast_t *const of_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-1].ast_pair).target_ast != NULL ) {
        // array-of or function-like-ret type
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-1].ast_pair).ast,
          c_ast_add_array( (yyvsp[-1].ast_pair).target_ast, (yyvsp[0].ast), of_ast )
        };
      } else {
        c_ast_t *const ast = IF_ELSE( (yyvsp[-1].ast_pair).ast, of_ast );
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_array( ast, (yyvsp[0].ast), of_ast ),
          .target_ast = NULL
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 9995 "parser.c"
    break;

  case 477: /* $@31: %empty  */
#line 5967 "parser.y"
    { //
      // A block AST has to be the type inherited attribute for cast_c_astp_opt
      // so we have to create it here.
      //
      ia_type_ast_push( c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) ) );
    }
#line 10006 "parser.c"
    break;

  case 478: /* block_cast_c_astp: '(' '^' $@31 type_qualifier_list_c_stid_opt cast_c_astp_opt rparen_exp lparen_exp param_c_ast_list_opt ')'  */
#line 5975 "parser.y"
    {
      c_ast_t *const block_ast = ia_type_ast_pop();
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "block_cast_c_astp",
                  "'(' '^' type_qualifier_list_c_stid_opt cast_c_astp_opt ')' "
                  "'(' param_c_ast_list_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_TID( "type_qualifier_list_c_stid_opt", (yyvsp[-5].tid) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-4].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-1].ast_list) );

      PARSE_ASSERT(
        c_type_add_tid( &block_ast->type, (yyvsp[-5].tid), &(yylsp[-5]) )
      );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), block_ast );
      block_ast->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );

      c_ast_t *const ret_ast = ia_type_spec_ast( type_ast );
      if ( (yyvsp[-4].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          (yyvsp[-4].ast_pair).ast,
          c_ast_add_func( (yyvsp[-4].ast_pair).target_ast, block_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( (yyvsp[-4].ast_pair).ast, block_ast, ret_ast ),
          block_ast->block.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10046 "parser.c"
    break;

  case 479: /* func_cast_c_astp: cast2_c_astp '(' param_c_ast_list_opt rparen_func_qualifier_list_c_stid_opt noexcept_c_stid_opt trailing_return_type_c_ast_opt  */
#line 6020 "parser.y"
    {
      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "func_cast_c_astp",
                  "cast2_c_astp '(' param_c_ast_list_opt ')' "
                  "func_qualifier_list_c_stid_opt noexcept_c_stid_opt "
                  "trailing_return_type_c_ast_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast2_c_astp", (yyvsp[-5].ast_pair) );
      DUMP_AST_LIST( "param_c_ast_list_opt", (yyvsp[-3].ast_list) );
      DUMP_TID( "func_qualifier_list_c_stid_opt", (yyvsp[-2].tid) );
      DUMP_AST( "trailing_return_type_c_ast_opt", (yyvsp[0].ast) );
      DUMP_TID( "noexcept_c_stid_opt", (yyvsp[-1].tid) );

      c_ast_t *const func_ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      func_ast->type.stids =
        c_tid_check( (yyvsp[-2].tid) | (yyvsp[-1].tid), C_TPID_STORE );
      c_ast_list_set_param_of( &(yyvsp[-3].ast_list), func_ast );
      func_ast->func.param_ast_list = slist_move( &(yyvsp[-3].ast_list) );

      c_ast_t *const cast_ast = (yyvsp[-5].ast_pair).ast;
      //
      // This is for a case similar to the one in func_decl_c_astp like:
      //
      //     void f( int () () )
      //              |   |  |
      //              |   |  func
      //              |   |
      //              |   cast_ast (func)
      //              |
      //              ret_ast
      //
      // We replace ret_ast with cast_ast:
      //
      //      void f( int() () )
      //              |  |  |
      //              |  |  func
      //              X  |
      //              |  cast_ast (func)
      //              |
      //              ret_ast <- cast_ast (func)
      //
      // that is, a "function returning function returning int" -- which is
      // illegal (since functions can't return functions) and will be caught by
      // c_ast_check_ret_type().
      //
      c_ast_t *const ret_ast = cast_ast->kind == K_FUNCTION ?
        cast_ast : IF_ELSE( (yyvsp[0].ast), ia_type_spec_ast( type_ast ) );

      if ( (yyvsp[-5].ast_pair).target_ast != NULL ) {
        (yyval.ast_pair) = (c_ast_pair_t){
          cast_ast,
          c_ast_add_func( (yyvsp[-5].ast_pair).target_ast, func_ast, ret_ast )
        };
      }
      else {
        (yyval.ast_pair) = (c_ast_pair_t){
          c_ast_add_func( cast_ast, func_ast, ret_ast ),
          func_ast->func.ret_ast
        };
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10116 "parser.c"
    break;

  case 480: /* $@32: %empty  */
#line 6091 "parser.y"
    {
      ia_type_ast_push( c_ast_new_gc( K_PLACEHOLDER, &(yyloc) ) );
      ++in_attr.ast_depth;
    }
#line 10125 "parser.c"
    break;

  case 481: /* nested_cast_c_astp: '(' $@32 cast_c_astp_opt rparen_exp  */
#line 6096 "parser.y"
    {
      ia_type_ast_pop();
      --in_attr.ast_depth;

      c_ast_t *const type_ast = ia_type_ast_peek();

      DUMP_START( "nested_cast_c_astp", "'(' cast_c_astp_opt ')'" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast_pair) = (yyvsp[-1].ast_pair);

      if ( (yyval.ast_pair).ast == NULL ) {
        //
        // This is for a case like:
        //
        //      void f( int() )
        //                 ^^
        //
        // where the unnamed parameter is a "function returning int".  (In
        // param_c_ast, this will be converted into a "pointer to function
        // returning int".)
        //
        (yyval.ast_pair).ast = c_ast_new_gc( K_FUNCTION, &(yyloc) );
        c_ast_set_parent( type_ast, (yyval.ast_pair).ast );
      } else {
        (yyval.ast_pair).ast->loc = (yyloc);
      }

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10162 "parser.c"
    break;

  case 482: /* $@33: %empty  */
#line 6133 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10168 "parser.c"
    break;

  case 483: /* pointer_cast_c_astp: pointer_type_c_ast $@33 cast_c_astp_opt  */
#line 6135 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_cast_c_astp", "pointer_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10188 "parser.c"
    break;

  case 484: /* $@34: %empty  */
#line 6155 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10194 "parser.c"
    break;

  case 485: /* pointer_to_member_cast_c_astp: pointer_to_member_type_c_ast $@34 cast_c_astp_opt  */
#line 6157 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_cast_c_astp",
                  "pointer_to_member_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10215 "parser.c"
    break;

  case 486: /* $@35: %empty  */
#line 6178 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10221 "parser.c"
    break;

  case 487: /* reference_cast_c_astp: reference_type_c_ast $@35 cast_c_astp_opt  */
#line 6180 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_cast_c_astp",
                  "reference_type_c_ast cast_c_astp_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[0].ast_pair) );

      (yyval.ast_pair) = (c_ast_pair_t){
        c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast_pair).ast ),
        (yyvsp[0].ast_pair).target_ast
      };

      DUMP_AST_PAIR( "$$_astp", (yyval.ast_pair) );
      DUMP_END();
    }
#line 10242 "parser.c"
    break;

  case 488: /* udc_decl_c_ast_opt: %empty  */
#line 6207 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10248 "parser.c"
    break;

  case 494: /* $@36: %empty  */
#line 6219 "parser.y"
                                 { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10254 "parser.c"
    break;

  case 495: /* pointer_udc_decl_c_ast: pointer_type_c_ast $@36 udc_decl_c_ast_opt  */
#line 6221 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_udc_decl_c_ast",
                  "pointer_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10272 "parser.c"
    break;

  case 496: /* $@37: %empty  */
#line 6237 "parser.y"
                                           { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10278 "parser.c"
    break;

  case 497: /* pointer_to_member_udc_decl_c_ast: pointer_to_member_type_c_ast $@37 udc_decl_c_ast_opt  */
#line 6239 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "pointer_to_member_udc_decl_c_ast",
                  "pointer_to_member_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "pointer_to_member_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10296 "parser.c"
    break;

  case 498: /* $@38: %empty  */
#line 6255 "parser.y"
                                   { ia_type_ast_push( (yyvsp[0].ast) ); }
#line 10302 "parser.c"
    break;

  case 499: /* reference_udc_decl_c_ast: reference_type_c_ast $@38 udc_decl_c_ast_opt  */
#line 6257 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "reference_udc_decl_c_ast",
                  "reference_type_c_ast udc_decl_c_ast_opt" );
      DUMP_AST( "reference_type_c_ast", (yyvsp[-2].ast) );
      DUMP_AST( "udc_decl_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-2].ast), (yyvsp[0].ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10320 "parser.c"
    break;

  case 500: /* type_c_ast: type_modifier_list_c_type  */
#line 6283 "parser.y"
    {
      DUMP_START( "type_c_ast", "type_modifier_list_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[0].type) );

      //
      // Prior to C99, typeless declarations are implicitly int, so we set it
      // here.  In C99 and later, however, implicit int is an error, so we
      // don't set it here and c_ast_check() will catch the error later.
      //
      // Note that type modifiers, e.g., unsigned, count as a type since that
      // means unsigned int; however, neither qualifiers, e.g., const, nor
      // storage classes, e.g., register, by themselves count as a type:
      //
      //      unsigned i;   // legal in C99
      //      const    j;   // illegal in C99
      //      register k;   // illegal in C99
      //
      c_type_t type = OPT_LANG_IS( IMPLICIT_int ) ?
        C_TYPE_LIT_B( TB_int ) : T_NONE;

      PARSE_ASSERT( c_type_add( &type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10353 "parser.c"
    break;

  case 501: /* type_c_ast: type_modifier_list_c_type east_modified_type_c_ast  */
#line 6318 "parser.y"
    {
      DUMP_START( "type_c_ast",
                  "type_modifier_list_c_type east_modified_type_c_ast " );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_AST( "east_modified_type_c_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10371 "parser.c"
    break;

  case 503: /* type_modifier_list_c_type_opt: %empty  */
#line 6336 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 10377 "parser.c"
    break;

  case 505: /* type_modifier_list_c_type: type_modifier_list_c_type type_modifier_c_type  */
#line 6342 "parser.y"
    {
      DUMP_START( "type_modifier_list_c_type",
                  "type_modifier_list_c_type type_modifier_c_type" );
      DUMP_TYPE( "type_modifier_list_c_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_c_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 10394 "parser.c"
    break;

  case 507: /* type_modifier_c_type: type_modifier_base_type  */
#line 6360 "parser.y"
    {
      (yyval.type) = (yyvsp[0].type);
      //
      // This is for a case like:
      //
      //      explain typedef unsigned long size_t
      //
      // that is: explain a redefinition of a typedef'd type with the same type
      // that contains only one or more type_modifier_base_type.  The problem
      // is that, without an east_modified_type_c_ast (like int), the parser
      // would ordinarily take the typedef'd type (here, the size_t) as part of
      // the type_c_ast and then be out of tokens for the decl_c_astp -- at
      // which time it'll complain.
      //
      // Since type modifiers can't apply to a typedef'd type (e.g., "long
      // size_t" is illegal), we tell the lexer not to return either
      // Y_TYPEDEF_NAME or Y_TYPEDEF_SNAME if we encounter at least one type
      // modifier (except "register" since it's is really a storage class --
      // see the comment in type_modifier_base_type about "register").
      //
      if ( (yyval.type).stids != TS_register )
        lexer_find &= ~LEXER_FIND_TYPES;
    }
#line 10422 "parser.c"
    break;

  case 508: /* type_modifier_c_type: type_qualifier_c_stid  */
#line 6383 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10428 "parser.c"
    break;

  case 510: /* type_modifier_c_type: attribute_specifier_list_c_atid  */
#line 6386 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 10436 "parser.c"
    break;

  case 511: /* type_modifier_base_type: Y__Complex  */
#line 6392 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10442 "parser.c"
    break;

  case 512: /* type_modifier_base_type: Y__Imaginary  */
#line 6393 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10448 "parser.c"
    break;

  case 513: /* type_modifier_base_type: Y_long  */
#line 6394 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10454 "parser.c"
    break;

  case 514: /* type_modifier_base_type: Y_short  */
#line 6395 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10460 "parser.c"
    break;

  case 515: /* type_modifier_base_type: Y_signed  */
#line 6396 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10466 "parser.c"
    break;

  case 516: /* type_modifier_base_type: Y_unsigned  */
#line 6397 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10472 "parser.c"
    break;

  case 517: /* type_modifier_base_type: Y_EMC__Sat  */
#line 6398 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 10478 "parser.c"
    break;

  case 518: /* type_modifier_base_type: Y_register  */
#line 6404 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10484 "parser.c"
    break;

  case 519: /* east_modified_type_c_ast: atomic_builtin_typedef_type_c_ast type_modifier_list_c_type_opt  */
#line 6410 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "atomic_builtin_typedef_type_c_ast "
                  "type_modifier_list_c_type_opt" );
      DUMP_AST( "atomic_builtin_typedef_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TYPE( "type_modifier_list_c_type_opt", (yyvsp[0].type) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10503 "parser.c"
    break;

  case 520: /* east_modified_type_c_ast: enum_class_struct_union_c_ast cv_qualifier_list_stid_opt  */
#line 6427 "parser.y"
    {
      DUMP_START( "east_modified_type_c_ast",
                  "enum_class_struct_union_c_ast cv_qualifier_list_stid_opt" );
      DUMP_AST( "enum_class_struct_union_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10521 "parser.c"
    break;

  case 525: /* $@39: %empty  */
#line 6453 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10529 "parser.c"
    break;

  case 526: /* atomic_specifier_type_c_ast: Y__Atomic_SPEC lparen_exp type_c_ast $@39 cast_c_astp_opt rparen_exp  */
#line 6457 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "atomic_specifier_type_c_ast",
                  "ATOMIC '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      (yyval.ast) = IF_ELSE( (yyvsp[-1].ast_pair).ast, (yyvsp[-3].ast) );
      (yyval.ast)->loc = (yyloc);

      //
      // Ensure the _Atomic() specifier type doesn't have either a storage
      // class or attributes:
      //
      //      const _Atomic(int) x;     // OK
      //      _Atomic(const int) y;     // error
      //
      // This check has to be done now in the parser rather than later in the
      // AST since the type would be stored as "atomic const int" either way so
      // the AST has no "memory" of which it was.
      //
      if ( (yyval.ast)->type.stids != TS_NONE || (yyval.ast)->type.atids != TA_NONE ) {
        static c_type_t const TSA_ANY = { TB_NONE, TS_ANY, TA_ANY };
        c_type_t const error_type = c_type_and( &(yyval.ast)->type, &TSA_ANY );
        print_error( &(yylsp[-3]),
          "\"%s\" can not be of \"%s\"\n",
          c_tid_name_error( TS__Atomic ),
          c_type_name_c( &error_type )
        );
        PARSE_ABORT();
      }

      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, TS__Atomic, &(yylsp[-5]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10572 "parser.c"
    break;

  case 527: /* builtin_type_c_ast: builtin_no_BitInt_c_btid  */
#line 6501 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "builtin_no_BitInt_c_btid" );
      DUMP_TID( "builtin_no_BitInt_c_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10587 "parser.c"
    break;

  case 528: /* builtin_type_c_ast: Y__BitInt lparen_exp uint_lit_exp rparen_exp  */
#line 6512 "parser.y"
    {
      DUMP_START( "builtin_type_c_ast", "_BitInt '(' uint_lit_exp ')'" );
      DUMP_INT( "uint_lit_exp", (yyvsp[-1].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[-1].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10603 "parser.c"
    break;

  case 543: /* $@40: %empty  */
#line 6544 "parser.y"
    {
      ia_type_ast_push( (yyvsp[0].ast) );
    }
#line 10611 "parser.c"
    break;

  case 544: /* typeof_type_c_ast: typeof lparen_exp type_c_ast $@40 cast_c_astp_opt rparen_exp  */
#line 6548 "parser.y"
    {
      ia_type_ast_pop();

      DUMP_START( "typeof_type_c_ast",
                  "TYPEOF '(' type_c_ast cast_c_astp_opt ')'" );
      DUMP_BOOL( "is_unqual", (yyvsp[-5].flag) );
      DUMP_AST( "type_c_ast", (yyvsp[-3].ast) );
      DUMP_AST_PAIR( "cast_c_astp_opt", (yyvsp[-1].ast_pair) );

      if ( (yyvsp[-5].flag) ) {
        c_ast_t const *const raw_ast = c_ast_untypedef( (yyvsp[-3].ast) );
        if ( raw_ast != (yyvsp[-3].ast) &&
             c_tid_is_any( raw_ast->type.stids, TS__Atomic | TS_CVR ) ) {
          //
          // The type is a typedef and the type that it's for is ACVR-qualified
          // so we need to dup _that_ type before un-ACVR-qualifying it because
          // we don't want to modify it.
          //
          (yyvsp[-3].ast) = c_ast_dup_gc( raw_ast );
        }
        (yyvsp[-3].ast)->type.stids &= c_tid_compl( TS__Atomic | TS_CVR );
      }

      (yyval.ast) = c_ast_patch_placeholder( (yyvsp[-3].ast), (yyvsp[-1].ast_pair).ast );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();

      //
      // Overwrite type_spec_ast to be the typeof type since _that_ is the base
      // type for one or more declarators, e.g.:
      //
      //      typeof(int*) p, a[2], f(char)
      //
      in_attr.type_spec_ast = (yyval.ast);
    }
#line 10652 "parser.c"
    break;

  case 545: /* typeof_type_c_ast: typeof lparen_exp error  */
#line 6586 "parser.y"
    {
      elaborate_error(
        "typeof(expression) declarations not supported by " CDECL
      );
    }
#line 10662 "parser.c"
    break;

  case 546: /* typeof: Y_typeof  */
#line 6594 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/false; }
#line 10668 "parser.c"
    break;

  case 547: /* typeof: Y_typeof_unqual  */
#line 6595 "parser.y"
                                  { (yyval.flag) = /*is_unqual=*/true;  }
#line 10674 "parser.c"
    break;

  case 550: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_exp  */
#line 6608 "parser.y"
    {
      DUMP_START( "enum_class_struct_union_c_ast",
                  "class_struct_union_btid "
                  "attribute_specifier_list_c_atid_opt any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-1].tid), C_TPID_ATTR );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10695 "parser.c"
    break;

  case 551: /* class_struct_union_c_ast: class_struct_union_btid attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6627 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      c_sname_cleanup( &(yyvsp[-1].sname) );
      PARSE_ABORT();
    }
#line 10707 "parser.c"
    break;

  case 552: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_exp enum_fixed_type_c_ast_opt  */
#line 6639 "parser.y"
    {
      DUMP_START( "enum_c_ast",
                  "enum_btids attribute_specifier_list_c_atid_opt "
                  "any_sname_c_exp enum_fixed_type_c_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-3].tid) );
      DUMP_TID( "attribute_specifier_list_c_atid_opt", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_c_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-3].tid), C_TPID_BASE );
      (yyval.ast)->type.atids = c_tid_check( (yyvsp[-2].tid), C_TPID_ATTR );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10730 "parser.c"
    break;

  case 553: /* enum_c_ast: enum_btids attribute_specifier_list_c_atid_opt any_sname_c_opt '{'  */
#line 6660 "parser.y"
    {
      c_sname_cleanup( &(yyvsp[-1].sname) );
      UNSUPPORTED( &(yylsp[0]),
        "explaining %s declarations", c_tid_name_c( (yyvsp[-3].tid) )
      );
      PARSE_ABORT();
    }
#line 10742 "parser.c"
    break;

  case 554: /* enum_btids: Y_enum class_struct_btid_opt  */
#line 6672 "parser.y"
                                  { (yyval.tid) = (yyvsp[-1].tid) | (yyvsp[0].tid); }
#line 10748 "parser.c"
    break;

  case 555: /* enum_fixed_type_c_ast_opt: %empty  */
#line 6676 "parser.y"
                                  { (yyval.ast) = NULL; }
#line 10754 "parser.c"
    break;

  case 556: /* enum_fixed_type_c_ast_opt: ':' enum_fixed_type_c_ast  */
#line 6677 "parser.y"
                                  { (yyval.ast) = (yyvsp[0].ast); }
#line 10760 "parser.c"
    break;

  case 557: /* enum_fixed_type_c_ast_opt: ':' error  */
#line 6679 "parser.y"
    {
      elaborate_error( "type name expected" );
    }
#line 10768 "parser.c"
    break;

  case 558: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid  */
#line 6695 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10784 "parser.c"
    break;

  case 559: /* enum_fixed_type_c_ast: enum_fixed_type_modifier_list_btid enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6715 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-2].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10806 "parser.c"
    break;

  case 560: /* enum_fixed_type_c_ast: enum_unmodified_fixed_type_c_ast enum_fixed_type_modifier_list_btid_opt  */
#line 6740 "parser.y"
    {
      DUMP_START( "enum_fixed_type_c_ast",
                  "enum_unmodified_fixed_type_c_ast "
                  "enum_fixed_type_modifier_list_btid_opt" );
      DUMP_AST( "enum_unmodified_fixed_type_c_ast", (yyvsp[-1].ast) );
      DUMP_TID( "enum_fixed_type_modifier_list_btid_opt", (yyvsp[0].tid) );

      (yyval.ast) = (yyvsp[-1].ast);
      (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 10825 "parser.c"
    break;

  case 561: /* enum_fixed_type_modifier_list_btid_opt: %empty  */
#line 6757 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10831 "parser.c"
    break;

  case 563: /* enum_fixed_type_modifier_list_btid: enum_fixed_type_modifier_list_btid enum_fixed_type_modifier_btid  */
#line 6764 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_btid",
                  "enum_fixed_type_modifier_list_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 10849 "parser.c"
    break;

  case 572: /* class_struct_btid_opt: %empty  */
#line 6797 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 10855 "parser.c"
    break;

  case 578: /* type_qualifier_list_c_stid_opt: %empty  */
#line 6814 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10861 "parser.c"
    break;

  case 580: /* type_qualifier_list_c_stid: type_qualifier_list_c_stid type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6821 "parser.y"
    {
      DUMP_START( "type_qualifier_list_c_stid",
                  "type_qualifier_list_c_stid type_qualifier_c_stid" );
      DUMP_TID( "type_qualifier_list_c_stid", (yyvsp[-2].tid) );
      DUMP_TID( "type_qualifier_c_stid", (yyvsp[-1].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[-1].tid), &(yylsp[-1]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10878 "parser.c"
    break;

  case 581: /* type_qualifier_list_c_stid: gnu_or_msc_attribute_specifier_list_c type_qualifier_c_stid  */
#line 6835 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 10886 "parser.c"
    break;

  case 582: /* type_qualifier_list_c_stid: type_qualifier_c_stid gnu_or_msc_attribute_specifier_list_c_opt  */
#line 6840 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 10894 "parser.c"
    break;

  case 592: /* cv_qualifier_list_stid_opt: %empty  */
#line 6861 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 10900 "parser.c"
    break;

  case 593: /* cv_qualifier_list_stid_opt: cv_qualifier_list_stid_opt cv_qualifier_stid  */
#line 6863 "parser.y"
    {
      DUMP_START( "cv_qualifier_list_stid_opt",
                  "cv_qualifier_list_stid_opt cv_qualifier_stid" );
      DUMP_TID( "cv_qualifier_list_stid_opt", (yyvsp[-1].tid) );
      DUMP_TID( "cv_qualifier_stid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_stids", (yyval.tid) );
      DUMP_END();
    }
#line 10917 "parser.c"
    break;

  case 594: /* restrict_qualifier_c_stid: Y_restrict  */
#line 6879 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since both "restrict" and "__restrict" map to TS_restrict and the
      // AST has no "memory" of which it was.
      //
      if ( OPT_LANG_IS( CPP_ANY ) ) {
        print_error( &(yylsp[0]),
          "\"restrict\" not supported in C++; use \"%s\" instead\n",
          L_GNU___restrict
        );
        PARSE_ABORT();
      }
    }
#line 10935 "parser.c"
    break;

  case 599: /* upc_layout_qualifier_c: '[' error ']'  */
#line 6900 "parser.y"
    {
      elaborate_error( "one of nothing, integer, or '*' expected" );
    }
#line 10943 "parser.c"
    break;

  case 600: /* storage_class_c_type: Y_auto_STORAGE  */
#line 6908 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10949 "parser.c"
    break;

  case 601: /* storage_class_c_type: Y_Apple___block  */
#line 6909 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10955 "parser.c"
    break;

  case 602: /* storage_class_c_type: Y_consteval  */
#line 6910 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10961 "parser.c"
    break;

  case 603: /* storage_class_c_type: Y_constexpr  */
#line 6911 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10967 "parser.c"
    break;

  case 604: /* storage_class_c_type: Y_constinit  */
#line 6912 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10973 "parser.c"
    break;

  case 605: /* storage_class_c_type: Y_explicit  */
#line 6913 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10979 "parser.c"
    break;

  case 606: /* storage_class_c_type: Y_export  */
#line 6914 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10985 "parser.c"
    break;

  case 607: /* storage_class_c_type: Y_extern  */
#line 6915 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10991 "parser.c"
    break;

  case 608: /* storage_class_c_type: extern_linkage_c_stid  */
#line 6916 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 10997 "parser.c"
    break;

  case 609: /* storage_class_c_type: Y_final  */
#line 6917 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11003 "parser.c"
    break;

  case 610: /* storage_class_c_type: Y_friend  */
#line 6918 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11009 "parser.c"
    break;

  case 611: /* storage_class_c_type: Y_inline  */
#line 6919 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11015 "parser.c"
    break;

  case 612: /* storage_class_c_type: Y_mutable  */
#line 6920 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11021 "parser.c"
    break;

  case 613: /* storage_class_c_type: _Noreturn_atid  */
#line 6922 "parser.y"
    {
      //
      // These checks have to be done now in the parser rather than later in
      // the AST because the _Noreturn keyword is mapped to the [[noreturn]]
      // attribute and the AST has no "memory" that it was _Noreturn.
      //
      if ( !IS_SUPPORTED( _Noreturn ) ) {
        print_error( &(yylsp[0]),
          "\"%s\" keyword not supported%s",
          lexer_token, C_LANG_WHICH( _Noreturn )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
        PARSE_ABORT();
      }
      if ( !OPT_LANG_IS( _Noreturn_NOT_DEPRECATED ) ) {
        print_warning( &(yylsp[0]),
          "\"%s\" is deprecated%s",
          lexer_token, C_LANG_WHICH( _Noreturn_NOT_DEPRECATED )
        );
        print_hint(
          "%snoreturn%s", other_token_c( "[[" ), other_token_c( "]]" )
        );
      }

      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11054 "parser.c"
    break;

  case 614: /* storage_class_c_type: Y_override  */
#line 6950 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11060 "parser.c"
    break;

  case 615: /* storage_class_c_type: Y_static  */
#line 6952 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11066 "parser.c"
    break;

  case 616: /* storage_class_c_type: Y_typedef  */
#line 6953 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11072 "parser.c"
    break;

  case 617: /* storage_class_c_type: Y__Thread_local  */
#line 6954 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11078 "parser.c"
    break;

  case 618: /* storage_class_c_type: Y_thread_local  */
#line 6955 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11084 "parser.c"
    break;

  case 619: /* storage_class_c_type: Y_virtual  */
#line 6956 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11090 "parser.c"
    break;

  case 622: /* attribute_specifier_list_c_atid_opt: %empty  */
#line 6967 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11096 "parser.c"
    break;

  case 624: /* $@41: %empty  */
#line 6973 "parser.y"
    {
      if ( !IS_SUPPORTED( ATTRIBUTES ) ) {
        print_error( &(yylsp[-1]),
          "\"%s\" attribute syntax not supported%s\n",
          other_token_c( "[[" ),
          C_LANG_WHICH( ATTRIBUTES )
        );
        PARSE_ABORT();
      }
      lexer_keyword_ctx = C_KW_CTX_ATTRIBUTE;
    }
#line 11112 "parser.c"
    break;

  case 625: /* attribute_specifier_list_c_atid: Y_ATTR_BEGIN '[' $@41 using_opt attribute_list_c_atid_opt ']' rbracket_exp  */
#line 6985 "parser.y"
    {
      lexer_keyword_ctx = C_KW_CTX_DEFAULT;

      DUMP_START( "attribute_specifier_list_c_atid",
                  "'[[' using_opt attribute_list_c_atid_opt ']]'" );
      DUMP_TID( "attribute_list_c_atid_opt", (yyvsp[-2].tid) );

      (yyval.tid) = (yyvsp[-2].tid);

      DUMP_END();
    }
#line 11128 "parser.c"
    break;

  case 626: /* attribute_specifier_list_c_atid: gnu_or_msc_attribute_specifier_list_c  */
#line 6998 "parser.y"
    {
      (yyval.tid) = TA_NONE;
    }
#line 11136 "parser.c"
    break;

  case 628: /* using_opt: Y_using name_exp colon_exp  */
#line 7006 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "\"using\" in attributes" );
      free( (yyvsp[-1].name) );
    }
#line 11145 "parser.c"
    break;

  case 629: /* attribute_list_c_atid_opt: %empty  */
#line 7013 "parser.y"
                                  { (yyval.tid) = TA_NONE; }
#line 11151 "parser.c"
    break;

  case 631: /* attribute_list_c_atid: attribute_list_c_atid comma_exp attribute_c_atid_exp  */
#line 7019 "parser.y"
    {
      DUMP_START( "attribute_list_c_atid",
                  "attribute_list_c_atid ',' attribute_c_atid" );
      DUMP_TID( "attribute_list_c_atid", (yyvsp[-2].tid) );
      DUMP_TID( "attribute_c_atid_exp", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-2].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_atids", (yyval.tid) );
      DUMP_END();
    }
#line 11168 "parser.c"
    break;

  case 641: /* attribute_c_atid_exp: sname_c  */
#line 7045 "parser.y"
    {
      if ( c_sname_count( &(yyvsp[0].sname) ) > 1 ) {
        IGNORING( &(yylsp[0]),
          "\"%s\": namespaced attributes", c_sname_full_name( &(yyvsp[0].sname) )
        );
      }
      else {
        char const *adj = "unknown";
        c_lang_id_t lang_ids = LANG_NONE;

        char const *const name = c_sname_local_name( &(yyvsp[0].sname) );
        c_keyword_t const *const ck = c_keyword_find(
          name, c_lang_newer( opt_lang_id ), C_KW_CTX_ATTRIBUTE
        );
        if ( ck != NULL && c_tid_tpid( ck->tid ) == C_TPID_ATTR ) {
          adj = "unsupported";
          lang_ids = ck->lang_ids;
        }
        print_warning( &(yylsp[0]),
          "\"%s\": %s attribute%s",
          name, adj, c_lang_which( lang_ids )
        );

        print_suggestions( DYM_C_ATTRIBUTES, name );
        EPUTC( '\n' );
      }

      (yyval.tid) = TA_NONE;
      c_sname_cleanup( &(yyvsp[0].sname) );
    }
#line 11203 "parser.c"
    break;

  case 642: /* attribute_c_atid_exp: error  */
#line 7076 "parser.y"
    {
      elaborate_error_dym( DYM_C_ATTRIBUTES, "attribute name expected" );
    }
#line 11211 "parser.c"
    break;

  case 644: /* attribute_str_arg_c_opt: '(' str_lit_exp rparen_exp  */
#line 7084 "parser.y"
    {
      IGNORING( &(yylsp[-2]), "attribute arguments" );
      free( (yyvsp[-1].str_val) );
    }
#line 11220 "parser.c"
    break;

  case 653: /* $@42: %empty  */
#line 7112 "parser.y"
    {
      attr_syntax_not_supported( L_GNU___attribute__, &(yylsp[0]) );
      //
      // Temporariy disabling finding keywords allows GNU attributes that are C
      // keywords (e.g., const) to be found as ordinary string literals.
      //
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11233 "parser.c"
    break;

  case 654: /* gnu_attribute_specifier_c: Y_GNU___attribute__ $@42 lparen_exp lparen_exp gnu_attribute_list_c_opt ')' rparen_exp  */
#line 7121 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11241 "parser.c"
    break;

  case 659: /* gnu_attribute_c_exp: Y_NAME gnu_attribute_decl_arg_list_c_opt  */
#line 7138 "parser.y"
    {
      free( (yyvsp[-1].name) );
    }
#line 11249 "parser.c"
    break;

  case 660: /* gnu_attribute_c_exp: error  */
#line 7142 "parser.y"
    {
      elaborate_error( "attribute name expected" );
    }
#line 11257 "parser.c"
    break;

  case 667: /* gnu_attribute_arg_c: Y_NAME  */
#line 7163 "parser.y"
                                  { free( (yyvsp[0].name) ); }
#line 11263 "parser.c"
    break;

  case 668: /* gnu_attribute_arg_c: Y_CHAR_LIT  */
#line 7164 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11269 "parser.c"
    break;

  case 670: /* gnu_attribute_arg_c: Y_STR_LIT  */
#line 7166 "parser.y"
                                  { free( (yyvsp[0].str_val) ); }
#line 11275 "parser.c"
    break;

  case 672: /* gnu_attribute_arg_c: Y_LEXER_ERROR  */
#line 7169 "parser.y"
    {
      PARSE_ABORT();
    }
#line 11283 "parser.c"
    break;

  case 675: /* $@43: %empty  */
#line 7181 "parser.y"
    {
      attr_syntax_not_supported( L_MSC___declspec, &(yylsp[0]) );
      // See comment in gnu_attribute_specifier_c.
      lexer_find &= ~LEXER_FIND_C_KEYWORDS;
    }
#line 11293 "parser.c"
    break;

  case 676: /* msc_attribute_specifier_c: Y_MSC___declspec $@43 lparen_exp msc_attribute_list_c_opt ')'  */
#line 7187 "parser.y"
    {
      lexer_find |= LEXER_FIND_C_KEYWORDS;
    }
#line 11301 "parser.c"
    break;

  case 684: /* array_decl_english_ast: Y_array array_size_decl_ast of_exp decl_english_ast  */
#line 7223 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "ARRAY array_size_num_opt OF decl_english_ast" );
      DUMP_AST( "array_size_decl_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yylsp[-3]);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11319 "parser.c"
    break;

  case 685: /* array_decl_english_ast: Y_variable length_opt array_exp name_opt of_exp decl_english_ast  */
#line 7239 "parser.y"
    {
      DUMP_START( "array_decl_english_ast",
                  "VARIABLE LENGTH ARRAY name_opt OF decl_english_ast" );
      DUMP_STR( "name_opt", (yyvsp[-2].name) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      if ( (yyvsp[-2].name) == NULL ) {
        (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
      } else {
        (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
        (yyval.ast)->array.size_name = (yyvsp[-2].name);
      }
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11342 "parser.c"
    break;

  case 686: /* array_size_decl_ast: %empty  */
#line 7261 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_EMPTY_SIZE;
    }
#line 11351 "parser.c"
    break;

  case 687: /* array_size_decl_ast: uint_lit  */
#line 7266 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_INT_SIZE;
      (yyval.ast)->array.size_int = (yyvsp[0].uint_val);
    }
#line 11361 "parser.c"
    break;

  case 688: /* array_size_decl_ast: Y_NAME  */
#line 7272 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_NAMED_SIZE;
      (yyval.ast)->array.size_name = (yyvsp[0].name);
    }
#line 11371 "parser.c"
    break;

  case 689: /* array_size_decl_ast: '*'  */
#line 7278 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_ARRAY, &(yyloc) );
      (yyval.ast)->array.kind = C_ARRAY_VLA_STAR;
    }
#line 11380 "parser.c"
    break;

  case 692: /* block_decl_english_ast: Y_Apple_block paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7295 "parser.y"
    {
      DUMP_START( "block_decl_english_ast",
                  "BLOCK paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_APPLE_BLOCK, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->block.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11400 "parser.c"
    break;

  case 693: /* constructor_decl_english_ast: Y_constructor paren_param_decl_list_english_opt  */
#line 7316 "parser.y"
    {
      DUMP_START( "constructor_decl_english_ast",
                  "CONSTRUCTOR paren_param_decl_list_english_opt" );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[0].ast_list) );

      (yyval.ast) = c_ast_new_gc( K_CONSTRUCTOR, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[0].ast_list), (yyval.ast) );
      (yyval.ast)->ctor.param_ast_list = slist_move( &(yyvsp[0].ast_list) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11417 "parser.c"
    break;

  case 694: /* destructor_decl_english_ast: Y_destructor destructor_parens_opt  */
#line 7334 "parser.y"
    {
      DUMP_START( "destructor_decl_english_ast", "DESTRUCTOR ['(' ')']" );

      (yyval.ast) = c_ast_new_gc( K_DESTRUCTOR, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11430 "parser.c"
    break;

  case 697: /* func_decl_english_ast: func_qualifier_english_type_opt member_or_non_member_opt Y_function paren_param_decl_list_english_opt returning_english_ast_opt  */
#line 7356 "parser.y"
    {
      DUMP_START( "func_decl_english_ast",
                  "ref_qualifier_english_stid_opt "
                  "member_or_non_member_opt "
                  "FUNCTION paren_param_decl_list_english_opt "
                  "returning_english_ast_opt" );
      DUMP_TYPE( "func_qualifier_english_type_opt", (yyvsp[-4].type) );
      DUMP_INT( "member_or_non_member_opt", (yyvsp[-3].member) );
      DUMP_AST_LIST( "paren_param_decl_list_english_opt", (yyvsp[-1].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_FUNCTION, &(yyloc) );
      (yyval.ast)->type = (yyvsp[-4].type);
      c_ast_list_set_param_of( &(yyvsp[-1].ast_list), (yyval.ast) );
      (yyval.ast)->func.param_ast_list = slist_move( &(yyvsp[-1].ast_list) );
      (yyval.ast)->func.member = (yyvsp[-3].member);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11456 "parser.c"
    break;

  case 698: /* func_qualifier_english_type_opt: ref_qualifier_english_stid_opt  */
#line 7381 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) );
    }
#line 11464 "parser.c"
    break;

  case 699: /* func_qualifier_english_type_opt: msc_calling_convention_atid  */
#line 7385 "parser.y"
    {
      (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) );
    }
#line 11472 "parser.c"
    break;

  case 706: /* paren_param_decl_list_english_opt: %empty  */
#line 7402 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11478 "parser.c"
    break;

  case 708: /* paren_param_decl_list_english: '(' param_decl_list_english_opt ')'  */
#line 7408 "parser.y"
    {
      DUMP_START( "paren_param_decl_list_english",
                  "'(' param_decl_list_english_opt ')'" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-1].ast_list) );

      (yyval.ast_list) = (yyvsp[-1].ast_list);

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11493 "parser.c"
    break;

  case 709: /* param_decl_list_english_opt: %empty  */
#line 7421 "parser.y"
                                  { slist_init( &(yyval.ast_list) ); }
#line 11499 "parser.c"
    break;

  case 711: /* param_decl_list_english: param_decl_list_english comma_exp decl_english_ast_exp  */
#line 7428 "parser.y"
    {
      DUMP_START( "param_decl_list_english",
                  "param_decl_list_english ',' decl_english_ast" );
      DUMP_AST_LIST( "param_decl_list_english", (yyvsp[-2].ast_list) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast_list) = (yyvsp[-2].ast_list);
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11516 "parser.c"
    break;

  case 712: /* param_decl_list_english: decl_english_ast  */
#line 7442 "parser.y"
    {
      DUMP_START( "param_decl_list_english", "decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_FUNCTION ) // see the comment in param_c_ast
        (yyvsp[0].ast) = c_ast_pointer( (yyvsp[0].ast), &gc_ast_list );

      slist_init( &(yyval.ast_list) );
      slist_push_back( &(yyval.ast_list), (yyvsp[0].ast) );

      DUMP_AST_LIST( "$$_ast_list", (yyval.ast_list) );
      DUMP_END();
    }
#line 11534 "parser.c"
    break;

  case 714: /* decl_english_ast_exp: error  */
#line 7460 "parser.y"
    {
      elaborate_error( "declaration expected" );
    }
#line 11542 "parser.c"
    break;

  case 715: /* ref_qualifier_english_stid_opt: %empty  */
#line 7468 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 11548 "parser.c"
    break;

  case 716: /* ref_qualifier_english_stid_opt: Y_reference  */
#line 7469 "parser.y"
                                  { (yyval.tid) = TS_REFERENCE; }
#line 11554 "parser.c"
    break;

  case 717: /* ref_qualifier_english_stid_opt: Y_rvalue reference_exp  */
#line 7470 "parser.y"
                                  { (yyval.tid) = TS_RVALUE_REFERENCE; }
#line 11560 "parser.c"
    break;

  case 718: /* returning_english_ast_opt: %empty  */
#line 7477 "parser.y"
    {
      DUMP_START( "returning_english_ast_opt", "<empty>" );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      // see the comment in "type_c_ast"
      (yyval.ast)->type.btids = OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_void;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11575 "parser.c"
    break;

  case 720: /* returning_english_ast: returning decl_english_ast  */
#line 7493 "parser.y"
    {
      DUMP_START( "returning_english_ast", "RETURNING decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11589 "parser.c"
    break;

  case 721: /* returning_english_ast: returning error  */
#line 7504 "parser.y"
    {
      elaborate_error( "English expected after \"returning\"" );
    }
#line 11597 "parser.c"
    break;

  case 722: /* qualified_decl_english_ast: type_qualifier_list_english_type_opt qualifiable_decl_english_ast  */
#line 7514 "parser.y"
    {
      DUMP_START( "qualified_decl_english_ast",
                  "type_qualifier_list_english_type_opt "
                  "qualifiable_decl_english_ast" );
      DUMP_TYPE( "type_qualifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "qualifiable_decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) )
        (yyval.ast)->loc = (yyloc);
      PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11617 "parser.c"
    break;

  case 723: /* type_qualifier_list_english_type_opt: %empty  */
#line 7532 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 11623 "parser.c"
    break;

  case 725: /* type_qualifier_list_english_type: type_qualifier_list_english_type type_qualifier_english_type  */
#line 7539 "parser.y"
    {
      DUMP_START( "type_qualifier_list_english_type",
                  "type_qualifier_list_english_type "
                  "type_qualifier_english_type" );
      DUMP_TYPE( "type_qualifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_qualifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 11641 "parser.c"
    break;

  case 727: /* type_qualifier_english_type: attribute_english_atid  */
#line 7557 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_A( (yyvsp[0].tid) ); }
#line 11647 "parser.c"
    break;

  case 728: /* type_qualifier_english_type: storage_class_english_stid  */
#line 7558 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11653 "parser.c"
    break;

  case 729: /* type_qualifier_english_type: type_qualifier_english_stid  */
#line 7559 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_S( (yyvsp[0].tid) ); }
#line 11659 "parser.c"
    break;

  case 730: /* attribute_english_atid: Y_carries dependency_exp  */
#line 7563 "parser.y"
                                  { (yyval.tid) = TA_carries_dependency; }
#line 11665 "parser.c"
    break;

  case 733: /* attribute_english_atid: Y_maybe unused_exp  */
#line 7566 "parser.y"
                                  { (yyval.tid) = TA_maybe_unused; }
#line 11671 "parser.c"
    break;

  case 735: /* attribute_english_atid: Y_no Y_discard  */
#line 7568 "parser.y"
                                  { (yyval.tid) = TA_nodiscard; }
#line 11677 "parser.c"
    break;

  case 737: /* attribute_english_atid: Y_no Y_return  */
#line 7570 "parser.y"
                                  { (yyval.tid) = TA_noreturn; }
#line 11683 "parser.c"
    break;

  case 740: /* attribute_english_atid: Y_no Y_unique address_exp  */
#line 7573 "parser.y"
                                  { (yyval.tid) = TA_no_unique_address; }
#line 11689 "parser.c"
    break;

  case 746: /* storage_class_english_stid: Y_const_ENG eval_expr_init_stid  */
#line 7583 "parser.y"
    {
      (yyval.tid) = (yyvsp[0].tid);
    }
#line 11697 "parser.c"
    break;

  case 755: /* storage_class_english_stid: Y_extern linkage_stid linkage_opt  */
#line 7595 "parser.y"
    {
      (yyval.tid) = (yyvsp[-1].tid);
    }
#line 11705 "parser.c"
    break;

  case 760: /* storage_class_english_stid: Y_no Y_except  */
#line 7602 "parser.y"
                                  { (yyval.tid) = TS_noexcept; }
#line 11711 "parser.c"
    break;

  case 762: /* storage_class_english_stid: Y_non_empty  */
#line 7604 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 11717 "parser.c"
    break;

  case 766: /* storage_class_english_stid: Y_thread local_exp  */
#line 7609 "parser.y"
                                  { (yyval.tid) = TS_thread_local; }
#line 11723 "parser.c"
    break;

  case 772: /* storage_class_english_stid: Y_pure virtual_stid_exp  */
#line 7615 "parser.y"
                                  { (yyval.tid) = TS_PURE_virtual | (yyvsp[0].tid); }
#line 11729 "parser.c"
    break;

  case 773: /* eval_expr_init_stid: Y_evaluation  */
#line 7619 "parser.y"
                                  { (yyval.tid) = TS_consteval; }
#line 11735 "parser.c"
    break;

  case 774: /* eval_expr_init_stid: Y_expression  */
#line 7620 "parser.y"
                                  { (yyval.tid) = TS_constexpr; }
#line 11741 "parser.c"
    break;

  case 775: /* eval_expr_init_stid: Y_initialization  */
#line 7621 "parser.y"
                                  { (yyval.tid) = TS_constinit; }
#line 11747 "parser.c"
    break;

  case 776: /* linkage_stid: str_lit  */
#line 7633 "parser.y"
    {
      bool ok = true;

      if ( strcmp( (yyvsp[0].str_val), "C" ) == 0 )
        (yyval.tid) = TS_extern_C;
      else if ( strcmp( (yyvsp[0].str_val), "C++" ) == 0 )
        (yyval.tid) = TS_NONE;
      else {
        print_error( &(yylsp[0]), "\"%s\": unknown linkage language", (yyvsp[0].str_val) );
        print_hint( "\"C\" or \"C++\"" );
        ok = false;
      }

      free( (yyvsp[0].str_val) );
      PARSE_ASSERT( ok );
    }
#line 11768 "parser.c"
    break;

  case 796: /* pointer_decl_english_ast: Y_pointer to_exp decl_english_ast  */
#line 7690 "parser.y"
    {
      DUMP_START( "pointer_decl_english_ast", "POINTER TO decl_english_ast" );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        PARSE_ABORT();
      }

      (yyval.ast) = c_ast_new_gc( K_POINTER, &(yyloc) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11789 "parser.c"
    break;

  case 797: /* pointer_decl_english_ast: Y_pointer to_exp Y_member of_exp class_struct_union_btid_exp sname_english_exp decl_english_ast  */
#line 7713 "parser.y"
    {
      DUMP_START( "pointer_to_member_decl_english",
                  "POINTER TO MEMBER OF "
                  "class_struct_union_btid_exp "
                  "sname_english decl_english_ast" );
      DUMP_TID( "class_struct_union_btid_exp", (yyvsp[-2].tid) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[-1].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_POINTER_TO_MEMBER, &(yyloc) );
      (yyval.ast)->ptr_mbr.class_sname = c_sname_move( &(yyvsp[-1].sname) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-2].tid), &(yylsp[-2]) ) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11811 "parser.c"
    break;

  case 798: /* pointer_decl_english_ast: Y_pointer to_exp error  */
#line 7732 "parser.y"
    {
      if ( OPT_LANG_IS( POINTERS_TO_MEMBER ) )
        elaborate_error( "type name or \"member\" expected" );
      else
        elaborate_error( "type name expected" );
    }
#line 11822 "parser.c"
    break;

  case 799: /* reference_decl_english_ast: reference_english_ast to_exp decl_english_ast  */
#line 7745 "parser.y"
    {
      DUMP_START( "reference_decl_english_ast",
                  "reference_english_ast TO decl_english_ast" );
      DUMP_AST( "reference_english_ast", (yyvsp[-2].ast) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[-2].ast);
      (yyval.ast)->loc = (yyloc);
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11840 "parser.c"
    break;

  case 800: /* reference_english_ast: Y_reference  */
#line 7762 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_REFERENCE, &(yyloc) );
    }
#line 11848 "parser.c"
    break;

  case 801: /* reference_english_ast: Y_rvalue reference_exp  */
#line 7767 "parser.y"
    {
      (yyval.ast) = c_ast_new_gc( K_RVALUE_REFERENCE, &(yyloc) );
    }
#line 11856 "parser.c"
    break;

  case 802: /* user_defined_literal_decl_english_ast: user_defined literal_exp lparen_exp param_decl_list_english_opt ')' returning_english_ast_opt  */
#line 7778 "parser.y"
    { //
      // User-defined literals are supported only in C++11 and later.
      // (However, we always allow them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( USER_DEF_LITS ) ) {
        print_error( &(yylsp[-5]),
          "user-defined literals not supported%s\n",
          C_LANG_WHICH( USER_DEF_LITS )
        );
        PARSE_ABORT();
      }

      DUMP_START( "user_defined_literal_decl_english_ast",
                  "USER-DEFINED LITERAL '(' param_decl_list_english_opt ')' "
                  "returning_english_ast_opt" );
      DUMP_AST_LIST( "param_decl_list_english_opt", (yyvsp[-2].ast_list) );
      DUMP_AST( "returning_english_ast_opt", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_UDEF_LIT, &(yyloc) );
      c_ast_list_set_param_of( &(yyvsp[-2].ast_list), (yyval.ast) );
      (yyval.ast)->udef_lit.param_ast_list = slist_move( &(yyvsp[-2].ast_list) );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11891 "parser.c"
    break;

  case 803: /* var_decl_english_ast: sname_c Y_as decl_english_ast  */
#line 7817 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "sname_c AS decl_english_ast" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "decl_english_ast", (yyvsp[0].ast) );

      if ( (yyvsp[0].ast)->kind == K_NAME ) { // see the comment in "declare_command"
        assert( !c_sname_empty( &(yyvsp[0].ast)->sname ) );
        print_error_unknown_name( &(yylsp[0]), &(yyvsp[0].ast)->sname );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        PARSE_ABORT();
      }

      (yyval.ast) = (yyvsp[0].ast);
      (yyval.ast)->loc = (yyloc);
      c_sname_set( &(yyval.ast)->sname, &(yyvsp[-2].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11915 "parser.c"
    break;

  case 805: /* var_decl_english_ast: "..."  */
#line 7846 "parser.y"
    {
      DUMP_START( "var_decl_english_ast", "..." );

      (yyval.ast) = c_ast_new_gc( K_VARIADIC, &(yyloc) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11928 "parser.c"
    break;

  case 806: /* type_english_ast: type_modifier_list_english_type_opt unmodified_type_english_ast  */
#line 7863 "parser.y"
    {
      DUMP_START( "type_english_ast",
                  "type_modifier_list_english_type_opt "
                  "unmodified_type_english_ast" );
      DUMP_TYPE( "type_modifier_list_english_type_opt", (yyvsp[-1].type) );
      DUMP_AST( "unmodified_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( !c_type_is_none( &(yyvsp[-1].type) ) ) {
        // Set the AST's location to the entire rule only if the leading
        // optional rule is actually present, otherwise @$ refers to a column
        // before $ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add( &(yyval.ast)->type, &(yyvsp[-1].type), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11952 "parser.c"
    break;

  case 807: /* type_english_ast: type_modifier_list_english_type  */
#line 7885 "parser.y"
    {
      DUMP_START( "type_english_ast", "type_modifier_list_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[0].type) );

      // see the comment in "type_c_ast"
      c_type_t new_type =
        C_TYPE_LIT_B( OPT_LANG_IS( IMPLICIT_int ) ? TB_int : TB_NONE );

      PARSE_ASSERT( c_type_add( &new_type, &(yyvsp[0].type), &(yylsp[0]) ) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type = new_type;

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 11973 "parser.c"
    break;

  case 808: /* type_modifier_list_english_type_opt: %empty  */
#line 7904 "parser.y"
                                  { (yyval.type) = T_NONE; }
#line 11979 "parser.c"
    break;

  case 810: /* type_modifier_list_english_type: type_modifier_list_english_type type_modifier_english_type  */
#line 7911 "parser.y"
    {
      DUMP_START( "type_modifier_list_english_type",
                  "type_modifier_list_english_type "
                  "type_modifier_english_type" );
      DUMP_TYPE( "type_modifier_list_english_type", (yyvsp[-1].type) );
      DUMP_TYPE( "type_modifier_english_type", (yyvsp[0].type) );

      (yyval.type) = (yyvsp[-1].type);
      PARSE_ASSERT( c_type_add( &(yyval.type), &(yyvsp[0].type), &(yylsp[0]) ) );

      DUMP_TYPE( "$$_type", (yyval.type) );
      DUMP_END();
    }
#line 11997 "parser.c"
    break;

  case 817: /* builtin_type_english_ast: builtin_no_BitInt_english_btid  */
#line 7941 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast",
                  "builtin_no_BitInt_english_btid" );
      DUMP_TID( "builtin_no_BitInt_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12013 "parser.c"
    break;

  case 818: /* builtin_type_english_ast: BitInt_english_int  */
#line 7953 "parser.y"
    {
      DUMP_START( "builtin_type_english_ast", "BitInt_english_int" );
      DUMP_INT( "BitInt_english_int", (yyvsp[0].uint_val) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = TB__BitInt;
      (yyval.ast)->builtin.BitInt.width = (yyvsp[0].uint_val);

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12029 "parser.c"
    break;

  case 823: /* builtin_no_BitInt_english_btid: Y_char uint_lit_opt  */
#line 7972 "parser.y"
    {
      switch ( (yyvsp[0].uint_val) ) {
        case  0: (yyval.tid) = TB_char    ; break;
        case  8: (yyval.tid) = TB_char8_t ; break;
        case 16: (yyval.tid) = TB_char16_t; break;
        case 32: (yyval.tid) = TB_char32_t; break;
        default:
          print_error( &(yylsp[0]), "bits must be one of 8, 16, or 32\n" );
          PARSE_ABORT();
      } // switch
    }
#line 12045 "parser.c"
    break;

  case 828: /* builtin_no_BitInt_english_btid: Y_wide char_exp  */
#line 7987 "parser.y"
                                  { (yyval.tid) = TB_wchar_t; }
#line 12051 "parser.c"
    break;

  case 831: /* builtin_no_BitInt_english_btid: Y_floating point_exp  */
#line 7990 "parser.y"
                                  { (yyval.tid) = TB_float; }
#line 12057 "parser.c"
    break;

  case 832: /* builtin_no_BitInt_english_btid: Y_double precision_opt  */
#line 7991 "parser.y"
                                  { (yyval.tid) = TB_double; }
#line 12063 "parser.c"
    break;

  case 835: /* BitInt_english_int: BitInt_english uint_lit bits_opt  */
#line 7998 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12071 "parser.c"
    break;

  case 836: /* BitInt_english_int: BitInt_english '(' uint_lit_exp rparen_exp  */
#line 8002 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12079 "parser.c"
    break;

  case 837: /* BitInt_english_int: BitInt_english Y_width uint_lit_exp bits_opt  */
#line 8006 "parser.y"
    {
      (yyval.uint_val) = (yyvsp[-1].uint_val);
    }
#line 12087 "parser.c"
    break;

  case 838: /* BitInt_english_int: BitInt_english error  */
#line 8010 "parser.y"
    {
      elaborate_error( "integer literal, '(', or \"width\" expected" );
    }
#line 12095 "parser.c"
    break;

  case 844: /* class_struct_union_english_ast: class_struct_union_btid any_sname_c_exp  */
#line 8028 "parser.y"
    {
      DUMP_START( "class_struct_union_english_ast",
                  "class_struct_union_btid any_sname_c_exp" );
      DUMP_TID( "class_struct_union_btid", (yyvsp[-1].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[0].sname) );

      (yyval.ast) = c_ast_new_gc( K_CLASS_STRUCT_UNION, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-1].tid), C_TPID_BASE );
      (yyval.ast)->csu.csu_sname = c_sname_move( &(yyvsp[0].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12113 "parser.c"
    break;

  case 845: /* enum_english_ast: enum_btids any_sname_c_exp of_type_enum_fixed_type_english_ast_opt  */
#line 8046 "parser.y"
    {
      DUMP_START( "enum_english_ast",
                  "enum_btids any_sname_c_exp "
                  "of_type_enum_fixed_type_english_ast_opt" );
      DUMP_TID( "enum_btids", (yyvsp[-2].tid) );
      DUMP_SNAME( "any_sname_c_exp", (yyvsp[-1].sname) );
      DUMP_AST( "enum_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = c_ast_new_gc( K_ENUM, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[-2].tid), C_TPID_BASE );
      c_ast_set_parent( (yyvsp[0].ast), (yyval.ast) );
      (yyval.ast)->enum_.enum_sname = c_sname_move( &(yyvsp[-1].sname) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12134 "parser.c"
    break;

  case 846: /* of_type_enum_fixed_type_english_ast_opt: %empty  */
#line 8065 "parser.y"
                                        { (yyval.ast) = NULL; }
#line 12140 "parser.c"
    break;

  case 847: /* of_type_enum_fixed_type_english_ast_opt: Y_of type_opt enum_fixed_type_english_ast  */
#line 8067 "parser.y"
    {
      (yyval.ast) = (yyvsp[0].ast);
    }
#line 12148 "parser.c"
    break;

  case 848: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid_opt enum_unmodified_fixed_type_english_ast  */
#line 8075 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_stid" );
      DUMP_TID( "enum_fixed_type_modifier_list_stid", (yyvsp[-1].tid) );
      DUMP_AST( "enum_unmodified_fixed_type_english_ast", (yyvsp[0].ast) );

      (yyval.ast) = (yyvsp[0].ast);
      if ( (yyvsp[-1].tid) != TB_NONE ) {        // See comment in type_english_ast.
        (yyval.ast)->loc = (yyloc);
        PARSE_ASSERT( c_type_add_tid( &(yyval.ast)->type, (yyvsp[-1].tid), &(yylsp[-1]) ) );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12168 "parser.c"
    break;

  case 849: /* enum_fixed_type_english_ast: enum_fixed_type_modifier_list_english_btid  */
#line 8092 "parser.y"
    {
      DUMP_START( "enum_fixed_type_english_ast",
                  "enum_fixed_type_modifier_list_english_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[0].tid) );

      (yyval.ast) = c_ast_new_gc( K_BUILTIN, &(yyloc) );
      (yyval.ast)->type.btids = c_tid_check( (yyvsp[0].tid), C_TPID_BASE );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12184 "parser.c"
    break;

  case 850: /* enum_fixed_type_modifier_list_english_btid_opt: %empty  */
#line 8106 "parser.y"
                                  { (yyval.tid) = TB_NONE; }
#line 12190 "parser.c"
    break;

  case 852: /* enum_fixed_type_modifier_list_english_btid: enum_fixed_type_modifier_list_english_btid enum_fixed_type_modifier_btid  */
#line 8113 "parser.y"
    {
      DUMP_START( "enum_fixed_type_modifier_list_english_btid",
                  "enum_fixed_type_modifier_list_english_btid "
                  "enum_fixed_type_modifier_btid" );
      DUMP_TID( "enum_fixed_type_modifier_list_english_btid", (yyvsp[-1].tid) );
      DUMP_TID( "enum_fixed_type_modifier_btid", (yyvsp[0].tid) );

      (yyval.tid) = (yyvsp[-1].tid);
      PARSE_ASSERT( c_tid_add( &(yyval.tid), (yyvsp[0].tid), &(yylsp[0]) ) );

      DUMP_TID( "$$_btids", (yyval.tid) );
      DUMP_END();
    }
#line 12208 "parser.c"
    break;

  case 857: /* any_name: Y_TYPEDEF_NAME  */
#line 8142 "parser.y"
    {
      assert( c_sname_count( &(yyvsp[0].tdef)->ast->sname ) == 1 );
      (yyval.name) = check_strdup( c_sname_local_name( &(yyvsp[0].tdef)->ast->sname ) );
    }
#line 12217 "parser.c"
    break;

  case 859: /* any_name_exp: error  */
#line 8151 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12226 "parser.c"
    break;

  case 863: /* any_sname_c_exp: error  */
#line 8165 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12235 "parser.c"
    break;

  case 864: /* any_sname_c_opt: %empty  */
#line 8172 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12241 "parser.c"
    break;

  case 868: /* name_ast: Y_NAME  */
#line 8183 "parser.y"
    {
      DUMP_START( "name_ast", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
      c_sname_append_name( &(yyval.ast)->sname, (yyvsp[0].name) );

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12256 "parser.c"
    break;

  case 870: /* name_exp: error  */
#line 8198 "parser.y"
    {
      (yyval.name) = NULL;
      elaborate_error( "name expected" );
    }
#line 12265 "parser.c"
    break;

  case 871: /* name_cat: name_cat Y_NAME  */
#line 8206 "parser.y"
    {
      (yyval.name) = str_realloc_cat( (yyvsp[-1].name), " ", (yyvsp[0].name) );
      free( (yyvsp[0].name) );
    }
#line 12274 "parser.c"
    break;

  case 873: /* name_opt: %empty  */
#line 8214 "parser.y"
                                  { (yyval.name) = NULL; }
#line 12280 "parser.c"
    break;

  case 875: /* oper_sname_c_opt: %empty  */
#line 8219 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12286 "parser.c"
    break;

  case 876: /* oper_sname_c_opt: Y_OPERATOR_SNAME Y_COLON_COLON  */
#line 8222 "parser.y"
    {
      (yyval.sname) = (yyvsp[-1].sname);
      if ( c_type_is_none( c_sname_local_type( &(yyval.sname) ) ) )
        c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
    }
#line 12296 "parser.c"
    break;

  case 877: /* typedef_type_c_ast: any_typedef sub_scope_sname_c_opt  */
#line 8231 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();
      c_ast_t const *type_for_ast = (yyvsp[-1].tdef)->ast;

      DUMP_START( "typedef_type_c_ast", "any_typedef sub_scope_sname_c_opt" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_AST( "any_typedef__ast", type_for_ast );
      DUMP_SNAME( "sub_scope_sname_c_opt", (yyvsp[0].sname) );

      if ( c_sname_empty( &(yyvsp[0].sname) ) ) {
ttntd:  (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = type_for_ast;
      }
      else {
        c_sname_t temp_name = c_sname_dup( &(yyvsp[-1].tdef)->ast->sname );
        c_sname_append_sname( &temp_name, &(yyvsp[0].sname) );

        if ( type_ast == NULL ) {
          //
          // This is for a case like:
          //
          //      define S as struct S
          //      explain S::T x
          //
          // that is: a typedef'd type followed by ::T where T is an unknown
          // name used as a type. Just assume the T is some type, say int, and
          // create a name for it.
          //
          type_ast = c_ast_new_gc( K_BUILTIN, &(yylsp[0]) );
          type_ast->type.btids = TB_int;
          c_sname_set( &type_ast->sname, &temp_name );
          type_for_ast = type_ast;
          goto ttntd;
        }

        //
        // Otherwise, this is for cases like:
        //
        //  1. A typedef'd type used for a scope:
        //
        //          define S as struct S
        //          explain int S::x
        //
        //  2. A typedef'd type used for an intermediate scope:
        //
        //          define S as struct S
        //          define T as struct T
        //          explain int S::T::x
        //
        (yyval.ast) = type_ast;
        c_sname_set( &(yyval.ast)->sname, &temp_name );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12358 "parser.c"
    break;

  case 878: /* sub_scope_sname_c_opt: %empty  */
#line 8291 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12364 "parser.c"
    break;

  case 879: /* sub_scope_sname_c_opt: Y_COLON_COLON any_sname_c  */
#line 8293 "parser.y"
    {
      (yyval.sname) = (yyvsp[0].sname);
    }
#line 12372 "parser.c"
    break;

  case 880: /* sname_c: sname_c Y_COLON_COLON Y_NAME  */
#line 8300 "parser.y"
    {
      // see the comment in "of_scope_english"
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[-2].sname) );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }

      DUMP_START( "sname_c", "sname_c '::' NAME" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_STR( "name", (yyvsp[0].name) );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_append_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12400 "parser.c"
    break;

  case 881: /* sname_c: sname_c Y_COLON_COLON any_typedef  */
#line 8325 "parser.y"
    { //
      // This is for a case like:
      //
      //      define S::int8_t as char
      //
      // that is: the type int8_t is an existing type in no scope being defined
      // as a distinct type in a new scope.
      //
      DUMP_START( "sname_c", "sname_c '::' any_typedef" );
      DUMP_SNAME( "sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      (yyval.sname) = (yyvsp[-2].sname);
      c_sname_set_local_type( &(yyval.sname), &C_TYPE_LIT_B( TB_SCOPE ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12425 "parser.c"
    break;

  case 882: /* sname_c: Y_NAME  */
#line 8347 "parser.y"
    {
      DUMP_START( "sname_c", "NAME" );
      DUMP_STR( "NAME", (yyvsp[0].name) );

      c_sname_init_name( &(yyval.sname), (yyvsp[0].name) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12439 "parser.c"
    break;

  case 883: /* sname_c_ast: sname_c bit_field_c_uint_opt  */
#line 8361 "parser.y"
    {
      c_ast_t *type_ast = ia_type_ast_peek();

      DUMP_START( "sname_c_ast", "sname_c" );
      DUMP_AST( "in_attr__type_c_ast", type_ast );
      DUMP_SNAME( "sname_c", (yyvsp[-1].sname) );
      DUMP_INT( "bit_field_c_uint_opt", (yyvsp[0].uint_val) );

      type_ast = ia_type_spec_ast( type_ast );
      c_sname_set( &type_ast->sname, &(yyvsp[-1].sname) );
      PARSE_ASSERT( c_ast_set_bit_field_width( type_ast, (yyvsp[0].uint_val) ) );

      (yyval.ast) = type_ast;
      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12460 "parser.c"
    break;

  case 884: /* bit_field_c_uint_opt: %empty  */
#line 8380 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 12466 "parser.c"
    break;

  case 885: /* bit_field_c_uint_opt: ':' uint_lit_exp  */
#line 8382 "parser.y"
    { //
      // This check has to be done now in the parser rather than later in the
      // AST since we use 0 to mean "no bit-field."
      //
      if ( (yyvsp[0].uint_val) == 0 ) {
        print_error( &(yylsp[0]), "bit-field width must be > 0\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = (yyvsp[0].uint_val);
    }
#line 12481 "parser.c"
    break;

  case 887: /* sname_c_exp: error  */
#line 8397 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12490 "parser.c"
    break;

  case 888: /* sname_c_opt: %empty  */
#line 8404 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12496 "parser.c"
    break;

  case 890: /* sname_english: any_sname_c of_scope_list_english_opt  */
#line 8410 "parser.y"
    {
      DUMP_START( "sname_english", "any_sname_c of_scope_list_english_opt" );
      DUMP_SNAME( "any_sname_c", (yyvsp[-1].sname) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_type_t const *local_type = c_sname_local_type( &(yyvsp[0].sname) );
      if ( c_type_is_none( local_type ) )
        local_type = c_sname_local_type( &(yyvsp[-1].sname) );
      (yyval.sname) = (yyvsp[0].sname);
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_set_local_type( &(yyval.sname), local_type );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12516 "parser.c"
    break;

  case 891: /* sname_english_ast: Y_NAME of_scope_list_english_opt  */
#line 8429 "parser.y"
    {
      DUMP_START( "sname_english_ast", "NAME of_scope_list_english_opt" );
      DUMP_STR( "NAME", (yyvsp[-1].name) );
      DUMP_SNAME( "of_scope_list_english_opt", (yyvsp[0].sname) );

      c_sname_t sname = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_name( &sname, (yyvsp[-1].name) );

      //
      // See if the full name is the name of a typedef'd type.
      //
      c_typedef_t const *const tdef = c_typedef_find_sname( &sname );
      if ( tdef != NULL ) {
        (yyval.ast) = c_ast_new_gc( K_TYPEDEF, &(yyloc) );
        (yyval.ast)->type.btids = TB_typedef;
        (yyval.ast)->tdef.for_ast = tdef->ast;
        c_sname_cleanup( &sname );
      } else {
        (yyval.ast) = c_ast_new_gc( K_NAME, &(yyloc) );
        c_sname_set( &(yyval.ast)->sname, &sname );
      }

      DUMP_AST( "$$_ast", (yyval.ast) );
      DUMP_END();
    }
#line 12546 "parser.c"
    break;

  case 893: /* sname_english_exp: error  */
#line 8459 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      elaborate_error( "name expected" );
    }
#line 12555 "parser.c"
    break;

  case 894: /* sname_english_opt: %empty  */
#line 8466 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 12561 "parser.c"
    break;

  case 896: /* sname_list_english: sname_list_english ',' sname_english_exp  */
#line 8472 "parser.y"
    {
      DUMP_START( "sname_list_english",
                  "sname_list_english ',' sname_english" );
      DUMP_SNAME_LIST( "sname_list_english", (yyvsp[-2].sname_list) );
      DUMP_SNAME( "sname_english_exp", (yyvsp[0].sname) );

      (yyval.sname_list) = (yyvsp[-2].sname_list);
      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12580 "parser.c"
    break;

  case 897: /* sname_list_english: sname_english  */
#line 8488 "parser.y"
    {
      DUMP_START( "sname_list_english", "sname_english" );
      DUMP_SNAME( "sname_english", (yyvsp[0].sname) );

      c_sname_t *const temp_sname = MALLOC( c_sname_t, 1 );
      *temp_sname = c_sname_move( &(yyvsp[0].sname) );
      slist_init( &(yyval.sname_list) );
      slist_push_back( &(yyval.sname_list), temp_sname );

      DUMP_SNAME_LIST( "$$_sname_list", (yyval.sname_list) );
      DUMP_END();
    }
#line 12597 "parser.c"
    break;

  case 898: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON sname_c  */
#line 8504 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' sname_c" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_SNAME( "sname_c", (yyvsp[0].sname) );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define S::T as struct T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[0].sname) );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12619 "parser.c"
    break;

  case 899: /* typedef_sname_c: typedef_sname_c Y_COLON_COLON any_typedef  */
#line 8523 "parser.y"
    {
      DUMP_START( "typedef_sname_c", "typedef_sname_c '::' any_typedef" );
      DUMP_SNAME( "typedef_sname_c", (yyvsp[-2].sname) );
      DUMP_AST( "any_typedef__ast", (yyvsp[0].tdef)->ast );

      //
      // This is for a case like:
      //
      //      define S as struct S
      //      define T as struct T
      //      define S::T as struct S_T
      //
      (yyval.sname) = c_sname_move( &(yyvsp[-2].sname) );
      c_sname_set_local_type( &(yyval.sname), c_sname_local_type( &(yyvsp[0].tdef)->ast->sname ) );
      c_sname_t temp_sname = c_sname_dup( &(yyvsp[0].tdef)->ast->sname );
      c_sname_append_sname( &(yyval.sname), &temp_sname );

      DUMP_SNAME( "$$_sname", (yyval.sname) );
      DUMP_END();
    }
#line 12644 "parser.c"
    break;

  case 900: /* typedef_sname_c: any_typedef  */
#line 8544 "parser.y"
                                  { (yyval.sname) = c_sname_dup( &(yyvsp[0].tdef)->ast->sname ); }
#line 12650 "parser.c"
    break;

  case 902: /* address_exp: error  */
#line 8554 "parser.y"
    {
      keyword_expected( L_address );
    }
#line 12658 "parser.c"
    break;

  case 904: /* array_exp: error  */
#line 8562 "parser.y"
    {
      keyword_expected( L_array );
    }
#line 12666 "parser.c"
    break;

  case 905: /* as_exp: Y_as  */
#line 8569 "parser.y"
    {
      if ( OPT_LANG_IS( MEMBER_FUNCTIONS ) ) {
        //
        // For either "declare" or "define", neither "override" nor "final"
        // must be matched initially to allow for cases like:
        //
        //      c++decl> declare final as int
        //      int final;
        //
        // (which is legal).  However, in C++, after parsing "as", the keyword
        // context has to be set to C_KW_CTX_MBR_FUNC to be able to match
        // "override" and "final", e.g.:
        //
        //      c++decl> declare f as final function
        //      void f() final;
        //
        lexer_keyword_ctx = C_KW_CTX_MBR_FUNC;
      }
    }
#line 12690 "parser.c"
    break;

  case 906: /* as_exp: error  */
#line 8589 "parser.y"
    {
      keyword_expected( L_as );
    }
#line 12698 "parser.c"
    break;

  case 910: /* as_into_to_exp: error  */
#line 8599 "parser.y"
    {
      elaborate_error( "\"as\", \"into\", or \"to\" expected" );
    }
#line 12706 "parser.c"
    break;

  case 920: /* cast_exp: error  */
#line 8624 "parser.y"
    {
      keyword_expected( L_cast );
    }
#line 12714 "parser.c"
    break;

  case 922: /* char_exp: error  */
#line 8632 "parser.y"
    {
      keyword_expected( L_char );
    }
#line 12722 "parser.c"
    break;

  case 924: /* class_struct_union_btid_exp: error  */
#line 8640 "parser.y"
    {
      elaborate_error( "\"class\", \"struct\", or \"union\" expected" );
    }
#line 12730 "parser.c"
    break;

  case 926: /* colon_exp: error  */
#line 8648 "parser.y"
    {
      punct_expected( ':' );
    }
#line 12738 "parser.c"
    break;

  case 928: /* comma_exp: error  */
#line 8656 "parser.y"
    {
      punct_expected( ',' );
    }
#line 12746 "parser.c"
    break;

  case 930: /* conversion_exp: error  */
#line 8664 "parser.y"
    {
      keyword_expected( L_conversion );
    }
#line 12754 "parser.c"
    break;

  case 931: /* c_operator: Y_co_await  */
#line 8670 "parser.y"
                                  { (yyval.op_id) = C_OP_CO_AWAIT              ; }
#line 12760 "parser.c"
    break;

  case 932: /* c_operator: Y_new  */
#line 8671 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW                   ; }
#line 12766 "parser.c"
    break;

  case 933: /* c_operator: Y_new '[' rbracket_exp  */
#line 8672 "parser.y"
                                  { (yyval.op_id) = C_OP_NEW_ARRAY             ; }
#line 12772 "parser.c"
    break;

  case 934: /* c_operator: Y_delete  */
#line 8673 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE                ; }
#line 12778 "parser.c"
    break;

  case 935: /* c_operator: Y_delete '[' rbracket_exp  */
#line 8674 "parser.y"
                                  { (yyval.op_id) = C_OP_DELETE_ARRAY          ; }
#line 12784 "parser.c"
    break;

  case 936: /* c_operator: '!'  */
#line 8675 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM                ; }
#line 12790 "parser.c"
    break;

  case 937: /* c_operator: Y_EXCLAM_EQUAL  */
#line 8676 "parser.y"
                                  { (yyval.op_id) = C_OP_EXCLAM_EQUAL          ; }
#line 12796 "parser.c"
    break;

  case 938: /* c_operator: '%'  */
#line 8677 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT               ; }
#line 12802 "parser.c"
    break;

  case 939: /* c_operator: Y_PERCENT_EQUAL  */
#line 8678 "parser.y"
                                  { (yyval.op_id) = C_OP_PERCENT_EQUAL         ; }
#line 12808 "parser.c"
    break;

  case 940: /* c_operator: '&'  */
#line 8679 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER                 ; }
#line 12814 "parser.c"
    break;

  case 941: /* c_operator: Y_AMPER_AMPER  */
#line 8680 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_AMPER           ; }
#line 12820 "parser.c"
    break;

  case 942: /* c_operator: Y_AMPER_EQUAL  */
#line 8681 "parser.y"
                                  { (yyval.op_id) = C_OP_AMPER_EQUAL           ; }
#line 12826 "parser.c"
    break;

  case 943: /* c_operator: '(' rparen_exp  */
#line 8682 "parser.y"
                                  { (yyval.op_id) = C_OP_PARENS                ; }
#line 12832 "parser.c"
    break;

  case 944: /* c_operator: '*'  */
#line 8683 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR                  ; }
#line 12838 "parser.c"
    break;

  case 945: /* c_operator: Y_STAR_EQUAL  */
#line 8684 "parser.y"
                                  { (yyval.op_id) = C_OP_STAR_EQUAL            ; }
#line 12844 "parser.c"
    break;

  case 946: /* c_operator: '+'  */
#line 8685 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS                  ; }
#line 12850 "parser.c"
    break;

  case 947: /* c_operator: "++"  */
#line 8686 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_PLUS             ; }
#line 12856 "parser.c"
    break;

  case 948: /* c_operator: Y_PLUS_EQUAL  */
#line 8687 "parser.y"
                                  { (yyval.op_id) = C_OP_PLUS_EQUAL            ; }
#line 12862 "parser.c"
    break;

  case 949: /* c_operator: ','  */
#line 8688 "parser.y"
                                  { (yyval.op_id) = C_OP_COMMA                 ; }
#line 12868 "parser.c"
    break;

  case 950: /* c_operator: '-'  */
#line 8689 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS                 ; }
#line 12874 "parser.c"
    break;

  case 951: /* c_operator: "--"  */
#line 8690 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_MINUS           ; }
#line 12880 "parser.c"
    break;

  case 952: /* c_operator: Y_MINUS_EQUAL  */
#line 8691 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_EQUAL           ; }
#line 12886 "parser.c"
    break;

  case 953: /* c_operator: Y_MINUS_GREATER  */
#line 8692 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER         ; }
#line 12892 "parser.c"
    break;

  case 954: /* c_operator: Y_MINUS_GREATER_STAR  */
#line 8693 "parser.y"
                                  { (yyval.op_id) = C_OP_MINUS_GREATER_STAR    ; }
#line 12898 "parser.c"
    break;

  case 955: /* c_operator: '.'  */
#line 8694 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT                   ; }
#line 12904 "parser.c"
    break;

  case 956: /* c_operator: Y_DOT_STAR  */
#line 8695 "parser.y"
                                  { (yyval.op_id) = C_OP_DOT_STAR              ; }
#line 12910 "parser.c"
    break;

  case 957: /* c_operator: '/'  */
#line 8696 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH                 ; }
#line 12916 "parser.c"
    break;

  case 958: /* c_operator: Y_SLASH_EQUAL  */
#line 8697 "parser.y"
                                  { (yyval.op_id) = C_OP_SLASH_EQUAL           ; }
#line 12922 "parser.c"
    break;

  case 959: /* c_operator: Y_COLON_COLON  */
#line 8698 "parser.y"
                                  { (yyval.op_id) = C_OP_COLON_COLON           ; }
#line 12928 "parser.c"
    break;

  case 960: /* c_operator: '<'  */
#line 8699 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS                  ; }
#line 12934 "parser.c"
    break;

  case 961: /* c_operator: Y_LESS_LESS  */
#line 8700 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS             ; }
#line 12940 "parser.c"
    break;

  case 962: /* c_operator: Y_LESS_LESS_EQUAL  */
#line 8701 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_LESS_EQUAL       ; }
#line 12946 "parser.c"
    break;

  case 963: /* c_operator: Y_LESS_EQUAL  */
#line 8702 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL            ; }
#line 12952 "parser.c"
    break;

  case 964: /* c_operator: Y_LESS_EQUAL_GREATER  */
#line 8703 "parser.y"
                                  { (yyval.op_id) = C_OP_LESS_EQUAL_GREATER    ; }
#line 12958 "parser.c"
    break;

  case 965: /* c_operator: '='  */
#line 8704 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL                 ; }
#line 12964 "parser.c"
    break;

  case 966: /* c_operator: Y_EQUAL_EQUAL  */
#line 8705 "parser.y"
                                  { (yyval.op_id) = C_OP_EQUAL_EQUAL           ; }
#line 12970 "parser.c"
    break;

  case 967: /* c_operator: '>'  */
#line 8706 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER               ; }
#line 12976 "parser.c"
    break;

  case 968: /* c_operator: Y_GREATER_GREATER  */
#line 8707 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER       ; }
#line 12982 "parser.c"
    break;

  case 969: /* c_operator: Y_GREATER_GREATER_EQUAL  */
#line 8708 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_GREATER_EQUAL ; }
#line 12988 "parser.c"
    break;

  case 970: /* c_operator: Y_GREATER_EQUAL  */
#line 8709 "parser.y"
                                  { (yyval.op_id) = C_OP_GREATER_EQUAL         ; }
#line 12994 "parser.c"
    break;

  case 971: /* c_operator: Y_QMARK_COLON  */
#line 8710 "parser.y"
                                  { (yyval.op_id) = C_OP_QMARK_COLON           ; }
#line 13000 "parser.c"
    break;

  case 972: /* c_operator: '[' rbracket_exp  */
#line 8711 "parser.y"
                                  { (yyval.op_id) = C_OP_BRACKETS              ; }
#line 13006 "parser.c"
    break;

  case 973: /* c_operator: '^'  */
#line 8712 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET                 ; }
#line 13012 "parser.c"
    break;

  case 974: /* c_operator: Y_CARET_EQUAL  */
#line 8713 "parser.y"
                                  { (yyval.op_id) = C_OP_CARET_EQUAL           ; }
#line 13018 "parser.c"
    break;

  case 975: /* c_operator: '|'  */
#line 8714 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE                  ; }
#line 13024 "parser.c"
    break;

  case 976: /* c_operator: Y_PIPE_PIPE  */
#line 8715 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_PIPE             ; }
#line 13030 "parser.c"
    break;

  case 977: /* c_operator: Y_PIPE_EQUAL  */
#line 8716 "parser.y"
                                  { (yyval.op_id) = C_OP_PIPE_EQUAL            ; }
#line 13036 "parser.c"
    break;

  case 978: /* c_operator: '~'  */
#line 8717 "parser.y"
                                  { (yyval.op_id) = C_OP_TILDE                 ; }
#line 13042 "parser.c"
    break;

  case 980: /* default_exp: error  */
#line 8723 "parser.y"
    {
      keyword_expected( L_default );
    }
#line 13050 "parser.c"
    break;

  case 982: /* defined_exp: error  */
#line 8731 "parser.y"
    {
      keyword_expected( L_defined );
    }
#line 13058 "parser.c"
    break;

  case 984: /* dependency_exp: error  */
#line 8739 "parser.y"
    {
      keyword_expected( L_dependency );
    }
#line 13066 "parser.c"
    break;

  case 986: /* destructor_sname: Y_LEXER_ERROR  */
#line 8747 "parser.y"
    {
      c_sname_init( &(yyval.sname) );
      PARSE_ABORT();
    }
#line 13075 "parser.c"
    break;

  case 987: /* empty_str_lit_exp: str_lit_exp  */
#line 8755 "parser.y"
    { //
      // This check is done now in the parser rather than later in the AST so
      // we don't have to keep the string literal around.
      //
      bool const is_empty = (yyvsp[0].str_val) == NULL || (yyvsp[0].str_val)[0] == '\0';
      free( (yyvsp[0].str_val) );
      if ( !is_empty ) {
        print_error( &(yylsp[0]), "empty string literal expected\n" );
        PARSE_ABORT();
      }
    }
#line 13091 "parser.c"
    break;

  case 989: /* equals_exp: error  */
#line 8771 "parser.y"
    {
      punct_expected( '=' );
    }
#line 13099 "parser.c"
    break;

  case 990: /* extern_linkage_c_stid: Y_extern linkage_stid  */
#line 8777 "parser.y"
                                  { (yyval.tid) = (yyvsp[0].tid); }
#line 13105 "parser.c"
    break;

  case 991: /* extern_linkage_c_stid: Y_extern linkage_stid '{'  */
#line 8779 "parser.y"
    {
      UNSUPPORTED( &(yylsp[0]), "scoped linkage declarations" );
      PARSE_ABORT();
    }
#line 13114 "parser.c"
    break;

  case 992: /* extern_linkage_c_stid_opt: %empty  */
#line 8786 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13120 "parser.c"
    break;

  case 994: /* glob: Y_GLOB  */
#line 8792 "parser.y"
    {
      if ( !OPT_LANG_IS( SCOPED_NAMES ) && strchr( (yyvsp[0].name), ':' ) != NULL ) {
        print_error( &(yylsp[0]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        free( (yyvsp[0].name) );
        PARSE_ABORT();
      }
      (yyval.name) = (yyvsp[0].name);
    }
#line 13136 "parser.c"
    break;

  case 995: /* glob_opt: %empty  */
#line 8806 "parser.y"
                                  { (yyval.name) = NULL; }
#line 13142 "parser.c"
    break;

  case 998: /* gt_exp: error  */
#line 8813 "parser.y"
    {
      punct_expected( '>' );
    }
#line 13150 "parser.c"
    break;

  case 999: /* inline_stid_opt: %empty  */
#line 8819 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13156 "parser.c"
    break;

  case 1002: /* int_exp: error  */
#line 8826 "parser.y"
    {
      elaborate_error( "\"int[eger]\" expected" );
    }
#line 13164 "parser.c"
    break;

  case 1004: /* literal_exp: error  */
#line 8834 "parser.y"
    {
      keyword_expected( L_literal );
    }
#line 13172 "parser.c"
    break;

  case 1006: /* local_exp: error  */
#line 8842 "parser.y"
    {
      keyword_expected( L_local );
    }
#line 13180 "parser.c"
    break;

  case 1008: /* lparen_exp: error  */
#line 8850 "parser.y"
    {
      punct_expected( '(' );
    }
#line 13188 "parser.c"
    break;

  case 1010: /* lt_exp: error  */
#line 8858 "parser.y"
    {
      punct_expected( '<' );
    }
#line 13196 "parser.c"
    break;

  case 1011: /* member_or_non_member_opt: %empty  */
#line 8864 "parser.y"
                                  { (yyval.member) = C_FUNC_UNSPECIFIED; }
#line 13202 "parser.c"
    break;

  case 1012: /* member_or_non_member_opt: Y_member  */
#line 8865 "parser.y"
                                  { (yyval.member) = C_FUNC_MEMBER     ; }
#line 13208 "parser.c"
    break;

  case 1013: /* member_or_non_member_opt: Y_non_member  */
#line 8866 "parser.y"
                                  { (yyval.member) = C_FUNC_NON_MEMBER ; }
#line 13214 "parser.c"
    break;

  case 1015: /* namespace_btid_exp: error  */
#line 8872 "parser.y"
    {
      keyword_expected( L_namespace );
    }
#line 13222 "parser.c"
    break;

  case 1016: /* namespace_type: Y_namespace  */
#line 8878 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13228 "parser.c"
    break;

  case 1017: /* namespace_type: Y_inline namespace_btid_exp  */
#line 8879 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT( (yyvsp[0].tid), (yyvsp[-1].tid), TA_NONE ); }
#line 13234 "parser.c"
    break;

  case 1019: /* of_exp: error  */
#line 8885 "parser.y"
    {
      keyword_expected( L_of );
    }
#line 13242 "parser.c"
    break;

  case 1020: /* of_scope_english: Y_of scope_english_type_exp any_sname_c_exp  */
#line 8892 "parser.y"
    { //
      // Scoped names are supported only in C++.  (However, we always allow
      // them in configuration files.)
      //
      // This check is better to do now in the parser rather than later in the
      // AST because it has to be done in fewer places in the code plus gives a
      // better error location.
      //
      if ( !IS_SUPPORTED( SCOPED_NAMES ) ) {
        print_error( &(yylsp[-1]),
          "scoped names not supported%s\n",
          C_LANG_WHICH( SCOPED_NAMES )
        );
        c_sname_cleanup( &(yyvsp[0].sname) );
        PARSE_ABORT();
      }
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_set_local_type( &(yyval.sname), &(yyvsp[-1].type) );
    }
#line 13266 "parser.c"
    break;

  case 1021: /* of_scope_list_english: of_scope_list_english of_scope_english  */
#line 8915 "parser.y"
    {
      // "of scope X of scope Y" means Y::X
      (yyval.sname) = c_sname_move( &(yyvsp[0].sname) );
      c_sname_append_sname( &(yyval.sname), &(yyvsp[-1].sname) );
      c_sname_fill_in_namespaces( &(yyval.sname) );
      if ( !c_sname_check( &(yyval.sname), &(yylsp[-1]) ) ) {
        c_sname_cleanup( &(yyval.sname) );
        PARSE_ABORT();
      }
    }
#line 13281 "parser.c"
    break;

  case 1023: /* of_scope_list_english_opt: %empty  */
#line 8929 "parser.y"
                                  { c_sname_init( &(yyval.sname) ); }
#line 13287 "parser.c"
    break;

  case 1026: /* operator_exp: error  */
#line 8936 "parser.y"
    {
      keyword_expected( L_operator );
    }
#line 13295 "parser.c"
    break;

  case 1030: /* point_exp: error  */
#line 8949 "parser.y"
    {
      keyword_expected( L_point );
    }
#line 13303 "parser.c"
    break;

  case 1034: /* rbrace_exp: error  */
#line 8961 "parser.y"
    {
      punct_expected( '}' );
    }
#line 13311 "parser.c"
    break;

  case 1036: /* rbracket_exp: error  */
#line 8969 "parser.y"
    {
      punct_expected( ']' );
    }
#line 13319 "parser.c"
    break;

  case 1038: /* reference_exp: error  */
#line 8977 "parser.y"
    {
      keyword_expected( L_reference );
    }
#line 13327 "parser.c"
    break;

  case 1042: /* returning_exp: error  */
#line 8990 "parser.y"
    {
      keyword_expected( L_returning );
    }
#line 13335 "parser.c"
    break;

  case 1044: /* rparen_exp: error  */
#line 8998 "parser.y"
    {
      punct_expected( ')' );
    }
#line 13343 "parser.c"
    break;

  case 1045: /* scope_english_type: class_struct_union_btid  */
#line 9004 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( (yyvsp[0].tid) ); }
#line 13349 "parser.c"
    break;

  case 1047: /* scope_english_type: Y_scope  */
#line 9006 "parser.y"
                                  { (yyval.type) = C_TYPE_LIT_B( TB_SCOPE ); }
#line 13355 "parser.c"
    break;

  case 1049: /* scope_english_type_exp: error  */
#line 9012 "parser.y"
    {
      elaborate_error(
        "\"class\", \"namespace\", \"scope\", \"struct\", or \"union\" expected"
      );
    }
#line 13365 "parser.c"
    break;

  case 1051: /* semi_exp: error  */
#line 9022 "parser.y"
    {
      punct_expected( ';' );
    }
#line 13373 "parser.c"
    break;

  case 1056: /* static_stid_opt: %empty  */
#line 9038 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13379 "parser.c"
    break;

  case 1057: /* static_stid_opt: Y_static  */
#line 9039 "parser.y"
                                  { (yyval.tid) = TS_NON_EMPTY_ARRAY; }
#line 13385 "parser.c"
    break;

  case 1059: /* str_lit: Y_LEXER_ERROR  */
#line 9045 "parser.y"
    {
      (yyval.str_val) = NULL;
      PARSE_ABORT();
    }
#line 13394 "parser.c"
    break;

  case 1061: /* str_lit_exp: error  */
#line 9054 "parser.y"
    {
      (yyval.str_val) = NULL;
      elaborate_error( "string literal expected" );
    }
#line 13403 "parser.c"
    break;

  case 1063: /* this_exp: error  */
#line 9063 "parser.y"
    {
      keyword_expected( L_this );
    }
#line 13411 "parser.c"
    break;

  case 1064: /* this_stid_opt: %empty  */
#line 9069 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13417 "parser.c"
    break;

  case 1067: /* to_exp: error  */
#line 9076 "parser.y"
    {
      keyword_expected( L_to );
    }
#line 13425 "parser.c"
    break;

  case 1070: /* typename_flag_opt: %empty  */
#line 9087 "parser.y"
                                  { (yyval.flag) = false; }
#line 13431 "parser.c"
    break;

  case 1071: /* typename_flag_opt: Y_typename  */
#line 9088 "parser.y"
                                  { (yyval.flag) = true; }
#line 13437 "parser.c"
    break;

  case 1072: /* uint_lit: Y_INT_LIT  */
#line 9093 "parser.y"
    {
      if ( (yyvsp[0].int_val) < 0 ) {
        //
        // This check is better to do now in the parser rather than later in
        // the AST because we can store the value as unsigned plus gives a
        // better error location.
        //
        print_error( &(yylsp[0]), "non-negative integer expected\n" );
        PARSE_ABORT();
      }
      (yyval.uint_val) = STATIC_CAST( unsigned, (yyvsp[0].int_val) );
    }
#line 13454 "parser.c"
    break;

  case 1074: /* uint_lit_exp: error  */
#line 9110 "parser.y"
    {
      elaborate_error( "integer literal expected" );
    }
#line 13462 "parser.c"
    break;

  case 1075: /* uint_lit_opt: %empty  */
#line 9116 "parser.y"
                                  { (yyval.uint_val) = 0; }
#line 13468 "parser.c"
    break;

  case 1078: /* unused_exp: error  */
#line 9123 "parser.y"
    {
      keyword_expected( L_unused );
    }
#line 13476 "parser.c"
    break;

  case 1082: /* virtual_stid_exp: error  */
#line 9136 "parser.y"
    {
      keyword_expected( L_virtual );
    }
#line 13484 "parser.c"
    break;

  case 1083: /* virtual_stid_opt: %empty  */
#line 9142 "parser.y"
                                  { (yyval.tid) = TS_NONE; }
#line 13490 "parser.c"
    break;


#line 13494 "parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 9146 "parser.y"


/// @endcond

// Re-enable warnings.
#ifdef __GNUC__
# pragma GCC diagnostic pop
#endif /* __GNUC__ */

/**
 * @addtogroup parser-group
 * @{
 */

////////// local functions ////////////////////////////////////////////////////

/**
 * Prints an additional parsing error message including a newline to standard
 * error that continues from where yyerror() left off.  Additionally:
 *
 * + If the lexer_printable_token() isn't NULL:
 *     + Checks to see if it's a keyword: if it is, mentions that it's a
 *       keyword in the error message.
 *     + May print "did you mean ...?" \a dym_kinds suggestions.
 *
 * + In debug mode, also prints the file & line where the function was called
 *   from as well as the ID of the lookahead token, if any.
 *
 * @note A newline _is_ printed.
 * @note This function isn't normally called directly; use the
 * #elaborate_error() or #elaborate_error_dym() macros instead.
 *
 * @param file The name of the file where this function was called from.
 * @param line The line number within \a file where this function was called
 * from.
 * @param dym_kinds The bitwise-or of the kind(s) of things possibly meant.
 * @param format A `printf()` style format string.  It _must not_ end in a
 * newline since this function prints its own newline.
 * @param ... Arguments to print.
 *
 * @sa #elaborate_error()
 * @sa #elaborate_error_dym()
 * @sa fl_keyword_expected()
 * @sa fl_punct_expected()
 * @sa yyerror()
 */
PJL_PRINTF_LIKE_FUNC(4)
static void fl_elaborate_error( char const *file, int line,
                                dym_kind_t dym_kinds, char const *format,
                                ... ) {
  assert( format != NULL );

  EPUTS( ": " );
  print_debug_file_line( file, line );

  char const *const error_token = lexer_printable_token();
  if ( print_error_token( error_token ) )
    EPUTS( ": " );

  va_list args;
  va_start( args, format );
  vfprintf( stderr, format, args );
  va_end( args );

  if ( error_token != NULL ) {
    print_error_token_is_a( error_token );
    print_suggestions( dym_kinds, error_token );
  }

  EPUTC( '\n' );
}

/**
 * Prints \a token, quoted; if \ref opt_cdecl_debug `!=` #CDECL_DEBUG_NO, also
 * prints the look-ahead character within `[]`.
 *
 * @param token The error token to print, if any.
 * @return Returns `true` only if anything was printed.
 */
static bool print_error_token( char const *token ) {
  if ( token == NULL )
    return false;
  EPRINTF( "\"%s\"", token );
  if ( opt_cdecl_debug != CDECL_DEBUG_NO ) {
    switch ( yychar ) {
      case YYEMPTY:
        EPUTS( " [<empty>]" );
        break;
      case YYEOF:
        EPUTS( " [<EOF>]" );
        break;
      default:
        EPRINTF( " [%d]", yychar );
    } // switch
  }
  return true;
}

////////// extern functions ///////////////////////////////////////////////////

void parser_cleanup( void ) {
  c_ast_list_cleanup_gc( &typedef_ast_list );
}

///////////////////////////////////////////////////////////////////////////////

/** @} */

/* vim:set et sw=2 ts=2: */
